/*
 *  Produced by ../../hzip
 */

#ifndef __CONFIG_H__
#define __CONFIG_H__

#define ARCH "x86_64"

#undef DISTMEM_GASNET_CONDUITS

#define DOT_CMD ""
#define DOT_FLAG 0
#define ENABLE_CUDA 1

#undef ENABLE_DISTMEM
#undef ENABLE_DISTMEM_ARMCI
#undef ENABLE_DISTMEM_GASNET
#undef ENABLE_DISTMEM_GPI
#undef ENABLE_DISTMEM_MPI
#define ENABLE_MT 1
#define ENABLE_MT_LPEL 0
#define ENABLE_MUTC 0
#define ENABLE_OMP 0
#define ENABLE_HWLOC 1
#define ENABLE_HASH 1
#define ENABLE_RTSPEC 1
#define ENABLE_UUID 1
#define HAVE_GCC_SIMD_OPERATIONS 1
#define ENABLE_GETTIME 0
#define ENABLE_ISL 0
#define ENABLE_BARVINOK 0
#if ENABLE_GETTIME
# define HAVE_GETTIME 1
#else
# undef HAVE_GETTIME
#endif
#define HAVE_MALLOC_H 1
#if HAVE_MALLOC_H == 0
# undef HAVE_MALLOC_H
#endif
#define HAVE_MKDTEMP 1
#define HAVE_OPENMP 0
#define HAVE_STRRCHR 1
#define HAVE_STRTOK 1

#define IS_CYGWIN 0
#define NEED_PTR_PREFIX 0
#define OS "Linux-3.16.0-4-amd64"
#define PF_MAXFUN 100
#define PF_MAXFUNAP 100
#define PF_MAXFUNNAMELEN 100
#define SAC_PRELUDE_NAME "sacprelude_d"
#define SBRK_T intptr_t


#endif 

#ifndef _SAC_RC_METHODS_H
#define _SAC_RC_METHODS_H
#define SAC_RCM_local 0
#define SAC_RCM_norc 1
#define SAC_RCM_async 2
#define SAC_RCM_local_norc_desc 3
#define SAC_RCM_local_norc_ptr 4
#define SAC_RCM_async_norc_copy_desc 5
#define SAC_RCM_async_norc_two_descs 6
#define SAC_RCM_async_norc_ptr 7
#define SAC_RCM_local_pasync_norc_desc 8
#define SAC_RCM_local_async_norc_ptr 9
#define SAC_RCM_local_pasync 10
#endif 

#ifndef _SAC_TYPES_H
#define _SAC_TYPES_H
#define MUTC 1
#if SAC_BACKEND == MUTC || defined SAC_BACKEND_MUTC
#ifndef __mt_freestanding__
#define USHORT_DEFINED
#define UINT_DEFINED
#define ULONG_DEFINED
#endif 
#endif
#undef MUTC
#ifndef FLOATVEC_DEFINED
# if HAVE_GCC_SIMD_OPERATIONS
typedef float __attribute__ ((vector_size (4 * sizeof (float)))) floatvec;
# define FLOATVEC_IDX(vec, idx) (vec)[(idx)]
# else

typedef struct {
float a,b,c,d;
} __attribute__((packed)) floatvec;
# define FLOATVEC_IDX(vec, idx) ((float *)&(vec))[(idx)]
# endif
#define FLOATVEC_DEFINED
#endif
#ifndef BYTE_DEFINED
typedef char byte;
#define BYTE_DEFINED
#endif
#ifndef LONGLONG_DEFINED
typedef long long longlong;
#define LONGLONG_DEFINED
#endif
#ifndef UBYTE_DEFINED
typedef unsigned char ubyte;
#define UBYTE_DEFINED
#endif
#ifndef ULONGLONG_DEFINED
typedef unsigned long long ulonglong;
#define ULONGLONG_DEFINED
#endif
#ifndef USHORT_DEFINED
typedef unsigned short ushort;
#define USHORT_DEFINED
#endif
#ifndef UINT_DEFINED
typedef unsigned int uint;
#define UINT_DEFINED
#endif
#ifndef ULONG_DEFINED
typedef unsigned long ulong;
#define ULONG_DEFINED
#endif
#endif 


#ifndef _SAC_AUDWL_H
#define _SAC_AUDWL_H

#define DEBUG_AUD_GENERATOR_CODE 0
#if DEBUG_AUD_GENERATOR_CODE
#define SAC_AUD_WL_DEBUG_PRINT( idx_vec_NT) {  int i;  if( SAC_in_gen)  printf("body at: ");  else  printf("default at: ");  for( i=0; i<SAC_ND_A_SIZE( idx_vec_NT ); i++)  printf(" %d", SAC_ND_READ( idx_vec_NT, i));  printf("\n"); }
#else
#define SAC_AUD_WL_DEBUG_PRINT( idx_vec_NT)
#endif

#define SAC_AUD_WL_BEGIN(idx_vec_NT, offset_NT, res_NT) { int SAC_in_gen;  int SAC_max_off = SAC_ND_A_SIZE( res_NT);  int SAC_off_inc = 1;  int SAC_max_d = SAC_ND_A_SIZE( idx_vec_NT)-1;  int SAC_d = SAC_ND_A_DIM( res_NT)-1;  int SAC_WL_SHAPE_FACTOR( res_NT, 0);   SAC_ND_WRITE( offset_NT, 0) = 0;   while( SAC_d > SAC_max_d) {  SAC_off_inc *= SAC_ND_A_SHAPE( res_NT, SAC_d);  SAC_d--;  }  SAC_WL_SHAPE_FACTOR( res_NT, 0) = SAC_off_inc;   while( SAC_d >= 0) {  SAC_ND_WRITE( idx_vec_NT, SAC_d) = 0;  SAC_d--;  }   while( SAC_ND_READ( offset_NT, 0) < SAC_max_off) {
#define SAC_AUD_WL_LU_GEN(lower_NT, idx_vec_NT, upper_NT)  SAC_d = SAC_max_d;   SAC_in_gen=1;  while( SAC_d>=0) {  SAC_in_gen = SAC_in_gen  && ( SAC_ND_READ( lower_NT, SAC_d) <= SAC_ND_READ( idx_vec_NT, SAC_d))  && ( SAC_ND_READ( idx_vec_NT, SAC_d) < SAC_ND_READ( upper_NT, SAC_d));  SAC_d--;  }  SAC_AUD_WL_DEBUG_PRINT(idx_vec_NT)
#define SAC_AUD_WL_LUS_GEN(lower_NT, idx_vec_NT, upper_NT, step_NT)  SAC_d = SAC_max_d;   SAC_in_gen=1;  while( SAC_d>=0) {  SAC_in_gen = SAC_in_gen  && ( SAC_ND_READ( lower_NT, SAC_d) <= SAC_ND_READ( idx_vec_NT, SAC_d))  && ( SAC_ND_READ( idx_vec_NT, SAC_d) < SAC_ND_READ( upper_NT, SAC_d))  && ( ((SAC_ND_READ( idx_vec_NT, SAC_d) - SAC_ND_READ( lower_NT, SAC_d))  % SAC_ND_READ( step_NT, SAC_d)) == 0 );  SAC_d--;  }  SAC_AUD_WL_DEBUG_PRINT(idx_vec_NT)
#define SAC_AUD_WL_LUSW_GEN(lower_NT, idx_vec_NT, upper_NT, step_NT, width_NT)  SAC_d = SAC_max_d;   SAC_in_gen=1;  while( SAC_d>=0) {  SAC_in_gen = SAC_in_gen  && ( SAC_ND_READ( lower_NT, SAC_d) <= SAC_ND_READ( idx_vec_NT, SAC_d))  && ( SAC_ND_READ( idx_vec_NT, SAC_d) < SAC_ND_READ( upper_NT, SAC_d))  && ( ((SAC_ND_READ( idx_vec_NT, SAC_d) - SAC_ND_READ( lower_NT, SAC_d))  % SAC_ND_READ( step_NT, SAC_d)) < SAC_ND_READ( width_NT, SAC_d));  SAC_d--;  }  SAC_AUD_WL_DEBUG_PRINT(idx_vec_NT)
#define SAC_AUD_WL_COND_BODY()  if( SAC_in_gen) { 
#define SAC_AUD_WL_COND_DEFAULT()  } else {
#define SAC_AUD_WL_COND_END()  }
#define SAC_AUD_WL_END( idx_vec_NT, offset_NT, res_NT)  SAC_d = SAC_max_d;  if( SAC_d >= 0) {  SAC_ND_WRITE( idx_vec_NT, SAC_d) = SAC_ND_READ( idx_vec_NT, SAC_d) + 1;  while(( SAC_d>0)  && ( SAC_ND_READ( idx_vec_NT, SAC_d) == SAC_ND_A_SHAPE( res_NT, SAC_d))){  SAC_ND_WRITE( idx_vec_NT, SAC_d) = 0;  SAC_d--;  SAC_ND_WRITE( idx_vec_NT, SAC_d) = SAC_ND_READ( idx_vec_NT, SAC_d) + 1;  }  }  SAC_ND_WRITE( offset_NT, 0) = SAC_ND_READ( offset_NT, 0) + SAC_off_inc;  } }

#define SAC_AUD_WL_FOLD_BEGIN(idx_vec_NT, lower_NT, upper_NT) { int SAC_in_gen;  int SAC_max_d = SAC_ND_A_SIZE( idx_vec_NT)-1;  int SAC_d = 0;  int SAC_within_bounds = 1;   while( SAC_d <= SAC_max_d) {  SAC_ND_WRITE( idx_vec_NT, SAC_d) = SAC_ND_READ( lower_NT, SAC_d);  SAC_within_bounds = SAC_within_bounds  && (SAC_ND_READ( lower_NT, SAC_d) < SAC_ND_READ( upper_NT, SAC_d));  SAC_d++;  }  while( SAC_within_bounds) {
#define SAC_AUD_WL_FOLD_LU_GEN( lower_NT, idx_vec_NT, upper_NT)  SAC_in_gen=1;  SAC_AUD_WL_DEBUG_PRINT(idx_vec_NT)
#define SAC_AUD_WL_FOLD_LUS_GEN( lower_NT, idx_vec_NT, upper_NT, step_NT)  SAC_d = SAC_max_d;  SAC_in_gen=1;  while( SAC_d>=0) {  SAC_in_gen = SAC_in_gen  && ( ((SAC_ND_READ( idx_vec_NT, SAC_d) - SAC_ND_READ( lower_NT, SAC_d))  % SAC_ND_READ( step_NT, SAC_d)) == 0 );  SAC_d--;  }  SAC_AUD_WL_DEBUG_PRINT(idx_vec_NT)
#define SAC_AUD_WL_FOLD_LUSW_GEN( lower_NT, idx_vec_NT, upper_NT, step_NT, width_NT)  SAC_d = SAC_max_d;  SAC_in_gen=1;  while( SAC_d>=0) {  SAC_in_gen = SAC_in_gen  && ( ((SAC_ND_READ( idx_vec_NT, SAC_d) - SAC_ND_READ( lower_NT, SAC_d))  % SAC_ND_READ( step_NT, SAC_d)) < SAC_ND_READ( width_NT, SAC_d));  SAC_d--;  }  SAC_AUD_WL_DEBUG_PRINT(idx_vec_NT)
#define SAC_AUD_WL_FOLD_END( idx_vec_NT, lower_NT, upper_NT)  SAC_d = SAC_max_d;  if( SAC_d >= 0) {  SAC_ND_WRITE( idx_vec_NT, SAC_d) = SAC_ND_READ( idx_vec_NT, SAC_d) + 1;  while(( SAC_d>0)  && ( SAC_ND_READ( idx_vec_NT, SAC_d) == SAC_ND_READ( upper_NT, SAC_d))){  SAC_ND_WRITE( idx_vec_NT, SAC_d) = SAC_ND_READ( lower_NT, SAC_d);  SAC_d--;  SAC_ND_WRITE( idx_vec_NT, SAC_d) = SAC_ND_READ( idx_vec_NT, SAC_d) + 1;  }  SAC_within_bounds = SAC_ND_READ( idx_vec_NT, SAC_d) < SAC_ND_READ( upper_NT, SAC_d);  } else {  SAC_within_bounds = 0;  }  } }

#endif 

#ifndef _SAC_COMMANDLINE_H_
#define _SAC_COMMANDLINE_H_
#ifndef SAC_C_EXTERN_VAR
#define SAC_C_EXTERN_VAR extern
#endif 
SAC_C_EXTERN_VAR char** SAC_commandline_argv;
SAC_C_EXTERN_VAR int SAC_commandline_argc;
#define SAC_COMMANDLINE_GET( argc, argv)  argc = SAC_commandline_argc;  argv = SAC_commandline_argv;
#define SAC_COMMANDLINE_SET( argc, argv)  SAC_commandline_argc = argc;  SAC_commandline_argv = argv;
#endif 

#ifndef _SAC_ICM_H
#define _SAC_ICM_H

#define Item0(a,b) a
#define Item1(a,b) Item0 b
#define Item2(a,b) Item1 b
#define Item3(a,b) Item2 b
#define Item4(a,b) Item3 b
#define Item5(a,b) Item4 b
#define Item6(a,b) Item5 b
#define Item7(a,b) Item6 b
#define Item8(a,b) Item7 b
#define Item9(a,b) Item8 b

#define CAT0( x, y) xCAT0( x, y)
#define xCAT0( x, y) x##y
#define CAT1( x, y) xCAT1( x, y)
#define xCAT1( x, y) x##y
#define CAT2( x, y) xCAT2( x, y)
#define xCAT2( x, y) x##y
#define CAT3( x, y) xCAT3( x, y)
#define xCAT3( x, y) x##y
#define CAT4( x, y) xCAT4( x, y)
#define xCAT4( x, y) x##y
#define CAT5( x, y) xCAT5( x, y)
#define xCAT5( x, y) x##y
#define CAT6( x, y) xCAT6( x, y)
#define xCAT6( x, y) x##y
#define CAT7( x, y) xCAT7( x, y)
#define xCAT7( x, y) x##y
#define CAT8( x, y) xCAT8( x, y)
#define xCAT8( x, y) x##y
#define CAT9( x, y) xCAT9( x, y)
#define xCAT9( x, y) x##y
#define CAT10( x, y) xCAT10( x, y)
#define xCAT10( x, y) x##y
#define CAT11( x, y) xCAT11( x, y)
#define xCAT11( x, y) x##y
#define CAT12( x, y) xCAT12( x, y)
#define xCAT12( x, y) x##y
#define CAT13( x, y) xCAT13( x, y)
#define xCAT13( x, y) x##y
#define CAT14( x, y) xCAT14( x, y)
#define xCAT14( x, y) x##y
#define CAT15( x, y) xCAT15( x, y)
#define xCAT15( x, y) x##y
#define CAT16( x, y) xCAT16( x, y)
#define xCAT16( x, y) x##y
#define CAT17( x, y) xCAT17( x, y)
#define xCAT17( x, y) x##y
#define CAT18( x, y) xCAT18( x, y)
#define xCAT18( x, y) x##y
#define CAT19( x, y) xCAT19( x, y)
#define xCAT19( x, y) x##y
#define CAT20( x, y) xCAT20( x, y)
#define xCAT20( x, y) x##y
#define CAT21( x, y) xCAT21( x, y)
#define xCAT21( x, y) x##y
#define CAT22( x, y) xCAT22( x, y)
#define xCAT22( x, y) x##y
#define CAT23( x, y) xCAT23( x, y)
#define xCAT23( x, y) x##y
#define CAT24( x, y) xCAT24( x, y)
#define xCAT24( x, y) x##y
#define CAT25( x, y) xCAT25( x, y)
#define xCAT25( x, y) x##y
#define CAT26( x, y) xCAT26( x, y)
#define xCAT26( x, y) x##y
#define CAT27( x, y) xCAT27( x, y)
#define xCAT27( x, y) x##y
#define CAT28( x, y) xCAT28( x, y)
#define xCAT28( x, y) x##y
#define CAT29( x, y) xCAT29( x, y)
#define xCAT29( x, y) x##y
#define CAT30( x, y) xCAT30( x, y)
#define xCAT30( x, y) x##y
#define CAT31( x, y) xCAT31( x, y)
#define xCAT31( x, y) x##y
#define CAT32( x, y) xCAT32( x, y)
#define xCAT32( x, y) x##y
#define CAT33( x, y) xCAT33( x, y)
#define xCAT33( x, y) x##y
#define CAT34( x, y) xCAT34( x, y)
#define xCAT34( x, y) x##y
#define CAT35( x, y) xCAT35( x, y)
#define xCAT35( x, y) x##y
#define CAT36( x, y) xCAT36( x, y)
#define xCAT36( x, y) x##y
#define CAT37( x, y) xCAT37( x, y)
#define xCAT37( x, y) x##y
#define CAT38( x, y) xCAT38( x, y)
#define xCAT38( x, y) x##y
#define CAT39( x, y) xCAT39( x, y)
#define xCAT39( x, y) x##y
#define CAT40( x, y) xCAT40( x, y)
#define xCAT40( x, y) x##y
#define CAT41( x, y) xCAT41( x, y)
#define xCAT41( x, y) x##y
#define CAT42( x, y) xCAT42( x, y)
#define xCAT42( x, y) x##y
#define CAT43( x, y) xCAT43( x, y)
#define xCAT43( x, y) x##y
#define CAT44( x, y) xCAT44( x, y)
#define xCAT44( x, y) x##y
#define CAT45( x, y) xCAT45( x, y)
#define xCAT45( x, y) x##y
#define CAT46( x, y) xCAT46( x, y)
#define xCAT46( x, y) x##y
#define CAT47( x, y) xCAT47( x, y)
#define xCAT47( x, y) x##y
#define CAT48( x, y) xCAT48( x, y)
#define xCAT48( x, y) x##y
#define CAT49( x, y) xCAT49( x, y)
#define xCAT49( x, y) x##y
#define CAT51( x, y) xCAT51( x, y)
#define xCAT51( x, y) x##y
#define CAT52( x, y) xCAT52( x, y)
#define xCAT52( x, y) x##y
#define CAT53( x, y) xCAT53( x, y)
#define xCAT53( x, y) x##y
#define CAT54( x, y) xCAT54( x, y)
#define xCAT54( x, y) x##y
#define CAT55( x, y) xCAT55( x, y)
#define xCAT55( x, y) x##y
#define CAT56( x, y) xCAT56( x, y)
#define xCAT56( x, y) x##y
#define CAT57( x, y) xCAT57( x, y)
#define xCAT57( x, y) x##y
#define CAT58( x, y) xCAT58( x, y)
#define xCAT58( x, y) x##y
#define CAT59( x, y) xCAT59( x, y)
#define xCAT59( x, y) x##y
#define CAT60( x, y) xCAT60( x, y)
#define xCAT60( x, y) x##y
#define CAT61( x, y) xCAT61( x, y)
#define xCAT61( x, y) x##y
#define CAT62( x, y) xCAT62( x, y)
#define xCAT62( x, y) x##y
#define CAT63( x, y) xCAT63( x, y)
#define xCAT63( x, y) x##y
#define CAT63( x, y) xCAT63( x, y)
#define xCAT63( x, y) x##y
#define CAT64( x, y) xCAT64( x, y)
#define xCAT64( x, y) x##y
#define CAT65( x, y) xCAT65( x, y)
#define xCAT65( x, y) x##y
#define CAT66( x, y) xCAT66( x, y)
#define xCAT66( x, y) x##y
#define CAT67( x, y) xCAT67( x, y)
#define xCAT67( x, y) x##y
#define CAT68( x, y) xCAT68( x, y)
#define xCAT68( x, y) x##y
#define AddParens( a) xAddParens( a) 
#define xAddParens( a) (a)

#define BuildArgs1( a) xBuildArgs1( a) 
#define xBuildArgs1( a) (a)
#define BuildArgs2( a, b) xBuildArgs2( a, b) 
#define xBuildArgs2( a, b) (a, b)
#define BuildArgs3( a, b, c) xBuildArgs3( a, b, c)
#define xBuildArgs3( a, b, c) (a, b, c)
#define BuildArgs4( a, b, c, d) xBuildArgs4( a, b, c, d)
#define xBuildArgs4( a, b, c, d) (a, b, c, d)

#define TO_STR( a) xTO_STR( a)
#define xTO_STR( a) #a

#define VIEW( a) #a expands to AddParens(a) 
#endif 

#ifndef _SAC_PRF_H_
#define _SAC_PRF_H_

#define SAC_ND_PRF_TOBOOL( arg) (int) (arg)
#define SAC_ND_PRF_TOC( arg) (char) (arg)
#define SAC_ND_PRF_TOB( arg) (byte) (arg)
#define SAC_ND_PRF_TOS( arg) (short) (arg)
#define SAC_ND_PRF_TOI( arg) (int) (arg)
#define SAC_ND_PRF_TOL( arg) (long) (arg)
#define SAC_ND_PRF_TOLL( arg) (longlong) (arg)
#define SAC_ND_PRF_TOUB( arg) (ubyte) (arg)
#define SAC_ND_PRF_TOUS( arg) (ushort) (arg)
#define SAC_ND_PRF_TOUI( arg) (uint) (arg)
#define SAC_ND_PRF_TOUL( arg) (ulong) (arg)
#define SAC_ND_PRF_TOULL( arg) (ulonglong) (arg)
#define SAC_ND_PRF_TOF( arg) (float) (arg)
#define SAC_ND_PRF_TOD( arg) (double) (arg)
#define SAC_ND_PRF_NOT( arg) !(arg)
#define SAC_ND_PRF_AND( arg1, arg2) (arg1) & (arg2)
#define SAC_ND_PRF_OR( arg1, arg2) (arg1) | (arg2)
#define SAC_ND_PRF_ADD( arg1, arg2) (arg1) + (arg2)
#define SAC_ND_PRF_SUB( arg1, arg2) (arg1) - (arg2)
#define SAC_ND_PRF_MUL( arg1, arg2) (arg1) * (arg2)
#define SAC_ND_PRF_DIV( arg1, arg2) (arg1) / (arg2)


#define SIGNUM( x) (( 0 == (x)) ? 0 : ( 0 < (x)) ? 1 : -1)
#define FLRDIV( arg1, arg2) (( 0==(arg2)) ? (arg1) : (arg1)-((arg2)*((arg1)/(arg2))))
#define SAC_ND_PRF_NEG( arg) -(arg)
#define SAC_ND_PRF_ABS( arg) ((arg) < 0) ? SAC_ND_PRF_NEG( arg) : (arg)
#define SAC_ND_PRF_MIN( arg1, arg2) (arg1) < (arg2) ? (arg1) : (arg2)
#define SAC_ND_PRF_MAX( arg1, arg2) (arg1) > (arg2) ? (arg1) : (arg2)
#define SAC_ND_PRF_MOD( arg1, arg2) (arg1) % (arg2)
#define SAC_ND_PRF_APLMOD( arg1, arg2)  ((( 0!= FLRDIV( arg1, arg2)) && ((SIGNUM( arg1) != SIGNUM( arg2)))) ?  FLRDIV( arg1, arg2) + ( arg2) : FLRDIV( arg1, arg2))
#define SAC_ND_PRF_EQ( arg1, arg2) (arg1) == (arg2)
#define SAC_ND_PRF_NE( arg1, arg2) (arg1) != (arg2)
#define SAC_ND_PRF_LE( arg1, arg2) (arg1) <= (arg2)
#define SAC_ND_PRF_LT( arg1, arg2) (arg1) < (arg2)
#define SAC_ND_PRF_GE( arg1, arg2) (arg1) >= (arg2)
#define SAC_ND_PRF_GT( arg1, arg2) (arg1) > (arg2)
#if HAVE_GCC_SIMD_OPERATIONS
# define SAC_ND_PRF_EQ_SIMD(arg1, arg2) SAC_ND_PRF_EQ (arg1, arg2)
# define SAC_ND_PRF_NE_SIMD(arg1, arg2) SAC_ND_PRF_NE (arg1, arg2)
# define SAC_ND_PRF_LE_SIMD(arg1, arg2) SAC_ND_PRF_LE (arg1, arg2)
# define SAC_ND_PRF_LT_SIMD(arg1, arg2) SAC_ND_PRF_LT (arg1, arg2)
# define SAC_ND_PRF_GE_SIMD(arg1, arg2) SAC_ND_PRF_GE (arg1, arg2)
# define SAC_ND_PRF_GT_SIMD(arg1, arg2) SAC_ND_PRF_GT (arg1, arg2)
# define SAC_ND_PRF_AND_SIMD(arg1, arg2) SAC_ND_PRF_AND (arg1, arg2)
# define SAC_ND_PRF_OR_SIMD(arg1, arg2) SAC_ND_PRF_OR (arg1, arg2)
# define SAC_ND_PRF_ADD_SIMD(arg1, arg2) SAC_ND_PRF_ADD (arg1, arg2)
# define SAC_ND_PRF_SUB_SIMD(arg1, arg2) SAC_ND_PRF_SUB (arg1, arg2)
# define SAC_ND_PRF_MUL_SIMD(arg1, arg2) SAC_ND_PRF_MUL (arg1, arg2)
# define SAC_ND_PRF_DIV_SIMD(arg1, arg2) SAC_ND_PRF_DIV (arg1, arg2)
#else

# define SAC_SIMD_WRAPPER(op, a, b) ((floatvec){op (FLOATVEC_IDX (a, 0), FLOATVEC_IDX (b, 0)),  op (FLOATVEC_IDX (a, 1), FLOATVEC_IDX (b, 1)),  op (FLOATVEC_IDX (a, 2), FLOATVEC_IDX (b, 2)),  op (FLOATVEC_IDX (a, 3), FLOATVEC_IDX (b, 3))})
# define SAC_ND_PRF_EQ_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_EQ, arg1, arg2)
# define SAC_ND_PRF_NE_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_NE, arg1, arg2)
# define SAC_ND_PRF_LE_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_LE, arg1, arg2)
# define SAC_ND_PRF_LT_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_LT, arg1, arg2)
# define SAC_ND_PRF_GE_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_GE, arg1, arg2)
# define SAC_ND_PRF_GT_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_GT, arg1, arg2)
# define SAC_ND_PRF_AND_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_AND, arg1, arg2)
# define SAC_ND_PRF_OR_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_OR, arg1, arg2)
# define SAC_ND_PRF_ADD_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_ADD, arg1, arg2)
# define SAC_ND_PRF_SUB_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_SUB, arg1, arg2)
# define SAC_ND_PRF_MUL_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_MUL, arg1, arg2)
# define SAC_ND_PRF_DIV_SIMD(arg1, arg2) SAC_SIMD_WRAPPER (SAC_ND_PRF_DIV, arg1, arg2)
#endif
#define __type_vector(num, base) base __attribute__ ((vector_size (num * sizeof (base))))
#define __to_vec(vectype, ptr) (*(vectype *)ptr)
#define SAC_ND_PRF_SIMD_ADD(basetype, num, arg1, arg2)  (__to_vec (__type_vector (num, basetype),arg1))  + (__to_vec (__type_vector (num, basetype), arg2))
#define SAC_ND_PRF_SIMD_SUB(basetype, num, arg1, arg2)  (__to_vec (__type_vector (num, basetype),arg1))  - (__to_vec (__type_vector (num, basetype), arg2))
#define SAC_ND_PRF_SIMD_MUL(basetype, num, arg1, arg2)  (__to_vec (__type_vector (num, basetype),arg1))  * (__to_vec (__type_vector (num, basetype), arg2))
#define SAC_ND_PRF_SIMD_DIV(basetype, num, arg1, arg2)  (__to_vec (__type_vector (num, basetype),arg1))  / (__to_vec (__type_vector (num, basetype), arg2))
#define __get_var(var) SAC_ND_GETVAR(var, SAC_ND_A_FIELD(var))
#define SAC_ND_PRF_SIMD_SELSxS__DATA(var, basetype, op, arg1, arg2)  __get_var (var) = FLOATVEC_IDX ((arg2), arg1);
#define SAC_ND_PRF_SIMD_MODARRAY(var, basetype, op, arg1, arg2, arg3)  {__get_var (var) = arg1; FLOATVEC_IDX ((__get_var (var)), arg2) = arg3; }
#define SAC_ND_PRF_SMxSM__DATA(var, basetype, op, num, arg1, arg2)  __to_vec (__type_vector (num, basetype), __get_var (var)) =  op (basetype, num, __get_var (arg1), __get_var (arg2));

#define SAC_ND_SIDM_ASSIGN(num, basetype, to_nt, to_pos, from_nt, from_pos, copyfun)  __to_vec (__type_vector (num, basetype), &(__get_var (to_nt)[to_pos]))  = __to_vec (__type_vector (num, basetype), &(__get_var (from_nt)[from_pos])); 

#define SAC_ND_PRF_DIM_A__DATA( to_NT, to_sdim, from_NT, from_sdim)  SAC_TR_PRF_PRINT( ("ND_PRF_DIM_A__...( %s, %d, %s, %d)\n",  NT_STR( to_NT), to_sdim, NT_STR( from_NT), from_sdim))  SAC_ND_CREATE__SCALAR__DATA( to_NT, SAC_ND_A_DIM( from_NT))
#if SAC_DO_DISTMEM
#define SAC_ND_PRF_IS_DIST_A__DATA( to_NT, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_IS_DIST_A__...( %s, %s)\n",  NT_STR( to_NT), NT_STR( from_NT)))  SAC_ND_CREATE__SCALAR__DATA( to_NT, SAC_ND_A_IS_DIST( from_NT))

#define SAC_ND_PRF_FIRST_ELEMS_A__DATA( to_NT, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_FIRST_ELEMS_A__...( %s, %s)\n",  NT_STR( to_NT), NT_STR( from_NT)))  SAC_ND_CREATE__SCALAR__DATA( to_NT, SAC_ND_A_FIRST_ELEMS( from_NT))

#define SAC_ND_PRF_LOCAL_FROM_A__DATA( to_NT, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_LOCAL_FROM_A__...( %s, %s)\n",  NT_STR( to_NT), NT_STR( from_NT)))  SAC_ND_CREATE__SCALAR__DATA( to_NT, SAC_ND_A_LOCAL_FROM( from_NT))

#define SAC_ND_PRF_LOCAL_COUNT_A__DATA( to_NT, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_LOCAL_COUNT_A__...( %s, %s)\n",  NT_STR( to_NT), NT_STR( from_NT)))  SAC_ND_CREATE__SCALAR__DATA( to_NT, SAC_ND_A_LOCAL_COUNT( from_NT))

#define SAC_ND_PRF_OFFS_A__DATA( to_NT, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_OFFS_A__...( %s, %s)\n",  NT_STR( to_NT), NT_STR( from_NT)))  SAC_ND_CREATE__SCALAR__DATA( to_NT, SAC_ND_A_OFFS( from_NT))
#else 

#define SAC_ND_PRF_IS_DIST_A__DATA( to_NT, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_IS_DIST_A__...( %s, %s)\n",  NT_STR( to_NT), NT_STR( from_NT)))  SAC_RuntimeError("This primitive function may only be called "  "if the distributed memory backend is used.");
#define SAC_ND_PRF_FIRST_ELEMS_A__DATA( to_NT, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_FIRST_ELEMS_A__...( %s, %s)\n",  NT_STR( to_NT), NT_STR( from_NT)))  SAC_RuntimeError("This primitive function may only be called "  "if the distributed memory backend is used.");
#define SAC_ND_PRF_LOCAL_FROM_A__DATA( to_NT, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_LOCAL_FROM_A__...( %s, %s)\n",  NT_STR( to_NT), NT_STR( from_NT)))  SAC_RuntimeError("This primitive function may only be called "  "if the distributed memory backend is used.");
#define SAC_ND_PRF_LOCAL_COUNT_A__DATA( to_NT, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_LOCAL_COUNT_A__...( %s, %s)\n",  NT_STR( to_NT), NT_STR( from_NT)))  SAC_RuntimeError("This primitive function may only be called "  "if the distributed memory backend is used.");
#define SAC_ND_PRF_OFFS_A__DATA( to_NT, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_OFFS_A__...( %s, %s)\n",  NT_STR( to_NT), NT_STR( from_NT)))  SAC_RuntimeError("This primitive function may only be called "  "if the distributed memory backend is used.");
#endif 

#define SAC_ND_PRF_SIZE_A__DATA( to_NT, to_sdim, from_NT, from_sdim)  SAC_TR_PRF_PRINT( ("ND_PRF_SIZE_A__...( %s, %d, %s, %d)\n",  NT_STR( to_NT), to_sdim, NT_STR( from_NT), from_sdim))  SAC_ND_CREATE__SCALAR__DATA( to_NT, SAC_ND_A_SIZE( from_NT))















#define SAC_ND_PRF_CAT_VxV__DATA( to_NT, to_sdim, from1_NT, from1_sdim,  from2_NT, from2_sdim, copyfun) { int SAC_i, SAC_off;  SAC_off = SAC_ND_A_SIZE( from1_NT);  for (SAC_i = 0; SAC_i < SAC_off; SAC_i++) {  SAC_ND_WRITE_READ_COPY( to_NT, SAC_i, from1_NT, SAC_i, copyfun);  }  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from2_NT); SAC_i++) {  SAC_ND_WRITE_READ_COPY( to_NT, SAC_off + SAC_i, from2_NT, SAC_i, copyfun);  } }
#define SAC_ND_PRF_S__DATA( to_NT, op_macro, scl)  SAC_TR_PRF_PRINT( ("ND_PRF_S__DATA( %s, %s, %s)\n",  NT_STR( to_NT), #op_macro, #scl));  SAC_ND_WRITE_COPY( to_NT, 0, op_macro( scl), ); 
#define SAC_ND_PRF_V__DATA( to_NT, op_macro, arg_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_V__DATA( %s, %s, %s)\n",  NT_STR( to_NT), #op_macro, NT_STR( arg_NT)));  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( to_NT); SAC_i++) {  SAC_ND_WRITE_COPY( to_NT, SAC_i,  op_macro( SAC_ND_READ( arg_NT, SAC_i)), );  }  }
#define SAC_ND_PRF_SxS__DATA( to_NT, op_macro, scl1, scl2)  SAC_TR_PRF_PRINT( ("ND_PRF_SxS__DATA( %s, %s, %s, %s)\n",  NT_STR( to_NT), #op_macro, #scl1, #scl2));  SAC_ND_WRITE_COPY( to_NT, 0, op_macro( scl1, scl2), ); 
#define SAC_ND_PRF_SxSxS__DATA( to_NT, op_macro, scl1, scl2, scl3)  SAC_TR_PRF_PRINT( ("ND_PRF_SxSxS__DATA( %s, %s, %s, %s, %s)\n",  NT_STR( to_NT), #op_macro, #scl1, #scl2, #scl3));  SAC_ND_WRITE_COPY( to_NT, 0, op_macro( scl1, scl2, scl3), ); 
#define SAC_ND_PRF_SxV__DATA( to_NT, op_macro, scl, from_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_SxV__DATA( %s, %s, %s, %s)\n",  NT_STR( to_NT), #op_macro, #scl, NT_STR( from_NT)));  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( to_NT); SAC_i++) {  SAC_ND_WRITE_COPY( to_NT, SAC_i,  op_macro( scl, SAC_ND_READ( from_NT, SAC_i)), );  }  }
#define SAC_ND_PRF_VxS__DATA( to_NT, op_macro, from_NT, scl)  SAC_TR_PRF_PRINT( ("ND_PRF_VxS__DATA( %s, %s, %s, %s)\n",  NT_STR( to_NT), #op_macro, NT_STR( from_NT), #scl));  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( to_NT); SAC_i++) {  SAC_ND_WRITE_COPY( to_NT, SAC_i,  op_macro( SAC_ND_READ( from_NT, SAC_i), scl), );  }  }
#define SAC_ND_PRF_VxV__DATA( to_NT, op_macro, from1_NT, from2_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_VxV__DATA( %s, %s, %s, %s)\n",  NT_STR( to_NT), #op_macro,  NT_STR( from1_NT), NT_STR( from2_NT)));  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( to_NT); SAC_i++) {  SAC_ND_WRITE_COPY( to_NT, SAC_i,  op_macro( SAC_ND_READ( from1_NT, SAC_i),  SAC_ND_READ( from2_NT, SAC_i)), );  }  }
#define SAC_ND_PRF_VxVxV__DATA( to_NT, op_macro,  from1_NT, from2_NT, from3_NT)  SAC_TR_PRF_PRINT( ("ND_PRF_VxVxV__DATA( %s, %s, %s, %s)\n",  NT_STR( to_NT), #op_macro,  NT_STR( from1_NT), NT_STR( from2_NT),  NT_STR( from3_NT)));  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( to_NT); SAC_i++) {  SAC_ND_WRITE_COPY( to_NT, SAC_i,  op_macro( SAC_ND_READ( from1_NT, SAC_i),  SAC_ND_READ( from2_NT, SAC_i),  SAC_ND_READ( from3_NT, SAC_i)  ), );  }  }
#define SAC_ND_PRF_IS_REUSED( to_NT, from_NT, from2_NT)  CAT17( SAC_ND_PRF_IS_REUSED__, NT_SHP( from_NT)  BuildArgs3( to_NT, from_NT, from2_NT))
#define SAC_ND_PRF_IS_REUSED__SCL( to_NT, from_NT, from2_NT)  SAC_ND_GETVAR( to_NT, SAC_ND_A_FIELD( to_NT)) = 0;
#define SAC_ND_PRF_IS_REUSED__AKS( to_NT, from_NT, from2_NT)  SAC_ND_GETVAR( to_NT, SAC_ND_A_FIELD( to_NT)) =  ( SAC_ND_GETVAR( from_NT, SAC_ND_A_FIELD( from_NT)) ==  SAC_ND_GETVAR( from2_NT, SAC_ND_A_FIELD( from2_NT))); 
#define SAC_ND_PRF_IS_REUSED__AKD( to_NT, from_NT, from2_NT)  SAC_ND_PRF_IS_REUSED__AKS( to_NT, from_NT, from2_NT)
#define SAC_ND_PRF_IS_REUSED__AUD( to_NT, from_NT, from2_NT)  SAC_ND_PRF_IS_REUSED__AKS( to_NT, from_NT, from2_NT)
#if 0 
#define SAC_ND_PRF_SINGLETHREAD__DATA( to_NT, to_sdim )  SAC_TR_PRF_PRINT( ("ND_PRF_SINGLETHREAD__...( %s, %d)\n",  NT_STR( to_NT), to_sdim));  SAC_ND_CREATE__SCALAR__DATA( to_NT, SAC_MT_NOT_LOCALLY_PARALLEL())
#endif
#define SAC_ND_PRF_GUARD( to_NT, from_NT)  { int SAC_i;  for (SAC_i = 0; SAC_i < ( SAC_ND_A_SIZE( from_NT) - 1); SAC_i++) {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from_NT, SAC_i), );  }  if ( !SAC_ND_READ(from_NT, SAC_i)) {  SAC_RuntimeError("Guard failed in "  __FILE__ ":" TO_STR( __LINE__) ".");  }  SAC_ND_A_FIELD(to_NT) = 1;  } 
#define SAC_ND_PRF_TYPE_CONSTRAINT_AKD( to_NT, from_NT, scl)  if (SAC_ND_A_DIM( from_NT) != scl)  SAC_RuntimeError("Array " NT_STR( from_NT) " does not adhere to "  "type constraint `dim == " #scl "' in "  __FILE__ ":" TO_STR( __LINE__) ".");  SAC_ND_A_FIELD(to_NT) = 1;
#define SAC_ND_PRF_TYPE_CONSTRAINT_AUDGZ( to_NT, from_NT)  if (SAC_ND_A_DIM( from_NT) == 0)  SAC_RuntimeError("Array " NT_STR( from_NT) " does not adhere to "  "type constraint `dim > 0' in " __FILE__ ":"  TO_STR( __LINE__) ".");  SAC_ND_A_FIELD( to_NT) = 1;
#define SAC_ND_PRF_SHAPE_MATCHES_DIM( to_NT, from_NT, from2_NT)  if ((SAC_ND_A_DIM(from_NT) != 1) ||  (SAC_ND_A_SHAPE(from_NT,0) != SAC_ND_A_DIM(from2_NT))) {  SAC_RuntimeError("Arrays " NT_STR( from_NT) " and "  NT_STR( from2_NT) " do not adhere to shape "  "matches dim constraint in " __FILE__ ":"  TO_STR( __LINE__) ".");  } else {  SAC_ND_A_FIELD( to_NT) = 1;  }
#define SAC_ND_PRF_NON_NEG_VAL_S( to_NT, from_NT)  {  if (SAC_ND_READ(from_NT, 0) < 0)  SAC_RuntimeError("Non-negativity constraint violated "  "for scalar " NT_STR( from_NT) " in "  __FILE__ ":" TO_STR( __LINE__) ".");  SAC_ND_WRITE_COPY(to_NT, 0, SAC_ND_READ(from_NT, 0), );  SAC_ND_A_FIELD(to_NT) = 1;  }
#define SAC_ND_PRF_NON_NEG_VAL_V( to_NT, from_NT)  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from_NT); SAC_i++) {  if (SAC_ND_READ(from_NT,SAC_i) < 0) {  SAC_RuntimeError("Non-negativity constraint violated "  "for vector " NT_STR( from_NT) " in "  __FILE__ ":" TO_STR( __LINE__) ".");  }  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from_NT, SAC_i), );  }  SAC_ND_A_FIELD(to_NT) = 1;  }
#define SAC_ND_PRF_VAL_LT_VAL_SxS( to_NT, from_NT, from2_NT)  {  if (SAC_ND_READ(from_NT, 0) >= SAC_ND_READ(from2_NT, 0)) {  SAC_RuntimeError("Scalar constraint " NT_STR( from_NT)  " (" SAC_NT_PRINT_CBASETYPE( from_NT)  ") < " NT_STR( from2_NT) " ("  SAC_NT_PRINT_CBASETYPE( from2_NT)  ") violated in "  __FILE__ ":" TO_STR( __LINE__) ".",  SAC_ND_READ(from_NT, 0),  SAC_ND_READ(from2_NT, 0));  }  SAC_ND_A_FIELD(to_NT) = 1;  }
#define SAC_ND_PRF_VAL_LE_VAL_VxV( to_NT, from_NT, from2_NT)  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from_NT); SAC_i++) {  if (SAC_ND_READ(from_NT, SAC_i) >  SAC_ND_READ(from2_NT, SAC_i)) {  SAC_RuntimeError("Vector constraint " NT_STR( from_NT)  " < " NT_STR( from2_NT) " violated in " __FILE__ ":" TO_STR( __LINE__) ".");  }  }  SAC_ND_A_FIELD(to_NT) = 1;  }
#define SAC_ND_PRF_VAL_LE_VAL_SxS( to_NT, from_NT, from2_NT)  {  if (SAC_ND_READ(from_NT, 0) >  SAC_ND_READ(from2_NT, 0)) {  SAC_RuntimeError("Scalar constraint " NT_STR( from_NT)  " (" SAC_NT_PRINT_CBASETYPE( from_NT)  ") <= " NT_STR( from2_NT) " ("  SAC_NT_PRINT_CBASETYPE( from2_NT)  ") violated in "  __FILE__ ":" TO_STR( __LINE__) ".",  SAC_ND_READ(from_NT, 0),  SAC_ND_READ(from2_NT, 0));  }  SAC_ND_A_FIELD(to_NT) = 1;  }
#define SAC_ND_PRF_MASK_SxSxS__DATA( to_NT, from1_NT, from2_NT, from3_NT)  {  if (SAC_ND_READ(from1_NT, 0)) {  SAC_ND_A_FIELD(to_NT) = SAC_ND_READ(from2_NT, 0);  } else {  SAC_ND_A_FIELD(to_NT) = SAC_ND_READ(from3_NT, 0);  }  }
#define SAC_ND_PRF_MASK_SxSxV__DATA( to_NT, from1_NT, from2_NT, from3_NT)  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from3_NT); SAC_i++) {  if (SAC_ND_READ(from1_NT, 0)) {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from2_NT, 0), );  } else {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from3_NT, SAC_i), );  }  }  }
#define SAC_ND_PRF_MASK_SxVxS__DATA( to_NT, from1_NT, from2_NT, from3_NT)  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from2_NT); SAC_i++) {  if (SAC_ND_READ(from1_NT, 0)) {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from2_NT, SAC_i), );  } else {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from3_NT, 0), );  }  }  }
#define SAC_ND_PRF_MASK_SxVxV__DATA( to_NT, from1_NT, from2_NT, from3_NT)  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from2_NT); SAC_i++) {  if (SAC_ND_READ(from1_NT, 0)) {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from2_NT, SAC_i), );  } else {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from3_NT, SAC_i), );  }  }  }
#define SAC_ND_PRF_MASK_VxSxS__DATA( to_NT, from1_NT, from2_NT, from3_NT)  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from1_NT); SAC_i++) {  if (SAC_ND_READ(from1_NT, SAC_i)) {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from2_NT, 0), );  } else {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from3_NT, 0), );  }  }  }
#define SAC_ND_PRF_MASK_VxSxV__DATA( to_NT, from1_NT, from2_NT, from3_NT)  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from1_NT); SAC_i++) {  if (SAC_ND_READ(from1_NT, SAC_i)) {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from2_NT, 0), );  } else {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from3_NT, SAC_i), );  }  }  }
#define SAC_ND_PRF_MASK_VxVxS__DATA( to_NT, from1_NT, from2_NT, from3_NT)  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from1_NT); SAC_i++) {  if (SAC_ND_READ(from1_NT, SAC_i)) {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from2_NT, SAC_i), );  } else {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from3_NT, 0), );  }  }  }
#define SAC_ND_PRF_MASK_VxVxV__DATA( to_NT, from1_NT, from2_NT, from3_NT)  { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from1_NT); SAC_i++) {  if (SAC_ND_READ(from1_NT, SAC_i)) {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from2_NT, SAC_i), );  } else {  SAC_ND_WRITE_COPY(to_NT, SAC_i, SAC_ND_READ(from3_NT, SAC_i), );  }  }  }
#define SAC_ND_PRF_SECOND_NODESC( to_NT, second_NT)  SAC_ND_A_FIELD( to_NT) = SAC_ND_A_FIELD( second_NT);
#define SAC_ND_PRF_SECOND_DESC( to_NT, second_NT)  SAC_ND_PRF_SECOND_NODESC( to_NT, second_NT)  SAC_ND_A_DESC( to_NT) = SAC_ND_A_DESC( second_NT);
#define SAC_ND_PRF_TYPE_CONV__SCL__SHP( error, left_NT, right_NT) {  if ( 0 != SAC_ND_A_DIM( right_NT)){  SAC_ND_PRF_TYPE_CONV_ERROR( error, right_NT);  }  SAC_ND_A_FIELD( left_NT) = SAC_ND_A_FIELD_UNBOX( right_NT);  SAC_ND_DEC_RC_FREE( right_NT, 1, ) }
#define SAC_ND_PRF_TYPE_CONV__SCL__SCL( error, left_NT, right_NT) {  SAC_ND_A_FIELD( left_NT) = SAC_ND_A_FIELD( right_NT); }
#define SAC_ND_PRF_TYPE_CONV__AKD_START( error, left_NT, right_NT) {  if ( SAC_ND_A_DIM( left_NT) != SAC_ND_A_DIM( right_NT)) {  SAC_ND_PRF_TYPE_CONV_ERROR( error, right_NT);  }  SAC_ND_A_FIELD( left_NT) = SAC_ND_A_FIELD( right_NT);  SAC_ND_A_DESC( left_NT) = SAC_ND_A_DESC( right_NT);  SAC_ND_A_MIRROR_SIZE( left_NT) = SAC_ND_A_SIZE( right_NT); 
#define SAC_ND_PRF_TYPE_CONV__AKD_SHAPE( num, left_NT, right_NT)  SAC_ND_A_MIRROR_SHAPE( left_NT, num) = SAC_ND_A_SHAPE( right_NT, num); 
#define SAC_ND_PRF_TYPE_CONV__AKD_END( error, left_NT, right_NT) }
#define SAC_ND_PRF_TYPE_CONV__AKS_START( error, left_NT, right_NT) {  if ( SAC_ND_A_DIM( left_NT) != SAC_ND_A_DIM( right_NT)) {  SAC_ND_PRF_TYPE_CONV_ERROR( error, right_NT);  }  if ( SAC_ND_A_DIM( left_NT) != SAC_ND_A_DIM( right_NT)) {  SAC_ND_PRF_TYPE_CONV_ERROR( error, right_NT);  }  SAC_ND_A_FIELD( left_NT) = SAC_ND_A_FIELD( right_NT);  SAC_ND_A_DESC( left_NT) = SAC_ND_A_DESC( right_NT);  if (
#define SAC_ND_PRF_TYPE_CONV__AKS_COND( num, left_NT, right_NT)  SAC_ND_A_SHAPE( left_NT, num) != SAC_ND_A_SHAPE( right_NT, num) || 
#define SAC_ND_PRF_TYPE_CONV__AKS_END( error, left_NT, right_NT)  0) {  SAC_ND_PRF_TYPE_CONV_ERROR( error, right_NT);  }  SAC_ND_A_FIELD( left_NT) = SAC_ND_A_FIELD( right_NT);  SAC_ND_A_DESC( left_NT) = SAC_ND_A_DESC( right_NT); }
#define SAC_ND_PRF_TYPE_CONV__AUD__SHP( error, left_NT, right_NT) {  if ( 0 == SAC_ND_A_DIM( right_NT)){  SAC_ND_PRF_TYPE_CONV_ERROR( error, right_NT);  }  SAC_ND_A_FIELD( left_NT) = SAC_ND_A_FIELD( right_NT);  SAC_ND_A_DESC( left_NT) = SAC_ND_A_DESC( right_NT);  SAC_ND_A_MIRROR_SIZE( left_NT) = SAC_ND_A_SIZE( right_NT);  SAC_ND_A_MIRROR_DIM( left_NT) = SAC_ND_A_DIM( right_NT); }

#define SAC_ND_PRF_TYPE_CONV__AUD__AUD( error, left_NT, right_NT) {  SAC_ND_A_FIELD( left_NT) = SAC_ND_A_FIELD( right_NT);  SAC_ND_A_DESC( left_NT) = SAC_ND_A_DESC( right_NT);  SAC_ND_A_MIRROR_SIZE( left_NT) = SAC_ND_A_SIZE( right_NT);  SAC_ND_A_MIRROR_DIM( left_NT) = SAC_ND_A_DIM( right_NT); }
#define SAC_ND_PRF_TYPE_CONV_ERROR_NAME( name, tuple)  #name
#define SAC_ND_PRF_TYPE_CONV_ERROR( error, right_NT) {  SAC_Print( " ___");  SAC_ND_PRINT_SHAPE( right_NT);  SAC_Print( " ");  SAC_Print( SAC_ND_PRF_TYPE_CONV_ERROR_NAME right_NT);  SAC_RuntimeError( error); }
#endif 

#ifndef _SAC_STD_H_
#define _SAC_STD_H_
#include <stdint.h> 
#include <limits.h> 
#define TRUE 1
#define FALSE 0
#ifndef SAC_RC_METHOD 
#define SAC_RC_METHOD -1
#endif

#define NT_NAME( var_NT) Item0 var_NT
#define NT_SHP( var_NT) Item1 var_NT
#define NT_HID( var_NT) Item2 var_NT
#define NT_UNQ( var_NT) Item3 var_NT
#define NT_REG( var_NT) Item4 var_NT
#define NT_SCO( var_NT) Item5 var_NT
#define NT_USG( var_NT) Item6 var_NT
#define NT_BIT( var_NT) Item7 var_NT
#define NT_DIS( var_NT) Item8 var_NT
#define NT_CBT( var_NT) Item9 var_NT
#define NT_STR( var_NT)  TO_STR( NT_NAME( var_NT))

typedef void* SAC_hidden;

typedef intptr_t SAC_referencecount_t;

typedef intptr_t* SAC_array_descriptor_parent_t;


typedef intptr_t* SAC_array_descriptor_t;
#define SAC_RC_T_MODE( rc)  (rc)
#define SAC_DESC_PARENT_T_SIZE  ( 1 * sizeof( intptr_t))



#if SAC_DO_DISTMEM
#define FIXED_SIZE_OF_DESC 9
#else 
#define FIXED_SIZE_OF_DESC 6
#endif 

#define VAR_SIZE_OF_DESC 1
#if SAC_DO_DISTMEM_PTR_DESC 

#define SIZE_OF_DESC( dim)  (FIXED_SIZE_OF_DESC + (dim) * VAR_SIZE_OF_DESC + SAC_DISTMEM_size)
#else 

#define SIZE_OF_DESC( dim)  (FIXED_SIZE_OF_DESC + (dim) * VAR_SIZE_OF_DESC)
#endif 
#ifndef SAC_FORCE_DESC_SIZE
#define SAC_FORCE_DESC_SIZE -1
#endif
#if SAC_FORCE_DESC_SIZE >= 0
#define BYTE_SIZE_OF_DESC( dim) SAC_FORCE_DESC_SIZE
#else 
#define BYTE_SIZE_OF_DESC( dim)  (SIZE_OF_DESC( dim) * sizeof( intptr_t))
#if SAC_DO_DISTMEM

#if SAC_DO_DISTMEM_PTR_DESC
#define SIZE_OF_DIST_DESC( dim)  (SIZE_OF_DESC( dim) + SAC_DISTMEM_size)
#else 
#define SIZE_OF_DIST_DESC( dim)  SIZE_OF_DESC( dim)
#endif 

#define BYTE_SIZE_OF_DIS_DESC( is_dist, dim)  ((is_dist) ? (SIZE_OF_DIST_DESC( dim) * sizeof( intptr_t)) : (SIZE_OF_DESC( dim) * sizeof( intptr_t)))
#endif 
#endif 


#define SAC_DESC_RC_MODE_LOCAL 0

#define SAC_DESC_RC_MODE_ASYNC 1

#define SAC_DESC_RC_MODE_NORC 2 

#define SAC_DESC_RC_MODE_OTHER 3

#define SAC_RC_PTR_MASK (3)
#define SAC_RC_PTR_NEG_MASK (-1 ^ SAC_RC_PTR_MASK)
#define SAC_DESC_HIDDEN_NONE 0
#define SAC_DESC_HIDDEN_HIDDEN 1
#define SAC_DESC_HIDDEN_NESTED 2

#define DESC_OFFSET_RC 0
#define DESC_OFFSET_PARENT 1
#define DESC_OFFSET_RC_MODE 2
#define DESC_OFFSET_DIM 3
#define DESC_OFFSET_SIZE 4
#define DESC_OFFSET_HIDDEN_TYPE 5
#if SAC_DO_DISTMEM
#define DESC_OFFSET_IS_DIST 6
#define DESC_OFFSET_OFFS 7
#define DESC_OFFSET_FIRST_ELEMS 8
#endif 
#define DESC_OFFSET_SHAPE FIXED_SIZE_OF_DESC

#define PARDESC_OFFSET_NCHILD 0

#if ( SAC_RC_METHOD == SAC_RCM_local_norc_ptr)  || ( SAC_RC_METHOD == SAC_RCM_async_norc_ptr)  || ( SAC_RC_METHOD == SAC_RCM_local_async_norc_ptr)  || ( SAC_RC_METHOD == SAC_RCM_SAC_local_async_norc_ptr)
#if 0 
#define SAC_READ_DESC_POINTER( desc, offset)  ({  intptr_t result;  asm ("ldq_u %0, %2(%1)"  : "=r"(result)  : "r"(desc) , "I" (offset*sizeof(*b)));  result;  })
#define SAC_WRITE_DESC_POINTER( desc, offset, value)  ({  asm ("ldq_u %0, %2(%1)"  :  :"=r"(value), "r"(desc) , "I" (offset*sizeof(*b)));  })
#define SAC_DESC_HIDDEN_DATA( desc) (((intptr_t)desc) & SAC_RC_PTR_MASK)
#define SAC_DESC_SET_HIDDEN_DATA( desc, val) desc = (SAC_array_descriptor_t*) ( ((intptr_t) desc) & val)
#else 
#define SAC_REAL_DESC( desc)  ((SAC_array_descriptor_t)(((intptr_t)desc) & SAC_RC_PTR_NEG_MASK))
#define SAC_DESC_HIDDEN_DATA( desc) (((intptr_t)desc) & SAC_RC_PTR_MASK)
#define SAC_DESC_SET_HIDDEN_DATA( desc, val) desc = (SAC_array_descriptor_t) ( (((intptr_t) desc) & SAC_RC_PTR_NEG_MASK) | val)
#endif
#else
#define SAC_REAL_DESC( desc) (desc)
#define SAC_DESC_HIDDEN_DATA( desc) 0
#endif
#define SAC_REAL_DESC_POINTER( desc, offset) (SAC_REAL_DESC(desc)[offset])
#define DESC_RC( desc)  SAC_REAL_DESC_POINTER(desc, DESC_OFFSET_RC)
#define DESC_PARENT( desc)  SAC_REAL_DESC_POINTER(desc, DESC_OFFSET_PARENT)
#define DESC_RC_MODE( desc)  SAC_REAL_DESC_POINTER(desc, DESC_OFFSET_RC_MODE)
#define DESC_DIM( desc)  SAC_REAL_DESC_POINTER(desc, DESC_OFFSET_DIM)
#define DESC_SIZE( desc)  SAC_REAL_DESC_POINTER(desc, DESC_OFFSET_SIZE)
#define DESC_HIDDEN_TYPE( desc)  SAC_REAL_DESC_POINTER(desc, DESC_OFFSET_HIDDEN_TYPE)
#define DESC_SHAPE( desc, pos)  SAC_REAL_DESC_POINTER(desc, (DESC_OFFSET_SHAPE + (pos)))
#if SAC_DO_DISTMEM
#define DESC_IS_DIST( desc)  SAC_REAL_DESC_POINTER(desc, DESC_OFFSET_IS_DIST)
#define DESC_OFFS( desc)  SAC_REAL_DESC_POINTER(desc, DESC_OFFSET_OFFS)
#define DESC_FIRST_ELEMS( desc)  SAC_REAL_DESC_POINTER(desc, DESC_OFFSET_FIRST_ELEMS)
#define DESC_PTR( desc, dims, rank)  SAC_REAL_DESC_POINTER(desc, (DESC_OFFSET_SHAPE + (dims) + (rank)))
#endif 

#define PARENT_DESC_NCHILD(desc)  (((SAC_ND_DESC_PARENT_TYPE)(desc))[PARDESC_OFFSET_NCHILD])

#define SAC_ND_DEF_FUN_BEGIN2( name, type, ...)  SAC_ND_DECL_FUN2(name, type, __VA_ARGS__){

#define SAC_ND_FUN_DEF_END2(...) }

#define SAC_ND_DECL_FUN2( name, type, ...)  type name( __VA_ARGS__)

#define SAC_ND_FUNAP2( name, ...) name(__VA_ARGS__);

#define SAC_ND_GETVAR( nt, name) name

#define SAC_ND_GETVAR_INOUT( nt, name) SAC_ND_GETVAR( nt, name)

#define SAC_ND_REAL_PARAM( type, name, var_NT) type name

#define SAC_ND_REAL_ARG( name, var_NT, type) name

#define SAC_ND_REAL_ARG_out( name, var_NT, type) name

#define SAC_INIT_LOCAL_MEM()

#define SAC_CLEANUP_LOCAL_MEM()

#define SAC_ND_PRF_RESTORERC( array, desc)

#define SAC_ND_PRF_2NORC( desc, array)
#define SAC_NOP(...) 

#define SAC_ND_A_RC_T_MODE( var_NT)  SAC_RC_T_MODE( SAC_ND_A_FIELD( var_NT))
#define SAC_ND_A_RC_T_RC( var_NT)  SAC_RC_T_RC( SAC_ND_A_FIELD( var_NT))

#define SAC_NT_CBASETYPE__INT( var_NT)  int
#define SAC_NT_CBASETYPE__FLO( var_NT)  float
#define SAC_NT_CBASETYPE__DOU( var_NT)  double
#define SAC_NT_CBASETYPE__UCH( var_NT)  unsigned char
#define SAC_NT_CBASETYPE__BOO( var_NT)  bool
#define SAC_NT_CBASETYPE__BYT( var_NT)  byte
#define SAC_NT_CBASETYPE__SHO( var_NT)  short
#define SAC_NT_CBASETYPE__LON( var_NT)  long
#define SAC_NT_CBASETYPE__LLO( var_NT)  longlong
#define SAC_NT_CBASETYPE__UBY( var_NT)  ubyte
#define SAC_NT_CBASETYPE__USH( var_NT)  ushort
#define SAC_NT_CBASETYPE__UIN( var_NT)  uint
#define SAC_NT_CBASETYPE__ULO( var_NT)  ulong
#define SAC_NT_CBASETYPE__ULL( var_NT)  ulonglong
#define SAC_NT_CBASETYPE__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_NT_PRINT_CBASETYPE__INT( var_NT)  "%d"
#define SAC_NT_PRINT_CBASETYPE__FLO( var_NT)  "%f"
#define SAC_NT_PRINT_CBASETYPE__DOU( var_NT)  "%f"
#define SAC_NT_PRINT_CBASETYPE__UCH( var_NT)  "%hhu"
#define SAC_NT_PRINT_CBASETYPE__BOO( var_NT)  "%d"
#define SAC_NT_PRINT_CBASETYPE__BYT( var_NT)  "%hhd"
#define SAC_NT_PRINT_CBASETYPE__SHO( var_NT)  "%hd"
#define SAC_NT_PRINT_CBASETYPE__LON( var_NT)  "%ld"
#define SAC_NT_PRINT_CBASETYPE__LLO( var_NT)  "%lld"
#define SAC_NT_PRINT_CBASETYPE__UBY( var_NT)  "%hhu"
#define SAC_NT_PRINT_CBASETYPE__USH( var_NT)  "%hu"
#define SAC_NT_PRINT_CBASETYPE__UIN( var_NT)  "%u"
#define SAC_NT_PRINT_CBASETYPE__ULO( var_NT)  "%lu"
#define SAC_NT_PRINT_CBASETYPE__ULL( var_NT)  "%llu"
#define SAC_NT_PRINT_CBASETYPE__UNDEF( var_NT)


#define SAC_ND_A_DESC__UNDEF( var_NT)  SAC_ICM_UNDEF()
#define SAC_ND_A_DESC__NULL( var_NT)  NULL
#define SAC_ND_A_DESC__DEFAULT( var_NT)  SAC_ND_GETVAR( var_NT, SAC_ND_A_DESC_NAME( var_NT))
#define SAC_ND_A_DESC_NAME__UNDEF( var_NT)  SAC_ICM_UNDEF()
#define SAC_ND_A_DESC_NAME__DEFAULT( var_NT)  CAT5( NT_NAME( var_NT), __desc)
#define SAC_ND_A_DESC_RC_MODE( var_NT)  DESC_RC_MODE( SAC_ND_A_DESC( var_NT))

#define SAC_ND_A_DESC_PARENT( var_NT)  ((SAC_ND_DESC_PARENT_TYPE) DESC_PARENT( SAC_ND_A_DESC( var_NT)))

#define SAC_ND_A_DESC_DIM__DEFAULT( var_NT)  DESC_DIM( SAC_ND_A_DESC( var_NT))
#define SAC_ND_A_DESC_DIM__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_DESC_SIZE__DEFAULT( var_NT)  DESC_SIZE( SAC_ND_A_DESC( var_NT))
#define SAC_ND_A_DESC_SIZE__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_DESC_SHAPE__DEFAULT( var_NT, dim)  DESC_SHAPE( SAC_ND_A_DESC( var_NT), dim)
#define SAC_ND_A_DESC_SHAPE__UNDEF( var_NT, dim)  SAC_ICM_UNDEF()
#if SAC_DO_DISTMEM

#define SAC_ND_A_DESC_IS_DIST__DEFAULT( var_NT)  DESC_IS_DIST( SAC_ND_A_DESC( var_NT))
#define SAC_ND_A_DESC_IS_DIST__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_DESC_OFFS__DEFAULT( var_NT)  DESC_OFFS( SAC_ND_A_DESC( var_NT))
#define SAC_ND_A_DESC_OFFS__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_DESC_FIRST_ELEMS__DEFAULT( var_NT)  DESC_FIRST_ELEMS( SAC_ND_A_DESC( var_NT))
#define SAC_ND_A_DESC_FIRST_ELEMS__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_DESC_PTR__DEFAULT( var_NT, rank)  DESC_PTR( SAC_ND_A_DESC( var_NT), SAC_ND_A_DIM( var_NT), rank)
#define SAC_ND_A_DESC_PTR__UNDEF( var_NT, rank)  SAC_ICM_UNDEF()
#endif 

#define SAC_ND_A_MIRROR_DIM__SCL( var_NT)  0
#define SAC_ND_A_MIRROR_DIM__DEFAULT( var_NT)  CAT12( NT_NAME( var_NT), __dim)

#define SAC_ND_A_MIRROR_SIZE__SCL( var_NT)  1
#define SAC_ND_A_MIRROR_SIZE__DEFAULT( var_NT)  CAT12( NT_NAME( var_NT), __sz)

#define SAC_ND_A_MIRROR_SHAPE__DEFAULT( var_NT, dim)  CAT12( NT_NAME( var_NT), CAT20( __shp, dim))
#define SAC_ND_A_MIRROR_SHAPE__UNDEF( var_NT, dim)  SAC_ICM_UNDEF()
#if SAC_DO_DISTMEM

#define SAC_ND_A_MIRROR_IS_DIST__DEFAULT( var_NT)  CAT12( NT_NAME( var_NT), __dm_isDist)
#define SAC_ND_A_MIRROR_IS_DIST__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_MIRROR_OFFS__DEFAULT( var_NT)  CAT12( NT_NAME( var_NT), __dm_offs)
#define SAC_ND_A_MIRROR_OFFS__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_MIRROR_FIRST_ELEMS__DEFAULT( var_NT)  CAT12( NT_NAME( var_NT), __dm_firstElems)
#define SAC_ND_A_MIRROR_FIRST_ELEMS__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_MIRROR_LOCAL_FROM__DEFAULT( var_NT)  CAT12( NT_NAME( var_NT), __dm_localFrom)
#define SAC_ND_A_MIRROR_LOCAL_FROM__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_MIRROR_LOCAL_COUNT__DEFAULT( var_NT)  CAT12( NT_NAME( var_NT), __dm_localCount)
#define SAC_ND_A_MIRROR_LOCAL_COUNT__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_MIRROR_PTR_CACHE__DEFAULT( var_NT)  CAT12( NT_NAME( var_NT), __dm_ptrCache)
#define SAC_ND_A_MIRROR_PTR_CACHE__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_MIRROR_PTR_CACHE_FROM__DEFAULT( var_NT)  CAT12( NT_NAME( var_NT), __dm_ptrCacheFrom)
#define SAC_ND_A_MIRROR_PTR_CACHE_FROM__UNDEF( var_NT)  SAC_ICM_UNDEF()

#define SAC_ND_A_MIRROR_PTR_CACHE_COUNT__DEFAULT( var_NT)  CAT12( NT_NAME( var_NT), __dm_ptrCacheCount)
#define SAC_ND_A_MIRROR_PTR_CACHE_COUNT__UNDEF( var_NT)  SAC_ICM_UNDEF()
#endif 

#define SAC_ND_A_FIELD__DEFAULT( var_NT)  NT_NAME( var_NT)
#define SAC_ND_A_FIELD__BOXED( var_NT)  *SAC_ND_A_FIELD( var_NT)

#define SAC_ND_A_DIM__DEFAULT( var_NT)  SAC_ND_A_MIRROR_DIM( var_NT)

#define SAC_ND_A_SIZE__DEFAULT( var_NT)  SAC_ND_A_MIRROR_SIZE( var_NT)

#define SAC_ND_A_SHAPE__SCL( var_NT, dim)  (-1) 

#define SAC_ND_A_SHAPE__AKS_AKD( var_NT, dim)  SAC_ND_A_MIRROR_SHAPE( var_NT, dim)
#define SAC_ND_A_SHAPE__AUD( var_NT, dim)  SAC_ND_A_DESC_SHAPE( var_NT, dim)
#if SAC_DO_DISTMEM

#define SAC_ND_A_IS_DIST__DIS_DSM( var_NT)  SAC_ND_A_MIRROR_IS_DIST( var_NT)
#define SAC_ND_A_IS_DIST__DEFAULT( var_NT)  FALSE

#define SAC_ND_A_IS_DSM__DSM( var_NT)  SAC_ND_A_IS_DIST( var_NT)
#define SAC_ND_A_IS_DSM__DEFAULT( var_NT)  FALSE

#define SAC_ND_A_OFFS__DIS_DSM( var_NT)  SAC_ND_A_MIRROR_OFFS( var_NT)
#define SAC_ND_A_OFFS__DEFAULT( var_NT)  0

#define SAC_ND_A_FIRST_ELEMS__DIS( var_NT)  SAC_ND_A_MIRROR_FIRST_ELEMS( var_NT)
#define SAC_ND_A_FIRST_ELEMS__DEFAULT( var_NT)  0

#define SAC_ND_A_LOCAL_FROM__DIS( var_NT)  SAC_ND_A_MIRROR_LOCAL_FROM( var_NT)
#define SAC_ND_A_LOCAL_FROM__DEFAULT( var_NT)  0

#define SAC_ND_A_LOCAL_COUNT__DIS( var_NT)  SAC_ND_A_MIRROR_LOCAL_COUNT( var_NT)
#define SAC_ND_A_LOCAL_COUNT__DEFAULT( var_NT)  SAC_ND_A_SIZE( var_NT)
#endif 


#define SAC_ND_WRITE_READ( to_NT, to_pos, from_NT, from_pos) {  SAC_ND_WRITE( to_NT, to_pos) = SAC_ND_READ( from_NT, from_pos); }
#define SAC_ND_WRITE_READ_COPY__DEFAULT( to_NT, to_pos, from_NT, from_pos, copyfun)  SAC_ND_WRITE_COPY( to_NT, to_pos, SAC_ND_READ( from_NT, from_pos), copyfun)

#define SAC_ND_READ__SCL( from_NT, from_pos)  SAC_ND_GETVAR(from_NT, SAC_ND_A_FIELD( from_NT))

#define SAC_ND_READ__BITARRAY( from_NT, from_pos) (  SAC_TR_AA_PRINT( "read_bit", from_NT, from_pos)  SAC_BC_READ( from_NT, from_pos)  SAC_CS_READ_ARRAY( from_NT, from_pos)  SAC_ND_GETVAR(from_NT, SAC_ND_A_FIELD( from_NT))[from_pos] )
#define SAC_ND_READ__DEFAULT( from_NT, from_pos) (  SAC_TR_AA_PRINT( "read", from_NT, from_pos)  SAC_BC_READ( from_NT, from_pos)  SAC_DISTMEM_CHECK_IS_NON_DIST_ARR( from_NT)  SAC_CS_READ_ARRAY( from_NT, from_pos)  SAC_ND_GETVAR(from_NT, SAC_ND_A_FIELD( from_NT))[from_pos] )
#define SAC_ND_READ__DSM( from_NT, from_pos) (  SAC_TR_AA_FPRINT( "%s read", from_NT, from_pos,  SAC_ND_A_IS_DIST( from_NT) ? "DSM" : "Non-DSM")  SAC_BC_READ( from_NT, from_pos)  SAC_DISTMEM_CHECK_IS_DSM_ARR( from_NT)  SAC_CS_READ_ARRAY( from_NT, from_pos)  SAC_ND_GETVAR(from_NT, SAC_ND_A_FIELD( from_NT))[from_pos] )

#define SAC_ND_READ__DLO( from_NT, from_pos) (  SAC_TR_AA_FPRINT( "%s read", from_NT, from_pos,  SAC_ND_A_IS_DIST( from_NT) ? "DLO" : "Non-DLO")  SAC_BC_READ( from_NT, from_pos)  SAC_CS_READ_ARRAY( from_NT, from_pos)  SAC_DISTMEM_CHECK_LOCAL_READ_ALLOWED(  &(SAC_ND_GETVAR(from_NT, SAC_ND_A_FIELD( from_NT))[from_pos]),  from_NT, from_pos)  SAC_DISTMEM_AVOIDED_PTR_CALC_KNOWN_LOCAL_READ_EXPR( from_NT)  SAC_ND_GETVAR(from_NT, SAC_ND_A_FIELD( from_NT))[from_pos] )

#if SAC_DO_DISTMEM_PTR_CACHE
#define SAC_ND_READ__DIS_REMOTE( from_NT, from_pos)  ((unsigned)(from_pos - SAC_ND_A_MIRROR_PTR_CACHE_FROM( from_NT))  >= SAC_ND_A_MIRROR_PTR_CACHE_COUNT( from_NT))  ? (  SAC_DISTMEM_UPDATE_PTR_CACHE_EXPR( from_NT, from_pos)  ) : (  SAC_DISTMEM_AVOIDED_PTR_CALC_REMOTE_READ_EXPR()  0  ),  SAC_DISTMEM_CHECK_PTR_FROM_CACHE( from_NT, from_pos,  &(SAC_ND_A_MIRROR_PTR_CACHE(from_NT)[from_pos]))  SAC_DISTMEM_CHECK_READ_ALLOWED(  &(SAC_ND_A_MIRROR_PTR_CACHE(from_NT)[from_pos]),  from_NT, from_pos)  SAC_ND_A_MIRROR_PTR_CACHE( from_NT)[from_pos] 
#else 
#if SAC_DO_DISTMEM_PTR_DESC
#define SAC_ND_READ__DIS_REMOTE( from_NT, from_pos)  SAC_DISTMEM_CHECK_PTR_FROM_DESC( from_NT, from_pos,  SAC_DISTMEM_ELEM_DESC_POINTER( from_NT, from_pos))  SAC_DISTMEM_CHECK_READ_ALLOWED(  SAC_DISTMEM_ELEM_DESC_POINTER( from_NT, from_pos),  from_NT, from_pos)  *SAC_DISTMEM_ELEM_DESC_POINTER( from_NT, from_pos) 
#else 
#define SAC_ND_READ__DIS_REMOTE( from_NT, from_pos)  SAC_DISTMEM_CHECK_READ_ALLOWED(  _SAC_DISTMEM_ELEM_POINTER( SAC_ND_A_OFFS( from_NT),  SAC_NT_CBASETYPE( from_NT),  SAC_ND_A_FIRST_ELEMS( from_NT),  from_pos),  from_NT, from_pos)  *SAC_DISTMEM_ELEM_POINTER( SAC_ND_A_OFFS( from_NT),  SAC_NT_CBASETYPE( from_NT),  SAC_ND_A_FIRST_ELEMS( from_NT),  from_pos)  to_NT, to_pos) 
#endif 
#endif 
#define SAC_ND_READ__DIS( from_NT, from_pos) (  SAC_TR_AA_FPRINT( "%s read", from_NT, from_pos,  SAC_ND_A_IS_DIST( from_NT) ? "DIS" : "Non-DIS")  SAC_BC_READ( from_NT, from_pos)  SAC_CS_READ_ARRAY( from_NT, from_pos)  (  ((unsigned)(from_pos - SAC_ND_A_LOCAL_FROM( from_NT))  >= SAC_ND_A_LOCAL_COUNT( from_NT))  ? (  SAC_ND_READ__DIS_REMOTE( from_NT, from_pos)  ) : (  SAC_DISTMEM_CHECK_READ_ALLOWED(  &(SAC_ND_GETVAR(from_NT, SAC_ND_A_FIELD( from_NT))[from_pos]),  from_NT, from_pos)  SAC_DISTMEM_AVOIDED_PTR_CALC_LOCAL_READ_EXPR( from_NT)  SAC_ND_GETVAR(from_NT, SAC_ND_A_FIELD( from_NT))[from_pos]  )  ) )

#define SAC_ND_WRITE__SCL( to_NT, to_pos)  SAC_ND_GETVAR(to_NT, SAC_ND_A_FIELD( to_NT))

#define SAC_ND_WRITE__BITARRAY( to_NT, to_pos)  SAC_TR_AA_PRINT( "write_bit", to_NT, to_pos)  SAC_BC_WRITE( to_NT, to_pos)  SAC_CS_WRITE_ARRAY( to_NT, to_pos)  SAC_ND_GETVAR(to_NT, SAC_ND_A_FIELD( to_NT))[to_pos]
#define SAC_ND_WRITE__DEFAULT( to_NT, to_pos)  SAC_TR_AA_PRINT( "write", to_NT, to_pos)  SAC_BC_WRITE( to_NT, to_pos)  SAC_DISTMEM_CHECK_IS_NON_DIST_ARR( to_NT)  SAC_CS_WRITE_ARRAY( to_NT, to_pos)  SAC_ND_GETVAR(to_NT, SAC_ND_A_FIELD( to_NT))[to_pos]
#define SAC_ND_WRITE__DSM( to_NT, to_pos)  SAC_TR_AA_FPRINT( "%s write", to_NT, to_pos,  SAC_ND_A_IS_DIST( to_NT) ? "DSM" : "Non-DSM")  SAC_BC_WRITE( to_NT, to_pos)  SAC_DISTMEM_CHECK_IS_DSM_ARR( to_NT)  SAC_CS_WRITE_ARRAY( to_NT, to_pos)  SAC_ND_GETVAR(to_NT, SAC_ND_A_FIELD( to_NT))[to_pos]

#define SAC_ND_WRITE__DIS( to_NT, to_pos)  SAC_TR_AA_FPRINT( "%s write", to_NT, to_pos,  SAC_ND_A_IS_DIST( to_NT) ? "DIS" : "Non-DIS")  SAC_BC_WRITE( to_NT, to_pos)  SAC_CS_WRITE_ARRAY( to_NT, to_pos)  SAC_DISTMEM_AVOIDED_PTR_CALC_LOCAL_WRITE_EXPR()  SAC_DISTMEM_CHECK_WRITE_ALLOWED(  _SAC_DISTMEM_ELEM_POINTER( SAC_ND_A_OFFS( to_NT),  SAC_NT_CBASETYPE( to_NT),  SAC_ND_A_FIRST_ELEMS( to_NT),  to_pos),  to_NT, to_pos)  SAC_ND_GETVAR(to_NT, SAC_ND_A_FIELD( to_NT))[to_pos]

#define SAC_ND_WRITE__DCA( to_NT, to_pos)  SAC_TR_AA_PRINT( "DCA write", to_NT, to_pos)  SAC_BC_WRITE( to_NT, to_pos)  SAC_CS_WRITE_ARRAY( to_NT, to_pos)  SAC_DISTMEM_CHECK_WRITE_ALLOWED(  _SAC_DISTMEM_ELEM_POINTER( SAC_ND_A_OFFS( to_NT),  SAC_NT_CBASETYPE( to_NT),  SAC_ND_A_FIRST_ELEMS( to_NT),  to_pos),  to_NT, to_pos)  *SAC_DISTMEM_ELEM_POINTER( SAC_ND_A_OFFS( to_NT),  SAC_NT_CBASETYPE( to_NT),  SAC_ND_A_FIRST_ELEMS( to_NT),  to_pos) 

#define SAC_ND_WRITE_COPY__NHD( to_NT, to_pos, expr, copyfun) {  SAC_ND_WRITE( to_NT, to_pos) = expr; }
#define SAC_ND_WRITE_COPY__HID( to_NT, to_pos, expr, copyfun) {  SAC_ND_WRITE( to_NT, to_pos) = copyfun( expr);  SAC_TR_MEM_PRINT( ("new hidden object at addr: %p",  SAC_ND_READ( to_NT, to_pos)))  SAC_TR_INC_HIDDEN_MEMCNT( 1) }

#define SAC_ND_TYPE_NT( basetype_NT)  SAC_ND_TYPE(basetype_NT, NT_NAME( basetype_NT))

#define SAC_ND_DESC_TYPE__DEFAULT( var_NT)  SAC_array_descriptor_t
#define SAC_ND_DESC_BASETYPE( var_NT) intptr_t
#define SAC_ND_DESC_PARENT_TYPE  SAC_array_descriptor_parent_t
#define SAC_ND_DESC_PARENT_BASETYPE intptr_t

#define SAC_ND_TYPE_TAG__SCL( var_NT, basetype)  SAC_ND_TYPE__SCL( basetype)
#define SAC_ND_TYPE_TAG__DEFAULT( var_NT, basetype)  SAC_ND_TYPE__AKS( basetype)

#define SAC_ND_TYPE__SCL( basetype)  basetype
#define SAC_ND_TYPE__AKS( basetype)  basetype *
#define SAC_ND_TYPE__AKD( basetype)  SAC_ND_TYPE__AKS( basetype)
#define SAC_ND_TYPE__AUD( basetype)  SAC_ND_TYPE__AKS( basetype)

#define SAC_ND_TYPEDEF__HID( var_NT, basetype)  typedef  SAC_ND_TYPE( var_NT, SAC_hidden)  NT_NAME( var_NT);
#define SAC_ND_TYPEDEF__DEFAULT( var_NT, basetype)  typedef  SAC_ND_TYPE( var_NT, basetype)  NT_NAME( var_NT);








#define SAC_ND_DECL__DATA( var_NT, basetype, decoration)  SAC_ND_DECL__DATA_##decoration( var_NT, basetype, decoration)
#define SAC_ND_DECL__DATA_extern( var_NT, basetype, decoration)  decoration SAC_ND_TYPE( var_NT, basetype) SAC_ND_A_FIELD( var_NT);
#define SAC_ND_DECL__DATA_( var_NT, basetype, decoration)  decoration SAC_ND_TYPE( var_NT, basetype) SAC_ND_A_FIELD( var_NT) ; 
#define SAC_ND_DECL_CONST__DATA( var_NT, basetype, val)  const SAC_ND_TYPE( var_NT, basetype) SAC_ND_A_FIELD( var_NT) = val;




#define SAC_ND_DECL__DESC__NONE( var_NT, decoration)  SAC_NOTHING()

#define SAC_ND_DECL__DESC__DEFAULT( var_NT, decoration)  SAC_ND_DECL__DESC__DEFAULT_##decoration( var_NT, decoration)
#define SAC_ND_DECL__DESC__DEFAULT_extern( var_NT, decoration)  decoration SAC_ND_DESC_TYPE( var_NT) SAC_ND_A_DESC( var_NT);
#define SAC_ND_DECL__DESC__DEFAULT_( var_NT, decoration)  decoration SAC_ND_DESC_TYPE( var_NT) SAC_ND_A_DESC( var_NT) = NULL;





#define SAC_NAMEP( name)  CAT0( name, __p)

#define SAC_ND_PARAM_( dummy, basetype)  basetype
#define SAC_ND_PARAM_in_nodesc( var_NT, basetype)  SAC_ND_REAL_PARAM(SAC_ND_TYPE( var_NT, basetype),  SAC_ND_A_FIELD( var_NT), var_NT)
#define SAC_ND_PARAM_in_justdesc( var_NT, type)  SAC_ND_REAL_PARAM( SAC_ND_DESC_TYPE( var_NT), SAC_ND_A_DESC_NAME( var_NT), var_NT)
#define SAC_ND_PARAM_out_nodesc( var_NT, basetype)  SAC_ND_REAL_PARAM(SAC_ND_TYPE( var_NT, basetype) *,  SAC_NAMEP( SAC_ND_A_FIELD( var_NT)),  SET_NT_REG( INT, var_NT))
#define SAC_ND_PARAM_inout( var_NT, basetype)  SAC_ND_PARAM_out( var_NT, basetype)
#define SAC_ND_PARAM_inout_nodesc( var_NT, basetype)  SAC_ND_PARAM_out_nodesc( var_NT, basetype)
#define SAC_ND_PARAM_inout_nodesc_bx( var_NT, basetype)  SAC_ND_PARAM_in_nodesc( var_NT, basetype)
#define SAC_ND_ARG_in_nodesc( var_NT, type)  SAC_ND_REAL_ARG( SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT)),  var_NT, SAC_ND_TYPE( var_NT, type))
#define SAC_ND_ARG_in_justdesc( var_NT, type)  SAC_ND_REAL_ARG( SAC_ND_A_DESC( var_NT), var_NT, SAC_ND_DESC_TYPE( var_NT))
#define SAC_ND_ARG_out_nodesc( var_NT, type)  SAC_ND_REAL_ARG_out( & SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT)),  var_NT, SAC_ND_TYPE( var_NT, type))
#define SAC_ND_ARG_inout( var_NT, type)  SAC_ND_ARG_out( var_NT, type)
#define SAC_ND_ARG_inout_nodesc( var_NT, type)  SAC_ND_ARG_out_nodesc( var_NT, type)
#define SAC_ND_ARG_inout_nodesc_bx( var_NT, type)  SAC_ND_ARG_in_nodesc( var_NT, type)
#define SAC_ND_RET_inout( retvar_NT, var_NT)  SAC_ND_RET_out( retvar_NT, var_NT)

#define SAC_ND_PARAM_in__NODESC( var_NT, basetype)  SAC_ND_PARAM_in_nodesc( var_NT, basetype)
#define SAC_ND_PARAM_in__DESC( var_NT, basetype)  SAC_ND_PARAM_in_nodesc( var_NT, basetype),  SAC_ND_REAL_PARAM( SAC_ND_DESC_TYPE( var_NT), SAC_ND_A_DESC_NAME( var_NT),  SET_NT_REG( INT, var_NT))

#define SAC_ND_PARAM_out__NODESC( var_NT, basetype)  SAC_ND_PARAM_out_nodesc( var_NT, basetype)
#define SAC_ND_PARAM_out__DESC( var_NT, basetype)  SAC_ND_PARAM_out_nodesc( var_NT, basetype),  SAC_ND_REAL_PARAM( SAC_ND_DESC_TYPE( var_NT) *,  SAC_NAMEP( SAC_ND_A_DESC_NAME( var_NT)),  SET_NT_REG( INT, var_NT))

#define SAC_ND_ARG_in__NODESC( var_NT, type)  SAC_ND_ARG_in_nodesc( var_NT, type)
#define SAC_ND_ARG_in__DESC( var_NT, type)  SAC_ND_ARG_in_nodesc( var_NT, type),  SAC_ND_REAL_ARG( SAC_ND_A_DESC( var_NT),  SET_NT_REG( INT, var_NT),  SAC_ND_DESC_TYPE( var_NT))

#define SAC_ND_ARG_out__NODESC( var_NT, type)  SAC_ND_ARG_out_nodesc( var_NT, type *)
#define SAC_ND_ARG_out__DESC( var_NT, type)  SAC_ND_ARG_out_nodesc( var_NT, type *),  SAC_ND_REAL_ARG_out( & SAC_ND_A_DESC( var_NT),  SET_NT_REG( INT, var_NT),  SAC_ND_DESC_TYPE( var_NT) *)

#define SAC_ND_RET_out__NODESC( retvar_NT, var_NT) {  * SAC_ND_GETVAR_INOUT( retvar_NT,  SAC_NAMEP( SAC_ND_A_FIELD( retvar_NT)))  = SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT)); }
#define SAC_ND_RET_out__DESC( retvar_NT, var_NT) {  * SAC_ND_GETVAR_INOUT( retvar_NT,  SAC_NAMEP( SAC_ND_A_FIELD( retvar_NT)))  = SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT));  * SAC_ND_GETVAR_INOUT( retvar_NT,  SAC_NAMEP( SAC_ND_A_DESC_NAME( retvar_NT)))  = SAC_ND_A_DESC( var_NT); }

#define SAC_ND_DECL_PARAM_inout__NODESC( var_NT, basetype)  SAC_ND_TYPE( var_NT, basetype)  SAC_ND_A_FIELD( var_NT)  = * SAC_ND_GETVAR_INOUT( var_NT, SAC_NAMEP( SAC_ND_A_FIELD( var_NT)));
#define SAC_ND_DECL_PARAM_inout__DESC( var_NT, basetype)  SAC_ND_TYPE( var_NT, basetype)  SAC_ND_A_FIELD( var_NT) = * SAC_ND_GETVAR_INOUT( var_NT, SAC_NAMEP( SAC_ND_A_FIELD( var_NT)));  SAC_ND_DESC_TYPE( var_NT)  SAC_ND_A_DESC( var_NT) = * SAC_ND_GETVAR_INOUT( var_NT, SAC_NAMEP( SAC_ND_A_DESC( var_NT)));






#define SAC_ND_ALLOC__DAO( var_NT, rc, dim, set_shape_icm) {  SAC_ND_ALLOC__DESC_AND_DATA( var_NT, dim)  SAC_ND_INIT__RC( var_NT, rc)  set_shape_icm }
#define SAC_ND_ALLOC__NO_DAO( var_NT, rc, dim, set_shape_icm) {  SAC_ND_ALLOC__DESC( var_NT, dim)  SAC_ND_INIT__RC( var_NT, rc)  set_shape_icm  SAC_ND_ALLOC__DATA( var_NT) }

#define SAC_ND_ALLOC_BEGIN__DAO( var_NT, rc, dim, basetype) {  SAC_ND_ALLOC__DESC_AND_DATA( var_NT,  dim,  basetype)  SAC_ND_INIT__RC( var_NT, rc)
#define SAC_ND_ALLOC_BEGIN__NO_DAO( var_NT, rc, dim, basetype) {  SAC_ND_ALLOC__DESC( var_NT, dim)  SAC_ND_INIT__RC( var_NT, rc)

#define SAC_ND_ALLOC_END__DAO( var_NT, rc, dim, basetype) }
#define SAC_ND_ALLOC_END__NO_DAO__DEFAULT( var_NT, rc, dim, basetype)  SAC_ND_ALLOC__DATA_BASETYPE( var_NT, basetype) }

#define SAC_ND_REALLOC_BEGIN__DAO( dest_NT, src_NT, rc, dim, basetype) {  SAC_ND_A_DESC( dest_NT) = SAC_ND_A_DESC( src_NT);  SAC_ND_A_FIELD( src_NT) =  SAC_ND_A_FIELD( dest_NT) =  realloc( SAC_ND_A_FIELD( src_NT),  (SAC_ND_A_SIZE( dest_NT)  * sizeof( * SAC_ND_A_FIELD( dest_NT))));  SAC_ND_SET__RC( dest_NT, rc) 
#define SAC_ND_REALLOC_BEGIN__NO_DAO( dest_NT, src_NT, rc, dim, basetype) {  SAC_ND_A_DESC( dest_NT) = SAC_ND_A_DESC( src_NT);  SAC_ND_SET__RC( dest_NT, rc) 

#define SAC_ND_REALLOC_END__DAO( dest_NT, src_NT, rc, dim, basetype) }
#define SAC_ND_REALLOC_END__NO_DAO( dest_NT, src_NT, rc, dim, basetype)  SAC_ND_A_FIELD( src_NT) =  SAC_ND_A_FIELD( dest_NT) =  realloc( SAC_ND_A_FIELD( src_NT),  (SAC_ND_A_SIZE( dest_NT)  * sizeof( * SAC_ND_A_FIELD( dest_NT)))); }

#define SAC_ND_ALLOC__DESC__NOOP( var_NT, dim)  SAC_NOOP()

#define SAC_ND_ALLOC__DESC__FIXED( var_NT, dim)  SAC_ND_ALLOC__DESC__FIXED_C99( var_NT, dim)

#define SAC_ND_ALLOC__DESC__FIXED_C99__DEFAULT( var_NT, dim) {  SAC_ASSURE_TYPE( (dim == SAC_ND_A_MIRROR_DIM( var_NT)),  ("Inconsistant dimension for array %s found!",  NT_STR( var_NT)));  SAC_HM_MALLOC_FIXED_SIZE( SAC_ND_A_DESC( var_NT),  BYTE_SIZE_OF_DESC( SAC_ND_A_MIRROR_DIM( var_NT)),  SAC_ND_DESC_BASETYPE( var_NT))  DESC_RC(SAC_ND_A_DESC( var_NT)) = 0;  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  DESC_PARENT( SAC_ND_A_DESC( var_NT)) = 0;  SAC_TR_MEM_PRINT( ("ND_ALLOC__DESC( %s, %s) at addr: %p",  NT_STR( var_NT), #dim, SAC_ND_A_DESC( var_NT))) }
#define SAC_ND_ALLOC__DESC__FIXED_C99__DIS( var_NT, dim) {  SAC_ASSURE_TYPE( (dim == SAC_ND_A_MIRROR_DIM( var_NT)),  ("Inconsistant dimension for array %s found!",  NT_STR( var_NT)));  SAC_HM_MALLOC_FIXED_SIZE( SAC_ND_A_DESC( var_NT),  BYTE_SIZE_OF_DIS_DESC( SAC_ND_A_IS_DIST( var_NT),  SAC_ND_A_MIRROR_DIM( var_NT)),  SAC_ND_DESC_BASETYPE( var_NT))  DESC_RC(SAC_ND_A_DESC( var_NT)) = 0;  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  DESC_PARENT( SAC_ND_A_DESC( var_NT)) = 0;  SAC_TR_MEM_PRINT( ("ND_ALLOC__DESC( %s, %s) at addr: %p",  NT_STR( var_NT), #dim, SAC_ND_A_DESC( var_NT))) }

#define SAC_ND_ALLOC__DESC__AUD( var_NT, dim)  SAC_ND_ALLOC__DESC__AUD_C99( var_NT, dim)

#define SAC_ND_ALLOC__DESC__AUD_C99__DEFAULT( var_NT, dim) {  SAC_ASSURE_TYPE( (dim >= 0),  ("Illegal dimension for array %s found!",  NT_STR( var_NT)));  SAC_HM_MALLOC( SAC_ND_A_DESC( var_NT),  BYTE_SIZE_OF_DESC( dim),  SAC_ND_DESC_BASETYPE( var_NT))  DESC_RC(SAC_ND_A_DESC( var_NT)) = 0;  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  DESC_PARENT( SAC_ND_A_DESC( var_NT)) = 0;  SAC_TR_MEM_PRINT( ("ND_ALLOC__DESC( %s, %s) at addr: %p",  NT_STR( var_NT), #dim, SAC_ND_A_DESC( var_NT)))  SAC_ND_A_DESC_DIM( var_NT) = SAC_ND_A_MIRROR_DIM( var_NT) = dim; }
#define SAC_ND_ALLOC__DESC__AUD_C99__DIS( var_NT, dim) {  SAC_ASSURE_TYPE( (dim >= 0),  ("Illegal dimension for array %s found!",  NT_STR( var_NT)));  SAC_HM_MALLOC( SAC_ND_A_DESC( var_NT),  BYTE_SIZE_OF_DIS_DESC( SAC_ND_A_IS_DIST( var_NT), dim), SAC_ND_DESC_BASETYPE( var_NT))  DESC_RC(SAC_ND_A_DESC( var_NT)) = 0;  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  DESC_PARENT( SAC_ND_A_DESC( var_NT)) = 0;  SAC_TR_MEM_PRINT( ("ND_ALLOC__DESC( %s, %s) at addr: %p",  NT_STR( var_NT), #dim, SAC_ND_A_DESC( var_NT)))  SAC_ND_A_DESC_DIM( var_NT) = SAC_ND_A_MIRROR_DIM( var_NT) = dim; }

#define SAC_DESC_ALLOC__DEFAULT( ndesc, dim) {  SAC_ASSURE_TYPE( (dim >= 0),  ("Illegal dimension for array %s found!",  NT_STR( var_NT)));  SAC_HM_MALLOC( ndesc,  BYTE_SIZE_OF_DESC( dim),  SAC_ND_DESC_BASETYPE( ndesc))  DESC_RC(ndesc) = 0;  DESC_RC_MODE( ndesc) = SAC_DESC_RC_MODE_LOCAL;  DESC_PARENT( ndesc) = 0;  DESC_DIM( ndesc) = dim; }
#define SAC_DESC_ALLOC__DIS( ndesc, dim) {  SAC_ASSURE_TYPE( (dim >= 0),  ("Illegal dimension for array %s found!",  NT_STR( var_NT)));  SAC_HM_MALLOC( ndesc,  BYTE_SIZE_OF_DIS_DESC( SAC_ND_A_IS_DIST( var_NT),  dim),  SAC_ND_DESC_BASETYPE( ndesc))  DESC_RC(ndesc) = 0;  DESC_RC_MODE( ndesc) = SAC_DESC_RC_MODE_LOCAL;  DESC_PARENT( ndesc) = 0;  DESC_DIM( ndesc) = dim; }
#define SAC_ND_ALLOC__DESC__PARENT( var_NT, dim)  SAC_HM_MALLOC_AS_SCALAR( DESC_PARENT( SAC_ND_A_DESC( var_NT)),  SAC_DESC_PARENT_T_SIZE,  SAC_ND_DESC_PARENT_BASETYPE)
#define SAC_DESC_ALLOC_PARENT( ndesc, dim)  SAC_HM_MALLOC_AS_SCALAR( DESC_PARENT( ndesc),  SAC_DESC_PARENT_T_SIZE,  SAC_ND_DESC_PARENT_BASETYPE)
#define SAC_ND_ALLOC__DESC__NOOP_BASETYPE( var_NT, dim, basetype)  SAC_ND_ALLOC__DESC__NOOP( var_NT, dim)
#define SAC_ND_ALLOC__DESC__FIXED_BASETYPE( var_NT, dim, basetype)  SAC_ND_ALLOC__DESC__FIXED( var_NT, dim)
#define SAC_ND_ALLOC__DESC__AUD_BASETYPE( var_NT, dim, basetype)  SAC_ND_ALLOC__DESC__AUD_C99( var_NT, dim)
#define SAC_ND_A_COPY_DESC( new, old)  SAC_ND_ALLOC__DESC( new, SAC_ND_A_DIM( old));  SAC_ND_A_COPY_OVER_DESC( new, old);
#define SAC_DESC_COPY_DESC( newd, oldd)  SAC_DESC_ALLOC( newd, DESC_DIM( oldd));  SAC_DESC_COPY_OVER_DESC( newd, oldd);
#define SAC_ND_A_COPY_OVER_DESC( new, old)  memcpy( SAC_ND_A_DESC( new),  SAC_ND_A_DESC( old),  BYTE_SIZE_OF_DESC( SAC_ND_A_DIM( old)));
#define SAC_DESC_COPY_OVER_DESC( newd, oldd)  memcpy( newd,  oldd,  BYTE_SIZE_OF_DESC( DESC_DIM( oldd)));
#define SAC_ND_ALLOC__DATA__NOOP( var_NT)  SAC_NOOP()
#define SAC_ND_ALLOC__DATA__AKS( var_NT) {  SAC_HM_MALLOC_FIXED_SIZE( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_SIZE( var_NT)  * sizeof( * SAC_ND_A_FIELD( var_NT)),  void)  SAC_TR_MEM_PRINT( ("ND_ALLOC__DATA( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)))  SAC_TR_INC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_REGISTER_ARRAY( var_NT) }
#define SAC_ND_ALLOC__DATA__AKD_AUD( var_NT) {  SAC_HM_MALLOC( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_SIZE( var_NT) * sizeof( * SAC_ND_A_FIELD( var_NT)),  void)  SAC_TR_MEM_PRINT( ("ND_ALLOC__DATA( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)))  SAC_TR_INC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_REGISTER_ARRAY( var_NT) }
#define SAC_ND_ALLOC__DATA__AKS_DIS( var_NT)  SAC_ND_ALLOC__DATA_BASETYPE__AKS_DIS( var_NT, SAC_NT_CBASETYPE( var_NT))
#define SAC_ND_ALLOC__DATA__AKD_AUD_DIS( var_NT)  SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD_DIS( var_NT, SAC_NT_CBASETYPE( var_NT))
#define SAC_ND_ALLOC__DATA_BASETYPE__NOOP( var_NT, basetype)  SAC_NOOP()
#define SAC_ND_ALLOC__DATA_BASETYPE__AKS( var_NT, basetype) {  SAC_HM_MALLOC_FIXED_SIZE( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_SIZE( var_NT)  * sizeof( * SAC_ND_A_FIELD( var_NT)),  basetype)  SAC_TR_MEM_PRINT( ("ND_ALLOC__DATA( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)))  SAC_TR_INC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_REGISTER_ARRAY( var_NT) }
#define SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD( var_NT, basetype) {  SAC_HM_MALLOC( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_SIZE( var_NT) * sizeof( * SAC_ND_A_FIELD( var_NT)),  basetype)  SAC_TR_MEM_PRINT( ("ND_ALLOC__DATA( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)))  SAC_TR_INC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_REGISTER_ARRAY( var_NT) }
#define SAC_ND_ALLOC__DATA_BASETYPE__AKS_DIS( var_NT, basetype) {  SAC_DISTMEM_RECHECK_IS_DIST( var_NT)  if (SAC_ND_A_IS_DIST( var_NT)) {  SAC_ND_A_DESC_FIRST_ELEMS( var_NT) =  SAC_ND_A_MIRROR_FIRST_ELEMS( var_NT) =  SAC_DISTMEM_DET_MAX_ELEMS_PER_NODE( SAC_ND_A_SIZE( var_NT),  SAC_ND_A_SHAPE( var_NT, 0));  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_MIRROR_FIRST_ELEMS( var_NT)  * sizeof( basetype),  basetype);  SAC_TR_MEM_PRINT( ("ND_ALLOC__DATA_DIS( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)))  SAC_TR_INC_ARRAY_MEMCNT( SAC_ND_A_FIRST_ELEMS( var_NT))  SAC_ND_A_DESC_OFFS( var_NT) = SAC_ND_A_MIRROR_OFFS( var_NT) =  SAC_DISTMEM_DET_OFFS( SAC_ND_A_FIELD( var_NT));  SAC_CS_REGISTER_ARRAY( var_NT)  SAC_DISTMEM_MOVE_PTR_FOR_WRITES( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT))  SAC_DISTMEM_INIT_PTR_DESC( var_NT)  } else {  SAC_ND_ALLOC__DATA_BASETYPE__AKS( var_NT, basetype)  }  SAC_ND_A_MIRROR_LOCAL_FROM( var_NT) = SAC_DISTMEM_DET_LOCAL_FROM( var_NT);  SAC_ND_A_MIRROR_LOCAL_COUNT( var_NT) = SAC_DISTMEM_DET_LOCAL_COUNT( var_NT); SAC_ND_A_MIRROR_PTR_CACHE_FROM( var_NT) = 0;  SAC_ND_A_MIRROR_PTR_CACHE_COUNT( var_NT) = 0; } 
#define SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD_DIS( var_NT, basetype) {  if (SAC_ND_A_IS_DIST( var_NT)) {  SAC_ND_A_DESC_FIRST_ELEMS( var_NT) =  SAC_ND_A_MIRROR_FIRST_ELEMS( var_NT) =  SAC_DISTMEM_DET_MAX_ELEMS_PER_NODE( SAC_ND_A_SIZE( var_NT),  SAC_ND_A_SHAPE( var_NT, 0)); SAC_DISTMEM_HM_MALLOC( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_MIRROR_FIRST_ELEMS( var_NT)  * sizeof( basetype),  basetype);  SAC_TR_MEM_PRINT( ("ND_ALLOC__DATA_DIS( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)))  SAC_TR_INC_ARRAY_MEMCNT( SAC_ND_A_FIRST_ELEMS( var_NT))  SAC_ND_A_DESC_OFFS( var_NT) = SAC_ND_A_MIRROR_OFFS( var_NT) =  SAC_DISTMEM_DET_OFFS( SAC_ND_A_FIELD( var_NT));  SAC_CS_REGISTER_ARRAY( var_NT)  SAC_DISTMEM_MOVE_PTR_FOR_WRITES( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT))  SAC_DISTMEM_INIT_PTR_DESC( var_NT)  } else {  SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD( var_NT, basetype)  }  SAC_ND_A_MIRROR_LOCAL_FROM( var_NT) = SAC_DISTMEM_DET_LOCAL_FROM( var_NT);  SAC_ND_A_MIRROR_LOCAL_COUNT( var_NT) = SAC_DISTMEM_DET_LOCAL_COUNT( var_NT); SAC_ND_A_MIRROR_PTR_CACHE_FROM( var_NT) = 0;  SAC_ND_A_MIRROR_PTR_CACHE_COUNT( var_NT) = 0; }

#define SAC_ND_ALLOC__DESC_AND_DATA__AKS( var_NT, dim, basetype) {  SAC_ASSURE_TYPE( (dim == SAC_ND_A_MIRROR_DIM( var_NT)),  ("Inconsistant dimension for array %s found!",  NT_STR( var_NT)));  SAC_HM_MALLOC_FIXED_SIZE_WITH_DESC( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_DESC( var_NT),  SAC_ND_A_MIRROR_SIZE( var_NT)  * sizeof( * SAC_ND_A_FIELD( var_NT)),  SAC_ND_A_MIRROR_DIM( var_NT),  basetype,  SAC_ND_DESC_BASETYPE( var_NT))  SAC_TR_MEM_PRINT( ("ND_ALLOC__DESC( %s, %s) at addr: %p",  NT_STR( var_NT), #dim, SAC_ND_A_DESC( var_NT)))  SAC_TR_MEM_PRINT( ("ND_ALLOC__DATA( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)))  SAC_TR_INC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_REGISTER_ARRAY( var_NT) }
#define SAC_ND_ALLOC__DESC_AND_DATA__AKS_DIS( var_NT, dim, basetype) {  SAC_DISTMEM_RECHECK_IS_DIST( var_NT)  if (SAC_ND_A_IS_DIST( var_NT)) {  SAC_ASSURE_TYPE( (dim == SAC_ND_A_MIRROR_DIM( var_NT)),  ("Inconsistant dimension for array %s found!",  NT_STR( var_NT)));  SAC_ND_A_MIRROR_FIRST_ELEMS( var_NT) =  SAC_DISTMEM_DET_MAX_ELEMS_PER_NODE( SAC_ND_A_SIZE( var_NT),  SAC_ND_A_SHAPE( var_NT, 0));  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_MIRROR_FIRST_ELEMS( var_NT)  * sizeof( basetype),  basetype);  SAC_HM_MALLOC_FIXED_SIZE(  SAC_ND_A_DESC( var_NT),  BYTE_SIZE_OF_DIS_DESC( TRUE, dim),  SAC_ND_DESC_BASETYPE( var_NT))  SAC_ND_A_DESC_FIRST_ELEMS( var_NT) = SAC_ND_A_MIRROR_FIRST_ELEMS( var_NT); SAC_TR_MEM_PRINT( ("ND_ALLOC__DESC( %s, %s) at addr: %p",  NT_STR( var_NT), #dim, SAC_ND_A_DESC( var_NT)))  SAC_TR_MEM_PRINT( ("ND_ALLOC__DATA( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)))  SAC_TR_INC_ARRAY_MEMCNT( SAC_ND_A_FIRST_ELEMS( var_NT))  SAC_ND_A_DESC_OFFS( var_NT) = SAC_ND_A_MIRROR_OFFS( var_NT) =  SAC_DISTMEM_DET_OFFS( SAC_ND_A_FIELD( var_NT));  SAC_DISTMEM_MOVE_PTR_FOR_WRITES( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT))  SAC_DISTMEM_INIT_PTR_DESC( var_NT)  SAC_CS_REGISTER_ARRAY( var_NT)  } else {  SAC_ND_ALLOC__DESC_AND_DATA__AKS( var_NT, dim, basetype)  }  SAC_ND_A_DESC_IS_DIST( var_NT) = SAC_ND_A_MIRROR_IS_DIST( var_NT);  SAC_ND_A_MIRROR_LOCAL_FROM( var_NT) = SAC_DISTMEM_DET_LOCAL_FROM( var_NT);  SAC_ND_A_MIRROR_LOCAL_COUNT( var_NT) = SAC_DISTMEM_DET_LOCAL_COUNT( var_NT); SAC_ND_A_MIRROR_PTR_CACHE_FROM( var_NT) = 0;  SAC_ND_A_MIRROR_PTR_CACHE_COUNT( var_NT) = 0; }
#define SAC_ND_ALLOC__DESC_AND_DATA__UNDEF( var_NT, dim, basetype)  SAC_ICM_UNDEF() ;

#define SAC_ND_FREE( var_NT, freefun) {  SAC_ND_FREE__DATA( var_NT, freefun)  SAC_ND_FREE__DESC( var_NT) }

#define SAC_ND_FREE__DESC__NOOP( var_NT)  SAC_NOOP()
#define SAC_ND_FREE__DESC__DEFAULT( var_NT) {  SAC_TR_MEM_PRINT( ("ND_FREE__DESC( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_DESC( var_NT)))  SAC_HM_FREE_DESC( SAC_REAL_DESC( SAC_ND_A_DESC( var_NT))) }

#define SAC_ND_FREE__DATA__SCL_NHD( var_NT, freefun)  SAC_NOOP()
#define SAC_ND_FREE__DATA__SCL_HID( var_NT, freefun) {  SAC_TR_MEM_PRINT( ("ND_FREE__DATA( %s, %s) at addr: %p",  NT_STR( var_NT), #freefun, SAC_ND_A_FIELD( var_NT)))  freefun( SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT)));  SAC_TR_DEC_HIDDEN_MEMCNT( 1) }
#define SAC_ND_FREE__DATA__AKS_NHD( var_NT, freefun) {  SAC_TR_MEM_PRINT( ("ND_FREE__DATA( %s, %s) at addr: %p",  NT_STR( var_NT), #freefun, SAC_ND_A_FIELD( var_NT)))  SAC_HM_FREE_FIXED_SIZE( SAC_ND_GETVAR(var_NT, SAC_ND_A_FIELD( var_NT)),  SAC_ND_A_SIZE( var_NT)  * sizeof( * SAC_ND_A_FIELD( var_NT)))  SAC_TR_DEC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_UNREGISTER_ARRAY( var_NT) }

#define SAC_ND_FREE__DATA__AKS_NHD_DIS( var_NT, freefun) {  if (SAC_ND_A_IS_DIST( var_NT)) {  SAC_DISTMEM_BARRIER();  SAC_TR_MEM_PRINT( ("ND_FREE__DATA_DIS( %s, %s) at addr: %p",  NT_STR( var_NT), #freefun, SAC_ND_A_FIELD( var_NT)))  SAC_DISTMEM_HM_FREE_FIXED_SIZE(  SAC_DISTMEM_GET_PTR_FOR_FREE(  SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT)),  SAC_ND_A_FIRST_ELEMS( var_NT)  ),  SAC_ND_A_FIRST_ELEMS( var_NT) * sizeof( * SAC_ND_A_FIELD( var_NT))  )  SAC_TR_DEC_ARRAY_MEMCNT( SAC_ND_A_FIRST_ELEMS( var_NT))  SAC_CS_UNREGISTER_ARRAY( var_NT)  } else {  SAC_ND_FREE__DATA__AKS_NHD( var_NT, freefun)  } }
#define SAC_ND_FREE__DATA__AKS_HID( var_NT, freefun) { int SAC_i;  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( var_NT); SAC_i++) {  freefun( SAC_ND_READ( var_NT, SAC_i));  }  SAC_ND_FREE__DATA__AKS_NHD( var_NT, freefun) }
#define SAC_ND_FREE__DATA__AKD_NHD( var_NT, freefun) {  SAC_TR_MEM_PRINT( ("ND_FREE__DATA( %s, %s) at addr: %p",  NT_STR( var_NT), #freefun, SAC_ND_A_FIELD( var_NT)))  SAC_HM_FREE(SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT)))  SAC_TR_DEC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_UNREGISTER_ARRAY( var_NT) }
#define SAC_ND_FREE__DATA__AKD_AUD_NHD_DIS( var_NT, freefun) {  if (SAC_ND_A_IS_DIST( var_NT)) {  SAC_DISTMEM_BARRIER();  SAC_TR_MEM_PRINT( ("ND_FREE__DATA_DIS( %s, %s) at addr: %p",  NT_STR( var_NT), #freefun, SAC_ND_A_FIELD( var_NT)))  SAC_DISTMEM_HM_FREE(  SAC_DISTMEM_GET_PTR_FOR_FREE(  SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT)),  SAC_ND_A_FIRST_ELEMS( var_NT)  )  )  SAC_TR_DEC_ARRAY_MEMCNT( SAC_ND_A_FIRST_ELEMS( var_NT))  SAC_CS_UNREGISTER_ARRAY( var_NT)  } else {  SAC_ND_FREE__DATA__AKD_NHD( var_NT, freefun)  } }
#define SAC_ND_PRINT_SHAPE__SCL( nt) {  SAC_Print( "[]\n"); } 
#define SAC_ND_PRINT_SHAPE__SHP( nt) {  SAC_Print( ( char*) SAC_PrintShape( SAC_ND_A_DESC( nt))); } 








#define SAC_ND_ASSIGN__DATA__UNDEF( to_NT, from_NT, copyfun)  SAC_ICM_UNDEF()
#define SAC_ND_ASSIGN__DATA__SCL_AUD( to_NT, from_NT, copyfun) {  SAC_ND_WRITE_READ_COPY( to_NT, 0, from_NT, 0, copyfun) }
#define SAC_ND_ASSIGN__DATA__SCL_AUD_UNQ( to_NT, from_NT, copyfun){  SAC_ND_WRITE_READ( to_NT, 0, from_NT, 0)    SAC_ND_FREE__DATA__AUD_NHD( from_NT, freefun) }
#define SAC_ND_ASSIGN__DATA__AKS_AKS( to_NT, from_NT, copyfun) {  SAC_ND_GETVAR( to_NT, SAC_ND_A_FIELD( to_NT))  = SAC_ND_GETVAR( from_NT, SAC_ND_A_FIELD( from_NT)); }
#define SAC_ND_ASSIGN__DATA__AUD_SCL_NHD( to_NT, from_NT, copyfun) {  SAC_ND_ALLOC__DATA( to_NT)  SAC_ND_WRITE_READ_COPY( to_NT, 0, from_NT, 0, copyfun) }
#define SAC_ND_ASSIGN__DATA__AUD_SCL_UNQ( to_NT, from_NT, copyfun) {  SAC_ND_ALLOC__DATA( to_NT)  SAC_ND_WRITE_READ( to_NT, 0, from_NT, 0); }
#define SAC_ND_ASSIGN__DATA__AUD_AKS( to_NT, from_NT, copyfun) {  SAC_ND_GETVAR( to_NT, SAC_ND_A_FIELD( to_NT)) =  SAC_ND_GETVAR( from_NT, SAC_ND_A_FIELD( from_NT)); }

#define SAC_ND_ASSIGN__DATA__TO_DIS( to_NT, from_NT, copyfun) {  if ( SAC_ND_A_IS_DIST( to_NT) && SAC_ND_A_IS_DIST( from_NT)) {  SAC_ND_GETVAR( to_NT, SAC_ND_A_FIELD( to_NT))  = SAC_ND_GETVAR( from_NT, SAC_ND_A_FIELD( from_NT));  SAC_ND_A_DESC_OFFS( to_NT) = SAC_ND_A_MIRROR_OFFS( to_NT) =  SAC_ND_A_OFFS( from_NT);  SAC_ND_A_DESC_FIRST_ELEMS( to_NT) = SAC_ND_A_MIRROR_FIRST_ELEMS( to_NT) =  SAC_ND_A_FIRST_ELEMS( from_NT);  SAC_DISTMEM_INIT_PTR_DESC( to_NT)  } else if ( SAC_ND_A_IS_DIST( to_NT) || SAC_ND_A_IS_DIST( from_NT)) {  SAC_ND_ALLOC__DATA( to_NT)  SAC_ND_COPY__DATA( to_NT, from_NT, copyfun)  } else {  SAC_ND_GETVAR( to_NT, SAC_ND_A_FIELD( to_NT)) =  SAC_ND_GETVAR( from_NT, SAC_ND_A_FIELD( from_NT));  }  SAC_ND_A_DESC_IS_DIST( to_NT) = SAC_ND_A_MIRROR_IS_DIST( to_NT);  SAC_ND_A_MIRROR_LOCAL_FROM( to_NT) = SAC_DISTMEM_DET_LOCAL_FROM( to_NT);  SAC_ND_A_MIRROR_LOCAL_COUNT( to_NT) = SAC_DISTMEM_DET_LOCAL_COUNT( to_NT);  SAC_ND_A_MIRROR_PTR_CACHE_FROM( to_NT) = 0;  SAC_ND_A_MIRROR_PTR_CACHE_COUNT( to_NT) = 0; }

#define SAC_ND_ASSIGN__DATA__TO_DSM( to_NT, from_NT, copyfun) {  if ( SAC_ND_A_IS_DIST( to_NT) && SAC_ND_A_IS_DIST( from_NT)) {  SAC_ND_GETVAR( to_NT, SAC_ND_A_FIELD( to_NT))  = SAC_ND_GETVAR( from_NT, SAC_ND_A_FIELD( from_NT));  SAC_ND_A_DESC_OFFS( to_NT) = SAC_ND_A_MIRROR_OFFS( to_NT) =  SAC_ND_A_OFFS( from_NT);  } else if ( SAC_ND_A_IS_DIST( to_NT) || SAC_ND_A_IS_DIST( from_NT)) {  SAC_ND_ALLOC__DATA( to_NT)  SAC_ND_COPY__DATA( to_NT, from_NT, copyfun)  } else {  SAC_ND_GETVAR( to_NT, SAC_ND_A_FIELD( to_NT)) =  SAC_ND_GETVAR( from_NT, SAC_ND_A_FIELD( from_NT));  } }
 
#define SAC_ND_ASSIGN__DATA__TO_NDI( to_NT, from_NT, copyfun) {  if ( SAC_ND_A_IS_DIST( from_NT)) {  SAC_ND_ALLOC__DATA( to_NT)  SAC_ND_COPY__DATA( to_NT, from_NT, copyfun)  } else {  SAC_ND_GETVAR( to_NT, SAC_ND_A_FIELD( to_NT)) =  SAC_ND_GETVAR( from_NT, SAC_ND_A_FIELD( from_NT));  } }


#define SAC_ND_COPY__DATA__SCL_SCL( to_NT, from_NT, copyfun) {  SAC_TR_MEM_PRINT( ("ND_COPY__DATA( %s, %s, %s)",  NT_STR( to_NT), #from_NT, #copyfun))  SAC_ND_WRITE_READ_COPY( to_NT, 0, from_NT, 0, copyfun) }
#define SAC_ND_COPY__DATA__SCL_ANY( to_NT, from_NT, copyfun) {  SAC_TR_MEM_PRINT( ("ND_COPY__DATA( %s, %s, %s)",  NT_STR( to_NT), #from_NT, #copyfun))  SAC_ASSURE_TYPE( (SAC_ND_A_DIM( from_NT) == 0),  ("Assignment with incompatible types found!"));  SAC_ND_WRITE_READ_COPY( to_NT, 0, from_NT, 0, copyfun) }
#define SAC_ND_COPY__DATA__ANY_SCL( to_NT, from_NT, copyfun) {  SAC_TR_MEM_PRINT( ("ND_COPY__DATA( %s, %s, %s)",  NT_STR( to_NT), #from_NT, #copyfun))  SAC_ASSURE_TYPE( (SAC_ND_A_DIM( to_NT) == 0),  ("Assignment with incompatible types found!"));  SAC_ND_WRITE_READ_COPY( to_NT, 0, from_NT, 0, copyfun) }
#define SAC_ND_COPY__DATA__ANY_ANY( to_NT, from_NT, copyfun) {  int SAC_i;  SAC_TR_MEM_PRINT( ("ND_COPY__DATA( %s, %s, %s) at addr: %p",  NT_STR( from_NT), #to_NT, #copyfun,  SAC_ND_A_FIELD( to_NT)))  SAC_ASSURE_TYPE( (SAC_ND_A_SIZE( to_NT) == SAC_ND_A_SIZE( from_NT)), ("Assignment with incompatible types found!"));  for (SAC_i = 0; SAC_i < SAC_ND_A_SIZE( from_NT); SAC_i++) {  SAC_ND_WRITE_READ_COPY( to_NT, SAC_i, from_NT, SAC_i, copyfun)  } }

#define SAC_ND_COPY__DATA__DIS_ANY( to_NT, from_NT, copyfun) {  int SAC_i;  SAC_TR_MEM_PRINT( ("ND_COPY__DATA%s( %s, %s, %s) at addr: %p",  SAC_ND_A_IS_DIST( to_NT) ? "_DIS" : "_NDI",  NT_STR( from_NT), #to_NT, #copyfun,  SAC_ND_A_FIELD( to_NT)))  SAC_ASSURE_TYPE( (SAC_ND_A_SIZE( to_NT) == SAC_ND_A_SIZE( from_NT)), ("Assignment with incompatible types found!"));  if ( SAC_ND_A_IS_DIST( to_NT)) {  SAC_DISTMEM_ALLOW_DIST_WRITES();  }  for (SAC_i = SAC_DISTMEM_DET_LOCAL_FROM( to_NT);  SAC_i <= SAC_DISTMEM_DET_LOCAL_TO( to_NT); SAC_i++) {  SAC_ND_WRITE_READ_COPY( to_NT, SAC_i, from_NT, SAC_i, copyfun)  }  if (SAC_ND_A_IS_DIST( to_NT)) {  SAC_DISTMEM_FORBID_DIST_WRITES();  SAC_DISTMEM_INVAL_CACHE( SAC_ND_A_OFFS( to_NT),  SAC_ND_A_FIRST_ELEMS( to_NT) * sizeof( SAC_NT_CBASETYPE( to_NT)));  SAC_DISTMEM_BARRIER();  } }
#define SAC_ND_COPY__DESC_SCL( to_NT, from_NT)
#define SAC_ND_COPY__DESC_AKS( to_NT, from_NT)  SAC_ND_A_COPY__DESC_SCL  SAC_ND_A_DESC_RC( to_NT) = SAC_ND_A_DESC_RC( from_NT);
#define SAC_ND_COPY__DESC_AKD( to_NT, from_NT)  SAC_ND_A_COPY__DESC_AKS( to_NT, from_NT)  SAC_ND_A_DESC_SIZE( to_NT) = SAC_ND_A_DESC_SIZE( from_NT);  {  int SAC_i;  for ( SAC_i=0; SAC_i < SAC_ND_A_DIM( from_NT); SAC_i++){  SAC_ND_A_DESC_SHAPE( to_NT) = SAC_ND_A_DESC_SHAPE( from_NT);  }  } 
#define SAC_ND_COPY__DESC_AUD( to_NT, from_NT)  SAC_ND_A_COPY__DESC_AKD( to_NT, from_NT)  SAC_ND_A_DESC_DIM( to_NT) = SAC_ND_A_DESC_DIM( from_NT); 

#define SAC_ND_CREATE__SCALAR__DATA( var_NT, val) {  SAC_ND_WRITE_COPY( var_NT, 0, val, ); }
#define SAC_ND_CREATE__STRING__DATA( var_NT, str) {  SAC_String2Array( SAC_ND_A_FIELD( var_NT), str); }






#define SAC_ND_SET__RC__NOOP( var_NT, rc)  SAC_NOOP()
#define SAC_ND_SET__RC__C99( var_NT, rc) {  SAC_TR_REF_PRINT( ("ND_SET__RC( %s, %d)", NT_STR( var_NT), rc))  SAC_ND_A_RC__C99( var_NT) = rc;  SAC_TR_REF_PRINT_RC( var_NT) }
#define SAC_DESC_SET__RC__C99( desc, rc) {  DESC_RC( var_NT) = rc; }

#define SAC_ND_INIT__RC__NOOP( var_NT, rc)  SAC_NOOP()
#define SAC_ND_INIT__RC__C99( var_NT, rc) {  SAC_TR_REF_PRINT( ("ND_INIT__RC( %s, %d)", NT_STR( var_NT), rc))  DESC_RC(SAC_ND_A_DESC( var_NT)) = rc;  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  DESC_PARENT( SAC_ND_A_DESC( var_NT)) = 0;  SAC_TR_REF_PRINT_RC( var_NT) }
#define SAC_DESC_INIT__RC__C99( desc, rc) {  DESC_RC(desc) = rc;  DESC_RC_MODE( desc) = SAC_DESC_RC_MODE_LOCAL;  DESC_PARENT( desc) = 0; }

#define SAC_ND_INC_RC__NOOP( var_NT, rc)  SAC_NOOP()
#define SAC_ND_INC_RC__C99( var_NT, rc) {  SAC_TR_REF_PRINT( ("ND_INC_RC( %s, %d)", NT_STR( var_NT), rc))  SAC_ND_A_RC__C99( var_NT) += rc;  SAC_TR_REF_PRINT_RC( var_NT) }
#define SAC_DESC_INC_RC__C99( desc, rc) {  DESC_RC( desc) += rc; }

#define SAC_ND_DEC_RC__NOOP( var_NT, rc)  SAC_NOOP()
#define SAC_ND_DEC_RC__C99( var_NT, rc) {  SAC_TR_REF_PRINT( ("ND_DEC_RC( %s, %d)", NT_STR( var_NT), rc))  SAC_ND_A_RC__C99( var_NT) -= rc;  SAC_TR_REF_PRINT_RC( var_NT) }
#define SAC_DESC_DEC_RC__C99( desc, rc) {  DESC_RC( desc) -= rc; }


#define SAC_ND_DEC_RC_FREE__UNQ( var_NT, rc, freefun)  SAC_ND_FREE( var_NT, freefun)
#define SAC_ND_DEC_RC_FREE__NOOP( var_NT, rc, freefun)  SAC_NOOP()
#define SAC_ND_DEC_RC_FREE__C99( var_NT, rc, freefun) {  SAC_TR_REF_PRINT( ("ND_DEC_RC_FREE( %s, %d, %s)",  NT_STR( var_NT), rc, #freefun))  if ((SAC_ND_A_RC__C99( var_NT) -= rc) == 0) {  SAC_TR_REF_PRINT_RC( var_NT)  SAC_ND_FREE( var_NT, freefun)  }  else {  SAC_TR_REF_PRINT_RC( var_NT)  } }
#define SAC_DESC_DEC_RC_FREE__C99( desc, rc, q_waslast) {  q_waslast = ((DESC_RC(desc) -= rc) == 0);  if (q_waslast) {  SAC_FREE( desc);  } }

#define SAC_ND_A_RC__UNDEF( var_NT)  SAC_ICM_UNDEF()
#define SAC_ND_A_RC__C99( var_NT)  DESC_RC( SAC_ND_A_DESC( var_NT))
#define SAC_DESC_A_RC__C99( desc)  DESC_RC( desc)
#if SAC_RC_METHOD == SAC_RCM_local

#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc)  SAC_ND_INIT__RC__C99( var_NT, rc)
#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun)  SAC_ND_DEC_RC_FREE__C99( var_NT, rc, freefun)
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc)  SAC_ND_SET__RC__C99( var_NT, rc)
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc)  SAC_ND_DEC_RC__C99( var_NT, rc)
#define SAC_ND_INC_RC__DEFAULT( var_NT, rc)  SAC_ND_INC_RC__C99( var_NT, rc)
#define SAC_ND_A_RC__DEFAULT( var_NT)  SAC_ND_A_RC__C99( var_NT)

#define SAC_DESC_INIT_RC( desc, rc)  SAC_DESC_INIT__RC__C99(desc, rc)
#define SAC_DESC_A_RC( desc)  SAC_DESC_A_RC__C99( desc)
#define SAC_DESC_INC_RC( desc, rc)  SAC_DESC_INC_RC__C99( desc, rc)
#define SAC_DESC_DEC_RC( desc, rc)  SAC_DESC_DEC_RC__C99( desc, rc)
#define SAC_DESC_DEC_RC_FREE( desc, rc, q_waslast)  SAC_DESC_DEC_RC_FREE__C99( desc, rc, q_waslast)
#define SAC_DESC_RC_GIVE_ASYNC( newd, arrayd)  newd = arrayd;
#endif
#include <stdint.h>
#define SAC_ND_INIT__RC__NORC( var_NT, rc) 
#define SAC_ND_DEC_RC_FREE__NORC( var_NT, rc, freefun)
#define SAC_ND_SET__RC__NORC( var_NT, rc)
#define SAC_ND_DEC_RC__NORC( var_NT, rc)
#define SAC_ND_INC_RC__NORC( var_NT, rc)
#define SAC_ND_A_RC__NORC( var_NT) INT_MAX
#define SAC_DESC_INIT__RC__NORC( desc, rc)
#define SAC_DESC_DEC_RC_FREE__NORC( desc, rc, q_waslast) { q_waslast = 0; }
#define SAC_DESC_SET__RC__NORC( desc, rc)
#define SAC_DESC_DEC_RC__NORC( desc, rc)
#define SAC_DESC_INC_RC__NORC( desc, rc)
#define SAC_DESC_A_RC__NORC( desc) INT_MAX
#if SAC_RC_METHOD == SAC_RCM_norc

#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc) SAC_ND_INIT__RC__NORC( var_NT, rc) 
#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) SAC_ND_DEC_RC_FREE__NORC( var_NT, rc, freefun)
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) SAC_ND_SET__RC__NORC( var_NT, rc)
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) SAC_ND_DEC_RC__NORC( var_NT, rc)
#define SAC_ND_INC_RC__DEFAULT( var_NT, rc) SAC_ND_INC_RC__NORC( var_NT, rc)
#define SAC_ND_A_RC__DEFAULT( var_NT) SAC_ND_A_RC__NORC( var_NT)
#endif

#define SAC_IS_LASTREF__BLOCK_ELSE( var_NT)  } else {
#define SAC_IS_LASTREF__BLOCK_END( var_NT)  }
#define SAC_IS_REUSED__BLOCK_ELSE( to_NT, from_NT)  } else {
#define SAC_IS_REUSED__BLOCK_END( to_NT, from_NT)  }

#define SAC_IS_LASTREF__BLOCK_BEGIN__UNQ( var_NT)  if (1) {
#define SAC_IS_LASTREF__BLOCK_BEGIN__SCL_NHD_NUQ( var_NT)  if (1) {
#define SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT( var_NT)  if (SAC_ND_A_RC( var_NT) == 1) {

#define SAC_IS_REUSED__BLOCK_BEGIN__SCL( to_NT, from_NT)  if (0) {
#ifdef DBUG_REUSE
#define SAC_IS_REUSED__BLOCK_BEGIN__DEFAULT( to_NT, from_NT)  if (SAC_ND_A_FIELD( to_NT) == SAC_ND_A_FIELD( from_NT)) {  fprintf( stderr, "REUSE DYNAMIC\n");
#else
#ifdef DBUG_NOREUSE
#define SAC_IS_REUSED__BLOCK_BEGIN__DEFAULT( to_NT, from_NT)  if (0) { 
#else
#define SAC_IS_REUSED__BLOCK_BEGIN__DEFAULT( to_NT, from_NT)  if (SAC_ND_A_FIELD( to_NT) == SAC_ND_A_FIELD( from_NT)) { 
#endif
#endif

#ifdef SAC_GENERATE_CLIBRARY

#define SAC_INITGLOBALOBJECT_BEGIN( varname)  if (! CAT1( SAC_INIT_FLAG_, varname)) {  CAT1( SAC_INIT_FLAG_, varname) = true;
#define SAC_INITGLOBALOBJECT_END()  }
#else

#define SAC_INITGLOBALOBJECT_BEGIN( varname )  SAC_NOTHING()
#define SAC_INITGLOBALOBJECT_END()  SAC_NOTHING()
#endif

#define SAC_IS_SHARED__BLOCK_BEGIN( va_NT, va_sdim, viv_NT, viv_sdim)  if ((SAC_ND_A_DESC_NULL( va_NT) != NULL)  && (SAC_ND_A_DESC_NULL( viv_NT) != NULL)  && (SAC_ND_A_DESC_NULL( va_NT) == SAC_ND_A_DESC_NULL( viv_NT))) {
#define SAC_IS_SHARED__BLOCK_END( va_NT, va_sdim, viv_NT, viv_sdim)  }


#define SAC_UPDATE_A_MIRROR_DIM__AUD( var_NT, val)  SAC_ND_A_MIRROR_DIM( var_NT) = val;
#define SAC_UPDATE_A_MIRROR_DIM__AKD( var_NT, val)
#define SAC_UPDATE_A_MIRROR_DIM__UNDEF( var_NT, val)  SAC_ICM_UNDEF()

#define SAC_A_DIM_BEFORE_UPDATE_MIRROR__AUD( var_NT)  SAC_ND_A_DESC_DIM( var_NT)
#define SAC_A_DIM_BEFORE_UPDATE_MIRROR__AKD( var_NT)  SAC_ND_A_DIM( var_NT)
#define SAC_A_DIM_BEFORE_UPDATE_MIRROR__UNDEF( var_NT)  SAC_ICM_UNDEF()
#endif 


#ifndef DEF_FILE_std_gen
#define DEF_FILE_std_gen
#define SAC_NT_CBASETYPE( nt ) CAT_M4_std_gen_1(SAC_NT_CBASETYPE_, NT_CBT(nt))( nt )
#define SAC_NT_CBASETYPE_INT(...) SAC_NT_CBASETYPE__INT(__VA_ARGS__)
#define SAC_NT_CBASETYPE_FLO(...) SAC_NT_CBASETYPE__FLO(__VA_ARGS__)
#define SAC_NT_CBASETYPE_DOU(...) SAC_NT_CBASETYPE__DOU(__VA_ARGS__)
#define SAC_NT_CBASETYPE_UCH(...) SAC_NT_CBASETYPE__UCH(__VA_ARGS__)
#define SAC_NT_CBASETYPE_BOO(...) SAC_NT_CBASETYPE__BOO(__VA_ARGS__)
#define SAC_NT_CBASETYPE_BYT(...) SAC_NT_CBASETYPE__BYT(__VA_ARGS__)
#define SAC_NT_CBASETYPE_SHO(...) SAC_NT_CBASETYPE__SHO(__VA_ARGS__)
#define SAC_NT_CBASETYPE_LON(...) SAC_NT_CBASETYPE__LON(__VA_ARGS__)
#define SAC_NT_CBASETYPE_LLO(...) SAC_NT_CBASETYPE__LLO(__VA_ARGS__)
#define SAC_NT_CBASETYPE_UBY(...) SAC_NT_CBASETYPE__UBY(__VA_ARGS__)
#define SAC_NT_CBASETYPE_USH(...) SAC_NT_CBASETYPE__USH(__VA_ARGS__)
#define SAC_NT_CBASETYPE_UIN(...) SAC_NT_CBASETYPE__UIN(__VA_ARGS__)
#define SAC_NT_CBASETYPE_ULO(...) SAC_NT_CBASETYPE__ULO(__VA_ARGS__)
#define SAC_NT_CBASETYPE_ULL(...) SAC_NT_CBASETYPE__ULL(__VA_ARGS__)
#define SAC_NT_CBASETYPE_OTH(...) SAC_NT_CBASETYPE__UNDEF(__VA_ARGS__)
#define SAC_NT_CBASETYPE____(...) SAC_NT_CBASETYPE__UNDEF(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE( nt ) CAT_M4_std_gen_2(SAC_NT_PRINT_CBASETYPE_, NT_CBT(nt))( nt )
#define SAC_NT_PRINT_CBASETYPE_INT(...) SAC_NT_PRINT_CBASETYPE__INT(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_FLO(...) SAC_NT_PRINT_CBASETYPE__FLO(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_DOU(...) SAC_NT_PRINT_CBASETYPE__DOU(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_UCH(...) SAC_NT_PRINT_CBASETYPE__UCH(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_BOO(...) SAC_NT_PRINT_CBASETYPE__BOO(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_BYT(...) SAC_NT_PRINT_CBASETYPE__BYT(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_SHO(...) SAC_NT_PRINT_CBASETYPE__SHO(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_LON(...) SAC_NT_PRINT_CBASETYPE__LON(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_LLO(...) SAC_NT_PRINT_CBASETYPE__LLO(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_UBY(...) SAC_NT_PRINT_CBASETYPE__UBY(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_USH(...) SAC_NT_PRINT_CBASETYPE__USH(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_UIN(...) SAC_NT_PRINT_CBASETYPE__UIN(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_ULO(...) SAC_NT_PRINT_CBASETYPE__ULO(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_ULL(...) SAC_NT_PRINT_CBASETYPE__ULL(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE_OTH(...) SAC_NT_PRINT_CBASETYPE__UNDEF(__VA_ARGS__)
#define SAC_NT_PRINT_CBASETYPE____(...) SAC_NT_PRINT_CBASETYPE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC( nt ) CAT_M4_std_gen_3(SAC_ND_A_DESC_, CAT_M4_std_gen_4(NT_SHP(nt), CAT_M4_std_gen_5(NT_HID(nt), NT_UNQ(nt))))( nt )
#define SAC_ND_A_DESC_SCLNHDNUQ(...) SAC_ND_A_DESC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SCLNHDUNQ(...) SAC_ND_A_DESC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SCLNHD___(...) SAC_ND_A_DESC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SCLHIDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_SCLHNSNUQ(...) SAC_ND_A_DESC_NESTED__SCL(__VA_ARGS__)
#define SAC_ND_A_DESC_SCLHIDUNQ(...) SAC_ND_A_DESC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SCLHNSUNQ(...) SAC_ND_A_DESC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SCL___UNQ(...) SAC_ND_A_DESC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_AKSNHDUNQ(...) SAC_ND_A_DESC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_AKSHIDUNQ(...) SAC_ND_A_DESC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_AKSHNSUNQ(...) SAC_ND_A_DESC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_AKS___UNQ(...) SAC_ND_A_DESC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SCLHID___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_SCLHNS___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_SCL___NUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_SCL______(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKSNHDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKSNHD___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKSHIDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKSHID___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKSHNSNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKSHNS___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKS___NUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKS______(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKDNHDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKDNHDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKDNHD___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKDHIDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKDHIDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKDHID___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKDHNSNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKDHNSUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKDHNS___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKD___NUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKD___UNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AKD______(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUDNHDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUDNHDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUDNHD___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUDHIDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUDHIDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUDHID___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUDHNSNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUDHNSUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUDHNS___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUD___NUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUD___UNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_AUD______(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC____NHDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC____NHDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC____NHD___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC____HIDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC____HIDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC____HID___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC____HNSNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC____HNSUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC____HNS___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_______NUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_______UNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC__________(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL( nt ) CAT_M4_std_gen_6(SAC_ND_A_DESC_NULL_, CAT_M4_std_gen_7(NT_SHP(nt), CAT_M4_std_gen_8(NT_HID(nt), NT_UNQ(nt))))( nt )
#define SAC_ND_A_DESC_NULL_SCLNHDNUQ(...) SAC_ND_A_DESC__NULL(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCLNHDUNQ(...) SAC_ND_A_DESC__NULL(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCLNHD___(...) SAC_ND_A_DESC__NULL(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCLHIDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCLHIDUNQ(...) SAC_ND_A_DESC__NULL(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCLHNSUNQ(...) SAC_ND_A_DESC__NULL(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCL___UNQ(...) SAC_ND_A_DESC__NULL(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKSNHDUNQ(...) SAC_ND_A_DESC__NULL(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKSHIDUNQ(...) SAC_ND_A_DESC__NULL(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKSHNSUNQ(...) SAC_ND_A_DESC__NULL(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKS___UNQ(...) SAC_ND_A_DESC__NULL(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCLHID___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCLHNSNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCLHNS___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCL___NUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_SCL______(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKSNHDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKSNHD___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKSHIDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKSHID___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKSHNSNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKSHNS___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKS___NUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKS______(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKDNHDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKDNHDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKDNHD___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKDHIDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKDHIDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKDHID___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKDHNSNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKDHNSUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKDHNS___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKD___NUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKD___UNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AKD______(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUDNHDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUDNHDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUDNHD___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUDHIDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUDHIDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUDHID___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUDHNSNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUDHNSUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUDHNS___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUD___NUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUD___UNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_AUD______(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL____NHDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL____NHDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL____NHD___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL____HIDNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL____HIDUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL____HID___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL____HNSNUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL____HNSUNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL____HNS___(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_______NUQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL_______UNQ(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NULL__________(...) SAC_ND_A_DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME( nt ) CAT_M4_std_gen_9(SAC_ND_A_DESC_NAME_, CAT_M4_std_gen_10(NT_SHP(nt), CAT_M4_std_gen_11(NT_HID(nt), NT_UNQ(nt))))( nt )
#define SAC_ND_A_DESC_NAME_SCLNHDNUQ(...) SAC_ND_A_DESC_NAME__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCLNHDUNQ(...) SAC_ND_A_DESC_NAME__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCLNHD___(...) SAC_ND_A_DESC_NAME__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCLHIDNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCLHIDUNQ(...) SAC_ND_A_DESC_NAME__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCLHNSUNQ(...) SAC_ND_A_DESC_NAME__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCL___UNQ(...) SAC_ND_A_DESC_NAME__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKSNHDUNQ(...) SAC_ND_A_DESC_NAME__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKSHIDUNQ(...) SAC_ND_A_DESC_NAME__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKSHNSUNQ(...) SAC_ND_A_DESC_NAME__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKS___UNQ(...) SAC_ND_A_DESC_NAME__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCLHID___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCLHNSNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCLHNS___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCL___NUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_SCL______(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKSNHDNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKSNHD___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKSHIDNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKSHID___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKSHNSNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKSHNS___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKS___NUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKS______(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKDNHDNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKDNHDUNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKDNHD___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKDHIDNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKDHIDUNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKDHID___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKDHNSNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKDHNSUNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKDHNS___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKD___NUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKD___UNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AKD______(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUDNHDNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUDNHDUNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUDNHD___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUDHIDNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUDHIDUNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUDHID___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUDHNSNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUDHNSUNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUDHNS___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUD___NUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUD___UNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_AUD______(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME____NHDNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME____NHDUNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME____NHD___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME____HIDNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME____HIDUNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME____HID___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME____HNSNUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME____HNSUNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME____HNS___(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_______NUQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME_______UNQ(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_NAME__________(...) SAC_ND_A_DESC_NAME__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_DIM( nt ) CAT_M4_std_gen_12(SAC_ND_A_DESC_DIM_, NT_SHP(nt))( nt )
#define SAC_ND_A_DESC_DIM_AUD(...) SAC_ND_A_DESC_DIM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_DIM_SCL(...) SAC_ND_A_DESC_DIM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_DIM_AKS(...) SAC_ND_A_DESC_DIM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_DIM_AKD(...) SAC_ND_A_DESC_DIM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_DIM____(...) SAC_ND_A_DESC_DIM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SIZE( nt ) CAT_M4_std_gen_13(SAC_ND_A_DESC_SIZE_, NT_SHP(nt))( nt )
#define SAC_ND_A_DESC_SIZE_AKD(...) SAC_ND_A_DESC_SIZE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_SIZE_AUD(...) SAC_ND_A_DESC_SIZE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_SIZE_SCL(...) SAC_ND_A_DESC_SIZE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SIZE_AKS(...) SAC_ND_A_DESC_SIZE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SIZE____(...) SAC_ND_A_DESC_SIZE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SHAPE( nt , gra1) CAT_M4_std_gen_14(SAC_ND_A_DESC_SHAPE_, NT_SHP(nt))( nt , gra1)
#define SAC_ND_A_DESC_SHAPE_AKD(...) SAC_ND_A_DESC_SHAPE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_SHAPE_AUD(...) SAC_ND_A_DESC_SHAPE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_SHAPE_SCL(...) SAC_ND_A_DESC_SHAPE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SHAPE_AKS(...) SAC_ND_A_DESC_SHAPE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_SHAPE____(...) SAC_ND_A_DESC_SHAPE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_IS_DIST( nt ) CAT_M4_std_gen_15(SAC_ND_A_DESC_IS_DIST_, NT_DIS(nt))( nt )
#define SAC_ND_A_DESC_IS_DIST_DIS(...) SAC_ND_A_DESC_IS_DIST__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_IS_DIST_DSM(...) SAC_ND_A_DESC_IS_DIST__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_IS_DIST_NDI(...) SAC_ND_A_DESC_IS_DIST__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_IS_DIST_DCA(...) SAC_ND_A_DESC_IS_DIST__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_IS_DIST_DLO(...) SAC_ND_A_DESC_IS_DIST__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_IS_DIST____(...) SAC_ND_A_DESC_IS_DIST__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_OFFS( nt ) CAT_M4_std_gen_16(SAC_ND_A_DESC_OFFS_, NT_SHP(nt))( nt )
#define SAC_ND_A_DESC_OFFS_AUD(...) SAC_ND_A_DESC_OFFS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_OFFS_AKS(...) SAC_ND_A_DESC_OFFS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_OFFS_AKD(...) SAC_ND_A_DESC_OFFS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_OFFS_SCL(...) SAC_ND_A_DESC_OFFS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_OFFS____(...) SAC_ND_A_DESC_OFFS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_FIRST_ELEMS( nt ) CAT_M4_std_gen_17(SAC_ND_A_DESC_FIRST_ELEMS_, NT_DIS(nt))( nt )
#define SAC_ND_A_DESC_FIRST_ELEMS_DIS(...) SAC_ND_A_DESC_FIRST_ELEMS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_FIRST_ELEMS_DSM(...) SAC_ND_A_DESC_FIRST_ELEMS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_FIRST_ELEMS_NDI(...) SAC_ND_A_DESC_FIRST_ELEMS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_FIRST_ELEMS_DCA(...) SAC_ND_A_DESC_FIRST_ELEMS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_FIRST_ELEMS_DLO(...) SAC_ND_A_DESC_FIRST_ELEMS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_FIRST_ELEMS____(...) SAC_ND_A_DESC_FIRST_ELEMS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_PTR( nt , gra1) CAT_M4_std_gen_18(SAC_ND_A_DESC_PTR_, NT_DIS(nt))( nt , gra1)
#define SAC_ND_A_DESC_PTR_DIS(...) SAC_ND_A_DESC_PTR__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DESC_PTR_DSM(...) SAC_ND_A_DESC_PTR__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_PTR_NDI(...) SAC_ND_A_DESC_PTR__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_PTR_DCA(...) SAC_ND_A_DESC_PTR__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_PTR_DLO(...) SAC_ND_A_DESC_PTR__UNDEF(__VA_ARGS__)
#define SAC_ND_A_DESC_PTR____(...) SAC_ND_A_DESC_PTR__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_DIM( nt ) CAT_M4_std_gen_19(SAC_ND_A_MIRROR_DIM_, NT_SHP(nt))( nt )
#define SAC_ND_A_MIRROR_DIM_SCL(...) SAC_ND_A_MIRROR_DIM__SCL(__VA_ARGS__)
#define SAC_ND_A_MIRROR_DIM_AKS(...) SAC_ND_A_MIRROR_DIM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_DIM_AKD(...) SAC_ND_A_MIRROR_DIM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_DIM_AUD(...) SAC_ND_A_MIRROR_DIM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_DIM____(...) SAC_ND_A_MIRROR_DIM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_SIZE( nt ) CAT_M4_std_gen_20(SAC_ND_A_MIRROR_SIZE_, NT_SHP(nt))( nt )
#define SAC_ND_A_MIRROR_SIZE_SCL(...) SAC_ND_A_MIRROR_SIZE__SCL(__VA_ARGS__)
#define SAC_ND_A_MIRROR_SIZE_AKS(...) SAC_ND_A_MIRROR_SIZE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_SIZE_AKD(...) SAC_ND_A_MIRROR_SIZE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_SIZE_AUD(...) SAC_ND_A_MIRROR_SIZE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_SIZE____(...) SAC_ND_A_MIRROR_SIZE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_SHAPE( nt , gra1) CAT_M4_std_gen_21(SAC_ND_A_MIRROR_SHAPE_, NT_SHP(nt))( nt , gra1)
#define SAC_ND_A_MIRROR_SHAPE_AKS(...) SAC_ND_A_MIRROR_SHAPE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_SHAPE_AKD(...) SAC_ND_A_MIRROR_SHAPE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_SHAPE_SCL(...) SAC_ND_A_MIRROR_SHAPE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_SHAPE_AUD(...) SAC_ND_A_MIRROR_SHAPE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_SHAPE____(...) SAC_ND_A_MIRROR_SHAPE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_IS_DIST( nt ) CAT_M4_std_gen_22(SAC_ND_A_MIRROR_IS_DIST_, NT_DIS(nt))( nt )
#define SAC_ND_A_MIRROR_IS_DIST_DIS(...) SAC_ND_A_MIRROR_IS_DIST__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_IS_DIST_DSM(...) SAC_ND_A_MIRROR_IS_DIST__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_IS_DIST_DLO(...) SAC_ND_A_MIRROR_IS_DIST__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_IS_DIST_NDI(...) SAC_ND_A_MIRROR_IS_DIST__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_IS_DIST_DCA(...) SAC_ND_A_MIRROR_IS_DIST__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_IS_DIST____(...) SAC_ND_A_MIRROR_IS_DIST__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_OFFS( nt ) CAT_M4_std_gen_23(SAC_ND_A_MIRROR_OFFS_, NT_DIS(nt))( nt )
#define SAC_ND_A_MIRROR_OFFS_DIS(...) SAC_ND_A_MIRROR_OFFS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_OFFS_DSM(...) SAC_ND_A_MIRROR_OFFS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_OFFS_DCA(...) SAC_ND_A_MIRROR_OFFS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_OFFS_DLO(...) SAC_ND_A_MIRROR_OFFS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_OFFS_NDI(...) SAC_ND_A_MIRROR_OFFS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_OFFS____(...) SAC_ND_A_MIRROR_OFFS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_FIRST_ELEMS( nt ) CAT_M4_std_gen_24(SAC_ND_A_MIRROR_FIRST_ELEMS_, NT_DIS(nt))( nt )
#define SAC_ND_A_MIRROR_FIRST_ELEMS_DIS(...) SAC_ND_A_MIRROR_FIRST_ELEMS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_FIRST_ELEMS_DCA(...) SAC_ND_A_MIRROR_FIRST_ELEMS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_FIRST_ELEMS_DLO(...) SAC_ND_A_MIRROR_FIRST_ELEMS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_FIRST_ELEMS_DSM(...) SAC_ND_A_MIRROR_FIRST_ELEMS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_FIRST_ELEMS_NDI(...) SAC_ND_A_MIRROR_FIRST_ELEMS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_FIRST_ELEMS____(...) SAC_ND_A_MIRROR_FIRST_ELEMS__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_FROM( nt ) CAT_M4_std_gen_25(SAC_ND_A_MIRROR_LOCAL_FROM_, NT_DIS(nt))( nt )
#define SAC_ND_A_MIRROR_LOCAL_FROM_DIS(...) SAC_ND_A_MIRROR_LOCAL_FROM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_FROM_DSM(...) SAC_ND_A_MIRROR_LOCAL_FROM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_FROM_NDI(...) SAC_ND_A_MIRROR_LOCAL_FROM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_FROM_DCA(...) SAC_ND_A_MIRROR_LOCAL_FROM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_FROM_DLO(...) SAC_ND_A_MIRROR_LOCAL_FROM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_FROM____(...) SAC_ND_A_MIRROR_LOCAL_FROM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_COUNT( nt ) CAT_M4_std_gen_26(SAC_ND_A_MIRROR_LOCAL_COUNT_, NT_DIS(nt))( nt )
#define SAC_ND_A_MIRROR_LOCAL_COUNT_DIS(...) SAC_ND_A_MIRROR_LOCAL_COUNT__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_COUNT_DSM(...) SAC_ND_A_MIRROR_LOCAL_COUNT__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_COUNT_NDI(...) SAC_ND_A_MIRROR_LOCAL_COUNT__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_COUNT_DCA(...) SAC_ND_A_MIRROR_LOCAL_COUNT__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_COUNT_DLO(...) SAC_ND_A_MIRROR_LOCAL_COUNT__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_LOCAL_COUNT____(...) SAC_ND_A_MIRROR_LOCAL_COUNT__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE( nt ) CAT_M4_std_gen_27(SAC_ND_A_MIRROR_PTR_CACHE_, NT_DIS(nt))( nt )
#define SAC_ND_A_MIRROR_PTR_CACHE_DIS(...) SAC_ND_A_MIRROR_PTR_CACHE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_DSM(...) SAC_ND_A_MIRROR_PTR_CACHE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_NDI(...) SAC_ND_A_MIRROR_PTR_CACHE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_DCA(...) SAC_ND_A_MIRROR_PTR_CACHE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_DLO(...) SAC_ND_A_MIRROR_PTR_CACHE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE____(...) SAC_ND_A_MIRROR_PTR_CACHE__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_FROM( nt ) CAT_M4_std_gen_28(SAC_ND_A_MIRROR_PTR_CACHE_FROM_, NT_DIS(nt))( nt )
#define SAC_ND_A_MIRROR_PTR_CACHE_FROM_DIS(...) SAC_ND_A_MIRROR_PTR_CACHE_FROM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_FROM_DSM(...) SAC_ND_A_MIRROR_PTR_CACHE_FROM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_FROM_NDI(...) SAC_ND_A_MIRROR_PTR_CACHE_FROM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_FROM_DCA(...) SAC_ND_A_MIRROR_PTR_CACHE_FROM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_FROM_DLO(...) SAC_ND_A_MIRROR_PTR_CACHE_FROM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_FROM____(...) SAC_ND_A_MIRROR_PTR_CACHE_FROM__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_COUNT( nt ) CAT_M4_std_gen_29(SAC_ND_A_MIRROR_PTR_CACHE_COUNT_, NT_DIS(nt))( nt )
#define SAC_ND_A_MIRROR_PTR_CACHE_COUNT_DIS(...) SAC_ND_A_MIRROR_PTR_CACHE_COUNT__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_COUNT_DSM(...) SAC_ND_A_MIRROR_PTR_CACHE_COUNT__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_COUNT_NDI(...) SAC_ND_A_MIRROR_PTR_CACHE_COUNT__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_COUNT_DCA(...) SAC_ND_A_MIRROR_PTR_CACHE_COUNT__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_COUNT_DLO(...) SAC_ND_A_MIRROR_PTR_CACHE_COUNT__UNDEF(__VA_ARGS__)
#define SAC_ND_A_MIRROR_PTR_CACHE_COUNT____(...) SAC_ND_A_MIRROR_PTR_CACHE_COUNT__UNDEF(__VA_ARGS__)
#define SAC_ND_A_FIELD(...) SAC_ND_A_FIELD_(__VA_ARGS__)
#define SAC_ND_A_FIELD_(...) SAC_ND_A_FIELD__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_FIELD_UNBOX( nt ) CAT_M4_std_gen_30(SAC_ND_A_FIELD_UNBOX_, NT_SHP(nt))( nt )
#define SAC_ND_A_FIELD_UNBOX_SCL(...) SAC_ND_A_FIELD(__VA_ARGS__)
#define SAC_ND_A_FIELD_UNBOX_AKS(...) SAC_ND_A_FIELD__BOXED(__VA_ARGS__)
#define SAC_ND_A_FIELD_UNBOX_AKD(...) SAC_ND_A_FIELD__BOXED(__VA_ARGS__)
#define SAC_ND_A_FIELD_UNBOX_AUD(...) SAC_ND_A_FIELD__BOXED(__VA_ARGS__)
#define SAC_ND_A_FIELD_UNBOX____(...) SAC_ND_A_FIELD__BOXED(__VA_ARGS__)
#define SAC_ND_A_RC( nt ) CAT_M4_std_gen_31(SAC_ND_A_RC_, CAT_M4_std_gen_32(NT_SHP(nt), CAT_M4_std_gen_33(NT_HID(nt), NT_UNQ(nt))))( nt )
#define SAC_ND_A_RC_SCLNHDUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_SCLHIDUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_SCLHNSUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_SCL___UNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AKSNHDUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AKSHIDUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AKSHNSUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AKS___UNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AKDNHDUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AKDHIDUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AKDHNSUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AKD___UNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AUDNHDUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AUDHIDUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AUDHNSUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_AUD___UNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC____NHDUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC____HIDUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC____HNSUNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_______UNQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_SCLNHDNUQ(...) SAC_ND_A_RC__UNDEF(__VA_ARGS__)
#define SAC_ND_A_RC_SCLHIDNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_SCLHNSNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_SCL___NUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AKSNHDNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AKSHIDNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AKSHNSNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AKS___NUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AKDNHDNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AKDHIDNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AKDHNSNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AKD___NUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AUDNHDNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AUDHIDNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AUDHNSNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_AUD___NUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC____NHDNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC____HIDNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC____HNSNUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_RC_______NUQ(...) SAC_ND_A_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_DIM(...) SAC_ND_A_DIM_(__VA_ARGS__)
#define SAC_ND_A_DIM_(...) SAC_ND_A_DIM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_SIZE(...) SAC_ND_A_SIZE_(__VA_ARGS__)
#define SAC_ND_A_SIZE_(...) SAC_ND_A_SIZE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_SHAPE( nt , gra1) CAT_M4_std_gen_34(SAC_ND_A_SHAPE_, NT_SHP(nt))( nt , gra1)
#define SAC_ND_A_SHAPE_SCL(...) SAC_ND_A_SHAPE__SCL(__VA_ARGS__)
#define SAC_ND_A_SHAPE_AKS(...) SAC_ND_A_SHAPE__AKS_AKD(__VA_ARGS__)
#define SAC_ND_A_SHAPE_AKD(...) SAC_ND_A_SHAPE__AKS_AKD(__VA_ARGS__)
#define SAC_ND_A_SHAPE_AUD(...) SAC_ND_A_SHAPE__AUD(__VA_ARGS__)
#define SAC_ND_A_IS_DIST( nt ) CAT_M4_std_gen_35(SAC_ND_A_IS_DIST_, NT_DIS(nt))( nt )
#define SAC_ND_A_IS_DIST_DIS(...) SAC_ND_A_IS_DIST__DIS_DSM(__VA_ARGS__)
#define SAC_ND_A_IS_DIST_DSM(...) SAC_ND_A_IS_DIST__DIS_DSM(__VA_ARGS__)
#define SAC_ND_A_IS_DIST_DLO(...) SAC_ND_A_IS_DIST__DIS_DSM(__VA_ARGS__)
#define SAC_ND_A_IS_DIST_NDI(...) SAC_ND_A_IS_DIST__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_IS_DIST_DCA(...) SAC_ND_A_IS_DIST__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_IS_DIST____(...) SAC_ND_A_IS_DIST__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_IS_DSM( nt ) CAT_M4_std_gen_36(SAC_ND_A_IS_DSM_, NT_DIS(nt))( nt )
#define SAC_ND_A_IS_DSM_DSM(...) SAC_ND_A_IS_DSM__DSM(__VA_ARGS__)
#define SAC_ND_A_IS_DSM_DIS(...) SAC_ND_A_IS_DSM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_IS_DSM_NDI(...) SAC_ND_A_IS_DSM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_IS_DSM_DCA(...) SAC_ND_A_IS_DSM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_IS_DSM_DLO(...) SAC_ND_A_IS_DSM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_IS_DSM____(...) SAC_ND_A_IS_DSM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_FIRST_ELEMS( nt ) CAT_M4_std_gen_37(SAC_ND_A_FIRST_ELEMS_, NT_DIS(nt))( nt )
#define SAC_ND_A_FIRST_ELEMS_DIS(...) SAC_ND_A_FIRST_ELEMS__DIS(__VA_ARGS__)
#define SAC_ND_A_FIRST_ELEMS_DCA(...) SAC_ND_A_FIRST_ELEMS__DIS(__VA_ARGS__)
#define SAC_ND_A_FIRST_ELEMS_DLO(...) SAC_ND_A_FIRST_ELEMS__DIS(__VA_ARGS__)
#define SAC_ND_A_FIRST_ELEMS_DSM(...) SAC_ND_A_SIZE__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_FIRST_ELEMS_NDI(...) SAC_ND_A_FIRST_ELEMS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_FIRST_ELEMS____(...) SAC_ND_A_FIRST_ELEMS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_LOCAL_FROM( nt ) CAT_M4_std_gen_38(SAC_ND_A_LOCAL_FROM_, NT_DIS(nt))( nt )
#define SAC_ND_A_LOCAL_FROM_DIS(...) SAC_ND_A_LOCAL_FROM__DIS(__VA_ARGS__)
#define SAC_ND_A_LOCAL_FROM_DSM(...) SAC_ND_A_LOCAL_FROM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_LOCAL_FROM_NDI(...) SAC_ND_A_LOCAL_FROM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_LOCAL_FROM_DCA(...) SAC_ND_A_LOCAL_FROM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_LOCAL_FROM_DLO(...) SAC_ND_A_LOCAL_FROM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_LOCAL_FROM____(...) SAC_ND_A_LOCAL_FROM__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_LOCAL_COUNT( nt ) CAT_M4_std_gen_39(SAC_ND_A_LOCAL_COUNT_, NT_DIS(nt))( nt )
#define SAC_ND_A_LOCAL_COUNT_DIS(...) SAC_ND_A_LOCAL_COUNT__DIS(__VA_ARGS__)
#define SAC_ND_A_LOCAL_COUNT_DSM(...) SAC_ND_A_LOCAL_COUNT__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_LOCAL_COUNT_NDI(...) SAC_ND_A_LOCAL_COUNT__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_LOCAL_COUNT_DCA(...) SAC_ND_A_LOCAL_COUNT__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_LOCAL_COUNT_DLO(...) SAC_ND_A_LOCAL_COUNT__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_LOCAL_COUNT____(...) SAC_ND_A_LOCAL_COUNT__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_OFFS( nt ) CAT_M4_std_gen_40(SAC_ND_A_OFFS_, NT_DIS(nt))( nt )
#define SAC_ND_A_OFFS_DIS(...) SAC_ND_A_OFFS__DIS_DSM(__VA_ARGS__)
#define SAC_ND_A_OFFS_DSM(...) SAC_ND_A_OFFS__DIS_DSM(__VA_ARGS__)
#define SAC_ND_A_OFFS_DCA(...) SAC_ND_A_OFFS__DIS_DSM(__VA_ARGS__)
#define SAC_ND_A_OFFS_DLO(...) SAC_ND_A_OFFS__DIS_DSM(__VA_ARGS__)
#define SAC_ND_A_OFFS_NDI(...) SAC_ND_A_OFFS__DEFAULT(__VA_ARGS__)
#define SAC_ND_A_OFFS____(...) SAC_ND_A_OFFS__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ( nt , gra1) CAT_M4_std_gen_41(SAC_ND_READ_, CAT_M4_std_gen_42(NT_SHP(nt), CAT_M4_std_gen_43(NT_BIT(nt), NT_DIS(nt))))( nt , gra1)
#define SAC_ND_READ_SCLYESDIS(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLYESDSM(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLYESNDI(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLYESDCA(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLYESDLO(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLYES___(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLNOTDIS(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLNOTDSM(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLNOTNDI(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLNOTDCA(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLNOTDLO(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCLNOT___(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCL___DIS(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCL___DSM(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCL___NDI(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCL___DCA(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCL___DLO(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_SCL______(...) SAC_ND_READ__SCL(__VA_ARGS__)
#define SAC_ND_READ_AKSYESDIS(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKSYESDSM(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKSYESNDI(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKSYESDCA(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKSYESDLO(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKSYES___(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKDYESDIS(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKDYESDSM(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKDYESNDI(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKDYESDCA(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKDYESDLO(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKDYES___(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AUDYESDIS(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AUDYESDSM(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AUDYESNDI(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AUDYESDCA(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AUDYESDLO(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AUDYES___(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ____YESDIS(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ____YESDSM(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ____YESNDI(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ____YESDCA(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ____YESDLO(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ____YES___(...) SAC_ND_READ__BITARRAY(__VA_ARGS__)
#define SAC_ND_READ_AKSNOTDLO(...) SAC_ND_READ__DLO(__VA_ARGS__)
#define SAC_ND_READ_AKS___DLO(...) SAC_ND_READ__DLO(__VA_ARGS__)
#define SAC_ND_READ_AKDNOTDLO(...) SAC_ND_READ__DLO(__VA_ARGS__)
#define SAC_ND_READ_AKD___DLO(...) SAC_ND_READ__DLO(__VA_ARGS__)
#define SAC_ND_READ_AUDNOTDLO(...) SAC_ND_READ__DLO(__VA_ARGS__)
#define SAC_ND_READ_AUD___DLO(...) SAC_ND_READ__DLO(__VA_ARGS__)
#define SAC_ND_READ____NOTDLO(...) SAC_ND_READ__DLO(__VA_ARGS__)
#define SAC_ND_READ_______DLO(...) SAC_ND_READ__DLO(__VA_ARGS__)
#define SAC_ND_READ_AKSNOTDIS(...) SAC_ND_READ__DIS(__VA_ARGS__)
#define SAC_ND_READ_AKS___DIS(...) SAC_ND_READ__DIS(__VA_ARGS__)
#define SAC_ND_READ_AKDNOTDIS(...) SAC_ND_READ__DIS(__VA_ARGS__)
#define SAC_ND_READ_AKD___DIS(...) SAC_ND_READ__DIS(__VA_ARGS__)
#define SAC_ND_READ_AUDNOTDIS(...) SAC_ND_READ__DIS(__VA_ARGS__)
#define SAC_ND_READ_AUD___DIS(...) SAC_ND_READ__DIS(__VA_ARGS__)
#define SAC_ND_READ____NOTDIS(...) SAC_ND_READ__DIS(__VA_ARGS__)
#define SAC_ND_READ_______DIS(...) SAC_ND_READ__DIS(__VA_ARGS__)
#define SAC_ND_READ_AKSNOTDSM(...) SAC_ND_READ__DSM(__VA_ARGS__)
#define SAC_ND_READ_AKS___DSM(...) SAC_ND_READ__DSM(__VA_ARGS__)
#define SAC_ND_READ_AKDNOTDSM(...) SAC_ND_READ__DSM(__VA_ARGS__)
#define SAC_ND_READ_AKD___DSM(...) SAC_ND_READ__DSM(__VA_ARGS__)
#define SAC_ND_READ_AUDNOTDSM(...) SAC_ND_READ__DSM(__VA_ARGS__)
#define SAC_ND_READ_AUD___DSM(...) SAC_ND_READ__DSM(__VA_ARGS__)
#define SAC_ND_READ____NOTDSM(...) SAC_ND_READ__DSM(__VA_ARGS__)
#define SAC_ND_READ_______DSM(...) SAC_ND_READ__DSM(__VA_ARGS__)
#define SAC_ND_READ_AKSNOTNDI(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKSNOTDCA(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKSNOT___(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKS___NDI(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKS___DCA(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKS______(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKDNOTNDI(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKDNOTDCA(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKDNOT___(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKD___NDI(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKD___DCA(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AKD______(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AUDNOTNDI(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AUDNOTDCA(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AUDNOT___(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AUD___NDI(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AUD___DCA(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_AUD______(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ____NOTNDI(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ____NOTDCA(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ____NOT___(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_______NDI(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ_______DCA(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_READ__________(...) SAC_ND_READ__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE( nt , gra1) CAT_M4_std_gen_44(SAC_ND_WRITE_, CAT_M4_std_gen_45(NT_SHP(nt), CAT_M4_std_gen_46(NT_BIT(nt), NT_DIS(nt))))( nt , gra1)
#define SAC_ND_WRITE_SCLYESDIS(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLYESDSM(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLYESNDI(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLYESDCA(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLYESDLO(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLYES___(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLNOTDIS(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLNOTDSM(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLNOTNDI(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLNOTDCA(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLNOTDLO(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCLNOT___(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCL___DIS(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCL___DSM(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCL___NDI(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCL___DCA(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCL___DLO(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_SCL______(...) SAC_ND_WRITE__SCL(__VA_ARGS__)
#define SAC_ND_WRITE_AKSYESDIS(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKSYESDSM(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKSYESNDI(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKSYESDCA(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKSYESDLO(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKSYES___(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKDYESDIS(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKDYESDSM(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKDYESNDI(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKDYESDCA(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKDYESDLO(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKDYES___(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AUDYESDIS(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AUDYESDSM(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AUDYESNDI(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AUDYESDCA(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AUDYESDLO(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AUDYES___(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE____YESDIS(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE____YESDSM(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE____YESNDI(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE____YESDCA(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE____YESDLO(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE____YES___(...) SAC_ND_WRITE__BITARRAY(__VA_ARGS__)
#define SAC_ND_WRITE_AKSNOTDIS(...) SAC_ND_WRITE__DIS(__VA_ARGS__)
#define SAC_ND_WRITE_AKS___DIS(...) SAC_ND_WRITE__DIS(__VA_ARGS__)
#define SAC_ND_WRITE_AKDNOTDIS(...) SAC_ND_WRITE__DIS(__VA_ARGS__)
#define SAC_ND_WRITE_AKD___DIS(...) SAC_ND_WRITE__DIS(__VA_ARGS__)
#define SAC_ND_WRITE_AUDNOTDIS(...) SAC_ND_WRITE__DIS(__VA_ARGS__)
#define SAC_ND_WRITE_AUD___DIS(...) SAC_ND_WRITE__DIS(__VA_ARGS__)
#define SAC_ND_WRITE____NOTDIS(...) SAC_ND_WRITE__DIS(__VA_ARGS__)
#define SAC_ND_WRITE_______DIS(...) SAC_ND_WRITE__DIS(__VA_ARGS__)
#define SAC_ND_WRITE_AKSNOTDCA(...) SAC_ND_WRITE__DCA(__VA_ARGS__)
#define SAC_ND_WRITE_AKS___DCA(...) SAC_ND_WRITE__DCA(__VA_ARGS__)
#define SAC_ND_WRITE_AKDNOTDCA(...) SAC_ND_WRITE__DCA(__VA_ARGS__)
#define SAC_ND_WRITE_AKD___DCA(...) SAC_ND_WRITE__DCA(__VA_ARGS__)
#define SAC_ND_WRITE_AUDNOTDCA(...) SAC_ND_WRITE__DCA(__VA_ARGS__)
#define SAC_ND_WRITE_AUD___DCA(...) SAC_ND_WRITE__DCA(__VA_ARGS__)
#define SAC_ND_WRITE____NOTDCA(...) SAC_ND_WRITE__DCA(__VA_ARGS__)
#define SAC_ND_WRITE_______DCA(...) SAC_ND_WRITE__DCA(__VA_ARGS__)
#define SAC_ND_WRITE_AKSNOTDSM(...) SAC_ND_WRITE__DSM(__VA_ARGS__)
#define SAC_ND_WRITE_AKS___DSM(...) SAC_ND_WRITE__DSM(__VA_ARGS__)
#define SAC_ND_WRITE_AKDNOTDSM(...) SAC_ND_WRITE__DSM(__VA_ARGS__)
#define SAC_ND_WRITE_AKD___DSM(...) SAC_ND_WRITE__DSM(__VA_ARGS__)
#define SAC_ND_WRITE_AUDNOTDSM(...) SAC_ND_WRITE__DSM(__VA_ARGS__)
#define SAC_ND_WRITE_AUD___DSM(...) SAC_ND_WRITE__DSM(__VA_ARGS__)
#define SAC_ND_WRITE____NOTDSM(...) SAC_ND_WRITE__DSM(__VA_ARGS__)
#define SAC_ND_WRITE_______DSM(...) SAC_ND_WRITE__DSM(__VA_ARGS__)
#define SAC_ND_WRITE_AKSNOTNDI(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKSNOTDLO(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKSNOT___(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKS___NDI(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKS___DLO(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKS______(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKDNOTNDI(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKDNOTDLO(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKDNOT___(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKD___NDI(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKD___DLO(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AKD______(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AUDNOTNDI(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AUDNOTDLO(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AUDNOT___(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AUD___NDI(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AUD___DLO(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_AUD______(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE____NOTNDI(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE____NOTDLO(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE____NOT___(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_______NDI(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_______DLO(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE__________(...) SAC_ND_WRITE__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_READ_COPY( nt , gra1, gra2, gra3, gra4) CAT_M4_std_gen_47(SAC_ND_WRITE_READ_COPY_, NT_HID(nt))( nt , gra1, gra2, gra3, gra4)
#define SAC_ND_WRITE_READ_COPY_HNS(...) SAC_ND_WRITE_READ_COPY__NESTED(__VA_ARGS__)
#define SAC_ND_WRITE_READ_COPY_NHD(...) SAC_ND_WRITE_READ_COPY__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_READ_COPY_HID(...) SAC_ND_WRITE_READ_COPY__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_READ_COPY____(...) SAC_ND_WRITE_READ_COPY__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_COPY( nt , gra1, gra2, gra3) CAT_M4_std_gen_48(SAC_ND_WRITE_COPY_, NT_HID(nt))( nt , gra1, gra2, gra3)
#define SAC_ND_WRITE_COPY_HID(...) SAC_ND_WRITE_COPY__HID(__VA_ARGS__)
#define SAC_ND_WRITE_COPY_NHD(...) SAC_ND_WRITE_COPY__NHD(__VA_ARGS__)
#define SAC_ND_WRITE_COPY_HNS(...) SAC_ND_WRITE_COPY__HNS(__VA_ARGS__)
#define SAC_ND_PRINT_SHAPE( nt ) CAT_M4_std_gen_49(SAC_ND_PRINT_SHAPE_, NT_SHP(nt))( nt )
#define SAC_ND_PRINT_SHAPE_SCL(...) SAC_ND_PRINT_SHAPE__SCL(__VA_ARGS__)
#define SAC_ND_PRINT_SHAPE_AKS(...) SAC_ND_PRINT_SHAPE__SHP(__VA_ARGS__)
#define SAC_ND_PRINT_SHAPE_AKD(...) SAC_ND_PRINT_SHAPE__SHP(__VA_ARGS__)
#define SAC_ND_PRINT_SHAPE_AUD(...) SAC_ND_PRINT_SHAPE__SHP(__VA_ARGS__)
#define SAC_ND_PRINT_SHAPE____(...) SAC_ND_PRINT_SHAPE__SHP(__VA_ARGS__)
#define SAC_ND_DESC_TYPE(...) SAC_ND_DESC_TYPE_(__VA_ARGS__)
#define SAC_ND_DESC_TYPE_(...) SAC_ND_DESC_TYPE__DEFAULT(__VA_ARGS__)
#define SAC_ND_TYPE( nt , gra1) CAT_M4_std_gen_50(SAC_ND_TYPE_, NT_SHP(nt))( nt , gra1)
#define SAC_ND_TYPE_SCL(...) SAC_ND_TYPE_TAG__SCL(__VA_ARGS__)
#define SAC_ND_TYPE_AKS(...) SAC_ND_TYPE_TAG__DEFAULT(__VA_ARGS__)
#define SAC_ND_TYPE_AKD(...) SAC_ND_TYPE_TAG__DEFAULT(__VA_ARGS__)
#define SAC_ND_TYPE_AUD(...) SAC_ND_TYPE_TAG__DEFAULT(__VA_ARGS__)
#define SAC_ND_TYPE____(...) SAC_ND_TYPE_TAG__DEFAULT(__VA_ARGS__)
#define SAC_ND_TYPEDEF( nt , gra1) CAT_M4_std_gen_51(SAC_ND_TYPEDEF_, NT_HID(nt))( nt , gra1)
#define SAC_ND_TYPEDEF_HID(...) SAC_ND_TYPEDEF__HID(__VA_ARGS__)
#define SAC_ND_TYPEDEF_NHD(...) SAC_ND_TYPEDEF__DEFAULT(__VA_ARGS__)
#define SAC_ND_TYPEDEF_HNS(...) SAC_ND_TYPEDEF__DEFAULT(__VA_ARGS__)
#define SAC_ND_TYPEDEF____(...) SAC_ND_TYPEDEF__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC( nt , gra1) CAT_M4_std_gen_52(SAC_ND_DECL__DESC_, CAT_M4_std_gen_53(NT_SHP(nt), CAT_M4_std_gen_54(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_DECL__DESC_SCLNHDNUQ(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCLNHDUNQ(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCLNHD___(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCLHIDUNQ(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCLHNSUNQ(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCL___UNQ(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKSNHDUNQ(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKSHIDUNQ(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKSHNSUNQ(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKS___UNQ(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCLHIDNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCLHID___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCLHNSNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCLHNS___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCL___NUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_SCL______(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKSNHDNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKSNHD___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKSHIDNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKSHID___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKSHNSNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKSHNS___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKS___NUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKS______(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKDNHDNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKDNHDUNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKDNHD___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKDHIDNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKDHIDUNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKDHID___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKDHNSNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKDHNSUNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKDHNS___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKD___NUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKD___UNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AKD______(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUDNHDNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUDNHDUNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUDNHD___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUDHIDNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUDHIDUNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUDHID___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUDHNSNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUDHNSUNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUDHNS___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUD___NUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUD___UNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_AUD______(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC____NHDNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC____NHDUNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC____NHD___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC____HIDNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC____HIDUNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC____HID___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC____HNSNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC____HNSUNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC____HNS___(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_______NUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC_______UNQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL__DESC__________(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_PARAM_in( nt , gra1) CAT_M4_std_gen_55(SAC_ND_PARAM_in_, CAT_M4_std_gen_56(NT_SHP(nt), CAT_M4_std_gen_57(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_PARAM_in_SCLNHDNUQ(...) SAC_ND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCLNHDUNQ(...) SAC_ND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCLNHD___(...) SAC_ND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCLHIDUNQ(...) SAC_ND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCLHNSNUQ(...) SAC_ND_PARAM_NESTED_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCLHNSUNQ(...) SAC_ND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCL___UNQ(...) SAC_ND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKSNHDUNQ(...) SAC_ND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKSHIDUNQ(...) SAC_ND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKSHNSUNQ(...) SAC_ND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKS___UNQ(...) SAC_ND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCLHNS___(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKSHNSNUQ(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKSHNS___(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKDHNSNUQ(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKDHNSUNQ(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKDHNS___(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUDHNSNUQ(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUDHNSUNQ(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUDHNS___(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in____HNSNUQ(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in____HNSUNQ(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in____HNS___(...) SAC_ND_PARAM_NESTED_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCLHIDNUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCLHID___(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCL___NUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_SCL______(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKSNHDNUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKSNHD___(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKSHIDNUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKSHID___(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKS___NUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKS______(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKDNHDNUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKDNHDUNQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKDNHD___(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKDHIDNUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKDHIDUNQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKDHID___(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKD___NUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKD___UNQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AKD______(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUDNHDNUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUDNHDUNQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUDNHD___(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUDHIDNUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUDHIDUNQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUDHID___(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUD___NUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUD___UNQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_AUD______(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in____NHDNUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in____NHDUNQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in____NHD___(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in____HIDNUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in____HIDUNQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in____HID___(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_______NUQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in_______UNQ(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_in__________(...) SAC_ND_PARAM_in__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out( nt , gra1) CAT_M4_std_gen_58(SAC_ND_PARAM_out_, CAT_M4_std_gen_59(NT_SHP(nt), CAT_M4_std_gen_60(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_PARAM_out_SCLNHDNUQ(...) SAC_ND_PARAM_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCLNHDUNQ(...) SAC_ND_PARAM_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCLNHD___(...) SAC_ND_PARAM_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCLHIDUNQ(...) SAC_ND_PARAM_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCLHNSNUQ(...) SAC_ND_PARAM_NESTED_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCLHNSUNQ(...) SAC_ND_PARAM_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCL___UNQ(...) SAC_ND_PARAM_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKSNHDUNQ(...) SAC_ND_PARAM_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKSHIDUNQ(...) SAC_ND_PARAM_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKSHNSUNQ(...) SAC_ND_PARAM_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKS___UNQ(...) SAC_ND_PARAM_out__NODESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCLHNS___(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKSHNSNUQ(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKSHNS___(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKDHNSNUQ(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKDHNSUNQ(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKDHNS___(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUDHNSNUQ(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUDHNSUNQ(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUDHNS___(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out____HNSNUQ(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out____HNSUNQ(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out____HNS___(...) SAC_ND_PARAM_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCLHIDNUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCLHID___(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCL___NUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_SCL______(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKSNHDNUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKSNHD___(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKSHIDNUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKSHID___(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKS___NUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKS______(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKDNHDNUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKDNHDUNQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKDNHD___(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKDHIDNUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKDHIDUNQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKDHID___(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKD___NUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKD___UNQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AKD______(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUDNHDNUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUDNHDUNQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUDNHD___(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUDHIDNUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUDHIDUNQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUDHID___(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUD___NUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUD___UNQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_AUD______(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out____NHDNUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out____NHDUNQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out____NHD___(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out____HIDNUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out____HIDUNQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out____HID___(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_______NUQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out_______UNQ(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_PARAM_out__________(...) SAC_ND_PARAM_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in( nt , gra1) CAT_M4_std_gen_61(SAC_ND_ARG_in_, CAT_M4_std_gen_62(NT_SHP(nt), CAT_M4_std_gen_63(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_ARG_in_SCLNHDNUQ(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCLNHDUNQ(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCLNHD___(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCLHIDUNQ(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCLHNSNUQ(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCLHNSUNQ(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCL___UNQ(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKSNHDUNQ(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKSHIDUNQ(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKSHNSUNQ(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKS___UNQ(...) SAC_ND_ARG_in__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCLHIDNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCLHID___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCLHNS___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCL___NUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_SCL______(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKSNHDNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKSNHD___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKSHIDNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKSHID___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKSHNSNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKSHNS___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKS___NUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKS______(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKDNHDNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKDNHDUNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKDNHD___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKDHIDNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKDHIDUNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKDHID___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKDHNSNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKDHNSUNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKDHNS___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKD___NUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKD___UNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AKD______(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUDNHDNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUDNHDUNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUDNHD___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUDHIDNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUDHIDUNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUDHID___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUDHNSNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUDHNSUNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUDHNS___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUD___NUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUD___UNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_AUD______(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in____NHDNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in____NHDUNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in____NHD___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in____HIDNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in____HIDUNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in____HID___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in____HNSNUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in____HNSUNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in____HNS___(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_______NUQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in_______UNQ(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_in__________(...) SAC_ND_ARG_in__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out( nt , gra1) CAT_M4_std_gen_64(SAC_ND_ARG_out_, CAT_M4_std_gen_65(NT_SHP(nt), CAT_M4_std_gen_66(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_ARG_out_SCLNHDNUQ(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCLNHDUNQ(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCLNHD___(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCLHIDUNQ(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCLHNSNUQ(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCLHNSUNQ(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCL___UNQ(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKSNHDUNQ(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKSHIDUNQ(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKSHNSUNQ(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKS___UNQ(...) SAC_ND_ARG_out__NODESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCLHNS___(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKSHNSNUQ(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKSHNS___(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKDHNSNUQ(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKDHNSUNQ(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKDHNS___(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUDHNSNUQ(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUDHNSUNQ(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUDHNS___(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out____HNSNUQ(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out____HNSUNQ(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out____HNS___(...) SAC_ND_ARG_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCLHIDNUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCLHID___(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCL___NUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_SCL______(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKSNHDNUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKSNHD___(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKSHIDNUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKSHID___(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKS___NUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKS______(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKDNHDNUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKDNHDUNQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKDNHD___(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKDHIDNUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKDHIDUNQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKDHID___(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKD___NUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKD___UNQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AKD______(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUDNHDNUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUDNHDUNQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUDNHD___(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUDHIDNUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUDHIDUNQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUDHID___(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUD___NUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUD___UNQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_AUD______(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out____NHDNUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out____NHDUNQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out____NHD___(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out____HIDNUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out____HIDUNQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out____HID___(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_______NUQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out_______UNQ(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_ARG_out__________(...) SAC_ND_ARG_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out( arg1, nt ) CAT_M4_std_gen_67(SAC_ND_RET_out_, CAT_M4_std_gen_68(NT_SHP(nt), CAT_M4_std_gen_69(NT_HID(nt), NT_UNQ(nt))))( arg1, nt )
#define SAC_ND_RET_out_SCLNHDNUQ(...) SAC_ND_RET_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCLNHDUNQ(...) SAC_ND_RET_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCLNHD___(...) SAC_ND_RET_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCLHIDUNQ(...) SAC_ND_RET_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCLHNSNUQ(...) SAC_ND_RET_NESTED_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCLHNSUNQ(...) SAC_ND_RET_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCL___UNQ(...) SAC_ND_RET_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKSNHDUNQ(...) SAC_ND_RET_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKSHIDUNQ(...) SAC_ND_RET_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKSHNSUNQ(...) SAC_ND_RET_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKS___UNQ(...) SAC_ND_RET_out__NODESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCLHNS___(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKSHNSNUQ(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKSHNS___(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKDHNSNUQ(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKDHNSUNQ(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKDHNS___(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUDHNSNUQ(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUDHNSUNQ(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUDHNS___(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out____HNSNUQ(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out____HNSUNQ(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out____HNS___(...) SAC_ND_RET_NESTED_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCLHIDNUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCLHID___(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCL___NUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_SCL______(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKSNHDNUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKSNHD___(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKSHIDNUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKSHID___(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKS___NUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKS______(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKDNHDNUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKDNHDUNQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKDNHD___(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKDHIDNUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKDHIDUNQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKDHID___(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKD___NUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKD___UNQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AKD______(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUDNHDNUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUDNHDUNQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUDNHD___(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUDHIDNUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUDHIDUNQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUDHID___(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUD___NUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUD___UNQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_AUD______(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out____NHDNUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out____NHDUNQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out____NHD___(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out____HIDNUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out____HIDUNQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out____HID___(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_______NUQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out_______UNQ(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_RET_out__________(...) SAC_ND_RET_out__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout( nt , gra1) CAT_M4_std_gen_70(SAC_ND_DECL_PARAM_inout_, CAT_M4_std_gen_71(NT_SHP(nt), CAT_M4_std_gen_72(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_DECL_PARAM_inout_SCLNHDNUQ(...) SAC_ND_DECL_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCLNHDUNQ(...) SAC_ND_DECL_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCLNHD___(...) SAC_ND_DECL_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCLHIDUNQ(...) SAC_ND_DECL_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCLHNSUNQ(...) SAC_ND_DECL_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCL___UNQ(...) SAC_ND_DECL_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKSNHDUNQ(...) SAC_ND_DECL_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKSHIDUNQ(...) SAC_ND_DECL_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKSHNSUNQ(...) SAC_ND_DECL_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKS___UNQ(...) SAC_ND_DECL_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCLHIDNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCLHID___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCLHNSNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCLHNS___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCL___NUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_SCL______(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKSNHDNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKSNHD___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKSHIDNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKSHID___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKSHNSNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKSHNS___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKS___NUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKS______(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKDNHDNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKDNHDUNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKDNHD___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKDHIDNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKDHIDUNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKDHID___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKDHNSNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKDHNSUNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKDHNS___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKD___NUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKD___UNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AKD______(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUDNHDNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUDNHDUNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUDNHD___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUDHIDNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUDHIDUNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUDHID___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUDHNSNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUDHNSUNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUDHNS___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUD___NUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUD___UNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_AUD______(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout____NHDNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout____NHDUNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout____NHD___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout____HIDNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout____HIDUNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout____HID___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout____HNSNUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout____HNSUNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout____HNS___(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_______NUQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout_______UNQ(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_DECL_PARAM_inout__________(...) SAC_ND_DECL_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_ND_ALLOC( nt , gra1, gra2, gra3) CAT_M4_std_gen_73(SAC_ND_ALLOC_, NT_SHP(nt))( nt , gra1, gra2, gra3)
#define SAC_ND_ALLOC_SCL(...) SAC_ND_ALLOC__DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_AKS(...) SAC_ND_ALLOC__DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_AKD(...) SAC_ND_ALLOC__NO_DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_AUD(...) SAC_ND_ALLOC__NO_DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_BEGIN( nt , gra1, gra2, gra3) CAT_M4_std_gen_74(SAC_ND_ALLOC_BEGIN_, NT_SHP(nt))( nt , gra1, gra2, gra3)
#define SAC_ND_ALLOC_BEGIN_SCL(...) SAC_ND_ALLOC_BEGIN__DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_BEGIN_AKS(...) SAC_ND_ALLOC_BEGIN__DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_BEGIN_AKD(...) SAC_ND_ALLOC_BEGIN__NO_DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_BEGIN_AUD(...) SAC_ND_ALLOC_BEGIN__NO_DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_END( nt , gra1, gra2, gra3) CAT_M4_std_gen_75(SAC_ND_ALLOC_END_, NT_SHP(nt))( nt , gra1, gra2, gra3)
#define SAC_ND_ALLOC_END_SCL(...) SAC_ND_ALLOC_END__DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_END_AKS(...) SAC_ND_ALLOC_END__DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_END_AKD(...) SAC_ND_ALLOC_END__NO_DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_END_AUD(...) SAC_ND_ALLOC_END__NO_DAO(__VA_ARGS__)
#define SAC_ND_ALLOC_END__NO_DAO( nt , gra1, gra2, gra3) CAT_M4_std_gen_76(SAC_ND_ALLOC_END__NO_DAO_, NT_HID(nt))( nt , gra1, gra2, gra3)
#define SAC_ND_ALLOC_END__NO_DAO_HNS(...) SAC_ND_ALLOC_END__NO_DAO__NESTED(__VA_ARGS__)
#define SAC_ND_ALLOC_END__NO_DAO_NHD(...) SAC_ND_ALLOC_END__NO_DAO__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC_END__NO_DAO_HID(...) SAC_ND_ALLOC_END__NO_DAO__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC_END__NO_DAO____(...) SAC_ND_ALLOC_END__NO_DAO__DEFAULT(__VA_ARGS__)
#define SAC_ND_REALLOC_BEGIN( nt , gra1, gra2, gra3, gra4) CAT_M4_std_gen_77(SAC_ND_REALLOC_BEGIN_, NT_SHP(nt))( nt , gra1, gra2, gra3, gra4)
#define SAC_ND_REALLOC_BEGIN_SCL(...) SAC_ND_REALLOC_BEGIN__DAO(__VA_ARGS__)
#define SAC_ND_REALLOC_BEGIN_AKS(...) SAC_ND_REALLOC_BEGIN__DAO(__VA_ARGS__)
#define SAC_ND_REALLOC_BEGIN_AKD(...) SAC_ND_REALLOC_BEGIN__NO_DAO(__VA_ARGS__)
#define SAC_ND_REALLOC_BEGIN_AUD(...) SAC_ND_REALLOC_BEGIN__NO_DAO(__VA_ARGS__)
#define SAC_ND_REALLOC_END( nt , gra1, gra2, gra3, gra4) CAT_M4_std_gen_78(SAC_ND_REALLOC_END_, NT_SHP(nt))( nt , gra1, gra2, gra3, gra4)
#define SAC_ND_REALLOC_END_SCL(...) SAC_ND_REALLOC_END__DAO(__VA_ARGS__)
#define SAC_ND_REALLOC_END_AKS(...) SAC_ND_REALLOC_END__DAO(__VA_ARGS__)
#define SAC_ND_REALLOC_END_AKD(...) SAC_ND_REALLOC_END__NO_DAO(__VA_ARGS__)
#define SAC_ND_REALLOC_END_AUD(...) SAC_ND_REALLOC_END__NO_DAO(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC( nt , gra1) CAT_M4_std_gen_79(SAC_ND_ALLOC__DESC_, CAT_M4_std_gen_80(NT_SHP(nt), CAT_M4_std_gen_81(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_ALLOC__DESC_SCLNHDNUQ(...) SAC_ND_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCLNHDUNQ(...) SAC_ND_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCLNHD___(...) SAC_ND_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCLHIDUNQ(...) SAC_ND_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCLHNSUNQ(...) SAC_ND_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCL___UNQ(...) SAC_ND_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKSNHDUNQ(...) SAC_ND_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKSHIDUNQ(...) SAC_ND_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKSHNSUNQ(...) SAC_ND_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKS___UNQ(...) SAC_ND_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUDNHDNUQ(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUDNHDUNQ(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUDNHD___(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUDHIDNUQ(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUDHIDUNQ(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUDHID___(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUDHNSNUQ(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUDHNSUNQ(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUDHNS___(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUD___NUQ(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUD___UNQ(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AUD______(...) SAC_ND_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCLHIDNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCLHID___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCLHNSNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCLHNS___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCL___NUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_SCL______(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKSNHDNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKSNHD___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKSHIDNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKSHID___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKSHNSNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKSHNS___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKS___NUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKS______(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKDNHDNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKDNHDUNQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKDNHD___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKDHIDNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKDHIDUNQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKDHID___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKDHNSNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKDHNSUNQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKDHNS___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKD___NUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKD___UNQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AKD______(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC____NHDNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC____NHDUNQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC____NHD___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC____HIDNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC____HIDUNQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC____HID___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC____HNSNUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC____HNSUNQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC____HNS___(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_______NUQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_______UNQ(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__________(...) SAC_ND_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__FIXED_C99( nt , gra1) CAT_M4_std_gen_82(SAC_ND_ALLOC__DESC__FIXED_C99_, NT_DIS(nt))( nt , gra1)
#define SAC_ND_ALLOC__DESC__FIXED_C99_DIS(...) SAC_ND_ALLOC__DESC__FIXED_C99__DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__FIXED_C99_DSM(...) SAC_ND_ALLOC__DESC__FIXED_C99__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__FIXED_C99_NDI(...) SAC_ND_ALLOC__DESC__FIXED_C99__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__FIXED_C99_DCA(...) SAC_ND_ALLOC__DESC__FIXED_C99__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__FIXED_C99_DLO(...) SAC_ND_ALLOC__DESC__FIXED_C99__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__FIXED_C99____(...) SAC_ND_ALLOC__DESC__FIXED_C99__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__AUD_C99( nt , gra1) CAT_M4_std_gen_83(SAC_ND_ALLOC__DESC__AUD_C99_, NT_DIS(nt))( nt , gra1)
#define SAC_ND_ALLOC__DESC__AUD_C99_DIS(...) SAC_ND_ALLOC__DESC__AUD_C99__DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__AUD_C99_DSM(...) SAC_ND_ALLOC__DESC__AUD_C99__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__AUD_C99_NDI(...) SAC_ND_ALLOC__DESC__AUD_C99__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__AUD_C99_DCA(...) SAC_ND_ALLOC__DESC__AUD_C99__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__AUD_C99_DLO(...) SAC_ND_ALLOC__DESC__AUD_C99__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC__AUD_C99____(...) SAC_ND_ALLOC__DESC__AUD_C99__DEFAULT(__VA_ARGS__)
#define SAC_DESC_ALLOC( nt , gra1) CAT_M4_std_gen_84(SAC_DESC_ALLOC_, NT_DIS(nt))( nt , gra1)
#define SAC_DESC_ALLOC_DIS(...) SAC_DESC_ALLOC__DIS(__VA_ARGS__)
#define SAC_DESC_ALLOC_DSM(...) SAC_DESC_ALLOC__DEFAULT(__VA_ARGS__)
#define SAC_DESC_ALLOC_NDI(...) SAC_DESC_ALLOC__DEFAULT(__VA_ARGS__)
#define SAC_DESC_ALLOC_DCA(...) SAC_DESC_ALLOC__DEFAULT(__VA_ARGS__)
#define SAC_DESC_ALLOC_DLO(...) SAC_DESC_ALLOC__DEFAULT(__VA_ARGS__)
#define SAC_DESC_ALLOC____(...) SAC_DESC_ALLOC__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA( nt ) CAT_M4_std_gen_85(SAC_ND_ALLOC__DATA_, CAT_M4_std_gen_86(NT_SHP(nt), NT_DIS(nt)))( nt )
#define SAC_ND_ALLOC__DATA_SCLDIS(...) SAC_ND_ALLOC__DATA__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_SCLDSM(...) SAC_ND_ALLOC__DATA__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_SCLNDI(...) SAC_ND_ALLOC__DATA__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_SCLDCA(...) SAC_ND_ALLOC__DATA__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_SCLDLO(...) SAC_ND_ALLOC__DATA__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_SCL___(...) SAC_ND_ALLOC__DATA__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKSDIS(...) SAC_ND_ALLOC__DATA__AKS_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKSDSM(...) SAC_ND_ALLOC__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKSNDI(...) SAC_ND_ALLOC__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKSDCA(...) SAC_ND_ALLOC__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKSDLO(...) SAC_ND_ALLOC__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKS___(...) SAC_ND_ALLOC__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKDDIS(...) SAC_ND_ALLOC__DATA__AKD_AUD_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AUDDIS(...) SAC_ND_ALLOC__DATA__AKD_AUD_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA____DIS(...) SAC_ND_ALLOC__DATA__AKD_AUD_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKDDSM(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKDNDI(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKDDCA(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKDDLO(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AKD___(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AUDDSM(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AUDNDI(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AUDDCA(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AUDDLO(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_AUD___(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA____DSM(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA____NDI(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA____DCA(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA____DLO(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_______(...) SAC_ND_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE( nt , gra1) CAT_M4_std_gen_87(SAC_ND_ALLOC__DATA_BASETYPE_, CAT_M4_std_gen_88(NT_SHP(nt), NT_DIS(nt)))( nt , gra1)
#define SAC_ND_ALLOC__DATA_BASETYPE_SCLDIS(...) SAC_ND_ALLOC__DATA_BASETYPE__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_SCLDSM(...) SAC_ND_ALLOC__DATA_BASETYPE__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_SCLNDI(...) SAC_ND_ALLOC__DATA_BASETYPE__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_SCLDCA(...) SAC_ND_ALLOC__DATA_BASETYPE__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_SCLDLO(...) SAC_ND_ALLOC__DATA_BASETYPE__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_SCL___(...) SAC_ND_ALLOC__DATA_BASETYPE__NOOP(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKSDIS(...) SAC_ND_ALLOC__DATA_BASETYPE__AKS_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKSDSM(...) SAC_ND_ALLOC__DATA_BASETYPE__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKSNDI(...) SAC_ND_ALLOC__DATA_BASETYPE__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKSDCA(...) SAC_ND_ALLOC__DATA_BASETYPE__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKSDLO(...) SAC_ND_ALLOC__DATA_BASETYPE__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKS___(...) SAC_ND_ALLOC__DATA_BASETYPE__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKDDIS(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AUDDIS(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE____DIS(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKDDSM(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKDNDI(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKDDCA(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKDDLO(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AKD___(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AUDDSM(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AUDNDI(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AUDDCA(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AUDDLO(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_AUD___(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE____DSM(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE____NDI(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE____DCA(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE____DLO(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE_______(...) SAC_ND_ALLOC__DATA_BASETYPE__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA( nt , gra1, gra2) CAT_M4_std_gen_89(SAC_ND_ALLOC__DESC_AND_DATA_, CAT_M4_std_gen_90(NT_SHP(nt), CAT_M4_std_gen_91(NT_HID(nt), CAT_M4_std_gen_92(NT_UNQ(nt), NT_DIS(nt)))))( nt , gra1, gra2)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDNUQDIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDNUQDSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDNUQNDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDNUQDCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDNUQDLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDNUQ___(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDUNQDIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDUNQDSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDUNQNDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDUNQDCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDUNQDLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHDUNQ___(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHD___DIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHD___DSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHD___NDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHD___DCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHD___DLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLNHD______(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDUNQDIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDUNQDSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDUNQNDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDUNQDCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDUNQDLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDUNQ___(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSUNQDIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSUNQDSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSUNQNDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSUNQDCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSUNQDLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSUNQ___(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___UNQDIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___UNQDSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___UNQNDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___UNQDCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___UNQDLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___UNQ___(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDUNQDIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDUNQDSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDUNQNDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDUNQDCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDUNQDLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDUNQ___(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDUNQDIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDUNQDSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDUNQNDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDUNQDCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDUNQDLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDUNQ___(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSUNQDIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSUNQDSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSUNQNDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSUNQDCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSUNQDLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSUNQ___(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___UNQDIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___UNQDSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___UNQNDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___UNQDCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___UNQDLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___UNQ___(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDNUQDIS(...) SAC_ND_ALLOC__DESC__FIXED_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDNUQDSM(...) SAC_ND_ALLOC__DESC__FIXED_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDNUQNDI(...) SAC_ND_ALLOC__DESC__FIXED_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDNUQDCA(...) SAC_ND_ALLOC__DESC__FIXED_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDNUQDLO(...) SAC_ND_ALLOC__DESC__FIXED_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHIDNUQ___(...) SAC_ND_ALLOC__DESC__FIXED_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSNUQDIS(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSNUQDSM(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSNUQNDI(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSNUQDCA(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSNUQDLO(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNSNUQ___(...) SAC_ND_ALLOC__DESC__NOOP_BASETYPE(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA_NESTED__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA_NESTED__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA_NESTED__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA_NESTED__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA_NESTED__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNSNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA_NESTED__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHD___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHID___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNS___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___NUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS______DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS_DIS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHDNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHD___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHD___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHD___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHD___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSNHD______(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHIDNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHID___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHID___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHID___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHID___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHID______(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNS___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNS___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNS___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNS___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKSHNS______(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___NUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___NUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___NUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___NUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS___NUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS______DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS______NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS______DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS______DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKS_________(...) SAC_ND_ALLOC__DESC_AND_DATA__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHID___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHID___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHID___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHID___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHID___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHID______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNS___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNS___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNS___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNS___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNS___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCLHNS______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___NUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___NUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___NUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___NUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___NUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL___NUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL______DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL______DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL______NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL______DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL______DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_SCL_________(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDUNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDUNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDUNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDUNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDUNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHDUNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHD___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHD___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHD___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHD___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHD___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDNHD______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDUNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDUNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDUNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDUNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDUNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHIDUNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHID___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHID___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHID___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHID___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHID___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHID______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSUNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSUNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSUNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSUNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSUNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNSUNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNS___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNS___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNS___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNS___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNS___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKDHNS______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___NUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___NUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___NUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___NUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___NUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___NUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___UNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___UNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___UNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___UNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___UNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD___UNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD______DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD______DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD______NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD______DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD______DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AKD_________(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDUNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDUNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDUNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDUNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDUNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHDUNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHD___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHD___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHD___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHD___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHD___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDNHD______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDUNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDUNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDUNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDUNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDUNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHIDUNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHID___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHID___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHID___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHID___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHID___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHID______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSUNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSUNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSUNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSUNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSUNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNSUNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNS___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNS___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNS___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNS___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNS___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUDHNS______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___NUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___NUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___NUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___NUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___NUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___NUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___UNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___UNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___UNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___UNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___UNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD___UNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD______DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD______DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD______NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD______DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD______DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_AUD_________(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDUNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDUNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDUNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDUNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDUNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHDUNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHD___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHD___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHD___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHD___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHD___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____NHD______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDUNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDUNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDUNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDUNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDUNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HIDUNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HID___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HID___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HID___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HID___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HID___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HID______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSNUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSNUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSNUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSNUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSNUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSNUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSUNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSUNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSUNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSUNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSUNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNSUNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNS___DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNS___DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNS___NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNS___DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNS___DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA____HNS______(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______NUQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______NUQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______NUQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______NUQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______NUQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______NUQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______UNQDIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______UNQDSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______UNQNDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______UNQDCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______UNQDLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_______UNQ___(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA__________DIS(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA__________DSM(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA__________NDI(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA__________DCA(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA__________DLO(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_ALLOC__DESC_AND_DATA_____________(...) SAC_ND_ALLOC__DESC_AND_DATA__UNDEF(__VA_ARGS__)
#define SAC_ND_FREE__DESC( nt ) CAT_M4_std_gen_93(SAC_ND_FREE__DESC_, CAT_M4_std_gen_94(NT_SHP(nt), CAT_M4_std_gen_95(NT_HID(nt), CAT_M4_std_gen_96(NT_UNQ(nt), NT_DIS(nt)))))( nt )
#define SAC_ND_FREE__DESC_SCLNHDNUQDIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDNUQDSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDNUQNDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDNUQDCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDNUQDLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDNUQ___(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDUNQDIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDUNQDSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDUNQNDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDUNQDCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDUNQDLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHDUNQ___(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHD___DIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHD___DSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHD___NDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHD___DCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHD___DLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLNHD______(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDUNQDIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDUNQDSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDUNQNDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDUNQDCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDUNQDLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDUNQ___(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSNUQDIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSNUQDSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSNUQNDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSNUQDCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSNUQDLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSNUQ___(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSUNQDIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSUNQDSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSUNQNDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSUNQDCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSUNQDLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNSUNQ___(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___UNQDIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___UNQDSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___UNQNDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___UNQDCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___UNQDLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___UNQ___(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDUNQDIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDUNQDSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDUNQNDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDUNQDCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDUNQDLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDUNQ___(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDUNQDIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDUNQDSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDUNQNDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDUNQDCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDUNQDLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDUNQ___(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSUNQDIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSUNQDSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSUNQNDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSUNQDCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSUNQDLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSUNQ___(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___UNQDIS(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___UNQDSM(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___UNQNDI(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___UNQDCA(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___UNQDLO(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___UNQ___(...) SAC_ND_FREE__DESC__NOOP(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHIDNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHID___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHID___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHID___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHID___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHID___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHID______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNS___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNS___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNS___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNS___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNS___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCLHNS______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___NUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___NUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___NUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___NUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___NUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL___NUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL______DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL______DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL______NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL______DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL______DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_SCL_________(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHDNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHD___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHD___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHD___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHD___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHD___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSNHD______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHIDNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHID___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHID___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHID___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHID___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHID___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHID______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNSNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNS___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNS___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNS___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNS___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNS___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKSHNS______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___NUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___NUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___NUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___NUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___NUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS___NUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS______DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS______DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS______NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS______DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS______DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKS_________(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDUNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDUNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDUNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDUNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDUNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHDUNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHD___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHD___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHD___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHD___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHD___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDNHD______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDUNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDUNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDUNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDUNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDUNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHIDUNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHID___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHID___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHID___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHID___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHID___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHID______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSUNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSUNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSUNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSUNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSUNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNSUNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNS___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNS___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNS___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNS___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNS___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKDHNS______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___NUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___NUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___NUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___NUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___NUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___NUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___UNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___UNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___UNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___UNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___UNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD___UNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD______DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD______DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD______NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD______DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD______DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AKD_________(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDUNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDUNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDUNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDUNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDUNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHDUNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHD___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHD___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHD___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHD___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHD___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDNHD______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDUNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDUNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDUNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDUNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDUNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHIDUNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHID___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHID___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHID___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHID___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHID___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHID______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSUNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSUNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSUNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSUNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSUNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNSUNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNS___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNS___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNS___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNS___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNS___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUDHNS______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___NUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___NUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___NUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___NUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___NUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___NUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___UNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___UNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___UNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___UNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___UNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD___UNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD______DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD______DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD______NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD______DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD______DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_AUD_________(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDUNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDUNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDUNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDUNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDUNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHDUNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHD___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHD___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHD___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHD___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHD___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____NHD______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDUNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDUNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDUNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDUNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDUNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HIDUNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HID___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HID___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HID___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HID___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HID___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HID______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSNUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSNUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSNUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSNUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSNUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSNUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSUNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSUNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSUNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSUNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSUNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNSUNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNS___DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNS___DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNS___NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNS___DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNS___DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC____HNS______(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______NUQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______NUQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______NUQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______NUQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______NUQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______NUQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______UNQDIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______UNQDSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______UNQNDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______UNQDCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______UNQDLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_______UNQ___(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC__________DIS(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC__________DSM(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC__________NDI(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC__________DCA(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC__________DLO(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DESC_____________(...) SAC_ND_FREE__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_FREE__DATA( nt , gra1) CAT_M4_std_gen_97(SAC_ND_FREE__DATA_, CAT_M4_std_gen_98(NT_SHP(nt), CAT_M4_std_gen_99(NT_HID(nt), NT_DIS(nt))))( nt , gra1)
#define SAC_ND_FREE__DATA_SCLNHDDIS(...) SAC_ND_FREE__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLNHDDSM(...) SAC_ND_FREE__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLNHDNDI(...) SAC_ND_FREE__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLNHDDCA(...) SAC_ND_FREE__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLNHDDLO(...) SAC_ND_FREE__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLNHD___(...) SAC_ND_FREE__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHIDDIS(...) SAC_ND_FREE__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHIDDSM(...) SAC_ND_FREE__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHIDNDI(...) SAC_ND_FREE__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHIDDCA(...) SAC_ND_FREE__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHIDDLO(...) SAC_ND_FREE__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHID___(...) SAC_ND_FREE__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHNSDIS(...) SAC_ND_FREE__DATA__SCL_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHNSDSM(...) SAC_ND_FREE__DATA__SCL_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHNSNDI(...) SAC_ND_FREE__DATA__SCL_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHNSDCA(...) SAC_ND_FREE__DATA__SCL_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHNSDLO(...) SAC_ND_FREE__DATA__SCL_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_SCLHNS___(...) SAC_ND_FREE__DATA__SCL_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSNHDDIS(...) SAC_ND_FREE__DATA__AKS_NHD_DIS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSNHDDSM(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSNHDNDI(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSNHDDCA(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSNHDDLO(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSNHD___(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHIDDIS(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHIDDSM(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHIDNDI(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHIDDCA(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHIDDLO(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHID___(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHNSDIS(...) SAC_ND_FREE__DATA__AKS_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHNSDSM(...) SAC_ND_FREE__DATA__AKS_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHNSNDI(...) SAC_ND_FREE__DATA__AKS_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHNSDCA(...) SAC_ND_FREE__DATA__AKS_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHNSDLO(...) SAC_ND_FREE__DATA__AKS_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKSHNS___(...) SAC_ND_FREE__DATA__AKS_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDNHDDIS(...) SAC_ND_FREE__DATA__AKD_AUD_NHD_DIS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDNHDDSM(...) SAC_ND_FREE__DATA__AKD_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDNHDNDI(...) SAC_ND_FREE__DATA__AKD_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDNHDDCA(...) SAC_ND_FREE__DATA__AKD_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDNHDDLO(...) SAC_ND_FREE__DATA__AKD_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDNHD___(...) SAC_ND_FREE__DATA__AKD_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHIDDIS(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHIDDSM(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHIDNDI(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHIDDCA(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHIDDLO(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHID___(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDNHDDIS(...) SAC_ND_FREE__DATA__AKD_AUD_NHD_DIS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDNHDDSM(...) SAC_ND_FREE__DATA__AKD_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDNHDNDI(...) SAC_ND_FREE__DATA__AKD_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDNHDDCA(...) SAC_ND_FREE__DATA__AKD_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDNHDDLO(...) SAC_ND_FREE__DATA__AKD_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDNHD___(...) SAC_ND_FREE__DATA__AKD_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHIDDIS(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHIDDSM(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHIDNDI(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHIDDCA(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHIDDLO(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHID___(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA____NHDDIS(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA____NHDDSM(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA____NHDNDI(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA____NHDDCA(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA____NHDDLO(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA____NHD___(...) SAC_ND_FREE__DATA__AKS_NHD(__VA_ARGS__)
#define SAC_ND_FREE__DATA____HIDDIS(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA____HIDDSM(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA____HIDNDI(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA____HIDDCA(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA____HIDDLO(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA____HID___(...) SAC_ND_FREE__DATA__AKS_HID(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHNSDIS(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHNSDSM(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHNSNDI(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHNSDCA(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHNSDLO(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AKDHNS___(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHNSDIS(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHNSDSM(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHNSNDI(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHNSDCA(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHNSDLO(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_FREE__DATA_AUDHNS___(...) SAC_ND_FREE__DATA__AKD_HNS(__VA_ARGS__)
#define SAC_ND_PRF_SECOND( nt , gra1) CAT_M4_std_gen_100(SAC_ND_PRF_SECOND_, CAT_M4_std_gen_101(NT_SHP(nt), CAT_M4_std_gen_102(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_PRF_SECOND_SCLNHDNUQ(...) SAC_ND_PRF_SECOND_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCLNHDUNQ(...) SAC_ND_PRF_SECOND_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCLNHD___(...) SAC_ND_PRF_SECOND_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCLHIDUNQ(...) SAC_ND_PRF_SECOND_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCLHNSUNQ(...) SAC_ND_PRF_SECOND_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCL___UNQ(...) SAC_ND_PRF_SECOND_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKSNHDUNQ(...) SAC_ND_PRF_SECOND_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKSHIDUNQ(...) SAC_ND_PRF_SECOND_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKSHNSUNQ(...) SAC_ND_PRF_SECOND_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKS___UNQ(...) SAC_ND_PRF_SECOND_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCLHIDNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCLHID___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCLHNSNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCLHNS___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCL___NUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_SCL______(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKSNHDNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKSNHD___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKSHIDNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKSHID___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKSHNSNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKSHNS___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKS___NUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKS______(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKDNHDNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKDNHDUNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKDNHD___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKDHIDNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKDHIDUNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKDHID___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKDHNSNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKDHNSUNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKDHNS___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKD___NUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKD___UNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AKD______(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUDNHDNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUDNHDUNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUDNHD___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUDHIDNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUDHIDUNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUDHID___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUDHNSNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUDHNSUNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUDHNS___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUD___NUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUD___UNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_AUD______(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND____NHDNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND____NHDUNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND____NHD___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND____HIDNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND____HIDUNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND____HID___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND____HNSNUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND____HNSUNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND____HNS___(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_______NUQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND_______UNQ(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SECOND__________(...) SAC_ND_PRF_SECOND_DESC(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV( arg1, nt , gra1) CAT_M4_std_gen_103(SAC_ND_PRF_TYPE_CONV_, NT_SHP(nt))( arg1, nt , gra1)
#define SAC_ND_PRF_TYPE_CONV_SCL(...) SAC_ND_PRF_TYPE_CONV__SCL(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV_AKD(...) SAC_ND_PRF_TYPE_CONV__AKD(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV_AUD(...) SAC_ND_PRF_TYPE_CONV__AUD(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV__AUD( arg1, arg2, nt ) CAT_M4_std_gen_104(SAC_ND_PRF_TYPE_CONV__AUD_, NT_SHP(nt))( arg1, arg2, nt )
#define SAC_ND_PRF_TYPE_CONV__AUD_AUD(...) SAC_ND_PRF_TYPE_CONV__AUD__AUD(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV__AUD_SCL(...) SAC_ND_PRF_TYPE_CONV__AUD__SHP(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV__AUD_AKS(...) SAC_ND_PRF_TYPE_CONV__AUD__SHP(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV__AUD_AKD(...) SAC_ND_PRF_TYPE_CONV__AUD__SHP(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV__AUD____(...) SAC_ND_PRF_TYPE_CONV__AUD__SHP(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV__SCL( arg1, arg2, nt ) CAT_M4_std_gen_105(SAC_ND_PRF_TYPE_CONV__SCL_, NT_SHP(nt))( arg1, arg2, nt )
#define SAC_ND_PRF_TYPE_CONV__SCL_SCL(...) SAC_ND_PRF_TYPE_CONV__SCL__SCL(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV__SCL_AKS(...) SAC_ND_PRF_TYPE_CONV__SCL__SHP(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV__SCL_AKD(...) SAC_ND_PRF_TYPE_CONV__SCL__SHP(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV__SCL_AUD(...) SAC_ND_PRF_TYPE_CONV__SCL__SHP(__VA_ARGS__)
#define SAC_ND_PRF_TYPE_CONV__SCL____(...) SAC_ND_PRF_TYPE_CONV__SCL__SHP(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA( nt , gra1, gra2) CAT_M4_std_gen_106(SAC_ND_ASSIGN__DATA_, CAT_M4_std_gen_107(NT_SHP(nt), CAT_M4_std_gen_108(NT_HID(nt), NT_DIS(nt))))( nt , gra1, gra2)
#define SAC_ND_ASSIGN__DATA_SCLNHDDIS(...) GEN_SAC_ND_ASSIGN__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLNHDDSM(...) GEN_SAC_ND_ASSIGN__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLNHDNDI(...) GEN_SAC_ND_ASSIGN__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLNHDDCA(...) GEN_SAC_ND_ASSIGN__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLNHDDLO(...) GEN_SAC_ND_ASSIGN__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLNHD___(...) GEN_SAC_ND_ASSIGN__DATA__SCL_NHD(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLHIDDIS(...) GEN_SAC_ND_ASSIGN__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLHIDDSM(...) GEN_SAC_ND_ASSIGN__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLHIDNDI(...) GEN_SAC_ND_ASSIGN__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLHIDDCA(...) GEN_SAC_ND_ASSIGN__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLHIDDLO(...) GEN_SAC_ND_ASSIGN__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_SCLHID___(...) GEN_SAC_ND_ASSIGN__DATA__SCL_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSNHDDIS(...) GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSNHDDSM(...) GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSNHDNDI(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSNHDDCA(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSNHDDLO(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSNHD___(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHIDDIS(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHIDDSM(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHIDNDI(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHIDDCA(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHIDDLO(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHID___(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHNSDIS(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHNSDSM(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHNSNDI(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHNSDCA(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHNSDLO(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKSHNS___(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKS___DIS(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKS___DSM(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKS___NDI(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKS___DCA(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKS___DLO(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKS______(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDNHDDIS(...) GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDNHDDSM(...) GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDNHDNDI(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDNHDDCA(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDNHDDLO(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDNHD___(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHIDDIS(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHIDDSM(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHIDNDI(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHIDDCA(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHIDDLO(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHID___(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHNSDIS(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHNSDSM(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHNSNDI(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHNSDCA(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHNSDLO(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKDHNS___(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKD___DIS(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKD___DSM(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKD___NDI(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKD___DCA(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKD___DLO(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AKD______(...) GEN_SAC_ND_ASSIGN__DATA__AKS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDNHDDIS(...) GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDNHDDSM(...) GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDNHDNDI(...) GEN_SAC_ND_ASSIGN__DATA__AUD_NHD(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDNHDDCA(...) GEN_SAC_ND_ASSIGN__DATA__AUD_NHD(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDNHDDLO(...) GEN_SAC_ND_ASSIGN__DATA__AUD_NHD(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDNHD___(...) GEN_SAC_ND_ASSIGN__DATA__AUD_NHD(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHIDDIS(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHIDDSM(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHIDNDI(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHIDDCA(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHIDDLO(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHID___(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HID(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHNSDIS(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HNS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHNSDSM(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HNS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHNSNDI(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HNS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHNSDCA(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HNS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHNSDLO(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HNS(__VA_ARGS__)
#define SAC_ND_ASSIGN__DATA_AUDHNS___(...) GEN_SAC_ND_ASSIGN__DATA__AUD_HNS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD( arg1, nt , gra1) CAT_M4_std_gen_109(GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_, CAT_M4_std_gen_110(NT_SHP(nt), NT_HID(nt)))( arg1, nt , gra1)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_SCLNHD(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_SCLHID(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_SCLHNS(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_SCL___(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AUDNHD(...) SAC_ND_ASSIGN__DATA__SCL_AUD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AKSNHD(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AKSHID(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AKSHNS(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AKS___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AKDNHD(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AKDHID(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AKDHNS(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AKD___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AUDHID(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AUDHNS(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_AUD___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD____NHD(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD____HID(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD____HNS(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_NHD_______(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID( arg1, nt , gra1) CAT_M4_std_gen_111(GEN_SAC_ND_ASSIGN__DATA__SCL_HID_, CAT_M4_std_gen_112(NT_SHP(nt), CAT_M4_std_gen_113(NT_HID(nt), NT_UNQ(nt))))( arg1, nt , gra1)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCLNHDNUQ(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCLNHDUNQ(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCLNHD___(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCLHIDNUQ(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCLHIDUNQ(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCLHID___(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCLHNSNUQ(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCLHNSUNQ(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCLHNS___(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCL___NUQ(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCL___UNQ(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_SCL______(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUDHIDNUQ(...) SAC_ND_ASSIGN__DATA__SCL_AUD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUDHIDUNQ(...) SAC_ND_ASSIGN__DATA__SCL_AUD_UNQ(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKSNHDNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKSNHDUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKSNHD___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKSHIDNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKSHIDUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKSHID___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKSHNSNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKSHNSUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKSHNS___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKS___NUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKS___UNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKS______(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKDNHDNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKDNHDUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKDNHD___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKDHIDNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKDHIDUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKDHID___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKDHNSNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKDHNSUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKDHNS___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKD___NUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKD___UNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AKD______(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUDNHDNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUDNHDUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUDNHD___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUDHID___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUDHNSNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUDHNSUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUDHNS___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUD___NUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUD___UNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_AUD______(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID____NHDNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID____NHDUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID____NHD___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID____HIDNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID____HIDUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID____HID___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID____HNSNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID____HNSUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID____HNS___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_______NUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID_______UNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__SCL_HID__________(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS( arg1, nt , gra1) CAT_M4_std_gen_114(GEN_SAC_ND_ASSIGN__DATA__AKS_, CAT_M4_std_gen_115(NT_SHP(nt), NT_DIS(nt)))( arg1, nt , gra1)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_SCLDIS(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_SCLDSM(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_SCLNDI(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_SCLDCA(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_SCLDLO(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_SCL___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKSDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKDDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AUDDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS____DIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKSDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKDDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AUDDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS____DSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKSNDI(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKSDCA(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKSDLO(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKS___(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKDNDI(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKDDCA(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKDDLO(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD___(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AUDNDI(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AUDDCA(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AUDDLO(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AUD___(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS____NDI(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS____DCA(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS____DLO(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_______(...) SAC_ND_ASSIGN__DATA__AKS_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS( arg1, nt , gra1) CAT_M4_std_gen_116(GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_, CAT_M4_std_gen_117(NT_SHP(nt), NT_DIS(nt)))( arg1, nt , gra1)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_SCLDIS(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_SCLDSM(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_SCLNDI(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_SCLDCA(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_SCLDLO(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_SCL___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKSDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKSDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKSNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKSDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKSDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKS___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKDDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKDDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKDNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKDDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKDDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AKD___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AUDDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AUDDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AUDNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AUDDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AUDDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_AUD___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS____DIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS____DSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS____NDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS____DCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS____DLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DIS_______(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM( arg1, nt , gra1) CAT_M4_std_gen_118(GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_, CAT_M4_std_gen_119(NT_SHP(nt), NT_DIS(nt)))( arg1, nt , gra1)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_SCLDIS(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_SCLDSM(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_SCLNDI(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_SCLDCA(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_SCLDLO(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_SCL___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKSDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKSDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKSNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKSDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKSDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKS___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKDDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKDDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKDNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKDDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKDDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AKD___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AUDDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AUDDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AUDNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AUDDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AUDDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_AUD___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM____DIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM____DSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM____NDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM____DCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM____DLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AKS_AKD_DSM_______(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD( arg1, nt , gra1) CAT_M4_std_gen_120(GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_, CAT_M4_std_gen_121(NT_SHP(nt), CAT_M4_std_gen_122(NT_HID(nt), NT_DIS(nt))))( arg1, nt , gra1)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLNHDDIS(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLNHDDSM(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLNHDNDI(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLNHDDCA(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLNHDDLO(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLNHD___(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHIDDIS(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHIDDSM(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHIDNDI(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHIDDCA(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHIDDLO(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHID___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCL___DIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSNHDDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHIDDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKS___DIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDNHDDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHIDDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKD___DIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDNHDDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHIDDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUD___DIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____NHDDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HIDDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HNSDIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_______DIS(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCL___DSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSNHDDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHIDDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKS___DSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDNHDDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHIDDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKD___DSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDNHDDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHIDDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUD___DSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____NHDDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HIDDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HNSDSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_______DSM(...) SAC_ND_ASSIGN__DATA__TO_NDI(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHNSNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHNSDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHNSDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCLHNS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCL___NDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCL___DCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCL___DLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_SCL______(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSNHDNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSNHDDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSNHDDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSNHD___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHIDNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHIDDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHIDDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHID___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHNSNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHNSDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHNSDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKSHNS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKS___NDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKS___DCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKS___DLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKS______(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDNHDNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDNHDDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDNHDDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDNHD___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHIDNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHIDDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHIDDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHID___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHNSNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHNSDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHNSDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKDHNS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKD___NDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKD___DCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKD___DLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AKD______(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDNHDNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDNHDDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDNHDDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDNHD___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHIDNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHIDDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHIDDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHID___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHNSNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHNSDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHNSDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUDHNS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUD___NDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUD___DCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUD___DLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_AUD______(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____NHDNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____NHDDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____NHDDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____NHD___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HIDNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HIDDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HIDDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HID___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HNSNDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HNSDCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HNSDLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD____HNS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_______NDI(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_______DCA(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_______DLO(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD__________(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS( arg1, nt , gra1) CAT_M4_std_gen_123(GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_, CAT_M4_std_gen_124(NT_SHP(nt), CAT_M4_std_gen_125(NT_HID(nt), NT_DIS(nt))))( arg1, nt , gra1)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLNHDDIS(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLNHDDSM(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLNHDNDI(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLNHDDCA(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLNHDDLO(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLNHD___(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHIDDIS(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHIDDSM(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHIDNDI(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHIDDCA(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHIDDLO(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHID___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHNSNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHNSDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHNSDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCLHNS___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCL___DIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCL___DSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCL___NDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCL___DCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCL___DLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_SCL______(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSNHDDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSNHDDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSNHDNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSNHDDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSNHDDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSNHD___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHIDDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHIDDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHIDNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHIDDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHIDDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHID___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHNSNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHNSDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHNSDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKSHNS___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKS___DIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKS___DSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKS___NDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKS___DCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKS___DLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKS______(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDNHDDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDNHDDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDNHDNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDNHDDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDNHDDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDNHD___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHIDDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHIDDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHIDNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHIDDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHIDDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHID___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHNSNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHNSDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHNSDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKDHNS___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKD___DIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKD___DSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKD___NDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKD___DCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKD___DLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AKD______(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDNHDDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDNHDDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDNHDNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDNHDDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDNHDDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDNHD___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHIDDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHIDDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHIDNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHIDDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHIDDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHID___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHNSNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHNSDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHNSDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUDHNS___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUD___DIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUD___DSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUD___NDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUD___DCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUD___DLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_AUD______(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____NHDDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____NHDDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____NHDNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____NHDDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____NHDDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____NHD___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HIDDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HIDDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HIDNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HIDDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HIDDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HID___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HNSDIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HNSDSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HNSNDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HNSDCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HNSDLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS____HNS___(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_______DIS(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_______DSM(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_______NDI(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_______DCA(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS_______DLO(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DIS__________(...) SAC_ND_ASSIGN__DATA__TO_DIS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM( arg1, nt , gra1) CAT_M4_std_gen_126(GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_, CAT_M4_std_gen_127(NT_SHP(nt), CAT_M4_std_gen_128(NT_HID(nt), NT_DIS(nt))))( arg1, nt , gra1)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLNHDDIS(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLNHDDSM(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLNHDNDI(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLNHDDCA(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLNHDDLO(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLNHD___(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHIDDIS(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHIDDSM(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHIDNDI(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHIDDCA(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHIDDLO(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHID___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHNSNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHNSDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHNSDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCLHNS___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCL___DIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCL___DSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCL___NDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCL___DCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCL___DLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_SCL______(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSNHDDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSNHDDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSNHDNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSNHDDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSNHDDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSNHD___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHIDDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHIDDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHIDNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHIDDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHIDDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHID___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHNSNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHNSDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHNSDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKSHNS___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKS___DIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKS___DSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKS___NDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKS___DCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKS___DLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKS______(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDNHDDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDNHDDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDNHDNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDNHDDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDNHDDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDNHD___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHIDDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHIDDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHIDNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHIDDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHIDDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHID___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHNSNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHNSDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHNSDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKDHNS___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKD___DIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKD___DSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKD___NDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKD___DCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKD___DLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AKD______(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDNHDDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDNHDDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDNHDNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDNHDDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDNHDDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDNHD___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHIDDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHIDDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHIDNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHIDDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHIDDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHID___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHNSDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHNSDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHNSNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHNSDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHNSDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUDHNS___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUD___DIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUD___DSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUD___NDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUD___DCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUD___DLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_AUD______(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____NHDDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____NHDDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____NHDNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____NHDDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____NHDDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____NHD___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HIDDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HIDDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HIDNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HIDDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HIDDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HID___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HNSDIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HNSDSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HNSNDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HNSDCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HNSDLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM____HNS___(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_______DIS(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_______DSM(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_______NDI(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_______DCA(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM_______DLO(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_NHD_DSM__________(...) SAC_ND_ASSIGN__DATA__TO_DSM(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID( arg1, nt , gra1) CAT_M4_std_gen_129(GEN_SAC_ND_ASSIGN__DATA__AUD_HID_, CAT_M4_std_gen_130(NT_SHP(nt), CAT_M4_std_gen_131(NT_HID(nt), NT_UNQ(nt))))( arg1, nt , gra1)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCLHIDNUQ(...) SAC_ND_ASSIGN__DATA__AUD_SCL_NHD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCLHIDUNQ(...) SAC_ND_ASSIGN__DATA__AUD_SCL_UNQ(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCLNHDNUQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCLNHDUNQ(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCLNHD___(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCLHID___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCLHNSNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCLHNSUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCLHNS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCL___NUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCL___UNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_SCL______(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKSNHDNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKSNHDUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKSNHD___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKSHIDNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKSHIDUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKSHID___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKSHNSNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKSHNSUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKSHNS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKS___NUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKS___UNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKS______(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKDNHDNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKDNHDUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKDNHD___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKDHIDNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKDHIDUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKDHID___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKDHNSNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKDHNSUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKDHNS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKD___NUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKD___UNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AKD______(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUDNHDNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUDNHDUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUDNHD___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUDHIDNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUDHIDUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUDHID___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUDHNSNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUDHNSUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUDHNS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUD___NUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUD___UNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_AUD______(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID____NHDNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID____NHDUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID____NHD___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID____HIDNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID____HIDUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID____HID___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID____HNSNUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID____HNSUNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID____HNS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_______NUQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID_______UNQ(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HID__________(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define SAC_ND_COPY__DATA( nt , gra1, gra2) CAT_M4_std_gen_132(SAC_ND_COPY__DATA_, CAT_M4_std_gen_133(NT_SHP(nt), NT_DIS(nt)))( nt , gra1, gra2)
#define SAC_ND_COPY__DATA_SCLDIS(...) GEN_SAC_ND_COPY__DATA__SCL(__VA_ARGS__)
#define SAC_ND_COPY__DATA_SCLDSM(...) GEN_SAC_ND_COPY__DATA__SCL(__VA_ARGS__)
#define SAC_ND_COPY__DATA_SCLNDI(...) GEN_SAC_ND_COPY__DATA__SCL(__VA_ARGS__)
#define SAC_ND_COPY__DATA_SCLDCA(...) GEN_SAC_ND_COPY__DATA__SCL(__VA_ARGS__)
#define SAC_ND_COPY__DATA_SCLDLO(...) GEN_SAC_ND_COPY__DATA__SCL(__VA_ARGS__)
#define SAC_ND_COPY__DATA_SCL___(...) GEN_SAC_ND_COPY__DATA__SCL(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKSDIS(...) GEN_SAC_ND_COPY__DATA__DIS(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKDDIS(...) GEN_SAC_ND_COPY__DATA__DIS(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AUDDIS(...) GEN_SAC_ND_COPY__DATA__DIS(__VA_ARGS__)
#define SAC_ND_COPY__DATA____DIS(...) GEN_SAC_ND_COPY__DATA__DIS(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKSDSM(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKSNDI(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKSDCA(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKSDLO(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKS___(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKDDSM(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKDNDI(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKDDCA(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKDDLO(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AKD___(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AUDDSM(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AUDNDI(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AUDDCA(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AUDDLO(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_AUD___(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA____DSM(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA____NDI(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA____DCA(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA____DLO(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define SAC_ND_COPY__DATA_______(...) GEN_SAC_ND_COPY__DATA__ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__SCL( arg1, nt , gra1) CAT_M4_std_gen_134(GEN_SAC_ND_COPY__DATA__SCL_, NT_SHP(nt))( arg1, nt , gra1)
#define GEN_SAC_ND_COPY__DATA__SCL_SCL(...) SAC_ND_COPY__DATA__SCL_SCL(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__SCL_AKS(...) SAC_ND_COPY__DATA__SCL_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__SCL_AKD(...) SAC_ND_COPY__DATA__SCL_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__SCL_AUD(...) SAC_ND_COPY__DATA__SCL_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__SCL____(...) SAC_ND_COPY__DATA__SCL_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__ANY( arg1, nt , gra1) CAT_M4_std_gen_135(GEN_SAC_ND_COPY__DATA__ANY_, NT_SHP(nt))( arg1, nt , gra1)
#define GEN_SAC_ND_COPY__DATA__ANY_SCL(...) SAC_ND_COPY__DATA__ANY_SCL(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__ANY_AKS(...) SAC_ND_COPY__DATA__ANY_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__ANY_AKD(...) SAC_ND_COPY__DATA__ANY_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__ANY_AUD(...) SAC_ND_COPY__DATA__ANY_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__ANY____(...) SAC_ND_COPY__DATA__ANY_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__DIS( arg1, nt , gra1) CAT_M4_std_gen_136(GEN_SAC_ND_COPY__DATA__DIS_, NT_SHP(nt))( arg1, nt , gra1)
#define GEN_SAC_ND_COPY__DATA__DIS_SCL(...) SAC_ND_COPY__DATA__ANY_SCL(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__DIS_AKS(...) SAC_ND_COPY__DATA__DIS_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__DIS_AKD(...) SAC_ND_COPY__DATA__DIS_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__DIS_AUD(...) SAC_ND_COPY__DATA__DIS_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DATA__DIS____(...) SAC_ND_COPY__DATA__DIS_ANY(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DESC( nt , gra1, gra2) CAT_M4_std_gen_137(GEN_SAC_ND_COPY__DESC_, NT_SHP(nt))( nt , gra1, gra2)
#define GEN_SAC_ND_COPY__DESC_SCL(...) SAC_ND_COPY__DESC_SCL(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DESC_AKS(...) SAC_ND_COPY__DESC_AKS(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DESC_AKD(...) SAC_ND_COPY__DESC_AKD(__VA_ARGS__)
#define GEN_SAC_ND_COPY__DESC_AUD(...) SAC_ND_COPY__DESC_AUD(__VA_ARGS__)
#define SAC_ND_SET__RC( nt , gra1) CAT_M4_std_gen_138(SAC_ND_SET__RC_, CAT_M4_std_gen_139(NT_SHP(nt), CAT_M4_std_gen_140(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_SET__RC_SCLNHDUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_SCLHIDUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_SCLHNSUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_SCL___UNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AKSNHDUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AKSHIDUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AKSHNSUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AKS___UNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AKDNHDUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AKDHIDUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AKDHNSUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AKD___UNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AUDNHDUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AUDHIDUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AUDHNSUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_AUD___UNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC____NHDUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC____HIDUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC____HNSUNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_______UNQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_SCLNHDNUQ(...) SAC_ND_SET__RC__NOOP(__VA_ARGS__)
#define SAC_ND_SET__RC_SCLHIDNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_SCLHNSNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_SCL___NUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AKSNHDNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AKSHIDNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AKSHNSNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AKS___NUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AKDNHDNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AKDHIDNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AKDHNSNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AKD___NUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AUDNHDNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AUDHIDNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AUDHNSNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_AUD___NUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC____NHDNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC____HIDNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC____HNSNUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_SET__RC_______NUQ(...) SAC_ND_SET__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC( nt , gra1) CAT_M4_std_gen_141(SAC_ND_INIT__RC_, CAT_M4_std_gen_142(NT_SHP(nt), CAT_M4_std_gen_143(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_INIT__RC_SCLNHDUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_SCLHIDUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_SCLHNSUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_SCL___UNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKSNHDUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKSHIDUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKSHNSUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKS___UNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKDNHDUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKDHIDUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKDHNSUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKD___UNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AUDNHDUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AUDHIDUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AUDHNSUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_AUD___UNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC____NHDUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC____HIDUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC____HNSUNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_______UNQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_SCLNHDNUQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_SCLHNSNUQ(...) SAC_ND_INIT__RC__NOOP(__VA_ARGS__)
#define SAC_ND_INIT__RC_SCLHIDNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_SCL___NUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKSNHDNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKSHIDNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKSHNSNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKS___NUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKDNHDNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKDHIDNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKDHNSNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AKD___NUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AUDNHDNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AUDHIDNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AUDHNSNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_AUD___NUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC____NHDNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC____HIDNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC____HNSNUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INIT__RC_______NUQ(...) SAC_ND_INIT__RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC( nt , gra1) CAT_M4_std_gen_144(SAC_ND_INC_RC_, CAT_M4_std_gen_145(NT_SHP(nt), CAT_M4_std_gen_146(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_INC_RC_SCLNHDUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_SCLHIDUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_SCLHNSUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_SCL___UNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AKSNHDUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AKSHIDUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AKSHNSUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AKS___UNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AKDNHDUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AKDHIDUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AKDHNSUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AKD___UNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AUDNHDUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AUDHIDUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AUDHNSUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_AUD___UNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC____NHDUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC____HIDUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC____HNSUNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_______UNQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_SCLNHDNUQ(...) SAC_ND_INC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_INC_RC_SCLHIDNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_SCLHNSNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_SCL___NUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AKSNHDNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AKSHIDNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AKSHNSNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AKS___NUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AKDNHDNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AKDHIDNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AKDHNSNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AKD___NUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AUDNHDNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AUDHIDNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AUDHNSNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_AUD___NUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC____NHDNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC____HIDNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC____HNSNUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_INC_RC_______NUQ(...) SAC_ND_INC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC( nt , gra1) CAT_M4_std_gen_147(SAC_ND_DEC_RC_, CAT_M4_std_gen_148(NT_SHP(nt), CAT_M4_std_gen_149(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_DEC_RC_SCLNHDUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_SCLHIDUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_SCLHNSUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_SCL___UNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKSNHDUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKSHIDUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKSHNSUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKS___UNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKDNHDUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKDHIDUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKDHNSUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKD___UNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AUDNHDUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AUDHIDUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AUDHNSUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_AUD___UNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC____NHDUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC____HIDUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC____HNSUNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_______UNQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_SCLNHDNUQ(...) SAC_ND_DEC_RC__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_SCLHIDNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_SCLHNSNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_SCL___NUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKSNHDNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKSHIDNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKSHNSNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKS___NUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKDNHDNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKDHIDNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKDHNSNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AKD___NUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AUDNHDNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AUDHIDNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AUDHNSNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_AUD___NUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC____NHDNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC____HIDNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC____HNSNUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_______NUQ(...) SAC_ND_DEC_RC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE( nt , gra1, gra2) CAT_M4_std_gen_150(SAC_ND_DEC_RC_FREE_, CAT_M4_std_gen_151(NT_SHP(nt), CAT_M4_std_gen_152(NT_HID(nt), NT_UNQ(nt))))( nt , gra1, gra2)
#define SAC_ND_DEC_RC_FREE_SCLNHDUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_SCLHIDUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_SCLHNSUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_SCL___UNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKSNHDUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKSHIDUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKSHNSUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKS___UNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKDNHDUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKDHIDUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKDHNSUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKD___UNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AUDNHDUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AUDHIDUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AUDHNSUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AUD___UNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE____NHDUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE____HIDUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE____HNSUNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_______UNQ(...) SAC_ND_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_SCLNHDNUQ(...) SAC_ND_DEC_RC_FREE__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_SCLHNSNUQ(...) SAC_ND_DEC_RC_FREE__NOOP(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_SCLHIDNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_SCL___NUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKSNHDNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKSHIDNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKSHNSNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKS___NUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKDNHDNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKDHIDNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKDHNSNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AKD___NUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AUDNHDNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AUDHIDNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AUDHNSNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_AUD___NUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE____NHDNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE____HIDNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE____HNSNUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_ND_DEC_RC_FREE_______NUQ(...) SAC_ND_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN( nt ) CAT_M4_std_gen_153(SAC_IS_LASTREF__BLOCK_BEGIN_, CAT_M4_std_gen_154(NT_SHP(nt), CAT_M4_std_gen_155(NT_HID(nt), NT_UNQ(nt))))( nt )
#define SAC_IS_LASTREF__BLOCK_BEGIN_SCLNHDUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_SCLHIDUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_SCLHNSUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_SCL___UNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKSNHDUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKSHIDUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKSHNSUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKS___UNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKDNHDUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKDHIDUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKDHNSUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKD___UNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AUDNHDUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AUDHIDUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AUDHNSUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AUD___UNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN____NHDUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN____HIDUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN____HNSUNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_______UNQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__UNQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_SCLNHDNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__SCL_NHD_NUQ(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_SCLHIDNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_SCLHNSNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_SCL___NUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKSNHDNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKSHIDNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKSHNSNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKS___NUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKDNHDNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKDHIDNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKDHNSNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AKD___NUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AUDNHDNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AUDHIDNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AUDHNSNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_AUD___NUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN____NHDNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN____HIDNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN____HNSNUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_LASTREF__BLOCK_BEGIN_______NUQ(...) SAC_IS_LASTREF__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_REUSED__BLOCK_BEGIN( nt , gra1) CAT_M4_std_gen_156(SAC_IS_REUSED__BLOCK_BEGIN_, NT_SHP(nt))( nt , gra1)
#define SAC_IS_REUSED__BLOCK_BEGIN_SCL(...) SAC_IS_REUSED__BLOCK_BEGIN__SCL(__VA_ARGS__)
#define SAC_IS_REUSED__BLOCK_BEGIN_AKS(...) SAC_IS_REUSED__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_REUSED__BLOCK_BEGIN_AKD(...) SAC_IS_REUSED__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_REUSED__BLOCK_BEGIN_AUD(...) SAC_IS_REUSED__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_IS_REUSED__BLOCK_BEGIN____(...) SAC_IS_REUSED__BLOCK_BEGIN__DEFAULT(__VA_ARGS__)
#define SAC_UPDATE_A_MIRROR_DIM( nt , gra1) CAT_M4_std_gen_157(SAC_UPDATE_A_MIRROR_DIM_, NT_SHP(nt))( nt , gra1)
#define SAC_UPDATE_A_MIRROR_DIM_AUD(...) SAC_UPDATE_A_MIRROR_DIM__AUD(__VA_ARGS__)
#define SAC_UPDATE_A_MIRROR_DIM_AKD(...) SAC_UPDATE_A_MIRROR_DIM__AKD(__VA_ARGS__)
#define SAC_UPDATE_A_MIRROR_DIM_SCL(...) SAC_UPDATE_A_MIRROR_DIM__UNDEF(__VA_ARGS__)
#define SAC_UPDATE_A_MIRROR_DIM_AKS(...) SAC_UPDATE_A_MIRROR_DIM__UNDEF(__VA_ARGS__)
#define SAC_UPDATE_A_MIRROR_DIM____(...) SAC_UPDATE_A_MIRROR_DIM__UNDEF(__VA_ARGS__)
#define SAC_A_DIM_BEFORE_UPDATE_MIRROR( nt ) CAT_M4_std_gen_158(SAC_A_DIM_BEFORE_UPDATE_MIRROR_, NT_SHP(nt))( nt )
#define SAC_A_DIM_BEFORE_UPDATE_MIRROR_AUD(...) SAC_A_DIM_BEFORE_UPDATE_MIRROR__AUD(__VA_ARGS__)
#define SAC_A_DIM_BEFORE_UPDATE_MIRROR_AKD(...) SAC_A_DIM_BEFORE_UPDATE_MIRROR__AKD(__VA_ARGS__)
#define SAC_A_DIM_BEFORE_UPDATE_MIRROR_SCL(...) SAC_A_DIM_BEFORE_UPDATE_MIRROR__UNDEF(__VA_ARGS__)
#define SAC_A_DIM_BEFORE_UPDATE_MIRROR_AKS(...) SAC_A_DIM_BEFORE_UPDATE_MIRROR__UNDEF(__VA_ARGS__)
#define SAC_A_DIM_BEFORE_UPDATE_MIRROR____(...) SAC_A_DIM_BEFORE_UPDATE_MIRROR__UNDEF(__VA_ARGS__)
#define CAT_M4_std_gen_158(x, y) xCAT_M4_std_gen_158(x, y)
#define xCAT_M4_std_gen_158(x, y) x##y
#define CAT_M4_std_gen_157(x, y) xCAT_M4_std_gen_157(x, y)
#define xCAT_M4_std_gen_157(x, y) x##y
#define CAT_M4_std_gen_156(x, y) xCAT_M4_std_gen_156(x, y)
#define xCAT_M4_std_gen_156(x, y) x##y
#define CAT_M4_std_gen_155(x, y) xCAT_M4_std_gen_155(x, y)
#define xCAT_M4_std_gen_155(x, y) x##y
#define CAT_M4_std_gen_154(x, y) xCAT_M4_std_gen_154(x, y)
#define xCAT_M4_std_gen_154(x, y) x##y
#define CAT_M4_std_gen_153(x, y) xCAT_M4_std_gen_153(x, y)
#define xCAT_M4_std_gen_153(x, y) x##y
#define CAT_M4_std_gen_152(x, y) xCAT_M4_std_gen_152(x, y)
#define xCAT_M4_std_gen_152(x, y) x##y
#define CAT_M4_std_gen_151(x, y) xCAT_M4_std_gen_151(x, y)
#define xCAT_M4_std_gen_151(x, y) x##y
#define CAT_M4_std_gen_150(x, y) xCAT_M4_std_gen_150(x, y)
#define xCAT_M4_std_gen_150(x, y) x##y
#define CAT_M4_std_gen_149(x, y) xCAT_M4_std_gen_149(x, y)
#define xCAT_M4_std_gen_149(x, y) x##y
#define CAT_M4_std_gen_148(x, y) xCAT_M4_std_gen_148(x, y)
#define xCAT_M4_std_gen_148(x, y) x##y
#define CAT_M4_std_gen_147(x, y) xCAT_M4_std_gen_147(x, y)
#define xCAT_M4_std_gen_147(x, y) x##y
#define CAT_M4_std_gen_146(x, y) xCAT_M4_std_gen_146(x, y)
#define xCAT_M4_std_gen_146(x, y) x##y
#define CAT_M4_std_gen_145(x, y) xCAT_M4_std_gen_145(x, y)
#define xCAT_M4_std_gen_145(x, y) x##y
#define CAT_M4_std_gen_144(x, y) xCAT_M4_std_gen_144(x, y)
#define xCAT_M4_std_gen_144(x, y) x##y
#define CAT_M4_std_gen_143(x, y) xCAT_M4_std_gen_143(x, y)
#define xCAT_M4_std_gen_143(x, y) x##y
#define CAT_M4_std_gen_142(x, y) xCAT_M4_std_gen_142(x, y)
#define xCAT_M4_std_gen_142(x, y) x##y
#define CAT_M4_std_gen_141(x, y) xCAT_M4_std_gen_141(x, y)
#define xCAT_M4_std_gen_141(x, y) x##y
#define CAT_M4_std_gen_140(x, y) xCAT_M4_std_gen_140(x, y)
#define xCAT_M4_std_gen_140(x, y) x##y
#define CAT_M4_std_gen_139(x, y) xCAT_M4_std_gen_139(x, y)
#define xCAT_M4_std_gen_139(x, y) x##y
#define CAT_M4_std_gen_138(x, y) xCAT_M4_std_gen_138(x, y)
#define xCAT_M4_std_gen_138(x, y) x##y
#define CAT_M4_std_gen_137(x, y) xCAT_M4_std_gen_137(x, y)
#define xCAT_M4_std_gen_137(x, y) x##y
#define CAT_M4_std_gen_136(x, y) xCAT_M4_std_gen_136(x, y)
#define xCAT_M4_std_gen_136(x, y) x##y
#define CAT_M4_std_gen_135(x, y) xCAT_M4_std_gen_135(x, y)
#define xCAT_M4_std_gen_135(x, y) x##y
#define CAT_M4_std_gen_134(x, y) xCAT_M4_std_gen_134(x, y)
#define xCAT_M4_std_gen_134(x, y) x##y
#define CAT_M4_std_gen_133(x, y) xCAT_M4_std_gen_133(x, y)
#define xCAT_M4_std_gen_133(x, y) x##y
#define CAT_M4_std_gen_132(x, y) xCAT_M4_std_gen_132(x, y)
#define xCAT_M4_std_gen_132(x, y) x##y
#define CAT_M4_std_gen_131(x, y) xCAT_M4_std_gen_131(x, y)
#define xCAT_M4_std_gen_131(x, y) x##y
#define CAT_M4_std_gen_130(x, y) xCAT_M4_std_gen_130(x, y)
#define xCAT_M4_std_gen_130(x, y) x##y
#define CAT_M4_std_gen_129(x, y) xCAT_M4_std_gen_129(x, y)
#define xCAT_M4_std_gen_129(x, y) x##y
#define CAT_M4_std_gen_128(x, y) xCAT_M4_std_gen_128(x, y)
#define xCAT_M4_std_gen_128(x, y) x##y
#define CAT_M4_std_gen_127(x, y) xCAT_M4_std_gen_127(x, y)
#define xCAT_M4_std_gen_127(x, y) x##y
#define CAT_M4_std_gen_126(x, y) xCAT_M4_std_gen_126(x, y)
#define xCAT_M4_std_gen_126(x, y) x##y
#define CAT_M4_std_gen_125(x, y) xCAT_M4_std_gen_125(x, y)
#define xCAT_M4_std_gen_125(x, y) x##y
#define CAT_M4_std_gen_124(x, y) xCAT_M4_std_gen_124(x, y)
#define xCAT_M4_std_gen_124(x, y) x##y
#define CAT_M4_std_gen_123(x, y) xCAT_M4_std_gen_123(x, y)
#define xCAT_M4_std_gen_123(x, y) x##y
#define CAT_M4_std_gen_122(x, y) xCAT_M4_std_gen_122(x, y)
#define xCAT_M4_std_gen_122(x, y) x##y
#define CAT_M4_std_gen_121(x, y) xCAT_M4_std_gen_121(x, y)
#define xCAT_M4_std_gen_121(x, y) x##y
#define CAT_M4_std_gen_120(x, y) xCAT_M4_std_gen_120(x, y)
#define xCAT_M4_std_gen_120(x, y) x##y
#define CAT_M4_std_gen_119(x, y) xCAT_M4_std_gen_119(x, y)
#define xCAT_M4_std_gen_119(x, y) x##y
#define CAT_M4_std_gen_118(x, y) xCAT_M4_std_gen_118(x, y)
#define xCAT_M4_std_gen_118(x, y) x##y
#define CAT_M4_std_gen_117(x, y) xCAT_M4_std_gen_117(x, y)
#define xCAT_M4_std_gen_117(x, y) x##y
#define CAT_M4_std_gen_116(x, y) xCAT_M4_std_gen_116(x, y)
#define xCAT_M4_std_gen_116(x, y) x##y
#define CAT_M4_std_gen_115(x, y) xCAT_M4_std_gen_115(x, y)
#define xCAT_M4_std_gen_115(x, y) x##y
#define CAT_M4_std_gen_114(x, y) xCAT_M4_std_gen_114(x, y)
#define xCAT_M4_std_gen_114(x, y) x##y
#define CAT_M4_std_gen_113(x, y) xCAT_M4_std_gen_113(x, y)
#define xCAT_M4_std_gen_113(x, y) x##y
#define CAT_M4_std_gen_112(x, y) xCAT_M4_std_gen_112(x, y)
#define xCAT_M4_std_gen_112(x, y) x##y
#define CAT_M4_std_gen_111(x, y) xCAT_M4_std_gen_111(x, y)
#define xCAT_M4_std_gen_111(x, y) x##y
#define CAT_M4_std_gen_110(x, y) xCAT_M4_std_gen_110(x, y)
#define xCAT_M4_std_gen_110(x, y) x##y
#define CAT_M4_std_gen_109(x, y) xCAT_M4_std_gen_109(x, y)
#define xCAT_M4_std_gen_109(x, y) x##y
#define CAT_M4_std_gen_108(x, y) xCAT_M4_std_gen_108(x, y)
#define xCAT_M4_std_gen_108(x, y) x##y
#define CAT_M4_std_gen_107(x, y) xCAT_M4_std_gen_107(x, y)
#define xCAT_M4_std_gen_107(x, y) x##y
#define CAT_M4_std_gen_106(x, y) xCAT_M4_std_gen_106(x, y)
#define xCAT_M4_std_gen_106(x, y) x##y
#define CAT_M4_std_gen_105(x, y) xCAT_M4_std_gen_105(x, y)
#define xCAT_M4_std_gen_105(x, y) x##y
#define CAT_M4_std_gen_104(x, y) xCAT_M4_std_gen_104(x, y)
#define xCAT_M4_std_gen_104(x, y) x##y
#define CAT_M4_std_gen_103(x, y) xCAT_M4_std_gen_103(x, y)
#define xCAT_M4_std_gen_103(x, y) x##y
#define CAT_M4_std_gen_102(x, y) xCAT_M4_std_gen_102(x, y)
#define xCAT_M4_std_gen_102(x, y) x##y
#define CAT_M4_std_gen_101(x, y) xCAT_M4_std_gen_101(x, y)
#define xCAT_M4_std_gen_101(x, y) x##y
#define CAT_M4_std_gen_100(x, y) xCAT_M4_std_gen_100(x, y)
#define xCAT_M4_std_gen_100(x, y) x##y
#define CAT_M4_std_gen_99(x, y) xCAT_M4_std_gen_99(x, y)
#define xCAT_M4_std_gen_99(x, y) x##y
#define CAT_M4_std_gen_98(x, y) xCAT_M4_std_gen_98(x, y)
#define xCAT_M4_std_gen_98(x, y) x##y
#define CAT_M4_std_gen_97(x, y) xCAT_M4_std_gen_97(x, y)
#define xCAT_M4_std_gen_97(x, y) x##y
#define CAT_M4_std_gen_96(x, y) xCAT_M4_std_gen_96(x, y)
#define xCAT_M4_std_gen_96(x, y) x##y
#define CAT_M4_std_gen_95(x, y) xCAT_M4_std_gen_95(x, y)
#define xCAT_M4_std_gen_95(x, y) x##y
#define CAT_M4_std_gen_94(x, y) xCAT_M4_std_gen_94(x, y)
#define xCAT_M4_std_gen_94(x, y) x##y
#define CAT_M4_std_gen_93(x, y) xCAT_M4_std_gen_93(x, y)
#define xCAT_M4_std_gen_93(x, y) x##y
#define CAT_M4_std_gen_92(x, y) xCAT_M4_std_gen_92(x, y)
#define xCAT_M4_std_gen_92(x, y) x##y
#define CAT_M4_std_gen_91(x, y) xCAT_M4_std_gen_91(x, y)
#define xCAT_M4_std_gen_91(x, y) x##y
#define CAT_M4_std_gen_90(x, y) xCAT_M4_std_gen_90(x, y)
#define xCAT_M4_std_gen_90(x, y) x##y
#define CAT_M4_std_gen_89(x, y) xCAT_M4_std_gen_89(x, y)
#define xCAT_M4_std_gen_89(x, y) x##y
#define CAT_M4_std_gen_88(x, y) xCAT_M4_std_gen_88(x, y)
#define xCAT_M4_std_gen_88(x, y) x##y
#define CAT_M4_std_gen_87(x, y) xCAT_M4_std_gen_87(x, y)
#define xCAT_M4_std_gen_87(x, y) x##y
#define CAT_M4_std_gen_86(x, y) xCAT_M4_std_gen_86(x, y)
#define xCAT_M4_std_gen_86(x, y) x##y
#define CAT_M4_std_gen_85(x, y) xCAT_M4_std_gen_85(x, y)
#define xCAT_M4_std_gen_85(x, y) x##y
#define CAT_M4_std_gen_84(x, y) xCAT_M4_std_gen_84(x, y)
#define xCAT_M4_std_gen_84(x, y) x##y
#define CAT_M4_std_gen_83(x, y) xCAT_M4_std_gen_83(x, y)
#define xCAT_M4_std_gen_83(x, y) x##y
#define CAT_M4_std_gen_82(x, y) xCAT_M4_std_gen_82(x, y)
#define xCAT_M4_std_gen_82(x, y) x##y
#define CAT_M4_std_gen_81(x, y) xCAT_M4_std_gen_81(x, y)
#define xCAT_M4_std_gen_81(x, y) x##y
#define CAT_M4_std_gen_80(x, y) xCAT_M4_std_gen_80(x, y)
#define xCAT_M4_std_gen_80(x, y) x##y
#define CAT_M4_std_gen_79(x, y) xCAT_M4_std_gen_79(x, y)
#define xCAT_M4_std_gen_79(x, y) x##y
#define CAT_M4_std_gen_78(x, y) xCAT_M4_std_gen_78(x, y)
#define xCAT_M4_std_gen_78(x, y) x##y
#define CAT_M4_std_gen_77(x, y) xCAT_M4_std_gen_77(x, y)
#define xCAT_M4_std_gen_77(x, y) x##y
#define CAT_M4_std_gen_76(x, y) xCAT_M4_std_gen_76(x, y)
#define xCAT_M4_std_gen_76(x, y) x##y
#define CAT_M4_std_gen_75(x, y) xCAT_M4_std_gen_75(x, y)
#define xCAT_M4_std_gen_75(x, y) x##y
#define CAT_M4_std_gen_74(x, y) xCAT_M4_std_gen_74(x, y)
#define xCAT_M4_std_gen_74(x, y) x##y
#define CAT_M4_std_gen_73(x, y) xCAT_M4_std_gen_73(x, y)
#define xCAT_M4_std_gen_73(x, y) x##y
#define CAT_M4_std_gen_72(x, y) xCAT_M4_std_gen_72(x, y)
#define xCAT_M4_std_gen_72(x, y) x##y
#define CAT_M4_std_gen_71(x, y) xCAT_M4_std_gen_71(x, y)
#define xCAT_M4_std_gen_71(x, y) x##y
#define CAT_M4_std_gen_70(x, y) xCAT_M4_std_gen_70(x, y)
#define xCAT_M4_std_gen_70(x, y) x##y
#define CAT_M4_std_gen_69(x, y) xCAT_M4_std_gen_69(x, y)
#define xCAT_M4_std_gen_69(x, y) x##y
#define CAT_M4_std_gen_68(x, y) xCAT_M4_std_gen_68(x, y)
#define xCAT_M4_std_gen_68(x, y) x##y
#define CAT_M4_std_gen_67(x, y) xCAT_M4_std_gen_67(x, y)
#define xCAT_M4_std_gen_67(x, y) x##y
#define CAT_M4_std_gen_66(x, y) xCAT_M4_std_gen_66(x, y)
#define xCAT_M4_std_gen_66(x, y) x##y
#define CAT_M4_std_gen_65(x, y) xCAT_M4_std_gen_65(x, y)
#define xCAT_M4_std_gen_65(x, y) x##y
#define CAT_M4_std_gen_64(x, y) xCAT_M4_std_gen_64(x, y)
#define xCAT_M4_std_gen_64(x, y) x##y
#define CAT_M4_std_gen_63(x, y) xCAT_M4_std_gen_63(x, y)
#define xCAT_M4_std_gen_63(x, y) x##y
#define CAT_M4_std_gen_62(x, y) xCAT_M4_std_gen_62(x, y)
#define xCAT_M4_std_gen_62(x, y) x##y
#define CAT_M4_std_gen_61(x, y) xCAT_M4_std_gen_61(x, y)
#define xCAT_M4_std_gen_61(x, y) x##y
#define CAT_M4_std_gen_60(x, y) xCAT_M4_std_gen_60(x, y)
#define xCAT_M4_std_gen_60(x, y) x##y
#define CAT_M4_std_gen_59(x, y) xCAT_M4_std_gen_59(x, y)
#define xCAT_M4_std_gen_59(x, y) x##y
#define CAT_M4_std_gen_58(x, y) xCAT_M4_std_gen_58(x, y)
#define xCAT_M4_std_gen_58(x, y) x##y
#define CAT_M4_std_gen_57(x, y) xCAT_M4_std_gen_57(x, y)
#define xCAT_M4_std_gen_57(x, y) x##y
#define CAT_M4_std_gen_56(x, y) xCAT_M4_std_gen_56(x, y)
#define xCAT_M4_std_gen_56(x, y) x##y
#define CAT_M4_std_gen_55(x, y) xCAT_M4_std_gen_55(x, y)
#define xCAT_M4_std_gen_55(x, y) x##y
#define CAT_M4_std_gen_54(x, y) xCAT_M4_std_gen_54(x, y)
#define xCAT_M4_std_gen_54(x, y) x##y
#define CAT_M4_std_gen_53(x, y) xCAT_M4_std_gen_53(x, y)
#define xCAT_M4_std_gen_53(x, y) x##y
#define CAT_M4_std_gen_52(x, y) xCAT_M4_std_gen_52(x, y)
#define xCAT_M4_std_gen_52(x, y) x##y
#define CAT_M4_std_gen_51(x, y) xCAT_M4_std_gen_51(x, y)
#define xCAT_M4_std_gen_51(x, y) x##y
#define CAT_M4_std_gen_50(x, y) xCAT_M4_std_gen_50(x, y)
#define xCAT_M4_std_gen_50(x, y) x##y
#define CAT_M4_std_gen_49(x, y) xCAT_M4_std_gen_49(x, y)
#define xCAT_M4_std_gen_49(x, y) x##y
#define CAT_M4_std_gen_48(x, y) xCAT_M4_std_gen_48(x, y)
#define xCAT_M4_std_gen_48(x, y) x##y
#define CAT_M4_std_gen_47(x, y) xCAT_M4_std_gen_47(x, y)
#define xCAT_M4_std_gen_47(x, y) x##y
#define CAT_M4_std_gen_46(x, y) xCAT_M4_std_gen_46(x, y)
#define xCAT_M4_std_gen_46(x, y) x##y
#define CAT_M4_std_gen_45(x, y) xCAT_M4_std_gen_45(x, y)
#define xCAT_M4_std_gen_45(x, y) x##y
#define CAT_M4_std_gen_44(x, y) xCAT_M4_std_gen_44(x, y)
#define xCAT_M4_std_gen_44(x, y) x##y
#define CAT_M4_std_gen_43(x, y) xCAT_M4_std_gen_43(x, y)
#define xCAT_M4_std_gen_43(x, y) x##y
#define CAT_M4_std_gen_42(x, y) xCAT_M4_std_gen_42(x, y)
#define xCAT_M4_std_gen_42(x, y) x##y
#define CAT_M4_std_gen_41(x, y) xCAT_M4_std_gen_41(x, y)
#define xCAT_M4_std_gen_41(x, y) x##y
#define CAT_M4_std_gen_40(x, y) xCAT_M4_std_gen_40(x, y)
#define xCAT_M4_std_gen_40(x, y) x##y
#define CAT_M4_std_gen_39(x, y) xCAT_M4_std_gen_39(x, y)
#define xCAT_M4_std_gen_39(x, y) x##y
#define CAT_M4_std_gen_38(x, y) xCAT_M4_std_gen_38(x, y)
#define xCAT_M4_std_gen_38(x, y) x##y
#define CAT_M4_std_gen_37(x, y) xCAT_M4_std_gen_37(x, y)
#define xCAT_M4_std_gen_37(x, y) x##y
#define CAT_M4_std_gen_36(x, y) xCAT_M4_std_gen_36(x, y)
#define xCAT_M4_std_gen_36(x, y) x##y
#define CAT_M4_std_gen_35(x, y) xCAT_M4_std_gen_35(x, y)
#define xCAT_M4_std_gen_35(x, y) x##y
#define CAT_M4_std_gen_34(x, y) xCAT_M4_std_gen_34(x, y)
#define xCAT_M4_std_gen_34(x, y) x##y
#define CAT_M4_std_gen_33(x, y) xCAT_M4_std_gen_33(x, y)
#define xCAT_M4_std_gen_33(x, y) x##y
#define CAT_M4_std_gen_32(x, y) xCAT_M4_std_gen_32(x, y)
#define xCAT_M4_std_gen_32(x, y) x##y
#define CAT_M4_std_gen_31(x, y) xCAT_M4_std_gen_31(x, y)
#define xCAT_M4_std_gen_31(x, y) x##y
#define CAT_M4_std_gen_30(x, y) xCAT_M4_std_gen_30(x, y)
#define xCAT_M4_std_gen_30(x, y) x##y
#define CAT_M4_std_gen_29(x, y) xCAT_M4_std_gen_29(x, y)
#define xCAT_M4_std_gen_29(x, y) x##y
#define CAT_M4_std_gen_28(x, y) xCAT_M4_std_gen_28(x, y)
#define xCAT_M4_std_gen_28(x, y) x##y
#define CAT_M4_std_gen_27(x, y) xCAT_M4_std_gen_27(x, y)
#define xCAT_M4_std_gen_27(x, y) x##y
#define CAT_M4_std_gen_26(x, y) xCAT_M4_std_gen_26(x, y)
#define xCAT_M4_std_gen_26(x, y) x##y
#define CAT_M4_std_gen_25(x, y) xCAT_M4_std_gen_25(x, y)
#define xCAT_M4_std_gen_25(x, y) x##y
#define CAT_M4_std_gen_24(x, y) xCAT_M4_std_gen_24(x, y)
#define xCAT_M4_std_gen_24(x, y) x##y
#define CAT_M4_std_gen_23(x, y) xCAT_M4_std_gen_23(x, y)
#define xCAT_M4_std_gen_23(x, y) x##y
#define CAT_M4_std_gen_22(x, y) xCAT_M4_std_gen_22(x, y)
#define xCAT_M4_std_gen_22(x, y) x##y
#define CAT_M4_std_gen_21(x, y) xCAT_M4_std_gen_21(x, y)
#define xCAT_M4_std_gen_21(x, y) x##y
#define CAT_M4_std_gen_20(x, y) xCAT_M4_std_gen_20(x, y)
#define xCAT_M4_std_gen_20(x, y) x##y
#define CAT_M4_std_gen_19(x, y) xCAT_M4_std_gen_19(x, y)
#define xCAT_M4_std_gen_19(x, y) x##y
#define CAT_M4_std_gen_18(x, y) xCAT_M4_std_gen_18(x, y)
#define xCAT_M4_std_gen_18(x, y) x##y
#define CAT_M4_std_gen_17(x, y) xCAT_M4_std_gen_17(x, y)
#define xCAT_M4_std_gen_17(x, y) x##y
#define CAT_M4_std_gen_16(x, y) xCAT_M4_std_gen_16(x, y)
#define xCAT_M4_std_gen_16(x, y) x##y
#define CAT_M4_std_gen_15(x, y) xCAT_M4_std_gen_15(x, y)
#define xCAT_M4_std_gen_15(x, y) x##y
#define CAT_M4_std_gen_14(x, y) xCAT_M4_std_gen_14(x, y)
#define xCAT_M4_std_gen_14(x, y) x##y
#define CAT_M4_std_gen_13(x, y) xCAT_M4_std_gen_13(x, y)
#define xCAT_M4_std_gen_13(x, y) x##y
#define CAT_M4_std_gen_12(x, y) xCAT_M4_std_gen_12(x, y)
#define xCAT_M4_std_gen_12(x, y) x##y
#define CAT_M4_std_gen_11(x, y) xCAT_M4_std_gen_11(x, y)
#define xCAT_M4_std_gen_11(x, y) x##y
#define CAT_M4_std_gen_10(x, y) xCAT_M4_std_gen_10(x, y)
#define xCAT_M4_std_gen_10(x, y) x##y
#define CAT_M4_std_gen_9(x, y) xCAT_M4_std_gen_9(x, y)
#define xCAT_M4_std_gen_9(x, y) x##y
#define CAT_M4_std_gen_8(x, y) xCAT_M4_std_gen_8(x, y)
#define xCAT_M4_std_gen_8(x, y) x##y
#define CAT_M4_std_gen_7(x, y) xCAT_M4_std_gen_7(x, y)
#define xCAT_M4_std_gen_7(x, y) x##y
#define CAT_M4_std_gen_6(x, y) xCAT_M4_std_gen_6(x, y)
#define xCAT_M4_std_gen_6(x, y) x##y
#define CAT_M4_std_gen_5(x, y) xCAT_M4_std_gen_5(x, y)
#define xCAT_M4_std_gen_5(x, y) x##y
#define CAT_M4_std_gen_4(x, y) xCAT_M4_std_gen_4(x, y)
#define xCAT_M4_std_gen_4(x, y) x##y
#define CAT_M4_std_gen_3(x, y) xCAT_M4_std_gen_3(x, y)
#define xCAT_M4_std_gen_3(x, y) x##y
#define CAT_M4_std_gen_2(x, y) xCAT_M4_std_gen_2(x, y)
#define xCAT_M4_std_gen_2(x, y) x##y
#define CAT_M4_std_gen_1(x, y) xCAT_M4_std_gen_1(x, y)
#define xCAT_M4_std_gen_1(x, y) x##y
#endif
#if defined(SAC_BACKEND_C99) || defined(SAC_BACKEND_DISTMEM)





#if SAC_DEBUG_RC

#define SAC_RC_PRINT( var_NT)  SAC_Print( "%s:%d " TO_STR( var_NT) " @ %p = {%d} [ %d, %p, %d]\n",  __FILE__,  __LINE__,  SAC_ND_A_DESC( var_NT),  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)),  (int) SAC_ND_A_DESC( var_NT)[0],  (void*) SAC_ND_A_DESC( var_NT)[1],  (int) SAC_ND_A_DESC( var_NT)[2]);

#define SAC_IF_DEBUG_RC( a) a
#define SAC_ASSERT_RC(cond, ...)  if (!(cond)) { SAC_RuntimeError( __VA_ARGS__); }
#else 

#define SAC_RC_PRINT( var_NT)
#define SAC_IF_DEBUG_RC( a)
#define SAC_ASSERT_RC(cond, ...)
#endif 



#define SAC_ND_INIT__RC__ASYNC( var_NT, rc) {  SAC_RC_PRINT( var_NT);  SAC_ND_INIT__RC__C99( var_NT, rc) }

#define SAC_ND_DEC_RC__ASYNC( var_NT, rc) {  SAC_IF_DEBUG_RC( SAC_Print( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_TR_REF_PRINT( ("ND_DEC_RC( %s, %d)", NT_STR( var_NT), rc))  SAC_RC_PRINT( var_NT);  __sync_sub_and_fetch( &DESC_RC(SAC_ND_A_DESC(var_NT)), rc);  SAC_TR_REF_PRINT_RC( var_NT); }

#define SAC_ND_SET__RC__ASYNC( var_NT, rc) {  SAC_IF_DEBUG_RC( SAC_Print( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_TR_REF_PRINT( ("ND_SET__RC( %s, %d)", NT_STR( var_NT), rc))  SAC_RC_PRINT( var_NT);  DESC_RC(SAC_ND_A_DESC(var_NT)) = rc;  SAC_TR_REF_PRINT_RC( var_NT) }

#define SAC_ND_INC_RC__ASYNC( var_NT, rc) {  SAC_TR_REF_PRINT( ("ND_INC_RC_ASYNC_RC( %s, %d)", NT_STR( var_NT), rc))  SAC_RC_PRINT( var_NT);  SAC_ND_TRY_LOCALIZE_RC__ASYNC( var_NT);  __sync_add_and_fetch( &DESC_RC(SAC_ND_A_DESC(var_NT)), rc);  SAC_TR_REF_PRINT_RC( var_NT) }

#define SAC_ND_A_RC__ASYNC( var_NT)  DESC_RC( SAC_ND_A_DESC( var_NT))
#if 0
#define SAC_ND_A_RC__ASYNC( var_NT) ({  SAC_TR_REF_PRINT( ("ND_A_RC( %s)", NT_STR( var_NT)))  SAC_IF_DEBUG_RC( SAC_Print( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_RC_PRINT( var_NT);  DESC_RC( SAC_ND_A_DESC( var_NT)); })
#endif


#define SAC_ND_DEC_RC_FREE__ASYNC( var_NT, rc, freefun) {  SAC_TR_REF_PRINT( ("ND_DEC_RC_FREE( %s, %d, %s)",  NT_STR( var_NT), rc, #freefun))  SAC_IF_DEBUG_RC( SAC_Print( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_RC_PRINT( var_NT);  if (__sync_sub_and_fetch( &DESC_RC( SAC_ND_A_DESC( var_NT)), rc) == 0) {  free( SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD(var_NT)));  free( SAC_ND_A_DESC( var_NT));  } }


#if SAC_RC_METHOD == SAC_RCM_async
#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc) SAC_ND_INIT__RC__ASYNC( var_NT, rc)
#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) SAC_ND_DEC_RC_FREE__ASYNC( var_NT, rc, freefun)
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) SAC_ND_SET__RC__ASYNC( var_NT, rc)
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) SAC_ND_DEC_RC__ASYNC( var_NT, rc)
#define SAC_ND_INC_RC__DEFAULT( var_NT, rc) SAC_ND_INC_RC__ASYNC( var_NT, rc)
#define SAC_ND_A_RC__DEFAULT( var_NT) SAC_ND_A_RC__ASYNC( var_NT)
#define SAC_ND_TRY_LOCALIZE_RC__ASYNC( var_NT) 

#define SAC_HAS_RC_NORC 0
#define SAC_ND_RC_TO_NORC__NODESC( var_NT) 
#define SAC_ND_RC_TO_NORC__DESC( var_NT) 
#define SAC_ND_RC_FROM_NORC__NODESC( var_NT) 
#define SAC_ND_RC_FROM_NORC__DESC( var_NT) 
#endif 





#endif 
#if defined(SAC_BACKEND_C99) || defined(SAC_BACKEND_DISTMEM)

#if SAC_RC_METHOD == SAC_RCM_local_async_norc_ptr


#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc) {  SAC_ND_INIT__RC__C99( var_NT, rc)  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( var_NT), SAC_DESC_RC_MODE_OTHER); }


#define SAC_ND_TRY_LOCALIZE_RC__ASYNC( var_NT)  if ( SAC_ND_A_RC__ASYNC( var_NT) == 1) {  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  }

#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun)  {  SAC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC) {  SAC_ND_DEC_RC_FREE__NORC( var_NT, rc, freefun);  } else {  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL) {  SAC_ND_DEC_RC_FREE__C99( var_NT, rc, freefun);  } else {  SAC_ND_DEC_RC_FREE__ASYNC( var_NT, rc, freefun);  }  }  }

#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) {  SAC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC) {  SAC_ND_SET__RC__NORC( var_NT, rc);  } else {  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_SET__RC__C99( var_NT, rc);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT))){  SAC_ND_SET__RC__ASYNC( var_NT, rc);  }  } }

#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) {  SAC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC) {  SAC_ND_DEC_RC__NORC( var_NT, rc);  } else {  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_DEC_RC__C99( var_NT, rc);  } else {  SAC_ND_DEC_RC__ASYNC( var_NT, rc);  }  } }

#define SAC_ND_INC_RC__DEFAULT( var_NT, rc)  {  SAC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC) {  SAC_ND_INC_RC__NORC( var_NT, rc);  } else {  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL) {  SAC_ND_INC_RC__C99( var_NT, rc);  } else {  SAC_ND_INC_RC__ASYNC( var_NT, rc);  }  }  }

#define SAC_ND_A_RC__DEFAULT( var_NT)  ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC  ? SAC_ND_A_RC__NORC( var_NT)  : ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL  ? SAC_ND_A_RC__C99( var_NT)  : SAC_ND_A_RC__ASYNC( var_NT)  )  )
#if 0

#define SAC_ND_A_RC__DEFAULT( var_NT)  ({  int rc;  SAC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC){  rc = SAC_ND_A_RC__NORC( var_NT);  } else {  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  rc = SAC_ND_A_RC__C99( var_NT);  } else {  rc = SAC_ND_A_RC__ASYNC( var_NT);  if ( rc == 1) {  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  }  }  }  (int)rc;  })
#endif
#define SAC_ND_RC_TO_NORC__NODESC( var_NT) 
#define SAC_ND_RC_FROM_NORC__NODESC( var_NT) 

#define SAC_ND_RC_TO_NORC__DESC( var_NT)  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) != SAC_DESC_RC_MODE_NORC){  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( var_NT), SAC_DESC_RC_MODE_NORC);  }

#define SAC_ND_RC_FROM_NORC__DESC( var_NT)  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( var_NT), DESC_RC_MODE( SAC_ND_A_DESC( var_NT)));

#define SAC_HAS_RC_NORC 1


#define SAC_ND_RC_GIVE_ASYNC__NODESC(new, array)  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));
#define SAC_ND_RC_GIVE_ASYNC__DESC(new, array) {  SAC_ASSERT_RC( DESC_RC_MODE( SAC_ND_A_DESC( array)) != SAC_DESC_RC_MODE_NORC,  "SAC_RCM_local_pasync_norc_desc::SAC_ND_RC_GIVE_ASYNC__DESC: called on NORC descriptor!");  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));  if ( DESC_RC( SAC_ND_A_DESC( array)) > 1) {  SAC_ND_A_DESC_RC_MODE( array) = SAC_DESC_RC_MODE_ASYNC;  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( array), SAC_DESC_RC_MODE_ASYNC);  }  SAC_ND_A_DESC( new) = SAC_ND_A_DESC( array); }
#endif 
#endif 
#if defined(SAC_BACKEND_C99) || defined(SAC_BACKEND_DISTMEM)

#if SAC_RC_METHOD == SAC_RCM_local_pasync
#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc)  SAC_ND_INIT__RC__C99( var_NT, rc)

#define SAC_ND_TRY_LOCALIZE_RC__ASYNC( var_NT) {  SAC_TR_REF_PRINT( ("SAC_ND_TRY_LOCALIZE_RC__ASYNC( %s)", NT_STR( var_NT)))  SAC_IF_DEBUG_RC( SAC_Print( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););   SAC_ND_DESC_PARENT_TYPE parent = SAC_ND_A_DESC_PARENT( var_NT);  if ( PARENT_DESC_NCHILD(parent) == 1) {  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  free( parent);  DESC_PARENT( SAC_ND_A_DESC( var_NT)) = 0;  } }

#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) {  SAC_RC_PRINT( var_NT);  SAC_ND_SET__RC__C99( var_NT, rc); }
#define SAC_ND_SET__RC__ASYNC_RC( var_NT, rc) {  DESC_RC(SAC_ND_A_DESC(var_NT)) = rc;  SAC_TR_REF_PRINT_RC( var_NT) }

#define SAC_ND_INC_RC__DEFAULT( var_NT, rc) {  SAC_RC_PRINT( var_NT);  SAC_ND_INC_RC__C99( var_NT, rc); }

#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) {  SAC_RC_PRINT( var_NT);  SAC_ND_DEC_RC__C99( var_NT, rc); }

#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) {  SAC_RC_PRINT( var_NT);  if ((SAC_ND_A_RC__C99( var_NT) -= rc) == 0) {  SAC_TR_REF_PRINT_RC( var_NT)  if (DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC) {  SAC_DEC_FREE_PARENT__ASYNC_RC( var_NT)  }  SAC_ND_FREE( var_NT, freefun)  } else {  if (DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC) {  SAC_ND_TRY_LOCALIZE_RC__ASYNC( var_NT);  }  SAC_TR_REF_PRINT_RC( var_NT)  } }

#define SAC_DEC_FREE_PARENT__ASYNC_RC( var_NT) {  SAC_ND_DESC_PARENT_TYPE parent = SAC_ND_A_DESC_PARENT( var_NT);  if ( __sync_sub_and_fetch( &PARENT_DESC_NCHILD(parent), 1) == 0) {  free( parent);  } }
#define SAC_ND_A_RC__DEFAULT( var_NT)  ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL  ? SAC_ND_A_RC__C99( var_NT)  : SAC_ND_A_RC__ASYNC_RC( var_NT)  )
#define SAC_ND_A_RC__ASYNC_RC( var_NT)  ( SAC_ND_A_RC__C99( var_NT) <= 1 ?  SAC_ND_A_PARENT_ASYNC_RC( var_NT) : SAC_ND_A_RC__C99( var_NT) )
#define SAC_ND_A_PARENT_ASYNC_RC( var_NT)  PARENT_DESC_NCHILD( SAC_ND_A_DESC_PARENT( var_NT))

#define SAC_RC_PARENT_INC_SYNC( var_NT) {  SAC_IF_DEBUG_RC( SAC_Print( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_TR_REF_PRINT( ("RC_PARENT_INC( %s)",  NT_STR( var_NT)))  __sync_add_and_fetch( &PARENT_DESC_NCHILD( (SAC_ND_DESC_PARENT_TYPE)SAC_ND_A_DESC_PARENT(var_NT)), 1);  SAC_TR_REF_PRINT_RC( var_NT) }

#define SAC_HAS_RC_NORC 0

#define SAC_ND_RC_TO_NORC__NODESC( var_NT) 
#define SAC_ND_RC_TO_NORC__DESC( var_NT) 
#define SAC_ND_RC_FROM_NORC__NODESC( var_NT) 
#define SAC_ND_RC_FROM_NORC__DESC( var_NT) 

#define SAC_ND_RC_GIVE_ASYNC__NODESC(new, array)  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));
#define SAC_ND_RC_GIVE_ASYNC__DESC(new, array) {  SAC_ASSERT_RC( DESC_RC_MODE( SAC_ND_A_DESC( array)) != SAC_DESC_RC_MODE_NORC,  "SAC_RCM_local_pasync_norc_desc::SAC_ND_RC_GIVE_ASYNC__DESC: called on NORC descriptor!");  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));  if ( DESC_RC( SAC_ND_A_DESC( array)) == 1) {  SAC_ND_A_DESC( new) = SAC_ND_A_DESC( array);  } else {  SAC_RC_PRINT( array);  if ( DESC_RC_MODE( SAC_ND_A_DESC( array)) == SAC_DESC_RC_MODE_LOCAL) {  SAC_ND_A_DESC_RC_MODE( array) = SAC_DESC_RC_MODE_ASYNC;  }  if ( SAC_ND_A_DESC_PARENT( array) == NULL) {  SAC_ND_ALLOC__DESC__PARENT( array, SAC_ND_A_DIM( array));  SAC_DEBUG_RC(  SAC_Print( "alloced parent at %p in %p\n",  (void*)SAC_ND_A_DESC_PARENT( array),  SAC_ND_A_DESC( array));)  PARENT_DESC_NCHILD( SAC_ND_A_DESC_PARENT( array)) = 2;  } else {  SAC_RC_PARENT_INC_SYNC( array);  }  SAC_ND_A_COPY_DESC( new, array);  DESC_RC( SAC_ND_A_DESC( new)) = 0;  SAC_ND_DEC_RC__DEFAULT( array, 1);  SAC_IF_DEBUG_RC(  SAC_Print( "copy from %p to %p\n",  SAC_ND_GETVAR( array, SAC_ND_A_DESC( array)),  SAC_ND_A_DESC( new)););  SAC_RC_PRINT( array);  SAC_RC_PRINT( new);  } }
#endif 
#endif 
#if defined(SAC_BACKEND_C99) || defined(SAC_BACKEND_DISTMEM)

#if SAC_RC_METHOD == SAC_RCM_local_pasync_norc_desc
#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc)  SAC_ND_INIT__RC__C99( var_NT, rc)
#define SAC_DESC_INIT_RC(desc, rc)  SAC_DESC_INIT__RC__C99(desc, rc)

#define SAC_ND_TRY_LOCALIZE_RC__ASYNC( var_NT) {  SAC_TR_REF_PRINT( ("SAC_ND_TRY_LOCALIZE_RC__ASYNC( %s)", NT_STR( var_NT)))  SAC_IF_DEBUG_RC( SAC_Print( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););   SAC_ND_DESC_PARENT_TYPE parent = SAC_ND_A_DESC_PARENT( var_NT);  if ( PARENT_DESC_NCHILD(parent) == 1) {  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  free( parent);  DESC_PARENT( SAC_ND_A_DESC( var_NT)) = 0;  } }
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) {  SAC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL) {  SAC_ND_SET__RC__C99( var_NT, rc);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC) {  SAC_ND_SET__RC__NORC( var_NT, rc);  } else {  SAC_ND_SET__RC__C99( var_NT, rc);  } }
#define SAC_ND_SET__RC__ASYNC_RC( var_NT, rc) {  DESC_RC(SAC_ND_A_DESC(var_NT)) = rc;  SAC_TR_REF_PRINT_RC( var_NT) }


#define SAC_ND_INC_RC__DEFAULT( var_NT, rc) {  SAC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL) {  SAC_ND_INC_RC__C99( var_NT, rc);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC) {  SAC_ND_INC_RC__NORC( var_NT, rc);  } else {  SAC_ND_TRY_LOCALIZE_RC__ASYNC( var_NT);  SAC_ND_INC_RC__C99( var_NT, rc);  } }
#define SAC_DESC_INC_RC( desc, rc) {  if ( DESC_RC_MODE( desc) == SAC_DESC_RC_MODE_LOCAL) {  SAC_DESC_INC_RC__C99( desc, rc);  } else if ( DESC_RC_MODE( desc) == SAC_DESC_RC_MODE_NORC) {  SAC_DESC_INC_RC__NORC( desc, rc);  } else {  SAC_DESC_INC_RC__C99( desc, rc);  } }
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) {  SAC_RC_PRINT( var_NT);  SAC_ASSERT_RC( DESC_RC( SAC_ND_A_DESC( var_NT)) > 1, "SAC_ND_DEC_RC called but RC is <= 1");  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL) {  SAC_ND_DEC_RC__C99( var_NT, rc);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC) {  SAC_ND_DEC_RC__NORC( var_NT, rc);  } else {  SAC_ND_DEC_RC__C99( var_NT, rc);  } }
#define SAC_DESC_DEC_RC( desc, rc) {  SAC_ASSERT_RC( DESC_RC( desc) > 1, "SAC_DESC_DEC_RC called but RC is <= 1");  if ( DESC_RC_MODE( desc) == SAC_DESC_RC_MODE_LOCAL) {  SAC_DESC_DEC_RC__C99( desc, rc);  } else if ( DESC_RC_MODE( desc) == SAC_DESC_RC_MODE_NORC) {  SAC_DESC_DEC_RC__NORC( desc, rc);  } else {  SAC_DESC_DEC_RC__C99( desc, rc);  } }

#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) {  SAC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL) {  SAC_ND_DEC_RC_FREE__C99( var_NT, rc, freefun);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) ==  SAC_DESC_RC_MODE_NORC){  SAC_ND_DEC_RC_FREE__NORC( var_NT, rc, freefun);  } else {  SAC_ND_DEC_RC_FREE__ASYNC_RC( var_NT, rc, freefun);  } }
#define SAC_DESC_DEC_RC_FREE( desc, rc, q_waslast) {  if ( DESC_RC_MODE( desc) == SAC_DESC_RC_MODE_LOCAL) {  SAC_DESC_DEC_RC_FREE__C99( desc, rc, q_waslast);  } else if ( DESC_RC_MODE( desc) == SAC_DESC_RC_MODE_NORC) {  SAC_DESC_DEC_RC_FREE__NORC( desc, rc, q_waslast);  } else {  SAC_DESC_DEC_RC_FREE__ASYNC_RC( desc, rc, q_waslast);  } }

#define SAC_ND_DEC_RC_FREE__ASYNC_RC( var_NT, rc, freefun) {  SAC_RC_PRINT( var_NT);  if ((SAC_ND_A_RC__C99( var_NT) -= rc) == 0) {  SAC_TR_REF_PRINT_RC( var_NT)  SAC_DEC_FREE_PARENT__ASYNC_RC( var_NT, freefun)  } else {  SAC_TR_REF_PRINT_RC( var_NT)  } }
#define SAC_DESC_DEC_RC_FREE__ASYNC_RC( desc, rc, q_waslast) {  if ((DESC_RC( desc) -= rc) == 0) {  SAC_DESC_DEC_FREE_PARENT__ASYNC_RC( desc, q_waslast);  } else {  q_waslast = 0;  } }

#define SAC_DEC_FREE_PARENT__ASYNC_RC( var_NT, freefun) {  SAC_ND_DESC_PARENT_TYPE parent = SAC_ND_A_DESC_PARENT( var_NT);  if ( __sync_sub_and_fetch( &PARENT_DESC_NCHILD(parent), 1) == 0) {  SAC_ND_FREE( var_NT, freefun)  free( parent);  } }
#define SAC_DESC_DEC_FREE_PARENT__ASYNC_RC( desc, q_waslast) {  SAC_ND_DESC_PARENT_TYPE parent = (SAC_ND_DESC_PARENT_TYPE)DESC_PARENT( desc);  if ( __sync_sub_and_fetch( &PARENT_DESC_NCHILD(parent), 1) == 0) {  free( parent);  SAC_FREE( desc);  q_waslast = 1;  } else {  q_waslast = 0;  } }
#define SAC_ND_A_RC__DEFAULT( var_NT)  ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL  ? SAC_ND_A_RC__C99( var_NT)  : ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC  ? SAC_ND_A_RC__NORC( var_NT)  : SAC_ND_A_RC__ASYNC_RC( var_NT)  )  )
#define SAC_DESC_A_RC( desc)  ( DESC_RC_MODE( desc) == SAC_DESC_RC_MODE_LOCAL  ? SAC_DESC_A_RC__C99( desc)  : ( DESC_RC_MODE( desc) == SAC_DESC_RC_MODE_NORC  ? SAC_DESC_A_RC__NORC( desc)  : SAC_DESC_A_RC__ASYNC_RC( desc)  )  )
#define SAC_ND_A_RC__ASYNC_RC( var_NT)  ( SAC_ND_A_RC__C99( var_NT) <= 1 ?  SAC_ND_A_PARENT_ASYNC_RC( var_NT) : SAC_ND_A_RC__C99( var_NT) )
#define SAC_DESC_A_RC__ASYNC_RC( desc)  ( SAC_DESC_A_RC__C99( desc) <= 1 ?  SAC_DESC_A_PARENT_ASYNC_RC( desc) : SAC_DESC_A_RC__C99( desc) )
#define SAC_ND_A_PARENT_ASYNC_RC( var_NT)  PARENT_DESC_NCHILD( SAC_ND_A_DESC_PARENT( var_NT))
#define SAC_DESC_A_PARENT_ASYNC_RC( desc)  PARENT_DESC_NCHILD( DESC_PARENT( desc))
#if 0

#define SAC_ND_A_PARENT_ASYNC_RC( var_NT) ({  SAC_TR_REF_PRINT( ("ND_A_RC__ASYNC_RC( %s)", NT_STR( var_NT)))  SAC_IF_DEBUG_RC( SAC_Print( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););   SAC_ND_DESC_PARENT_TYPE parent = SAC_ND_A_DESC_PARENT( var_NT);  int rc;  if ( PARENT_DESC_NCHILD(parent) == 1) {  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  free( parent);  DESC_PARENT( SAC_ND_A_DESC( var_NT)) = 0;  rc = SAC_ND_A_RC__C99( var_NT);  } else {  rc = PARENT_DESC_NCHILD(parent);  }  rc; })
#endif

#define SAC_RC_PARENT_INC_SYNC( var_NT) {  SAC_IF_DEBUG_RC( SAC_Print( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_TR_REF_PRINT( ("RC_PARENT_INC( %s)",  NT_STR( var_NT)))  __sync_add_and_fetch( &PARENT_DESC_NCHILD( (SAC_ND_DESC_PARENT_TYPE)SAC_ND_A_DESC_PARENT(var_NT)), 1);  SAC_TR_REF_PRINT_RC( var_NT) }
#define SAC_DESC_RC_PARENT_INC_SYNC( desc) {  __sync_add_and_fetch( &PARENT_DESC_NCHILD( (SAC_ND_DESC_PARENT_TYPE)DESC_PARENT(desc)), 1); }

#define SAC_ND_RC_TO_NORC__NODESC( var_NT) 
#define SAC_ND_RC_TO_NORC__DESC( var_NT)  SAC_ASSERT_RC( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) != SAC_DESC_RC_MODE_NORC,  "SAC_ND_RC_TO_NORC__DESC: already in the NORC mode!");  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_NORC;

#define SAC_ND_RC_FROM_NORC__NODESC( var_NT) 
#define SAC_ND_RC_FROM_NORC__DESC( var_NT) {  SAC_ASSERT_RC( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC,  "SAC_ND_RC_FROM_NORC__DESC: not in the NORC mode!");  if (SAC_ND_A_DESC_PARENT( var_NT) != 0) {  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_ASYNC;  } else {  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  } }

#define SAC_HAS_RC_NORC 1

#if 0
#define SAC_ND_RC_GIVE_ASYNC__NODESC(new, array)  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));
#define SAC_ND_RC_GIVE_ASYNC__DESC(new, array) {  SAC_ASSERT_RC( DESC_RC_MODE( SAC_ND_A_DESC( array)) != SAC_DESC_RC_MODE_NORC,  "SAC_RCM_local_pasync_norc_desc::SAC_ND_RC_GIVE_ASYNC__DESC: called on NORC descriptor!");  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));  if ( DESC_RC( SAC_ND_A_DESC( array)) == 1) {  SAC_ND_A_DESC( new) = SAC_ND_A_DESC( array);  } else {  SAC_RC_PRINT( array);  if ( DESC_RC_MODE( SAC_ND_A_DESC( array)) == SAC_DESC_RC_MODE_LOCAL) {  SAC_ND_A_DESC_RC_MODE( array) = SAC_DESC_RC_MODE_ASYNC;  }  if ( SAC_ND_A_DESC_PARENT( array) == NULL) {  SAC_ND_ALLOC__DESC__PARENT( array, SAC_ND_A_DIM( array));  SAC_IF_DEBUG_RC(  SAC_Print( "alloced parent at %p in %p\n",  (void*)SAC_ND_A_DESC_PARENT( array),  SAC_ND_A_DESC( array));)  PARENT_DESC_NCHILD( SAC_ND_A_DESC_PARENT( array)) = 2;  } else {  SAC_RC_PARENT_INC_SYNC( array);  }  SAC_ND_A_COPY_DESC( new, array);  DESC_RC( SAC_ND_A_DESC( new)) = 1;  SAC_ND_DEC_RC__DEFAULT( array, 1);  SAC_IF_DEBUG_RC(  SAC_Print( "copy from %p to %p\n",  SAC_ND_GETVAR( array, SAC_ND_A_DESC( array)),  SAC_ND_A_DESC( new)););  SAC_RC_PRINT( array);  SAC_RC_PRINT( new);  } }
#endif
#define SAC_DESC_RC_GIVE_ASYNC( newd, arrayd) {  SAC_ASSERT_RC( DESC_RC_MODE( arrayd) != SAC_DESC_RC_MODE_NORC,  "SAC_RCM_local_pasync_norc_desc::SAC_DESC_RC_GIVE_ASYNC: called on NORC descriptor!");  if ( DESC_RC( arrayd) == 1) {  newd = arrayd;  } else {  if ( DESC_RC_MODE( arrayd) == SAC_DESC_RC_MODE_LOCAL) {  DESC_RC_MODE( arrayd) = SAC_DESC_RC_MODE_ASYNC;  }  if ( DESC_PARENT( arrayd) == 0) {  SAC_DESC_ALLOC_PARENT( arrayd, DESC_DIM( arrayd));  SAC_IF_DEBUG_RC(  SAC_Print( "alloced parent at %p in %p\n",  (void*)DESC_PARENT( arrayd),  arrayd);)  PARENT_DESC_NCHILD( DESC_PARENT( arrayd)) = 2;  } else {  SAC_DESC_RC_PARENT_INC_SYNC( arrayd);  }  SAC_DESC_COPY_DESC( newd, arrayd);  DESC_RC( newd) = 1;  SAC_DESC_DEC_RC( arrayd, 1);  SAC_IF_DEBUG_RC(  SAC_Print( "copy from %p to %p\n",  arrayd,  newd););  } }
#endif 
#endif 
#if defined(SAC_BACKEND_C99) || defined(SAC_BACKEND_DISTMEM)
#ifndef SAC_HAS_RC_NORC

#define SAC_HAS_RC_NORC 0
#define SAC_ND_RC_TO_NORC__NODESC( var_NT) 
#define SAC_ND_RC_TO_NORC__DESC( var_NT) 
#define SAC_ND_RC_FROM_NORC__NODESC( var_NT) 
#define SAC_ND_RC_FROM_NORC__DESC( var_NT) 
#endif 
#endif 


#ifndef DEF_FILE_rc_impl_gen
#define DEF_FILE_rc_impl_gen
#ifndef _SAC_RC_IMPL_GEN_H_
#define _SAC_RC_IMPL_GEN_H_
#define SAC_ND_RC_TO_NORC( nt ) CAT_M4_rc_impl_gen_1(SAC_ND_RC_TO_NORC_, NT_SHP(nt))( nt )
#define SAC_ND_RC_TO_NORC_SCL(...) SAC_ND_RC_TO_NORC__NODESC(__VA_ARGS__)
#define SAC_ND_RC_TO_NORC_AKS(...) SAC_ND_RC_TO_NORC__DESC(__VA_ARGS__)
#define SAC_ND_RC_TO_NORC_AKD(...) SAC_ND_RC_TO_NORC__DESC(__VA_ARGS__)
#define SAC_ND_RC_TO_NORC_AUD(...) SAC_ND_RC_TO_NORC__DESC(__VA_ARGS__)
#define SAC_ND_RC_FROM_NORC( nt ) CAT_M4_rc_impl_gen_2(SAC_ND_RC_FROM_NORC_, NT_SHP(nt))( nt )
#define SAC_ND_RC_FROM_NORC_SCL(...) SAC_ND_RC_FROM_NORC__NODESC(__VA_ARGS__)
#define SAC_ND_RC_FROM_NORC_AKS(...) SAC_ND_RC_FROM_NORC__DESC(__VA_ARGS__)
#define SAC_ND_RC_FROM_NORC_AKD(...) SAC_ND_RC_FROM_NORC__DESC(__VA_ARGS__)
#define SAC_ND_RC_FROM_NORC_AUD(...) SAC_ND_RC_FROM_NORC__DESC(__VA_ARGS__)
#define SAC_ND_RC_GIVE_ASYNC( arg1, nt ) CAT_M4_rc_impl_gen_3(SAC_ND_RC_GIVE_ASYNC_, NT_SHP(nt))( arg1, nt )
#define SAC_ND_RC_GIVE_ASYNC_SCL(...) SAC_ND_RC_GIVE_ASYNC__NODESC(__VA_ARGS__)
#define SAC_ND_RC_GIVE_ASYNC_AKS(...) SAC_ND_RC_GIVE_ASYNC__DESC(__VA_ARGS__)
#define SAC_ND_RC_GIVE_ASYNC_AKD(...) SAC_ND_RC_GIVE_ASYNC__DESC(__VA_ARGS__)
#define SAC_ND_RC_GIVE_ASYNC_AUD(...) SAC_ND_RC_GIVE_ASYNC__DESC(__VA_ARGS__)
#endif
#define CAT_M4_rc_impl_gen_3(x, y) xCAT_M4_rc_impl_gen_3(x, y)
#define xCAT_M4_rc_impl_gen_3(x, y) x##y
#define CAT_M4_rc_impl_gen_2(x, y) xCAT_M4_rc_impl_gen_2(x, y)
#define xCAT_M4_rc_impl_gen_2(x, y) x##y
#define CAT_M4_rc_impl_gen_1(x, y) xCAT_M4_rc_impl_gen_1(x, y)
#define xCAT_M4_rc_impl_gen_1(x, y) x##y
#endif

#ifndef _SAC_MESSAGE_H_
#define _SAC_MESSAGE_H_
#ifndef SAC_C_EXTERN
#define SAC_C_EXTERN extern
#endif 
SAC_C_EXTERN void (*SAC_MessageExtensionCallback)( void);
SAC_C_EXTERN void SAC_RuntimeError( char *format, ...);
SAC_C_EXTERN void SAC_RuntimeError_Mult( int cnt, ...);
SAC_C_EXTERN void SAC_RuntimeErrorLine( int line, char *format, ...);
SAC_C_EXTERN void SAC_RuntimeWarning( char *format, ...);
SAC_C_EXTERN void SAC_RuntimeWarningMaster(char *format, ...);
SAC_C_EXTERN const char * SAC_PrintShape( SAC_array_descriptor_t desc);
SAC_C_EXTERN void SAC_Print( char *format, ...);
#endif 

#ifndef _SAC_BOOL_H
#define _SAC_BOOL_H
#define MUTC 1
#ifdef SAC_BACKEND_MUTC
#include "stdbool.h"
#else
#ifdef __bool_true_false_are_defined 
#undef bool
#undef true
#undef false
#undef __bool_true_false_are_defined
#endif 
#if SAC_MUTC_MACROS
typedef int boolbool;
#elif SAC_CUDA_MACROS
typedef int boolboolbool;
#else
# ifndef __cplusplus
typedef int bool;
# endif
#endif
#define true 1
#define false 0
#define __bool_true_false_are_defined
#endif
#undef MUTC
#endif 

#ifndef _SAC_ERRORS_H_
#define _SAC_ERRORS_H_

#define SAC_TYPE_ERROR( message)  SAC_RuntimeError( message);
#endif 

#ifndef _SAC_IDX_H
#define _SAC_IDX_H




#endif 

#ifndef _SAC_MISC_H_
#define _SAC_MISC_H_
#ifndef SAC_C_EXTERN
#define SAC_C_EXTERN extern
#endif 
#if SAC_MUTC_MACROS
#define SAC_String2Array( array, string) SAC_STRING2ARRAY( array, string)
#else
SAC_C_EXTERN void SAC_String2Array( unsigned char *array, const char *string);
#endif

#define SAC_ICM_UNDEF()  _ICM_IS_UNDEFINED_ 
#define SAC_NOOP()   ;
#define SAC_NOTHING()
#define SAC_BLOCK_BEGIN()  {
#define SAC_BLOCK_END()  }
#define SAC_MIN( a, b)  ((a) < (b) ? (a) : (b))
#define SAC_MAX( a, b)  ((a) > (b) ? (a) : (b))
#define SAC_ABS( a)  (((a) < 0) ? (- (a)) : (a))

#define SAC_ND_LABEL( label)  label: ;
#define SAC_ND_GOTO( label)  goto label;
#define SAC_BREAK_ON_GUARD( guard, label)  if( guard) goto label;
#endif 

#ifndef _SAC_WL_H_
#define _SAC_WL_H_



#define SAC_WL_VAR( type, idx_scl_NT)  CAT0( CAT0( CAT0( SAC_, type), _), NT_NAME( idx_scl_NT))
#define SAC_WL_SHAPE_FACTOR( res_NT, dim)  CAT0( CAT0( CAT0( SAC_, NT_NAME( res_NT)), _shpfac), dim)
#define SAC_WL_MT_SCHEDULE_START( dim)  CAT0( SAC_schedule_start, dim)
#define SAC_WL_MT_SCHEDULE_STOP( dim)  CAT0( SAC_schedule_stop, dim)
#define SAC_WL_IS_DISTRIBUTED  SAC_wl_is_distributed
#define SAC_WL_DIST_DIM0_SIZE  SAC_wl_dist_dim0_size
#define SAC_WL_DIST_OFFS  SAC_wl_dist_offs
#define SAC_WL_DIST_BYTES  SAC_wl_dist_bytes




#define SAC_WL_BLOCK_LOOP0_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { for (SAC_ND_WRITE( idx_scl_NT, 0) = bnd1; SAC_ND_READ( idx_scl_NT, 0) < bnd2; ) {  int SAC_WL_VAR( first, idx_scl_NT) = SAC_ND_READ( idx_scl_NT, 0);  int SAC_WL_VAR( last, idx_scl_NT) = SAC_MIN( SAC_WL_VAR( first, idx_scl_NT) + step,  bnd2);
#define SAC_WL_MT_BLOCK_LOOP0_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { int SAC_WL_VAR( block_stop, idx_scl_NT) = SAC_MIN( bnd2, SAC_WL_MT_SCHEDULE_STOP( dim));  for (SAC_ND_WRITE( idx_scl_NT, 0) = SAC_MAX( bnd1, SAC_WL_MT_SCHEDULE_START( dim));  SAC_ND_READ( idx_scl_NT, 0) < SAC_WL_VAR( block_stop, idx_scl_NT); ) {  int SAC_WL_VAR( first, idx_scl_NT) = SAC_ND_READ( idx_scl_NT, 0);  int SAC_WL_VAR( last, idx_scl_NT) = SAC_MIN( SAC_WL_VAR( first, idx_scl_NT) + step,  SAC_WL_VAR( block_stop, idx_scl_NT));

#define SAC_WL_BLOCK_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { int SAC_WL_VAR( block_stop, idx_scl_NT) = SAC_WL_VAR( last, idx_scl_NT);  for (SAC_ND_WRITE( idx_scl_NT, 0) = SAC_WL_VAR( first, idx_scl_NT) + bnd1;  SAC_ND_READ( idx_scl_NT, 0) < SAC_WL_VAR( block_stop, idx_scl_NT); ) {  int SAC_WL_VAR( first, idx_scl_NT) = SAC_ND_READ( idx_scl_NT, 0);  int SAC_WL_VAR( last, idx_scl_NT) = SAC_MIN( SAC_WL_VAR( first, idx_scl_NT) + step,  SAC_WL_VAR( block_stop, idx_scl_NT));
#define SAC_WL_MT_BLOCK_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_BLOCK_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)

#define SAC_WL_BLOCK_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) } }
#define SAC_WL_MT_BLOCK_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_BLOCK_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)




#define SAC_WL_BLOCK_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { int SAC_WL_VAR( diff, idx_scl_NT) = (bnd2 - bnd1);
#define SAC_WL_MT_BLOCK_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_BLOCK_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)

#define SAC_WL_BLOCK_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) }
#define SAC_WL_MT_BLOCK_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_BLOCK_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)




#define SAC_WL_UBLOCK_LOOP0_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { for (SAC_ND_WRITE( idx_scl_NT, 0) = bnd1; SAC_ND_READ( idx_scl_NT, 0) < bnd2; ) {  int SAC_WL_VAR( first, idx_scl_NT) = SAC_ND_READ( idx_scl_NT, 0);
#define SAC_WL_MT_UBLOCK_LOOP0_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { int SAC_WL_VAR( block_stop, idx_scl_NT) = SAC_MIN( bnd2, SAC_WL_MT_SCHEDULE_STOP( dim));  for (SAC_ND_WRITE( idx_scl_NT, 0) = SAC_MAX( bnd1, SAC_WL_MT_SCHEDULE_START( dim));  SAC_ND_READ( idx_scl_NT, 0) < SAC_WL_VAR( block_stop, idx_scl_NT); ) {  int SAC_WL_VAR( first, idx_scl_NT) = SAC_ND_READ( idx_scl_NT, 0);

#define SAC_WL_UBLOCK_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { for (SAC_ND_WRITE( idx_scl_NT, 0) = SAC_WL_VAR( first, idx_scl_NT) + bnd1;  SAC_ND_READ( idx_scl_NT, 0) < SAC_WL_VAR( last, idx_scl_NT); ) {  int SAC_WL_VAR( first, idx_scl_NT) = SAC_ND_READ( idx_scl_NT, 0);
#define SAC_WL_MT_UBLOCK_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_UBLOCK_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)

#define SAC_WL_UBLOCK_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) } }
#define SAC_WL_MT_UBLOCK_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_UBLOCK_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)




#define SAC_WL_UBLOCK_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { int SAC_WL_VAR( diff, idx_scl_NT) = (bnd2 - bnd1);
#define SAC_WL_MT_UBLOCK_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_UBLOCK_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)

#define SAC_WL_UBLOCK_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) }
#define SAC_WL_MT_UBLOCK_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_UBLOCK_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)




#define SAC_WL_STRIDE_LOOP0_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { int SAC_WL_VAR( stop, idx_scl_NT) = bnd2;  for (SAC_ND_WRITE( idx_scl_NT, 0) = bnd1; SAC_ND_READ( idx_scl_NT, 0) < bnd2; ) {
#define SAC_WL_MT_STRIDE_LOOP0_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { int SAC_WL_VAR( stop, idx_scl_NT) = SAC_MIN( bnd2, SAC_WL_MT_SCHEDULE_STOP( dim));  for (SAC_ND_WRITE( idx_scl_NT, 0) = SAC_MAX( bnd1, SAC_WL_MT_SCHEDULE_START( dim));  SAC_ND_READ( idx_scl_NT, 0) < SAC_WL_VAR( stop, idx_scl_NT); ) {


#define SAC_WL_STRIDE_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { int SAC_WL_VAR( stop, idx_scl_NT) = SAC_MIN( SAC_WL_VAR( first, idx_scl_NT) + bnd2,  SAC_WL_VAR( last, idx_scl_NT));  for (SAC_ND_WRITE( idx_scl_NT, 0) = SAC_WL_VAR( first, idx_scl_NT) + bnd1;  SAC_ND_READ( idx_scl_NT, 0) < SAC_WL_VAR( stop, idx_scl_NT); ) {
#define SAC_WL_MT_STRIDE_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_STRIDE_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)

#define SAC_WL_STRIDE_LAST_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { int SAC_WL_VAR( stop, idx_scl_NT) = SAC_WL_VAR( last, idx_scl_NT);  for (SAC_ND_WRITE( idx_scl_NT, 0) = SAC_WL_VAR( first, idx_scl_NT) + bnd1;  SAC_ND_READ( idx_scl_NT, 0) < SAC_WL_VAR( stop, idx_scl_NT); ) {
#define SAC_WL_MT_STRIDE_LAST_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_STRIDE_LAST_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)

#define SAC_WL_STRIDE_UNROLL_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_ND_WRITE( idx_scl_NT, 0) = SAC_WL_VAR( first, idx_scl_NT) + bnd1;
#define SAC_WL_MT_STRIDE_UNROLL_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_STRIDE_UNROLL_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)

#define SAC_WL_STRIDE_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) } }
#define SAC_WL_MT_STRIDE_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_STRIDE_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)

#define SAC_WL_STRIDE_UNROLL_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  
#define SAC_WL_MT_STRIDE_UNROLL_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_STRIDE_UNROLL_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)




#define SAC_WL_STRIDE_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) { int SAC_WL_VAR( diff, idx_scl_NT) = (bnd2 - bnd1);
#define SAC_WL_MT_STRIDE_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_STRIDE_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)

#define SAC_WL_STRIDE_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step) }
#define SAC_WL_MT_STRIDE_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)  SAC_WL_STRIDE_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2, step)






#define SAC_WL_GRID_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2) { int SAC_WL_VAR( grid_stop, idx_scl_NT) = SAC_ND_READ( idx_scl_NT, 0) + (bnd2 - bnd1);  for ( ; SAC_ND_READ( idx_scl_NT, 0) < SAC_WL_VAR( grid_stop, idx_scl_NT);  SAC_ND_WRITE( idx_scl_NT, 0) = SAC_ND_READ( idx_scl_NT, 0) + 1) {
#define SAC_WL_MT_GRID_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_WL_GRID_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)

#define SAC_WL_GRID_UNROLL_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  
#define SAC_WL_MT_GRID_UNROLL_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_WL_GRID_UNROLL_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)

#define SAC_WL_GRID_FIT_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2) { int SAC_WL_VAR( grid_stop, idx_scl_NT) = SAC_MIN( SAC_ND_READ( idx_scl_NT, 0)  + (bnd2 - bnd1),  SAC_WL_VAR( stop, idx_scl_NT));  for ( ; SAC_ND_READ( idx_scl_NT, 0) < SAC_WL_VAR( grid_stop, idx_scl_NT);  SAC_ND_WRITE( idx_scl_NT, 0) = SAC_ND_READ( idx_scl_NT, 0) + 1) {
#define SAC_WL_MT_GRID_FIT_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_WL_GRID_FIT_LOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)

#define SAC_WL_GRID_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2) } }
#define SAC_WL_MT_GRID_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_WL_GRID_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)

#define SAC_WL_GRID_UNROLL_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_ND_WRITE( idx_scl_NT, 0) = SAC_ND_READ( idx_scl_NT, 0) + 1;
#define SAC_WL_MT_GRID_UNROLL_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_WL_GRID_UNROLL_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)

#define SAC_WL_GRID_FIT_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2) } }
#define SAC_WL_MT_GRID_FIT_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_WL_GRID_FIT_LOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)




#define SAC_WL_GRID_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2) { int SAC_WL_VAR( diff, idx_scl_NT) = (bnd2 - bnd1);  SAC_ND_WRITE( idx_scl_NT, 0) = SAC_ND_READ( idx_scl_NT, 0) + SAC_WL_VAR( diff, idx_scl_NT);
#define SAC_WL_MT_GRID_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_WL_GRID_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)

#define SAC_WL_GRID_FIT_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2) { int SAC_WL_VAR( diff, idx_scl_NT) = SAC_MIN( (bnd2 - bnd1),  SAC_WL_VAR( stop, idx_scl_NT)  - SAC_ND_READ( idx_scl_NT, 0));  SAC_ND_WRITE( idx_scl_NT, 0) = SAC_ND_READ( idx_scl_NT, 0) + SAC_WL_VAR( diff, idx_scl_NT);
#define SAC_WL_MT_GRID_FIT_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_WL_GRID_FIT_NOOP_BEGIN( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)

#define SAC_WL_GRID_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2) }
#define SAC_WL_MT_GRID_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_WL_GRID_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)

#define SAC_WL_GRID_FIT_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2) }
#define SAC_WL_MT_GRID_FIT_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_WL_GRID_FIT_NOOP_END( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)


#define SAC_WL_SET_IDXVEC( dim, idx_vec_NT, idx_scl_NT, bnd1, bnd2)  SAC_ND_WRITE_READ( idx_vec_NT, dim, idx_scl_NT, 0);


#define SAC_WL_INC_OFFSET( off_NT, val_NT)  SAC_ND_WRITE( off_NT, 0) = SAC_ND_READ( off_NT, 0)  + SAC_ND_A_SIZE( val_NT);

#endif 


#define T_EMPTY (___, (___, (___, (___, (___, (___, (___, (___, (___,)))))))))
#define T_SHP( a, b) T_0( a, b)
#define T_HID( a, b) T_1( a, b)
#define T_UNQ( a, b) T_2( a, b)
#define T_REG( a, b) T_3( a, b)
#define T_SCO( a, b) T_4( a, b)
#define T_USG( a, b) T_5( a, b)
#define T_BIT( a, b) T_6( a, b)
#define T_DIS( a, b) T_7( a, b)
#define T_CBT( a, b) T_8( a, b)
#define SET_NT_NAME( a, b) NT_0( a, b)
#define SET_NT_SHP( a, b) NT_1( a, b)
#define SET_NT_HID( a, b) NT_2( a, b)
#define SET_NT_UNQ( a, b) NT_3( a, b)
#define SET_NT_REG( a, b) NT_4( a, b)
#define SET_NT_SCO( a, b) NT_5( a, b)
#define SET_NT_USG( a, b) NT_6( a, b)
#define SET_NT_BIT( a, b) NT_7( a, b)
#define SET_NT_DIS( a, b) NT_8( a, b)
#define SET_NT_CBT( a, b) NT_9( a, b)
#define SAC_SET_NT_NAME( a, b) NT_0( a, b)
#define SAC_SET_NT_SHP( a, b) NT_1( a, b)
#define SAC_SET_NT_HID( a, b) NT_2( a, b)
#define SAC_SET_NT_UNQ( a, b) NT_3( a, b)
#define SAC_SET_NT_REG( a, b) NT_4( a, b)
#define SAC_SET_NT_SCO( a, b) NT_5( a, b)
#define SAC_SET_NT_USG( a, b) NT_6( a, b)
#define SAC_SET_NT_BIT( a, b) NT_7( a, b)
#define SAC_SET_NT_DIS( a, b) NT_8( a, b)
#define SAC_SET_NT_CBT( a, b) NT_9( a, b)
#define T_OLD(a)  T_SHP( Item0 a, T_HID( Item1 a, T_UNQ( Item2 a, T_EMPTY)))
#define T(a, b)  (Item0 b, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (Item8 b,)))))))))
#define T_0(a, b) (a, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (Item8 b,)))))))))
#define T_1(a, b) (Item0 b, (a, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (Item8 b,)))))))))
#define T_2(a, b) (Item0 b, (Item1 b, (a, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (Item8 b,)))))))))
#define T_3(a, b) (Item0 b, (Item1 b, (Item2 b, (a, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (Item8 b,)))))))))
#define T_4(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (a, (Item5 b, (Item6 b, (Item7 b, (Item8 b,)))))))))
#define T_5(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (a, (Item6 b, (Item7 b, (Item8 b,)))))))))
#define T_6(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (a, (Item7 b, (Item8 b,)))))))))
#define T_7(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (a, (Item8 b,)))))))))
#define T_8(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (a,)))))))))
#define NT_0(a, b) (a, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (Item8 b, (Item9 b,))))))))))
#define NT_1(a, b) (Item0 b, (a, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (Item8 b, (Item9 b,))))))))))
#define NT_2(a, b) (Item0 b, (Item1 b, (a, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (Item8 b, (Item9 b,))))))))))
#define NT_3(a, b) (Item0 b, (Item1 b, (Item2 b, (a, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (Item8 b, (Item9 b,))))))))))
#define NT_4(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (a, (Item5 b, (Item6 b, (Item7 b, (Item8 b, (Item9 b,))))))))))
#define NT_5(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (a, (Item6 b, (Item7 b, (Item8 b, (Item9 b,))))))))))
#define NT_6(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (a, (Item7 b, (Item8 b, (Item9 b,))))))))))
#define NT_7(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (a, (Item8 b, (Item9 b,))))))))))
#define NT_8(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (a, (Item9 b,))))))))))
#define NT_9(a, b) (Item0 b, (Item1 b, (Item2 b, (Item3 b, (Item4 b, (Item5 b, (Item6 b, (Item7 b, (Item8 b, (a,))))))))))

#ifndef _SAC_CACHESIM_H
#define _SAC_CACHESIM_H
#ifndef SAC_C_EXTERN
#define SAC_C_EXTERN extern
#endif 
#if SAC_MUTC_MACROS
#else
#define SAC_CS_NONE 0
#define SAC_CS_FILE 1
#define SAC_CS_SIMPLE 2
#define SAC_CS_ADVANCED 3
typedef enum eWritePolicy{ SAC_CS_default, 
SAC_CS_fetch_on_write,
SAC_CS_write_validate, 
SAC_CS_write_around 
} tWritePolicy;
typedef enum eProfilingLevel{ SAC_CS_none,
SAC_CS_file,
SAC_CS_simple,
SAC_CS_advanced,
SAC_CS_piped_simple,
SAC_CS_piped_advanced
} tProfilingLevel;

SAC_C_EXTERN
void SAC_CS_CheckArguments( int argc, char *argv[],
tProfilingLevel *profilinglevel, int *cs_global, 
char **cshost, char **csfile, char **csdir,
unsigned long int *cachesize1, int *cachelinesize1, int *associativity1, 
tWritePolicy *writepolicy1, 
unsigned long int *cachesize2, int *cachelinesize2, int *associativity2, 
tWritePolicy *writepolicy2, 
unsigned long int *cachesize3, int *cachelinesize3, int *associativity3, 
tWritePolicy *writepolicy3 
);

SAC_C_EXTERN
void SAC_CS_Initialize( int nr_of_cpu,
tProfilingLevel profilinglevel, int cs_global, 
char *cshost, char *csfile, char *csdir,
unsigned long int cachesize1, int cachelinesize1, int associativity1, 
tWritePolicy writepolicy1, 
unsigned long int cachesize2, int cachelinesize2, int associativity2, 
tWritePolicy writepolicy2, 
unsigned long int cachesize3, int cachelinesize3, int associativity3, 
tWritePolicy writepolicy3 
);

SAC_C_EXTERN void (*SAC_CS_Finalize)( void);

SAC_C_EXTERN void (*SAC_CS_RegisterArray)( void* , 
int  );

SAC_C_EXTERN void (*SAC_CS_UnregisterArray)( void*  );

SAC_C_EXTERN void (*SAC_CS_ReadAccess)( void* , 
void*  );

SAC_C_EXTERN void (*SAC_CS_WriteAccess)( void* , 
void*  );

SAC_C_EXTERN void (*SAC_CS_Start)( char*  );

SAC_C_EXTERN void (*SAC_CS_Stop)( void);
#endif

#if (SAC_DO_CACHESIM)
#if (SAC_DO_CACHESIM_FILE)
#define SAC_CS_LEVEL SAC_CS_file
#elif (SAC_DO_CACHESIM_IMDE)
#if (SAC_DO_CACHESIM_ADV)
#define SAC_CS_LEVEL SAC_CS_advanced
#else
#define SAC_CS_LEVEL SAC_CS_simple
#endif
#elif (SAC_DO_CACHESIM_PIPE)
#if (SAC_DO_CACHESIM_ADV)
#define SAC_CS_LEVEL SAC_CS_piped_advanced
#else
#define SAC_CS_LEVEL SAC_CS_piped_simple
#endif
#else
#define SAC_CS_LEVEL SAC_CS_none
#endif
#define SAC_CS_SETUP() {  tProfilingLevel profilinglevel = SAC_CS_LEVEL;  int cs_global = SAC_DO_CACHESIM_GLOBAL;  char *cshost = SAC_SET_CACHESIM_HOST;  char *csfile = SAC_SET_CACHESIM_FILE;  char *csdir = SAC_SET_CACHESIM_DIR;   unsigned long int cachesize1 = SAC_SET_CACHE_1_SIZE;  int cachelinesize1 = SAC_SET_CACHE_1_LINE;  int associativity1 = SAC_SET_CACHE_1_ASSOC;  tWritePolicy writepolicy1 = SAC_SET_CACHE_1_WRITEPOL;   unsigned long int cachesize2 = SAC_SET_CACHE_2_SIZE;  int cachelinesize2 = SAC_SET_CACHE_2_LINE;  int associativity2 = SAC_SET_CACHE_2_ASSOC;  tWritePolicy writepolicy2 = SAC_SET_CACHE_2_WRITEPOL;   unsigned long int cachesize3 = SAC_SET_CACHE_3_SIZE;  int cachelinesize3 = SAC_SET_CACHE_3_LINE;  int associativity3 = SAC_SET_CACHE_3_ASSOC;  tWritePolicy writepolicy3 = SAC_SET_CACHE_3_WRITEPOL;   SAC_CS_CheckArguments(__argc, __argv, &profilinglevel, &cs_global,  &cshost, &csfile, &csdir,  &cachesize1, &cachelinesize1, &associativity1,  &writepolicy1,  &cachesize2, &cachelinesize2, &associativity2,  &writepolicy2,  &cachesize3, &cachelinesize3, &associativity3,  &writepolicy3 );   SAC_CS_Initialize(SAC_MT_GLOBAL_THREADS(), profilinglevel, cs_global,  cshost, csfile, csdir,  cachesize1, cachelinesize1, associativity1,  writepolicy1,  cachesize2, cachelinesize2, associativity2,  writepolicy2,  cachesize3, cachelinesize3, associativity3,  writepolicy3 );   SAC_CS_START("#"); }
#define SAC_CS_FINALIZE() {  SAC_CS_STOP("#");  SAC_CS_Finalize(); }
#define SAC_CS_READ_ARRAY( var_NT, pos)  SAC_CS_ReadAccess( SAC_ND_A_FIELD( var_NT), SAC_ND_A_FIELD( var_NT) + (pos)) ,
#define SAC_CS_WRITE_ARRAY( var_NT, pos)  SAC_CS_WriteAccess( SAC_ND_A_FIELD( var_NT), SAC_ND_A_FIELD( var_NT) + (pos)) , 
#define SAC_CS_REGISTER_ARRAY( var_NT)  SAC_CS_RegisterArray( SAC_ND_A_FIELD( var_NT),
SAC_ND_A_SIZE( var_NT) * sizeof( *(SAC_ND_A_FIELD( var_NT))));
#define SAC_CS_UNREGISTER_ARRAY( var_NT)  SAC_CS_UnregisterArray( SAC_ND_A_FIELD( var_NT));
#define SAC_CS_START( tag) SAC_CS_Start( tag);
#define SAC_CS_STOP( tag) SAC_CS_Stop();
#else 
#define SAC_CS_LEVEL SAC_CS_none
#define SAC_CS_SETUP()
#define SAC_CS_FINALIZE()
#define SAC_CS_READ_ARRAY( var_NT, pos)
#define SAC_CS_WRITE_ARRAY( var_NT, pos)
#define SAC_CS_REGISTER_ARRAY( var_NT)
#define SAC_CS_UNREGISTER_ARRAY( var_NT)
#define SAC_CS_START( tag)
#define SAC_CS_STOP( tag)
#endif 
#endif 

#ifndef _SAC_PROFILE_H
#define _SAC_PROFILE_H
#ifndef SAC_C_EXTERN
#define SAC_C_EXTERN extern
#endif 
#if SAC_MUTC_MACROS
#define SAC_PF_BEGIN_WITH(str)
#define SAC_PF_END_WITH(str)
#endif 
#if ! SAC_MUTC_MACROS

#if SAC_DO_COMPILE_MODULE
SAC_C_EXTERN void SAC_PF_BeginComm( void);
SAC_C_EXTERN void SAC_PF_EndComm( void);
#endif

#if SAC_DO_PROFILE

#include <sys/time.h>

#include <sys/resource.h>

#include <stdlib.h>

typedef struct timeval SAC_PF_TIMER;
typedef enum {PF_ow_fun=0,
PF_ow_genarray=1, PF_ow_modarray=2, PF_ow_fold=3,
PF_iw_fun=4, PF_iw_genarray=5, PF_iw_modarray=6, PF_iw_fold=7
#if SAC_DO_PROFILE_DISTMEM 

, PF_distmem_exec_rep=8, PF_distmem_exec_dist=9, PF_distmem_exec_side_effects=10
, PF_distmem_rep_barrier=11, PF_distmem_dist_barrier=12
, PF_distmem_side_effects_barrier=13, PF_distmem_comm=14
#endif 
} SAC_PF_timer_type;
#if SAC_DO_PROFILE_DISTMEM 
#define SAC_PF_NUM_TIMER_TYPES 15
#if SAC_DO_COMPILE_MODULE
#define SAC_PF_DISTMEM_DEFINE()  SAC_C_EXTERN SAC_PF_TIMER_RECORD SAC_PF_distmem_initial_record;  SAC_C_EXTERN SAC_PF_TIMER_RECORD *SAC_PF_distmem_act_record;  SAC_C_EXTERN SAC_PF_TIMER_RECORD SAC_PF_distmem_rep_record;  SAC_C_EXTERN SAC_PF_TIMER_RECORD SAC_PF_distmem_dist_record;  SAC_C_EXTERN SAC_PF_TIMER_RECORD SAC_PF_distmem_side_effects_record;  SAC_C_EXTERN SAC_PF_TIMER_RECORD SAC_PF_distmem_rep_barrier_record;  SAC_C_EXTERN SAC_PF_TIMER_RECORD SAC_PF_distmem_dist_barrier_record;  SAC_C_EXTERN SAC_PF_TIMER_RECORD SAC_PF_distmem_side_effects_barrier_record;  SAC_C_EXTERN SAC_PF_TIMER_RECORD SAC_PF_distmem_comm_record;
#else 
#define SAC_PF_DISTMEM_DEFINE()  SAC_PF_TIMER_RECORD SAC_PF_distmem_initial_record;  SAC_PF_TIMER_RECORD *SAC_PF_distmem_act_record = &SAC_PF_distmem_initial_record;  SAC_PF_TIMER_RECORD SAC_PF_distmem_rep_record;  SAC_PF_TIMER_RECORD SAC_PF_distmem_dist_record;  SAC_PF_TIMER_RECORD SAC_PF_distmem_side_effects_record;  SAC_PF_TIMER_RECORD SAC_PF_distmem_rep_barrier_record;  SAC_PF_TIMER_RECORD SAC_PF_distmem_dist_barrier_record;  SAC_PF_TIMER_RECORD SAC_PF_distmem_side_effects_barrier_record;  SAC_PF_TIMER_RECORD SAC_PF_distmem_comm_record;
#endif 
#define SAC_PF_DISTMEM_SETUP()  SAC_PF_distmem_rep_record.timer_type = PF_distmem_exec_rep;  SAC_PF_distmem_dist_record.timer_type = PF_distmem_exec_dist;  SAC_PF_distmem_side_effects_record.timer_type = PF_distmem_exec_side_effects;  SAC_PF_distmem_rep_barrier_record.timer_type = PF_distmem_rep_barrier;  SAC_PF_distmem_dist_barrier_record.timer_type = PF_distmem_dist_barrier;  SAC_PF_distmem_side_effects_barrier_record.timer_type = PF_distmem_side_effects_barrier;  SAC_PF_distmem_comm_record.timer_type = PF_distmem_comm;  SAC_PF_distmem_act_record->funno = 0;  SAC_PF_distmem_act_record->funapno = 0;  SAC_PF_distmem_act_record->timer_type = PF_distmem_exec_rep;  SAC_PF_distmem_act_record->parent = NULL;  SAC_PF_distmem_act_record->cycle_tag = NULL;
#else 
#define SAC_PF_NUM_TIMER_TYPES 8
#define SAC_PF_DISTMEM_DEFINE()
#define SAC_PF_DISTMEM_SETUP()
#endif 
typedef struct timer_record {
int funno;
int funapno;
SAC_PF_timer_type timer_type;
struct timer_record *parent;
int *cycle_tag;
} SAC_PF_TIMER_RECORD;

SAC_C_EXTERN int getrusage(int who, struct rusage *rusage);

SAC_C_EXTERN void SAC_PF_PrintHeader( char * title);
SAC_C_EXTERN void SAC_PF_PrintHeaderNode( char * title, size_t rank);
SAC_C_EXTERN void SAC_PF_PrintSubHeader( char * title, int lineno);
SAC_C_EXTERN void SAC_PF_PrintTime( char * title, char * space, 
SAC_PF_TIMER * time);
SAC_C_EXTERN void SAC_PF_PrintCount( char * title, char * space, unsigned long count);
SAC_C_EXTERN void SAC_PF_PrintTimePercentage( char * title, char * space,
SAC_PF_TIMER * time1, 
SAC_PF_TIMER * time2);

SAC_C_EXTERN int SAC_PF_act_funno; 
SAC_C_EXTERN int SAC_PF_act_funapno;
SAC_C_EXTERN int SAC_PF_with_level; 
SAC_C_EXTERN struct rusage SAC_PF_start_timer; 
SAC_C_EXTERN struct rusage SAC_PF_stop_timer; 

#if SAC_DO_COMPILE_MODULE
#define SAC_PF_DEFINE()  SAC_C_EXTERN SAC_PF_TIMER ***SAC_PF_timer;  SAC_C_EXTERN int **SAC_PF_cycle_tag;   SAC_C_EXTERN int SAC_PF_act_cycle_tag;  SAC_C_EXTERN SAC_PF_TIMER_RECORD *SAC_PF_act_record;   SAC_PF_DISTMEM_DEFINE()   SAC_C_EXTERN char **SAC_PF_fun_name;  SAC_C_EXTERN int *SAC_PF_maxfunap;  SAC_C_EXTERN int **SAC_PF_funapline;  SAC_C_EXTERN int **SAC_PF_parentfunno;
#else
#define SAC_PF_DEFINE()  SAC_PF_TIMER SAC_PF_timer[SAC_SET_MAXFUN][SAC_SET_MAXFUNAP][SAC_PF_NUM_TIMER_TYPES];  int SAC_PF_cycle_tag[SAC_SET_MAXFUN][SAC_SET_MAXFUNAP];   int SAC_PF_act_cycle_tag;  SAC_PF_TIMER_RECORD SAC_PF_initial_record;  SAC_PF_TIMER_RECORD *SAC_PF_act_record =&SAC_PF_initial_record;   SAC_PF_DISTMEM_DEFINE()   char *SAC_PF_fun_name[SAC_SET_MAXFUN]=SAC_SET_FUN_NAMES;  int SAC_PF_maxfunap[SAC_SET_MAXFUN]=SAC_SET_FUN_APPS;  int SAC_PF_funapline[SAC_SET_MAXFUN][SAC_SET_MAXFUNAP]=SAC_SET_FUN_AP_LINES;  int SAC_PF_parentfunno[SAC_SET_MAXFUN][SAC_SET_MAXFUNAP]=SAC_SET_FUN_PARENTS;   void SAC_PF_BeginComm( void) {  SAC_PF_BEGIN_COMM();  }   void SAC_PF_EndComm( void) {  SAC_PF_END_COMM();  }
#endif
#define SAC_PF_SETUP( ) {  int i,j,k;   SAC_PF_INIT_CLOCK();  for( i=0; i < SAC_SET_MAXFUN; i++) {  for( j=0; j < SAC_PF_maxfunap[i]; j++) {  for( k=0; k < SAC_PF_NUM_TIMER_TYPES ; k++) {  SAC_PF_INIT_TIMER( SAC_PF_timer[i][j][k]);  }  SAC_PF_cycle_tag[i][j] = 0;  }  }  SAC_PF_act_record->funno = 0;  SAC_PF_act_record->funapno = 0;  SAC_PF_act_record->timer_type = PF_ow_fun;  SAC_PF_act_record->parent = NULL;  SAC_PF_act_record->cycle_tag = &SAC_PF_cycle_tag[0][0];  SAC_PF_act_cycle_tag = 0;   SAC_PF_DISTMEM_SETUP()   SAC_PF_START_CLOCK(); }
#define SAC_PF_PRINT( ) {  if (SAC_DISTMEM_rank == SAC_DISTMEM_RANK_UNDEFINED   || SAC_DISTMEM_trace_profile_rank == SAC_DISTMEM_TRACE_PROFILE_RANK_ANY   || SAC_DISTMEM_trace_profile_rank == (int)SAC_DISTMEM_rank) {   SAC_PF_TIMER grand_total;   SAC_PF_STOP_CLOCK();  SAC_PF_ADD_TO_TIMER_CHAIN(SAC_PF_act_record); SAC_PF_PRINT_OVERALL(grand_total);  SAC_PF_PRINT_DISTMEM( grand_total);  SAC_PF_PRINT_FUNS(grand_total);  } }
#define SAC_PF_PRINT_OVERALL(total) {  int i,j,k;  SAC_PF_TIMER with_total;   SAC_PF_INIT_TIMER( with_total);  SAC_PF_INIT_TIMER( total);   for( k=PF_ow_genarray; k <=PF_iw_fold; k++) {  SAC_PF_ADD_TIMERS( with_total,  with_total,  SAC_PF_timer[0][0][k] );  }  SAC_PF_ADD_TIMERS( total, with_total, SAC_PF_timer[0][0][PF_ow_fun]);   if (SAC_DISTMEM_rank == SAC_DISTMEM_RANK_UNDEFINED) {  SAC_PF_PrintHeader("Overall Profile");  } else {  SAC_PF_PrintHeaderNode("Overall Profile", SAC_DISTMEM_rank);  }   SAC_PF_PrintTime("time used", SAC_PF_TIMER_SPACE, &total);   if( SAC_PF_DISPLAY_WITH ) {  SAC_PF_PrintTimePercentage(" with-loop", "", &with_total, &total);  SAC_PF_PrintTimePercentage(" non-with-loop", "",  &SAC_PF_timer[0][0][PF_ow_fun], &total);  } }
#define SAC_PF_PRINT_FUNS(total_time) {  int i,j,k,l;  SAC_PF_TIMER with_total, parent_with_total, non_with_total, total;   SAC_PF_PrintHeader("Function Profiles");   for( i=0; i<(SAC_PF_DISPLAY_FUN ? SAC_SET_MAXFUN : 1); i++) {  SAC_PF_INIT_TIMER( with_total);  SAC_PF_INIT_TIMER( parent_with_total);  SAC_PF_INIT_TIMER( non_with_total);  SAC_PF_INIT_TIMER( total);   for( j=0; j<SAC_PF_maxfunap[i]; j++) {  for( k= PF_ow_genarray; k <= PF_ow_fold; k++) {  SAC_PF_ADD_TIMERS( with_total,  with_total,  SAC_PF_timer[i][j][k] );  }  for( k= PF_iw_fun; k <= PF_iw_fold; k++) {  SAC_PF_ADD_TIMERS( parent_with_total,  parent_with_total,  SAC_PF_timer[i][j][k] );  }  SAC_PF_ADD_TIMERS( non_with_total,  non_with_total,  SAC_PF_timer[i][j][PF_ow_fun] );  }   SAC_PF_ADD_TIMERS( total, with_total, non_with_total);  SAC_PF_ADD_TIMERS( total, total, parent_with_total);   if( (total.tv_sec != 0) || (total.tv_usec != 0) ) {  SAC_PF_PrintHeader(SAC_PF_fun_name[i]);  SAC_PF_PrintTimePercentage("time used", SAC_PF_TIMER_SPACE, &total, &total_time);   if( SAC_PF_DISPLAY_WITH ) {  SAC_PF_PrintTimePercentage(" with-loop(own)",  "",  &with_total,  &total);   SAC_PF_PrintTimePercentage(" with-loop(parent)",  "",  &parent_with_total,  &total);   SAC_PF_PrintTimePercentage(" non-with-loop",  "",  &non_with_total,  &total);  }  if( SAC_PF_DISPLAY_FUN ) {  for( k=0; k < SAC_SET_MAXFUN; k += (k==(i-1)? 2 : 1)) {  if( k==i) { k++; }   for( j=0; j< SAC_PF_maxfunap[k]; j++) {  if( SAC_PF_parentfunno[k][j] == i) {  SAC_PF_TIMER sub_total;  SAC_PF_INIT_TIMER( sub_total);  SAC_PF_PrintSubHeader(SAC_PF_fun_name[k], SAC_PF_funapline[k][j]);  for( l=0; l<8; l++) {  SAC_PF_ADD_TIMERS( sub_total,  sub_total,  SAC_PF_timer[k][j][l] );  }  SAC_PF_PrintTimePercentage(" relative time used", SAC_PF_TIMER_SPACE,  &sub_total, &total);  }  }  }  }  }  } }
#define SAC_PF_INIT_CLOCK()
#define SAC_PF_INIT_TIMER(timer)timer.tv_sec = timer.tv_usec = 0
#define SAC_PF_START_CLOCK()getrusage(RUSAGE_SELF, &SAC_PF_start_timer)
#define SAC_PF_STOP_CLOCK()getrusage(RUSAGE_SELF, &SAC_PF_stop_timer)
#define SAC_PF_RECORD_TIMER( record) (SAC_PF_timer[record->funno][record->funapno][record->timer_type])
#if SAC_DO_PROFILE_DISTMEM

#define SAC_PF_ADD_STIME_TO_TIMER( record)  if ((SAC_PF_RECORD_TIMER(record).tv_usec +=  SAC_PF_stop_timer.ru_stime.tv_usec  - SAC_PF_start_timer.ru_stime.tv_usec) < 0 ) {  SAC_PF_RECORD_TIMER( record).tv_usec += 1000000;  SAC_PF_RECORD_TIMER( record).tv_sec +=  SAC_PF_stop_timer.ru_stime.tv_sec  - SAC_PF_start_timer.ru_stime.tv_sec-1;  } else {  SAC_PF_RECORD_TIMER( record).tv_sec +=  SAC_PF_stop_timer.ru_stime.tv_sec  - SAC_PF_start_timer.ru_stime.tv_sec;  } 
#else 
#define SAC_PF_ADD_STIME_TO_TIMER( record)
#endif 
#define SAC_PF_ADD_TO_TIMER(record) {  if( (SAC_PF_RECORD_TIMER(record).tv_usec +=  SAC_PF_stop_timer.ru_utime.tv_usec  - SAC_PF_start_timer.ru_utime.tv_usec) < 0 ) {  SAC_PF_RECORD_TIMER(record).tv_usec += 1000000;  SAC_PF_RECORD_TIMER(record).tv_sec +=  SAC_PF_stop_timer.ru_utime.tv_sec  - SAC_PF_start_timer.ru_utime.tv_sec-1;  }  else {  SAC_PF_RECORD_TIMER(record).tv_sec +=  SAC_PF_stop_timer.ru_utime.tv_sec  - SAC_PF_start_timer.ru_utime.tv_sec;  }   SAC_PF_ADD_STIME_TO_TIMER( record) }
#define SAC_PF_ADD_TO_TIMER_CHAIN(record) { SAC_PF_TIMER_RECORD *tmp;  tmp = record;  SAC_PF_act_cycle_tag++;  do{  if( *(tmp->cycle_tag) != SAC_PF_act_cycle_tag) {  *(tmp->cycle_tag) = SAC_PF_act_cycle_tag;  SAC_PF_ADD_TO_TIMER( tmp);  }  tmp = tmp->parent;  } while( tmp != NULL);  SAC_PF_ADD_TO_DISTMEM_TIMER_CHAIN() }
#define SAC_PF_ADD_TIMERS( timer, timer1, timer2) {  timer.tv_usec = timer1.tv_usec + timer2.tv_usec;  if( timer.tv_usec >= 1000000) {  timer.tv_usec -= 1000000;  timer.tv_sec = timer1.tv_sec + timer2.tv_sec + 1;  } else {  timer.tv_sec = timer1.tv_sec + timer2.tv_sec;  } }
#define SAC_PF_SUBTRACT_TIMERS( timer, timer1, timer2) {  if (timer1.tv_usec < timer2.tv_usec) {  int nsec = (timer2.tv_usec - timer1.tv_usec) / 1000000 + 1;  timer2.tv_usec -= 1000000 * nsec;  timer2.tv_sec += nsec;  }   if (timer1.tv_usec - timer2.tv_usec > 1000000) {  int nsec = (timer1.tv_usec - timer2.tv_usec) / 1000000;  timer2.tv_usec += 1000000 * nsec;  timer2.tv_sec -= nsec;  }     timer.tv_sec = timer1.tv_sec - timer2.tv_sec;  timer.tv_usec = timer1.tv_usec - timer2.tv_usec; }
#define SAC_PF_COPY_TIMER( totimer, fromtimer) {  totimer.tv_sec = fromtimer.tv_sec;  totimer.tv_usec = fromtimer.tv_usec; }
#define SAC_PF_TIMER_SPACE " "
#define SAC_PF_COUNT_SPACE " "
#else 
#if SAC_DO_COMPILE_MODULE
#define SAC_PF_DEFINE( )
#else 

#define SAC_PF_DEFINE( )  void SAC_PF_BeginComm( void) {} void SAC_PF_EndComm( void) {}
#endif 
#define SAC_PF_SETUP( )
#define SAC_PF_PRINT( )
#endif 

#if (SAC_DO_PROFILE_WITH && SAC_DO_PROFILE)
#define SAC_PF_BEGIN_WITH( str ) { SAC_PF_TIMER_RECORD SAC_PF_new_record;   SAC_PF_STOP_CLOCK();  SAC_PF_ADD_TO_TIMER_CHAIN( SAC_PF_act_record);  SAC_PF_new_record.parent = SAC_PF_act_record;  SAC_PF_new_record.funno = SAC_PF_act_record->funno;  SAC_PF_new_record.funapno = SAC_PF_act_record->funapno;  SAC_PF_new_record.timer_type = ( SAC_PF_with_level == 0 ? PF_ow_##str : PF_iw_##str); SAC_PF_new_record.cycle_tag = SAC_PF_act_record->cycle_tag;  SAC_PF_act_record = &SAC_PF_new_record;  SAC_PF_with_level++;  SAC_PF_START_CLOCK();
#define SAC_PF_END_WITH( str )  SAC_PF_STOP_CLOCK();  SAC_PF_with_level--;  SAC_PF_ADD_TO_TIMER_CHAIN( SAC_PF_act_record);  SAC_PF_act_record = SAC_PF_act_record->parent;  SAC_PF_START_CLOCK(); }
#define SAC_PF_DISPLAY_WITH 1
#else 
#define SAC_PF_BEGIN_WITH( str )
#define SAC_PF_END_WITH( str)
#define SAC_PF_DISPLAY_WITH 0
#endif 

#if (SAC_DO_PROFILE_DISTMEM && SAC_DO_PROFILE)
#define SAC_PF_PRINT_DISTMEM( total) {  int i;  SAC_PF_TIMER barrier_total;  SAC_PF_INIT_TIMER( barrier_total);  for(i = PF_distmem_rep_barrier; i <= PF_distmem_side_effects_barrier; i++) {  SAC_PF_ADD_TIMERS( barrier_total,  barrier_total,  SAC_PF_timer[0][0][i]);  }  SAC_PF_PrintHeader("Distributed Memory Backend Profile");  SAC_PF_PrintCount("Invalidated pages ", SAC_PF_COUNT_SPACE, SAC_DISTMEM_TR_num_inval_pages); SAC_PF_PrintCount("Seg faults/page fetches ", SAC_PF_COUNT_SPACE, SAC_DISTMEM_TR_num_segfaults);  SAC_PF_PrintCount("Pointer calculations ", SAC_PF_COUNT_SPACE, SAC_DISTMEM_TR_num_ptr_calcs);  SAC_PF_PrintCount("Avoided ptr calcs (local writes) ", SAC_PF_COUNT_SPACE,  SAC_DISTMEM_TR_num_avoided_ptr_calcs_local_writes);  SAC_PF_PrintCount("Avoided ptr calcs (local reads) ", SAC_PF_COUNT_SPACE,  SAC_DISTMEM_TR_num_avoided_ptr_calcs_local_reads);  SAC_PF_PrintCount("Avoided ptr calcs (known local reads)", SAC_PF_COUNT_SPACE,  SAC_DISTMEM_TR_num_avoided_ptr_calcs_known_local_reads);  SAC_PF_PrintCount("Avoided ptr calcs (remote reads) ", SAC_PF_COUNT_SPACE,  SAC_DISTMEM_TR_num_avoided_ptr_calcs_remote_reads);  SAC_PF_PrintCount("Ptr cache updates (remote reads) ", SAC_PF_COUNT_SPACE,  SAC_DISTMEM_TR_num_ptr_cache_updates);  SAC_PF_PrintCount("Barriers ", SAC_PF_COUNT_SPACE, SAC_DISTMEM_TR_num_barriers);   SAC_PF_PrintTimePercentage("Waiting at barriers ", SAC_PF_TIMER_SPACE,  &barrier_total,  &total);  SAC_PF_PrintTimePercentage("Communications ", SAC_PF_TIMER_SPACE,  &(SAC_PF_timer[0][0][PF_distmem_comm]),  &total);  SAC_PF_PrintTimePercentage("Replicated execution ", SAC_PF_TIMER_SPACE,  &(SAC_PF_timer[0][0][PF_distmem_exec_rep]),  &total);  SAC_PF_PrintTimePercentage(" Waiting at barriers ", SAC_PF_TIMER_SPACE,  &(SAC_PF_timer[0][0][PF_distmem_rep_barrier]),  &(SAC_PF_timer[0][0][PF_distmem_exec_rep]));  SAC_PF_PrintTimePercentage("Distributed execution ", SAC_PF_TIMER_SPACE,  &(SAC_PF_timer[0][0][PF_distmem_exec_dist]),  &total);  SAC_PF_PrintTimePercentage(" Waiting at barriers ", SAC_PF_TIMER_SPACE,  &(SAC_PF_timer[0][0][PF_distmem_dist_barrier]),  &(SAC_PF_timer[0][0][PF_distmem_exec_dist]));  SAC_PF_PrintTimePercentage("Side effects execution ", SAC_PF_TIMER_SPACE,  &(SAC_PF_timer[0][0][PF_distmem_exec_side_effects]),  &total);  SAC_PF_PrintTimePercentage(" Waiting at barriers ", SAC_PF_TIMER_SPACE,  &(SAC_PF_timer[0][0][PF_distmem_side_effects_barrier]),  &(SAC_PF_timer[0][0][PF_distmem_exec_side_effects])); }

#define SAC_PF_BEGIN_BARRIER()  switch ( SAC_DISTMEM_exec_mode) {  case SAC_DISTMEM_exec_mode_dist:  SAC_PF_BEGIN_DISTMEM( SAC_PF_distmem_dist_barrier_record)  break;  case SAC_DISTMEM_exec_mode_side_effects_outer:  case SAC_DISTMEM_exec_mode_side_effects:  SAC_PF_BEGIN_DISTMEM( SAC_PF_distmem_side_effects_barrier_record)  break;  default:   SAC_PF_BEGIN_DISTMEM( SAC_PF_distmem_rep_barrier_record)  break;  }
#define SAC_PF_END_BARRIER()  switch ( SAC_DISTMEM_exec_mode) {  case SAC_DISTMEM_exec_mode_dist:  SAC_PF_END_DISTMEM( SAC_PF_distmem_dist_barrier_record)  break;  case SAC_DISTMEM_exec_mode_side_effects_outer:  case SAC_DISTMEM_exec_mode_side_effects:  SAC_PF_END_DISTMEM( SAC_PF_distmem_side_effects_barrier_record)  break;  default:   SAC_PF_END_DISTMEM( SAC_PF_distmem_rep_barrier_record)  break;  }

#define SAC_PF_BEGIN_COMM()  SAC_PF_BEGIN_DISTMEM( SAC_PF_distmem_comm_record)
#define SAC_PF_END_COMM()  SAC_PF_END_DISTMEM( SAC_PF_distmem_comm_record)

#define SAC_PF_BEGIN_EXEC_SIDE_EFFECTS()  if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_sync) {  SAC_PF_BEGIN_DISTMEM( SAC_PF_distmem_side_effects_record) }
#define SAC_PF_BEGIN_EXEC_DIST()  SAC_PF_BEGIN_DISTMEM( SAC_PF_distmem_dist_record)

#define SAC_PF_END_EXEC_MODE()  switch ( SAC_DISTMEM_exec_mode) {  case SAC_DISTMEM_exec_mode_dist:  SAC_PF_END_DISTMEM( SAC_PF_distmem_dist_record)  break;  case SAC_DISTMEM_exec_mode_side_effects_outer:  SAC_PF_END_DISTMEM( SAC_PF_distmem_side_effects_record)  break;  default:    break;  }
#define SAC_PF_ADD_TO_DISTMEM_TIMER_CHAIN()  SAC_PF_ADD_TO_TIMER( SAC_PF_distmem_act_record);  if (SAC_PF_distmem_act_record->timer_type == PF_distmem_rep_barrier  || SAC_PF_distmem_act_record->timer_type == PF_distmem_dist_barrier  || SAC_PF_distmem_act_record->timer_type == PF_distmem_side_effects_barrier  || SAC_PF_distmem_act_record->timer_type == PF_distmem_comm) {  SAC_PF_ADD_TO_TIMER( SAC_PF_distmem_act_record->parent);  }

#define SAC_PF_BEGIN_DISTMEM( timer_record)  SAC_PF_STOP_CLOCK();  SAC_PF_ADD_TO_TIMER_CHAIN( SAC_PF_act_record);  timer_record.parent = SAC_PF_distmem_act_record;  timer_record.funno = SAC_PF_distmem_act_record->funno;  timer_record.funapno = SAC_PF_distmem_act_record->funapno;  timer_record.cycle_tag = SAC_PF_distmem_act_record->cycle_tag;  SAC_PF_distmem_act_record = &timer_record;  SAC_PF_START_CLOCK();
#define SAC_PF_END_DISTMEM( timer_record)  SAC_PF_STOP_CLOCK();  SAC_PF_ADD_TO_TIMER_CHAIN( SAC_PF_act_record);  SAC_PF_distmem_act_record = SAC_PF_distmem_act_record->parent;  SAC_PF_START_CLOCK();
#else 
#define SAC_PF_PRINT_DISTMEM( total)
#define SAC_PF_BEGIN_BARRIER()
#define SAC_PF_END_BARRIER()
#define SAC_PF_BEGIN_COMM()
#define SAC_PF_END_COMM()
#define SAC_PF_BEGIN_EXEC_SIDE_EFFECTS()
#define SAC_PF_BEGIN_EXEC_DIST()
#define SAC_PF_END_EXEC_MODE()
#define SAC_PF_ADD_TO_DISTMEM_TIMER_CHAIN()
#endif 
#ifdef DEBUG_PROFILING
#include <stdio.h>
#define DEBUG_PROFILE_PRINT( record) { SAC_PF_TIMER_RECORD * tmp;  tmp = SAC_PF_act_record;  while( tmp != NULL ) {  fprintf( stderr, "funno: %d funapno: %d timer_type: %d\n",  tmp->funno, tmp->funapno, tmp->timer_type);  tmp = tmp->parent;  } }
#define DEBUG_PROFILE_ENTER( record) {  fprintf( stderr, "entering UDF:\n");  DEBUG_PROFILE_PRINT( record); }
#define DEBUG_PROFILE_LEAVE( record) {  fprintf( stderr, "leaving UDF:\n");  DEBUG_PROFILE_PRINT( record); }
#else
#define DEBUG_PROFILE_ENTER( record)
#define DEBUG_PROFILE_LEAVE( record)
#endif

#if (SAC_DO_PROFILE_FUN && SAC_DO_PROFILE)
#define PROFILE_BEGIN_UDF( funno_in, funapno_in ) {  SAC_PF_TIMER_RECORD SAC_PF_new_record;   SAC_PF_STOP_CLOCK();  SAC_PF_ADD_TO_TIMER_CHAIN( SAC_PF_act_record);  SAC_PF_new_record.parent = SAC_PF_act_record;  SAC_PF_new_record.funno = funno_in;  SAC_PF_new_record.funapno = funapno_in;  SAC_PF_new_record.timer_type = ( SAC_PF_with_level == 0 ? PF_ow_fun : PF_iw_fun); SAC_PF_new_record.cycle_tag = &SAC_PF_cycle_tag[funno_in][funapno_in];  SAC_PF_act_record = &SAC_PF_new_record;  DEBUG_PROFILE_ENTER( SAC_PF_act_record);  SAC_PF_START_CLOCK();
#define PROFILE_END_UDF( funno, funapno )  SAC_PF_STOP_CLOCK();  SAC_PF_ADD_TO_TIMER_CHAIN( SAC_PF_act_record);  SAC_PF_act_record = SAC_PF_act_record->parent;  DEBUG_PROFILE_LEAVE( SAC_PF_act_record);  SAC_PF_START_CLOCK(); }
#define SAC_PF_DISPLAY_FUN 1
#else 
#define PROFILE_BEGIN_UDF( funno, funapno )
#define PROFILE_END_UDF( funno, funapno )
#define SAC_PF_DISPLAY_FUN 0
#endif 

#if (SAC_DO_PROFILE_INL && SAC_DO_PROFILE)
#define PROFILE_INLINE(x) x
#else 
#define PROFILE_INLINE(x)
#endif 

#if (SAC_DO_PROFILE_LIB && SAC_DO_PROFILE)
#define PROFILE_LIBRARY(x) x
#else 
#define PROFILE_LIBRARY(x)
#endif 
#else
#define SAC_PF_DEFINE()
#endif 
#endif 

#ifndef _SAC_RUNTIMECHECK_H_
#define _SAC_RUNTIMECHECK_H_

#if SAC_DO_CHECK_TYPE
#define SAC_ASSURE_TYPE( cond, message)  if (!(cond)) { SAC_RuntimeError message; }

#define SAC_ASSURE_TYPE_LINE( cond, line, message )  if (!(cond)) { SAC_RuntimeErrorLine( line, message); }
#else 
#define SAC_ASSURE_TYPE( cond, message)  
#define SAC_ASSURE_TYPE_LINE( cond, line, message)  
#endif 

#if SAC_DO_CHECK_BOUNDARY
#define SAC_BC_READ( var_NT, pos)  (((pos >= 0) && (pos < SAC_ND_A_SIZE( var_NT)))  ? 0  : (SAC_RuntimeError( "Memory access violation on reading from array %s\n"  "*** with size %d at index position %d !\n",  NT_STR( var_NT), SAC_ND_A_SIZE( var_NT), pos),  0)),
#define SAC_BC_WRITE( var_NT, pos)  (((pos >= 0) && (pos < SAC_ND_A_SIZE( var_NT)))  ? 0  : (SAC_RuntimeError( "Memory access violation on writing into array %s\n"  "*** with size %d at index position %d !\n",  NT_STR( var_NT), SAC_ND_A_SIZE( var_NT), pos),  0)),
#else 
#define SAC_BC_WRITE( var_NT, pos) 
#define SAC_BC_READ( var_NT, pos)
#endif 

#if SAC_DO_CHECK_DISTMEM
#define SAC_DISTMEM_CHECK_PTR_FROM_CACHE( var_NT, pos, ptr) (  (ptr == SAC_DISTMEM_ELEM_POINTER( SAC_ND_A_OFFS( var_NT),  SAC_NT_CBASETYPE( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT),  pos))  ? 0 : (  SAC_RuntimeError( "Pointer to element %d of array %s from cache (%p) "  "does not match calculated pointer (%p). "  "Offset: %"PRIuPTR", first elems: %zd. "  "Cache at %p: %d elements from %d.",  pos,  NT_STR( var_NT),  ptr,  SAC_DISTMEM_ELEM_POINTER(SAC_ND_A_OFFS( var_NT),  SAC_NT_CBASETYPE( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT),  pos),  SAC_ND_A_OFFS( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT),  SAC_ND_A_MIRROR_PTR_CACHE( var_NT),  SAC_ND_A_MIRROR_PTR_CACHE_COUNT( var_NT),  SAC_ND_A_MIRROR_PTR_CACHE_FROM( var_NT)),  0  ) ),
#define SAC_DISTMEM_CHECK_PTR_FROM_DESC( var_NT, pos, ptr) (  (ptr == SAC_DISTMEM_ELEM_POINTER( SAC_ND_A_OFFS( var_NT),  SAC_NT_CBASETYPE( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT),  pos))  ? 0 : (  SAC_RuntimeError( "Pointer to element %d of array %s from descriptor (%p) "  "does not match calculated pointer (%p). "  "Offset: %"PRIuPTR", first elems: %zd. "  "Element local to: %d, start of array there: %p.",  pos,  NT_STR( var_NT),  ptr,  SAC_DISTMEM_ELEM_POINTER(SAC_ND_A_OFFS( var_NT),  SAC_NT_CBASETYPE( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT),  pos),  SAC_ND_A_OFFS( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT),  ((unsigned)pos / (unsigned)SAC_ND_A_FIRST_ELEMS( var_NT)),  SAC_ND_A_DESC_PTR( var_NT, ((unsigned)pos / (unsigned)SAC_ND_A_FIRST_ELEMS( var_NT)))),  0  ) ),
#define SAC_DISTMEM_CHECK_IS_DSM_ALLOC_ALLOWED()  if (!SAC_DISTMEM_are_dsm_allocs_allowed) {  SAC_RuntimeError( "Allocations in the DSM segment are "  "not allowed at this point.");  }
#define SAC_DISTMEM_CHECK_IS_SWITCH_TO_SIDE_EFFECTS_OUTER_EXEC_ALLOWED()  if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_dist) {  SAC_RuntimeError( "Cannot switch from distributed to side effects outer execution mode.");  } else if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_side_effects_outer) {  SAC_RuntimeError( "Already in side effects outer execution mode.");  }
#define SAC_DISTMEM_CHECK_IS_SWITCH_TO_SIDE_EFFECTS_EXEC_ALLOWED()  if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_dist) {  SAC_RuntimeError( "Cannot switch from distributed to side effects execution mode.");  } else if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_side_effects) {  SAC_RuntimeError( "Already in side effects execution mode.");  } else if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_sync) {  SAC_RuntimeError( "Cannot switch from synchronous to side effects execution mode.");  }
#define SAC_DISTMEM_CHECK_IS_SWITCH_TO_DIST_EXEC_ALLOWED()  if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_dist) {  SAC_RuntimeError( "Already in distributed execution mode.");  } else if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_side_effects) {  SAC_RuntimeError( "Cannot switch from side effects to distributed execution mode.");  } else if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_side_effects_outer) {  SAC_RuntimeError( "Cannot switch from side effects outer to distributed execution mode.");  }
#define SAC_DISTMEM_CHECK_IS_SWITCH_TO_SYNC_EXEC_ALLOWED()  if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_sync) {  SAC_RuntimeError( "Already in synchronous execution mode.");  } else if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_side_effects) {  SAC_RuntimeError( "Cannot switch from side effects to synchronous execution mode.");  }
#define _SAC_DISTMEM_CHECK_IS_LEGAL_FOR_LOCAL_WRITE( ptr) (  (SAC_DISTMEM_are_dist_writes_allowed  && SAC_DISTMEM_IS_VALID_WRITE_PTR( ptr))  ? TRUE  : FALSE )
#define _SAC_DISTMEM_CHECK_IS_LEGAL_FOR_CACHE_WRITE( ptr) (  (SAC_DISTMEM_are_cache_writes_allowed  && SAC_DISTMEM_IS_VALID_CACHE_PTR( ptr))  ? TRUE  : FALSE )
#define SAC_DISTMEM_CHECK_WRITE_ALLOWED( ptr, var_NT, pos) (  (!SAC_ND_A_IS_DIST( var_NT)  || _SAC_DISTMEM_CHECK_IS_LEGAL_FOR_LOCAL_WRITE( ptr)  || _SAC_DISTMEM_CHECK_IS_LEGAL_FOR_CACHE_WRITE( ptr))  ? 0  : (SAC_RuntimeError( "Illegal write access to distributed array %s"  ", index position %d at %p\n"  "(legal pointer? %d, writes allowed? %d, "  "legal cache pointer? %d cache writes allowed? %d)",  NT_STR( var_NT), pos, ptr,  SAC_DISTMEM_IS_VALID_WRITE_PTR( ptr),  SAC_DISTMEM_are_dist_writes_allowed,  SAC_DISTMEM_IS_VALID_CACHE_PTR( ptr),  SAC_DISTMEM_are_cache_writes_allowed),  0) ),
#define SAC_DISTMEM_CHECK_READ_ALLOWED( ptr, var_NT, pos) (  (!SAC_ND_A_IS_DIST( var_NT) || SAC_DISTMEM_IS_VALID_READ_PTR( ptr))  ? 0  : (SAC_RuntimeError( "Illegal read access to distributed array %s"  ", index position %d at %p",  NT_STR( var_NT), pos, ptr),  0) ),
#define SAC_DISTMEM_CHECK_LOCAL_READ_ALLOWED( ptr, var_NT, pos) (  (!SAC_ND_A_IS_DIST( var_NT)  || (SAC_DISTMEM_IS_VALID_LOCAL_READ_IDX( var_NT, pos)  && SAC_DISTMEM_IS_VALID_LOCAL_READ_PTR( ptr)))  ? 0  : (SAC_RuntimeError( "Illegal local read access to distributed array %s"  ", index position %d at %p",  NT_STR( var_NT), pos, ptr),  0) ),
#define SAC_DISTMEM_CHECK_POINTER_VALID_FOR_READ( ptr)  if (!SAC_DISTMEM_IS_VALID_READ_PTR( ptr)) {  SAC_RuntimeError( "Illegal read access to distributed array at %p",  ptr);  }

#define SAC_DISTMEM_CHECK_IS_NON_DIST_ARR( var_NT) (  SAC_ND_A_IS_DIST( var_NT)  ? (SAC_RuntimeError( "Array %s is marked as distributed but treated "  "as non-distributed.", NT_STR( var_NT)), 0)  : (  (!SAC_DISTMEM_IS_NON_DIST_PTR( SAC_ND_A_FIELD( var_NT)))  ? (SAC_RuntimeError( "Array %s points to DSM memory at %p but is "  "treated as non-distributed.",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)), 0)  : 0  ) ),

#define SAC_DISTMEM_CHECK_IS_DSM_ARR( var_NT) (  (SAC_ND_A_IS_DIST( var_NT) && SAC_DISTMEM_IS_NON_DIST_PTR( SAC_ND_A_FIELD( var_NT)))  ? (SAC_RuntimeError( "Array %s is marked as allocated in DSM memory but allocated "  "in normal memory at %p.", NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)), 0)  : (  (!SAC_ND_A_IS_DIST( var_NT) && !SAC_DISTMEM_IS_NON_DIST_PTR( SAC_ND_A_FIELD( var_NT)))  ? (SAC_RuntimeError( "Array %s is marked as allocated in normal memory but is "  "allocated in DSM memory at %p.",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)), 0)  : 0  ) ),
#else 
#define SAC_DISTMEM_CHECK_PTR_FROM_CACHE( var_NT, pos, ptr)
#define SAC_DISTMEM_CHECK_PTR_FROM_DESC( var_NT, pos, ptr)
#define SAC_DISTMEM_CHECK_IS_DSM_ALLOC_ALLOWED()
#define SAC_DISTMEM_CHECK_IS_SWITCH_TO_SIDE_EFFECTS_OUTER_EXEC_ALLOWED()
#define SAC_DISTMEM_CHECK_IS_SWITCH_TO_SIDE_EFFECTS_EXEC_ALLOWED()
#define SAC_DISTMEM_CHECK_IS_SWITCH_TO_DIST_EXEC_ALLOWED()
#define SAC_DISTMEM_CHECK_IS_SWITCH_TO_SYNC_EXEC_ALLOWED()
#define SAC_DISTMEM_CHECK_WRITE_ALLOWED( ptr, var_NT, pos)
#define SAC_DISTMEM_CHECK_READ_ALLOWED( ptr, var_NT, pos)
#define SAC_DISTMEM_CHECK_LOCAL_READ_ALLOWED( ptr, var_NT, pos)
#define SAC_DISTMEM_CHECK_POINTER_VALID_FOR_READ( ptr)
#define SAC_DISTMEM_CHECK_IS_NON_DIST_ARR( var_NT)
#define SAC_DISTMEM_CHECK_IS_DSM_ARR( var_NT)
#endif 

#if SAC_DO_CHECK_GPU
#define SAC_CUDA_GET_LAST_ERROR( ERROR_MSG) do {  cudaError_t error = cudaGetLastError();  if(error != cudaSuccess){  SAC_RuntimeError("%s ERROR: %s (%d): %s\n", ERROR_MSG, __FILE__, __LINE__, cudaGetErrorString(error));  } }while(0)
#define SAC_CUDA_GET_LAST_KERNEL_ERROR( )  cudaDeviceSynchronize();  SAC_CUDA_GET_LAST_ERROR( "GPU KERNEL")
#define SAC_GET_CUDA_MEM_TRANSFER_ERROR( )  SAC_CUDA_GET_LAST_ERROR( "GPU MEMORY TRANSFER")
#define SAC_GET_CUDA_MALLOC_ERROR( )  SAC_CUDA_GET_LAST_ERROR( "GPU MALLOC")
#define SAC_GET_CUDA_FREE_ERROR( )  SAC_CUDA_GET_LAST_ERROR( "GPU CUDA FREE")
#else
#define SAC_CUDA_GET_LAST_ERROR( ERROR_MSG)
#define SAC_CUDA_GET_LAST_KERNEL_ERROR( )
#define SAC_GET_CUDA_MEM_TRANSFER_ERROR( )
#define SAC_GET_CUDA_MALLOC_ERROR( )
#define SAC_GET_CUDA_FREE_ERROR( )
#endif 
#endif 

#ifndef _SAC_TRACE_H
#define _SAC_TRACE_H
#ifndef SAC_C_EXTERN
#define SAC_C_EXTERN extern
#endif 

SAC_C_EXTERN void SAC_TR_Print( char *format, ...);
#define SAC_TR_LIBSAC_PRINT( msg)  ( SAC_MT_do_trace ? SAC_TR_Print msg : (void)0)
#if SAC_DO_TRACE

#if SAC_DO_TRACE_MT
#include <stdio.h>
#endif
#include <string.h>
SAC_C_EXTERN int SAC_TR_hidden_memcnt;
SAC_C_EXTERN int SAC_TR_array_memcnt;
SAC_C_EXTERN void SAC_TR_IncArrayMemcnt( int size);
SAC_C_EXTERN void SAC_TR_DecArrayMemcnt( int size);
SAC_C_EXTERN void SAC_TR_IncHiddenMemcnt( int size);
SAC_C_EXTERN void SAC_TR_DecHiddenMemcnt( int size);

#define SAC_TR_PRINT( msg)  SAC_TR_Print msg
#else 
#define SAC_TR_PRINT( msg)
#endif 
#if SAC_DO_TRACE_FUN
#define SAC_TR_FUN_PRINT( msg)  SAC_TR_PRINT( msg);
#else 
#define SAC_TR_FUN_PRINT( msg)
#endif 
#if SAC_DO_TRACE_PRF
#define SAC_TR_PRF_PRINT( msg)  SAC_TR_PRINT( msg);
#else 
#define SAC_TR_PRF_PRINT( msg)
#endif 
#if SAC_DO_TRACE_REF
#define SAC_TR_REF_PRINT( msg)  SAC_TR_PRINT( msg);
#define SAC_TR_REF_PRINT_RC( var_NT)  SAC_TR_REF_PRINT( ("refcnt of %s at address %p: %d",  NT_STR( var_NT), SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT)),  SAC_ND_A_RC( var_NT)))
#else 
#define SAC_TR_REF_PRINT( msg)
#define SAC_TR_REF_PRINT_RC( name)
#endif 
#if SAC_DO_TRACE_WL
#define SAC_TR_WL_PRINT( msg)  SAC_TR_PRINT( msg);
#else 
#define SAC_TR_WL_PRINT( msg)
#endif 
#if SAC_DO_TRACE_AA
#define SAC_TR_AA_PRINT( str, array, pos)  SAC_TR_PRINT( ("%s access to array %s at position %d", str, #array, pos)),
#define SAC_TR_AA_FPRINT( str, array, pos, ...)  SAC_TR_PRINT( (str" access to array %s at position %d", __VA_ARGS__, #array, pos)),
#else 
#define SAC_TR_AA_PRINT( str, array, idx)
#define SAC_TR_AA_FPRINT( str, array, pos, ...)
#endif 
#if SAC_DO_TRACE_MT
typedef enum
{
SAC_TR_foldres_int,
SAC_TR_foldres_float,
SAC_TR_foldres_double,
SAC_TR_foldres_hidden
}
SAC_TR_foldres_t;
#define SAC_TR_MT_PRINT( msg)  SAC_TR_PRINT( msg);
#define SAC_TR_MT_PRINT_FOLD_RESULT( basetype, accu_NT, msg)  CAT13( SAC_TR_MT_PRINT_FOLD_RESULT__, NT_SHP( accu_NT)  BuildArgs3( basetype, accu_NT, msg))
#define SAC_TR_MT_PRINT_FOLD_RESULT__SCL( basetype, accu_NT, msg) {  const SAC_TR_foldres_t SAC_TR_foldres = SAC_TR_foldres_##basetype;  switch (SAC_TR_foldres) {  case SAC_TR_foldres_int:  SAC_TR_MT_PRINT( (msg " (int) %d", SAC_ND_A_FIELD( accu_NT)));  break;  case SAC_TR_foldres_float:  SAC_TR_MT_PRINT( (msg " (float) %.15g", SAC_ND_A_FIELD( accu_NT)));  break;  case SAC_TR_foldres_double:  SAC_TR_MT_PRINT( (msg " (double) %.15g", SAC_ND_A_FIELD( accu_NT)));  break;  case SAC_TR_foldres_hidden:  SAC_TR_MT_PRINT( (msg " (hidden)"));  break;  } }

#define SAC_TR_MT_PRINT_FOLD_RESULT__AKS( basetype, accu_NT, msg) {  int SAC_i;  char SAC_tmp[19];  char *SAC_s;  const SAC_TR_foldres_t SAC_TR_foldres = SAC_TR_foldres_##basetype;  SAC_s = (char *) SAC_MALLOC( 200 * sizeof( char));  SAC_s[0] = '\0';  strcat( SAC_s, "[ ");  for (SAC_i = 0; SAC_i < SAC_MIN( SAC_ND_A_SIZE( accu_NT), 10); SAC_i++) {  switch (SAC_TR_foldres) {  case SAC_TR_foldres_int:  snprintf( SAC_tmp, 19, "%d ", SAC_ND_READ( accu_NT, SAC_i));  break;  case SAC_TR_foldres_float:  snprintf( SAC_tmp, 19, "%g ", SAC_ND_READ( accu_NT, SAC_i));  break;  case SAC_TR_foldres_double:  snprintf( SAC_tmp, 19, "%g ", SAC_ND_READ( accu_NT, SAC_i));  break;  case SAC_TR_foldres_hidden:  snprintf( SAC_tmp, 19, ". ");  break;  }  strcat( SAC_s, SAC_tmp);  }  if (SAC_ND_A_SIZE( accu_NT) > 10) {  strcat( SAC_s, "... ");  }  strcat( SAC_s, "]");  SAC_TR_MT_PRINT( (msg " (%s array) %p = %s",  #basetype, SAC_ND_A_FIELD( accu_NT), SAC_s)); }
#define SAC_TR_MT_PRINT_FOLD_RESULT__AKD( basetype, accu_NT, msg)  SAC_TR_MT_PRINT_FOLD_RESULT__AKS( basetype, accu_NT, msg)
#define SAC_TR_MT_PRINT_FOLD_RESULT__AUD( basetype, accu_NT, msg)  SAC_TR_MT_PRINT_FOLD_RESULT__AKS( basetype, accu_NT, msg)
#else 
#define SAC_TR_MT_PRINT( msg)
#define SAC_TR_MT_PRINT_FOLD_RESULT( basetype, accu_var, msg)
#endif 
#if SAC_DO_TRACE_DISTMEM
#define SAC_TR_DISTMEM_PRINT( ...)  SAC_TR_PRINT( ("DSM -> " __VA_ARGS__))
#define SAC_TR_DISTMEM_PRINT_EXPR( ...)  SAC_TR_PRINT( ("DSM -> " __VA_ARGS__)),
#if SAC_DO_TRACE_AA

#define SAC_TR_DISTMEM_AA_PRINT( ...)  SAC_TR_PRINT( ("DSM -> " __VA_ARGS__)),
#else 
#define SAC_TR_DISTMEM_AA_PRINT( ...)
#endif 
#else 
#define SAC_TR_DISTMEM_PRINT( ...)
#define SAC_TR_DISTMEM_PRINT_EXPR( ...)
#define SAC_TR_DISTMEM_AA_PRINT( ...)
#endif
#if SAC_DO_TRACE_MEM
#define SAC_TR_MEM_PRINT( msg)  SAC_TR_PRINT( msg);
#define SAC_TR_INC_ARRAY_MEMCNT( size)  SAC_TR_IncArrayMemcnt( size);
#define SAC_TR_DEC_ARRAY_MEMCNT( size)  SAC_TR_DecArrayMemcnt( size);
#define SAC_TR_INC_HIDDEN_MEMCNT( size)  SAC_TR_IncHiddenMemcnt( size);
#define SAC_TR_DEC_HIDDEN_MEMCNT( size)  SAC_TR_DecHiddenMemcnt( size);
#else 
#define SAC_TR_MEM_PRINT( msg)
#define SAC_TR_INC_ARRAY_MEMCNT( size)
#define SAC_TR_DEC_ARRAY_MEMCNT( size)
#define SAC_TR_INC_HIDDEN_MEMCNT( size)
#define SAC_TR_DEC_HIDDEN_MEMCNT( size)
#endif 
#else
#define SAC_HM_DEFINE()
#endif 

#ifndef _SAC_MT_H_
#define _SAC_MT_H_
#ifndef SAC_C_EXTERN
#define SAC_C_EXTERN extern
#endif 

#define SAC_MT_INVALID_GLOBAL_ID 0xdeadbeef
#if SAC_DO_MULTITHREAD || (SAC_MT_MODE > 0)

SAC_C_EXTERN unsigned int SAC_MT_global_threads;

SAC_C_EXTERN unsigned int SAC_MT_barrier_type;

SAC_C_EXTERN unsigned int SAC_MT_cpu_bind_strategy;

SAC_C_EXTERN unsigned int SAC_MT_do_trace;

SAC_C_EXTERN unsigned int SAC_RTSPEC_controller_threads;

SAC_C_EXTERN unsigned int SAC_MT_globally_single;
SAC_C_EXTERN void SAC_COMMON_MT_SetupInitial( int argc, char *argv[],
unsigned int num_threads, 
unsigned int max_threads);

SAC_C_EXTERN unsigned int SAC_MT_Internal_CurrentThreadId(void);
#endif
#if SAC_DO_MULTITHREAD

#ifndef SAC_SET_CACHE_1_LINE
#define SAC_SET_CACHE_1_LINE 0
#endif
#ifndef SAC_SET_CACHE_2_LINE
#define SAC_SET_CACHE_2_LINE 0
#endif
#ifndef SAC_SET_CACHE_3_LINE
#define SAC_SET_CACHE_3_LINE 0
#endif

#define SAC_MT_CACHE_LINE_MAX()  SAC_MAX( SAC_SET_CACHE_1_LINE,  SAC_MAX( SAC_SET_CACHE_2_LINE,  SAC_MAX( SAC_SET_CACHE_3_LINE, 1)))
#include <pthread.h>
#include <stdlib.h>
#ifndef _POSIX_C_SOURCE
#define _POSIX_C_SOURCE 199506L
#endif
#ifndef _REENTRANT
#define _REENTRANT
#endif
#ifndef __CUDACC__
#ifndef memset
extern void *memset(void *s, int c, size_t n);
#endif
#ifndef memcpy
extern void *memcpy(void *dest, const void *src, size_t n);
#endif
#endif 




#define SAC_MT_DEFINE_LOCK( name)  pthread_mutex_t name = PTHREAD_MUTEX_INITIALIZER;
#define SAC_MT_DECLARE_LOCK( name)  SAC_C_EXTERN pthread_mutex_t name;
#define SAC_MT_ACQUIRE_LOCK( name)  pthread_mutex_lock( &name);
#define SAC_MT_RELEASE_LOCK( name)  pthread_mutex_unlock( &name);

#if SAC_DO_THREADS_STATIC

#define SAC_MT_GLOBAL_THREADS()  SAC_SET_THREADS
#define SAC_HM_RTSPEC_THREADS()  SAC_RTSPEC_controller_threads
#else 


#define SAC_MT_GLOBAL_THREADS()  SAC_MT_global_threads
#define SAC_HM_RTSPEC_THREADS()  SAC_RTSPEC_controller_threads
#endif 

#else 

SAC_C_EXTERN unsigned int SAC_MT_globally_single;

SAC_C_EXTERN unsigned int SAC_RTSPEC_controller_threads;


#define SAC_MT_GLOBAL_THREADS()  1
#define SAC_HM_RTSPEC_THREADS()  SAC_RTSPEC_controller_threads
#define SAC_MT_SETUP()
#define SAC_MT_SETUP_INITIAL()
#define SAC_MT_DEFINE()
#define SAC_MT_DEFINE_LOCK( name)
#define SAC_MT_DECLARE_LOCK( name)
#define SAC_MT_ACQUIRE_LOCK( name)
#define SAC_MT_RELEASE_LOCK( name)
#define SAC_ND_PROP_OBJ_IN( )
#define SAC_ND_PROP_OBJ_OUT( )
#define SAC_ND_PROP_OBJ_UNBOX( unboxed, boxed)
#define SAC_ND_PROP_OBJ_BOX( boxed, unboxed)  SAC_ND_A_FIELD( boxed) = SAC_ND_A_FIELD( unboxed);
#define SAC_MT_FINALIZE()
#define SAC_INVOKE_MAIN_FUN( fname, arg)  fname ( arg )

#endif 
#endif 

#if ENABLE_HWLOC
#include <hwloc.h>
extern hwloc_cpuset_t* SAC_HWLOC_cpu_sets;
extern hwloc_topology_t SAC_HWLOC_topology;
void SAC_HWLOC_init(int threads);
void SAC_HWLOC_cleanup(void);
#endif

#ifndef _SAC_MT_OMP_H_
#define _SAC_MT_OMP_H_

#if SAC_DO_MULTITHREAD
#if SAC_DO_MT_OMP
SAC_C_EXTERN void SAC_OMP_SetupInitial( int argc, char *argv[], 
unsigned int num_threads,
unsigned int max_threads);
 
#define SAC_MT_SETUP_INITIAL()  SAC_OMP_SetupInitial( __argc, __argv,  SAC_SET_THREADS, SAC_SET_THREADS_MAX);
#define SAC_OMP_SET_NUM_THREADS() omp_set_num_threads(SAC_MT_GLOBAL_THREADS())
#define SAC_OMP_SET_MAX_ACTIVE_LEVEL() omp_set_max_active_levels(SAC_OMP_MAX_ACTIVE_LEVEL())
#define SAC_OMP_MAX_ACTIVE_LEVEL() SAC_OMP_ACTIVE_LEVEL
#define SAC_MT_SETUP() 
#define SAC_MT_DEFINE()
#define SAC_MT_FINALIZE()
#endif 

#endif 
#endif 

#ifndef _SAC_SCHEDULE_H_
#define _SAC_SCHEDULE_H_

#if SAC_DO_MULTITHREAD
#if SAC_DO_MT_PTHREAD || SAC_DO_MT_LPEL || SAC_DO_MT_BEEHIVE

#define SAC_MT_DEFINE()  SAC_MT_DEFINE_TASKLOCKS()  SAC_MT_DEFINE_TS_TASKLOCKS()  SAC_MT_DEFINE_TASKS()  SAC_MT_DEFINE_LAST_TASKS()  SAC_MT_DEFINE_REST_ITERATIONS()  SAC_MT_DEFINE_ACT_TASKSIZE()  SAC_MT_DEFINE_LAST_TASKEND()  SAC_MT_DEFINE_TASKCOUNT()




#define SAC_MT_DEFINE_TASKLOCKS()  pthread_mutex_t *SAC_MT_Tasklock;
#define SAC_MT_DEFINE_TASKS()  volatile int *SAC_MT_Task;
#define SAC_MT_DEFINE_LAST_TASKS()  volatile int *SAC_MT_LAST_Task;
#define SAC_MT_DEFINE_REST_ITERATIONS()  volatile int *SAC_MT_rest_iterations;
#define SAC_MT_DEFINE_ACT_TASKSIZE()  volatile int *SAC_MT_act_tasksize;
#define SAC_MT_DEFINE_LAST_TASKEND()  volatile int *SAC_MT_last_taskend;
#define SAC_MT_DEFINE_TS_TASKLOCKS()  pthread_mutex_t *SAC_MT_TS_Tasklock;
#define SAC_MT_DEFINE_TASKCOUNT()  volatile int *SAC_MT_Taskcount;



#define SAC_MT_TASKLOCK( sched_id, th)  SAC_MT_HIVE()->SAC_MT_Tasklock[sched_id + SAC_SET_NUM_SCHEDULERS * th]

#define SAC_MT_TASKLOCK_INIT( hive, sched_id, th, num_sched)  hive->SAC_MT_Tasklock[sched_id + num_sched * th]
#define SAC_MT_TASK( sched_id, th)  SAC_MT_HIVE()->SAC_MT_Task[sched_id + SAC_SET_NUM_SCHEDULERS * th]
#define SAC_MT_LAST_TASK( sched_id, th)  SAC_MT_HIVE()->SAC_MT_LAST_Task[sched_id + SAC_SET_NUM_SCHEDULERS * th]
#define SAC_MT_REST_ITERATIONS( sched_id)  SAC_MT_HIVE()->SAC_MT_rest_iterations[sched_id]
#define SAC_MT_ACT_TASKSIZE( sched_id)  SAC_MT_HIVE()->SAC_MT_act_tasksize[sched_id]
#define SAC_MT_LAST_TASKEND( sched_id)  SAC_MT_HIVE()->SAC_MT_last_taskend[sched_id]
#define SAC_MT_TS_TASKLOCK( sched_id)  SAC_MT_HIVE()->SAC_MT_TS_Tasklock[sched_id]
#define SAC_MT_TASKCOUNT( sched_id)  SAC_MT_HIVE()->SAC_MT_Taskcount[sched_id]


#define SAC_MT_ADJUST_SCHEDULER_BOUND( diff, bound, lower, upper, unrolling) {  (diff) = 0;  if (((bound) > (lower)) && ((bound) < (upper))) {  (diff) = ((bound) - (lower)) % (unrolling);   if (diff) {  (diff) = (unrolling) - (diff);   if ((bound) + (diff) >= (upper)) {  (diff) = (upper) - (bound);  (bound) = (upper);  }  else {  (bound) += (diff);  }  }  } }
#define SAC_MT_ADJUST_SCHEDULER__BEGIN( to_NT, dims, dim, lower, upper,  unrolling) {  int diff_start, diff_stop;   SAC_MT_ADJUST_SCHEDULER_BOUND( diff_start,  SAC_WL_MT_SCHEDULE_START( dim),  lower, upper, unrolling)  SAC_MT_ADJUST_SCHEDULER_BOUND( diff_stop,  SAC_WL_MT_SCHEDULE_STOP( dim),  lower, upper, unrolling)   SAC_TR_MT_PRINT( ("Scheduler Adjustment: dim %d: %d -> %d",  dim,  SAC_WL_MT_SCHEDULE_START( dim),  SAC_WL_MT_SCHEDULE_STOP( dim))); 

#define SAC_MT_ADJUST_SCHEDULER__OFFSET( off_NT, to_NT, dim)  SAC_ND_WRITE( off_NT, 0) = SAC_ND_READ( off_NT, 0) +  diff_start * SAC_WL_SHAPE_FACTOR( to_NT, dim);
#define SAC_MT_ADJUST_SCHEDULER__END( to_NT, dims, dim, lower, upper,  unrolling) }
#define SAC_MT_SCHEDULER_Static_BEGIN()
#define SAC_MT_SCHEDULER_Static_END()
#define SAC_MT_SCHEDULER_Block_DIM0( lower, upper, unrolling) {  const int iterations = (upper - lower) / unrolling;  const int iterations_per_thread = (iterations / SAC_MT_LOCAL_THREADS())  * unrolling;  const int iterations_rest = iterations % SAC_MT_LOCAL_THREADS();   if (iterations_rest &&  (SAC_MT_SELF_LOCAL_ID() < (unsigned int) iterations_rest)) {  SAC_WL_MT_SCHEDULE_START(0)  = lower + SAC_MT_SELF_LOCAL_ID() * (iterations_per_thread + unrolling);  SAC_WL_MT_SCHEDULE_STOP(0)  = SAC_WL_MT_SCHEDULE_START(0) + (iterations_per_thread + unrolling);  }  else {  SAC_WL_MT_SCHEDULE_START(0)  = (lower + iterations_rest * unrolling)  + SAC_MT_SELF_LOCAL_ID() * iterations_per_thread;  SAC_WL_MT_SCHEDULE_STOP(0)  = SAC_WL_MT_SCHEDULE_START(0) + iterations_per_thread;  }   SAC_TR_MT_PRINT( ("Scheduler 'Block': dim 0: %d -> %d",  SAC_WL_MT_SCHEDULE_START( 0),  SAC_WL_MT_SCHEDULE_STOP( 0))); }
#define SAC_MT_SCHEDULER_BlockVar_DIM0( lower, upper, unrolling) {  SAC_MT_SCHEDULER_Block_DIM0( lower, upper, unrolling) }

#define SAC_MT_SCHEDULER_TS_Even( sched_id, tasks_on_dim,  lower, upper, unrolling,  num_tasks, taskid, worktodo) {  const int number_of_tasks = num_tasks * SAC_MT_LOCAL_THREADS();  const int iterations = (upper - lower) / unrolling;  const int iterations_per_thread  = (iterations / number_of_tasks) * unrolling;  const int iterations_rest = iterations % number_of_tasks;   SAC_WL_MT_SCHEDULE_START( tasks_on_dim) = 0;  SAC_WL_MT_SCHEDULE_STOP( tasks_on_dim) = 0;   worktodo = (taskid < number_of_tasks);  if (worktodo) {  if (iterations_rest && (taskid < iterations_rest)) {  SAC_WL_MT_SCHEDULE_START( tasks_on_dim)  = lower + (iterations_per_thread + unrolling) * (taskid);  SAC_WL_MT_SCHEDULE_STOP( tasks_on_dim)  = SAC_WL_MT_SCHEDULE_START( tasks_on_dim)  + iterations_per_thread + unrolling;  }  else {  SAC_WL_MT_SCHEDULE_START( tasks_on_dim)  = (lower + iterations_rest * unrolling)  + taskid * iterations_per_thread;  SAC_WL_MT_SCHEDULE_STOP( tasks_on_dim)  = SAC_WL_MT_SCHEDULE_START( tasks_on_dim) + iterations_per_thread;  }  SAC_TR_MT_PRINT( ("'TS_Even': dim %d: %d -> %d, Task: %d",  tasks_on_dim,  SAC_WL_MT_SCHEDULE_START( tasks_on_dim),  SAC_WL_MT_SCHEDULE_STOP( tasks_on_dim), taskid));  } }
#define SAC_MT_SCHEDULER_TS_Factoring_INIT( sched_id, lower, upper) {  SAC_MT_REST_ITERATIONS( sched_id) = (upper - lower);  SAC_MT_LAST_TASKEND( sched_id) = 0;  SAC_MT_TASKCOUNT( sched_id) = 0;  SAC_MT_ACT_TASKSIZE( sched_id)  = ((SAC_MT_REST_ITERATIONS( sched_id)) / (2 * SAC_MT_LOCAL_THREADS())) + 1; }

#define SAC_MT_SCHEDULER_TS_Factoring( sched_id, tasks_on_dim, lower,  upper, unrolling, taskid, worktodo) {  int tasksize;  int restiter;  SAC_WL_MT_SCHEDULE_START( tasks_on_dim) = 0;  SAC_WL_MT_SCHEDULE_STOP( tasks_on_dim) = 0;   SAC_MT_ACQUIRE_LOCK( SAC_MT_TS_TASKLOCK( sched_id));   restiter = SAC_MT_REST_ITERATIONS( sched_id);  worktodo = (restiter > 0);   if (worktodo) {  if (SAC_MT_TASKCOUNT( sched_id) == SAC_MT_LOCAL_THREADS()) {  SAC_MT_ACT_TASKSIZE( sched_id)  = ((restiter) / (2 * SAC_MT_LOCAL_THREADS())) + 1;  SAC_MT_TASKCOUNT( sched_id) = 0;  }  tasksize = SAC_MT_ACT_TASKSIZE( sched_id);  (SAC_MT_TASKCOUNT( sched_id))++;   (SAC_WL_MT_SCHEDULE_START( tasks_on_dim))  = SAC_MT_LAST_TASKEND( sched_id);   if (restiter < tasksize) {  tasksize = restiter;  }  restiter -= tasksize;   SAC_WL_MT_SCHEDULE_STOP( tasks_on_dim)  = SAC_WL_MT_SCHEDULE_START( tasks_on_dim) + tasksize;   SAC_MT_ACT_TASKSIZE( sched_id) = tasksize;  SAC_MT_REST_ITERATIONS( sched_id) = restiter;  SAC_MT_LAST_TASKEND( sched_id) = SAC_WL_MT_SCHEDULE_STOP( tasks_on_dim);   SAC_TR_MT_PRINT( ("'TS_Factoring': dim %d: %d -> %d, Task: %d, Size: %d",  tasks_on_dim,  SAC_WL_MT_SCHEDULE_START( tasks_on_dim),  SAC_WL_MT_SCHEDULE_STOP( tasks_on_dim),  SAC_MT_TASKCOUNT( sched_id) - 1,  SAC_MT_ACT_TASKSIZE( sched_id)));  }  SAC_MT_RELEASE_LOCK( SAC_MT_TS_TASKLOCK( sched_id)); }

#define SAC_MT_SCHEDULER_SET_TASKS( sched_id, max_task) {  int i;   for (i = 0; i <= max_task; i++) {  SAC_MT_TASK( sched_id, i) = 0;  }  SAC_TR_MT_PRINT( ("SAC_MT_TASK set for sched_id %d", sched_id)); }
#define SAC_MT_SCHEDULER_Static_FIRST_TASK( taskid) {  taskid = SAC_MT_SELF_LOCAL_ID(); }
#define SAC_MT_SCHEDULER_Static_NEXT_TASK( taskid) {  taskid += SAC_MT_LOCAL_THREADS(); }
#define SAC_MT_SCHEDULER_Self_FIRST_TASK_STATIC( sched_id, taskid) {  taskid = SAC_MT_SELF_LOCAL_ID();  SAC_TR_MT_PRINT( ("SAC_MT_SCHEDULER_Self_FIRST_TASK_STATIC")); }
#define SAC_MT_SCHEDULER_Self_FIRST_TASK_DYNAMIC( sched_id, taskid) {  SAC_MT_SCHEDULER_Self_NEXT_TASK( sched_id, taskid);  SAC_TR_MT_PRINT( ("SAC_MT_SCHEDULER_Self_FIRST_TASK_DYNAMIC task = %d",  taskid)); }
#define SAC_MT_SCHEDULER_Self_NEXT_TASK( sched_id, taskid) {  SAC_MT_ACQUIRE_LOCK( SAC_MT_TASKLOCK( sched_id, 0));   taskid = SAC_MT_TASK( sched_id, 0);  (SAC_MT_TASK( sched_id, 0))++;   SAC_MT_RELEASE_LOCK( SAC_MT_TASKLOCK( sched_id, 0)); } 
 
#define SAC_MT_SCHEDULER_Affinity_INIT( sched_id, tasks_per_thread) {  int i;  for (i = 0; i < SAC_MT_LOCAL_THREADS(); i++) {  SAC_MT_TASK( sched_id, i) = i * tasks_per_thread;  SAC_MT_LAST_TASK( sched_id, i) = (i + 1) * tasks_per_thread;  } }
#define SAC_MT_SCHEDULER_Affinity_FIRST_TASK( sched_id, tasks_per_thread,  taskid, worktodo) {  SAC_MT_SCHEDULER_Affinity_NEXT_TASK( sched_id, tasks_per_thread,  taskid, worktodo) }
#define SAC_MT_SCHEDULER_Affinity_NEXT_TASK( sched_id, tasks_per_thread,  taskid, worktodo) {  int queueid, maxloadthread, mintask;  worktodo = 0;  taskid = 0;     SAC_MT_ACQUIRE_LOCK( SAC_MT_TASKLOCK( sched_id, SAC_MT_SELF_LOCAL_ID()));   if (SAC_MT_TASK( sched_id, SAC_MT_SELF_LOCAL_ID())  < SAC_MT_LAST_TASK( sched_id, SAC_MT_SELF_LOCAL_ID())) {  taskid = SAC_MT_TASK( sched_id, SAC_MT_SELF_LOCAL_ID());  (SAC_MT_TASK( sched_id, SAC_MT_SELF_LOCAL_ID()))++;  SAC_MT_RELEASE_LOCK( SAC_MT_TASKLOCK( sched_id, SAC_MT_SELF_LOCAL_ID()));  worktodo = 1;  }  else {    SAC_MT_RELEASE_LOCK( SAC_MT_TASKLOCK( sched_id, SAC_MT_SELF_LOCAL_ID()));  maxloadthread = 0;  mintask = SAC_MT_LAST_TASK( sched_id, 0) - SAC_MT_TASK( sched_id, 0);  for (queueid = 1; queueid < SAC_MT_LOCAL_THREADS(); queueid++)  if (SAC_MT_LAST_TASK( sched_id, queueid)  - SAC_MT_TASK( sched_id,queueid) > mintask) {  mintask = SAC_MT_TASK( sched_id, queueid)  - SAC_MT_LAST_TASK( sched_id, queueid);  maxloadthread = queueid;  }     SAC_MT_ACQUIRE_LOCK( SAC_MT_TASKLOCK( sched_id, maxloadthread));  if (SAC_MT_TASK( sched_id, maxloadthread)  < SAC_MT_LAST_TASK( sched_id, maxloadthread)) {  taskid = SAC_MT_LAST_TASK( sched_id, maxloadthread) - 1;  (SAC_MT_LAST_TASK( sched_id, maxloadthread))--;  worktodo = 1;  }  SAC_MT_RELEASE_LOCK( SAC_MT_TASKLOCK( sched_id, maxloadthread));  } }

#endif 
#endif 
#endif 

#ifndef _SAC_BEEHIVE_H_
#define _SAC_BEEHIVE_H_

#if SAC_DO_MULTITHREAD && (SAC_DO_MT_BEEHIVE || SAC_DO_MT_PTHREAD || SAC_DO_MT_LPEL)
struct sac_bee_common_t;
struct sac_hive_common_t;
#define SAC_MT_SPMDFUN_REAL_RETURN()  return (0);
#define SAC_MT_SPMDFUN_REAL_RETTYPE()  unsigned int

struct sac_bee_common_t {

unsigned local_id;

struct sac_hive_common_t *hive;

unsigned b_class;

unsigned thread_id;
};

struct sac_hive_common_t {

unsigned num_bees;

struct sac_bee_common_t **bees;

unsigned queen_class;

void *framedata;

void *retdata;

SAC_MT_DEFINE()
};

#define SAC_MT_SELF_LOCAL_ID() (SAC_MT_self->c.local_id)

#define SAC_MT_SELF_THREAD_ID() (SAC_MT_self->c.thread_id)


#define SAC_MT_LOCAL_THREADS() (current_nr_threads ? current_nr_threads : SAC_MT_self->c.hive->num_bees)

#define SAC_MT_HIVE() (SAC_MT_self->c.hive)
#define SAC_MT_MYTHREAD()  SAC_MT_self
#if 0 

#define SAC_MT_NOT_LOCALLY_PARALLEL() (!SAC_MT_self->c.hive->framedata)
#endif






#if SAC_DO_MT_GLOBAL_FRAME

#define SAC_MT_SPMD_FRAME_BEGIN( )  union SAC_spmd_frame_t {

#define SAC_MT_SPMD_FRAME_END( )  int _dummy;  } SAC_spmd_frame;
#else 

#define SAC_MT_SPMD_FRAME_BEGIN( ) 
#define SAC_MT_SPMD_FRAME_END( ) 
#endif 

#define SAC_MT_SPMD_FRAME_ELEMENT_BEGIN( spmdfun)  struct spmdfun ## _FT {
#if SAC_DO_MT_GLOBAL_FRAME


#define SAC_MT_SPMD_FRAME_ELEMENT_END( spmdfun)  int _dummy;  } spmdfun ## _FV;
#else 


#define SAC_MT_SPMD_FRAME_ELEMENT_END( spmdfun)  int _dummy;  };
#endif 
#define SAC_MT_FRAME_ELEMENT_in__NODESC( name, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype) in_##num;
#define SAC_MT_FRAME_ELEMENT_in__DESC( name, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype) in_##num;  SAC_ND_DESC_TYPE( var_NT) in_##num##_desc; 
#define SAC_MT_FRAME_ELEMENT_inout__NODESC( name, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype)* in_##num;
#define SAC_MT_FRAME_ELEMENT_inout__DESC( name, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype)* in_##num;  SAC_ND_DESC_TYPE( var_NT)* in_##num##_desc; 
#define SAC_MT_FRAME_ELEMENT__NOOP( name, num, basetype, var_NT)



#define SAC_MT_SEND_PARAM_in__NODESC( spmdfun, num, var_NT)  frame->in_##num = SAC_ND_A_FIELD( var_NT);
#define SAC_MT_SEND_PARAM_in__DESC_AKD( spmdfun, num, var_NT)  SAC_ND_RC_TO_NORC( var_NT);  DESC_DIM( SAC_ND_A_DESC( var_NT)) = SAC_ND_A_DIM( var_NT);  frame->in_##num = SAC_ND_A_FIELD( var_NT);  frame->in_##num##_desc = SAC_ND_A_DESC( var_NT);
#define SAC_MT_SEND_PARAM_in__DESC_AUD( spmdfun, num, var_NT)  SAC_ND_RC_TO_NORC( var_NT);  frame->in_##num = SAC_ND_A_FIELD( var_NT);  frame->in_##num##_desc = SAC_ND_A_DESC( var_NT);
#define SAC_MT_SEND_PARAM_inout__NODESC( spmdfun, num, var_NT)  frame->in_##num = & SAC_ND_A_FIELD( var_NT);
#define SAC_MT_SEND_PARAM_inout__DESC_AKD( spmdfun, num, var_NT)  SAC_ND_RC_TO_NORC( var_NT);  DESC_DIM( SAC_ND_A_DESC( var_NT)) = SAC_ND_A_DIM( var_NT);  frame->in_##num = & SAC_ND_A_FIELD( var_NT);  frame->in_##num##_desc = & SAC_ND_A_DESC( var_NT);
#define SAC_MT_SEND_PARAM_inout__DESC_AUD( spmdfun, num, var_NT)  SAC_ND_RC_TO_NORC( var_NT);  frame->in_##num = & SAC_ND_A_FIELD( var_NT);  frame->in_##num##_desc = & SAC_ND_A_DESC( var_NT);
#define SAC_MT_SEND_PARAM__NOOP( spmdfun, num, var_NT)  SAC_NOOP()


#define SAC_MT_SELF_FRAME(spmdfun)  ((struct spmdfun ## _FT *)SAC_MT_self->c.hive->framedata)

#define SAC_MT_RECEIVE_PARAM_in__NODESC( spmdfun, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype) SAC_ND_A_FIELD( var_NT) =  SAC_MT_SELF_FRAME(spmdfun)->in_##num;
#if 0

#define SAC_MT_RECEIVE_PARAM_in__NODESC__FAKERC( spmdfun, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype) SAC_ND_A_FIELD( var_NT) =  SAC_MT_SELF_FRAME(spmdfun)->in_##num;  SAC_ND_DESC_TYPE( var_NT) SAC_ND_A_DESC( var_NT) =  (SAC_ND_DESC_TYPE( var_NT)) alloca(BYTE_SIZE_OF_DESC(0));  DESC_RC( SAC_ND_A_DESC( var_NT)) = 2; 
#endif
#if SAC_HAS_RC_NORC

# define SAC_MT_RECEIVE_PARAM_in__DESC( spmdfun, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype) SAC_ND_A_FIELD( var_NT) = SAC_MT_SELF_FRAME(spmdfun)->in_##num;  SAC_ND_DESC_TYPE( var_NT) SAC_ND_A_DESC( var_NT) = SAC_MT_SELF_FRAME(spmdfun)->in_##num##_desc;
#else

# define SAC_MT_RECEIVE_PARAM_in__DESC( spmdfun, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype) SAC_ND_A_FIELD( var_NT) = SAC_MT_SELF_FRAME(spmdfun)->in_##num;  SAC_ND_DESC_TYPE( var_NT) SAC_ND_A_DESC( var_NT) =  (SAC_ND_DESC_TYPE( var_NT)) alloca(BYTE_SIZE_OF_DESC( DESC_DIM( SAC_MT_SELF_FRAME(spmdfun)->in_##num##_desc)));  memcpy( SAC_ND_A_DESC( var_NT), SAC_MT_SELF_FRAME(spmdfun)->in_##num##_desc,  BYTE_SIZE_OF_DESC( DESC_DIM( SAC_MT_SELF_FRAME(spmdfun)->in_##num##_desc)));
#endif

#define SAC_MT_RECEIVE_PARAM_in__NEWDESC( spmdfun, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype) SAC_ND_A_FIELD( var_NT) = SAC_MT_SELF_FRAME(spmdfun)->in_##num;  SAC_ND_DESC_TYPE( var_NT) SAC_ND_A_DESC( var_NT) =  (SAC_ND_DESC_TYPE( var_NT)) alloca(SIZE_OF_DESC(0) * sizeof(int));  SAC_ND_INIT__RC( var_NT, 2);

#define SAC_MT_RECEIVE_PARAM_inout__NODESC( spmdfun, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype)* SAC_NAMEP(SAC_ND_A_FIELD( var_NT)) =  SAC_MT_SELF_FRAME(spmdfun)->in_##num;
#if SAC_HAS_RC_NORC

# define SAC_MT_RECEIVE_PARAM_inout__DESC( spmdfun, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype)* SAC_NAMEP(SAC_ND_A_FIELD( var_NT)) = SAC_MT_SELF_FRAME(spmdfun)->in_##num;  SAC_ND_DESC_TYPE( var_NT) CAT0(SAC_ND_A_DESC( var_NT), __s) = *SAC_MT_SELF_FRAME(spmdfun)->in_##num##_desc;  SAC_ND_DESC_TYPE( var_NT)* SAC_NAMEP(SAC_ND_A_DESC( var_NT)) = &CAT0(SAC_ND_A_DESC( var_NT), __s);
#else

# define SAC_MT_RECEIVE_PARAM_inout__DESC( spmdfun, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype)* SAC_NAMEP(SAC_ND_A_FIELD( var_NT)) = SAC_MT_SELF_FRAME(spmdfun)->in_##num;  SAC_ND_DESC_TYPE( var_NT) CAT0(SAC_ND_A_DESC( var_NT), __s) =  (SAC_ND_DESC_TYPE( var_NT)) alloca(BYTE_SIZE_OF_DESC( DESC_DIM( *SAC_MT_SELF_FRAME(spmdfun)->in_##num##_desc)));  memcpy( CAT0(SAC_ND_A_DESC( var_NT),__s), *SAC_MT_SELF_FRAME(spmdfun)->in_##num##_desc,  BYTE_SIZE_OF_DESC( DESC_DIM( *SAC_MT_SELF_FRAME(spmdfun)->in_##num##_desc)));  SAC_ND_DESC_TYPE( var_NT)* SAC_NAMEP(SAC_ND_A_DESC( var_NT)) =  &CAT0(SAC_ND_A_DESC( var_NT), __s);
#endif


#define SAC_MT_RECEIVE_PARAM_inout__NODESC__FAKERC( spmdfun, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype)* SAC_NAMEP(SAC_ND_A_FIELD( var_NT)) = SAC_MT_SELF_FRAME(spmdfun)->in_##num;  SAC_ND_DESC_TYPE( var_NT) CAT0(SAC_ND_A_DESC( var_NT), __s) =  (SAC_ND_DESC_TYPE( var_NT)) alloca( FIXED_SIZE_OF_DESC * sizeof(int));  memset( CAT0(SAC_ND_A_DESC( var_NT),__s), '\0', FIXED_SIZE_OF_DESC * sizeof(int));  SAC_ND_DESC_TYPE( var_NT)* SAC_NAMEP(SAC_ND_A_DESC( var_NT)) =  &CAT0(SAC_ND_A_DESC( var_NT), __s);
#define SAC_MT_RECEIVE_PARAM__NOOP( spmdfun, num, basetype, var_NT)  SAC_NOOP()


#define SAC_MT_DECL__MIRROR_PARAM__DESC( var_NT, dim)  SAC_ND_DESC_TYPE( var_NT) SAC_ND_A_DESC( var_NT) = alloca( BYTE_SIZE_OF_DESC( dim));  SAC_ND_INIT__RC( var_NT, 2);  DESC_DIM( SAC_ND_A_DESC( var_NT)) = 2;
#define SAC_MT_DECL__MIRROR_PARAM__NODESC( var_NT, dim)  SAC_NOOP()


#if SAC_DO_MT_GLOBAL_FRAME
#define SAC_MT_SPMD_BARRIER_BEGIN( )  union SAC_spmd_barrier_t {
#else 
#define SAC_MT_SPMD_BARRIER_BEGIN( ) 
#endif 
#define SAC_MT_SPMD_BARRIER_ELEMENT_BEGIN( spmdfun)  struct spmdfun ## _RT {
#define SAC_MT_BARRIER_ELEMENT__NOOP( name, num, basetype, var_NT)
#define SAC_MT_BARRIER_ELEMENT_out__NODESC( name, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype) in_##num;
#define SAC_MT_BARRIER_ELEMENT_out__DESC( name, num, basetype, var_NT)  SAC_ND_TYPE( var_NT, basetype) in_##num;  SAC_ND_DESC_TYPE( var_NT) in_##num##_desc;
#if SAC_DO_MT_GLOBAL_FRAME

#define SAC_MT_SPMD_BARRIER_ELEMENT_END( spmdfun)  int _dummy;   } spmdfun ## _BV;
#define SAC_MT_SPMD_BARRIER_END( )  int _dummy;  } SAC_spmd_barrier[SAC_SET_THREADS_MAX+1];
#else 

#define SAC_MT_SPMD_BARRIER_ELEMENT_END( spmdfun)  int _dummy;   };
#define SAC_MT_SPMD_BARRIER_END( ) 
#endif 


#define SAC_MT_SEND_RESULT__NOOP( spmdfun, local_id, num, var_NT)  SAC_NOOP()
#define SAC_MT_SEND_RESULT_out__NODESC( spmdfun, local_id, num, var_NT)  rdata[local_id].in_##num = SAC_ND_A_FIELD( var_NT);
#define SAC_MT_SEND_RESULT_out__DESC( spmdfun, local_id, num, var_NT)  rdata[local_id].in_##num = SAC_ND_A_FIELD( var_NT);  rdata[local_id].in_##num##_desc = SAC_ND_A_DESC( var_NT);


#define SAC_MT_RECEIVE_RESULT__NOOP( spmdfun, local_id, num, var_NT)  SAC_NOOP()
#define SAC_MT_RECEIVE_RESULT_in__DESC( spmdfun, local_id, num, var_NT)  SAC_ND_RC_FROM_NORC( var_NT);
#define SAC_MT_RECEIVE_RESULT_inout__DESC( spmdfun, local_id, num, var_NT)  SAC_ND_RC_FROM_NORC( var_NT);
#define SAC_MT_RECEIVE_RESULT_out__NODESC( spmdfun, local_id, num, var_NT)  SAC_ND_A_FIELD( var_NT) = rdata[local_id].in_##num;
#define SAC_MT_RECEIVE_RESULT_out__DESC( spmdfun, local_id, num, var_NT)  SAC_ND_A_FIELD( var_NT) = rdata[local_id].in_##num;  SAC_ND_A_DESC( var_NT) = rdata[local_id].in_##num##_desc;


#define SAC_MT_SYNC_BEGIN( spmdfun) {  unsigned int SAC_MT_ready_count = SAC_MT_MYWORKERCLASS();  unsigned int SAC_MT_son_id;  unsigned int SAC_MT_i;  struct spmdfun##_RT *rdata;  rdata = (struct spmdfun##_RT *)SAC_MT_self->c.hive->retdata;   while (SAC_MT_ready_count > 0) {  SAC_MT_i = SAC_MT_MYWORKERCLASS();   do {  SAC_MT_son_id = SAC_MT_SELF_LOCAL_ID() + SAC_MT_i;   if (SAC_MT_CHECK_BARRIER( spmdfun, SAC_MT_son_id)) { 
#define SAC_MT_SYNC_CONT( spmdfun)  SAC_MT_CLEAR_BARRIER( spmdfun, SAC_MT_son_id)  SAC_MT_ready_count >>= 1;  if (SAC_MT_ready_count == 0) {  break;  }  }  } while (SAC_MT_i >>= 1);  SAC_MT_SYNC_RELAX();  }
#define SAC_MT_SYNC_END( spmdfun)  SAC_MT_SET_BARRIER( spmdfun, SAC_MT_SELF_LOCAL_ID()) }
#define SAC_MT_SYNC_FOLD__NOOP( spmdfun, num, accu_NT, val_NT, basetype, tag, foldfun)  SAC_NOOP()
#define SAC_MT_SYNC_FOLD_out__NODESC( spmdfun, num, accu_NT, val_NT, basetype, tag, foldfun)  SAC_MT_RECEIVE_RESULT_out__NODESC( spmdfun, SAC_MT_son_id, num, val_NT);  SAC_##tag##_FUNAP2( foldfun, SAC_ND_ARG_out( accu_NT, basetype),  SAC_ND_ARG_in( accu_NT, basetype), SAC_ND_ARG_in( val_NT, basetype));

#define SAC_MT_SYNC_FOLD_out__DESC( spmdfun, num, accu_NT, val_NT, basetype, tag, foldfun)  SAC_MT_RECEIVE_RESULT_out__DESC( spmdfun, SAC_MT_son_id, num, val_NT);  SAC_##tag##_FUNAP2( foldfun, SAC_ND_ARG_out( accu_NT, basetype),  SAC_ND_ARG_in( accu_NT, basetype), SAC_ND_ARG_in( val_NT, basetype)); 

#define SAC_MT_FUNAP2( name, ...) name( SAC_MT_self, __VA_ARGS__);



#if SAC_DO_MT_GLOBAL_FRAME

#define SAC_MT_BEGIN_SPMD_INVOCATION( name)  {  SAC_MT_BEGIN_SPMD_INVOCATION_PROLOG( name)  struct name##_FT *const frame = & SAC_spmd_frame. name ##_FV;  memset(frame, 0, sizeof(struct name##_FT));  struct name##_RT *rdata = (void*)SAC_spmd_barrier;  memset(rdata, 0, sizeof(struct name##_RT) * SAC_MT_self->c.hive->num_bees);
#else 

#define SAC_MT_BEGIN_SPMD_INVOCATION( name)  {  SAC_MT_BEGIN_SPMD_INVOCATION_PROLOG( name)  struct name##_FT _frame_st;  struct name##_FT *const frame = &_frame_st;  memset(frame, 0, sizeof(struct name##_FT));  struct name##_RT rdata[SAC_MT_self->c.hive->num_bees];  memset(rdata, 0, sizeof(struct name##_RT) * SAC_MT_self->c.hive->num_bees);
#endif 

#define SAC_MT_END_SPMD_INVOCATION( name)  SAC_MT_END_SPMD_INVOCATION_EPILOG( name)  }
#define SAC_MT_MYWORKERCLASS()  SAC_MT_self->c.b_class

#define SAC_MT_DECL_MYTHREAD()
#if SAC_DO_MT_CREATE_JOIN

#define SAC_MT_BEGIN_SPMD_INVOCATION_PROLOG( name)  SAC_MT_AttachHive( SAC_MT_AllocHive( SAC_MT_GLOBAL_THREADS(), SAC_SET_NUM_SCHEDULERS,  NULL, NULL));
#define SAC_MT_END_SPMD_INVOCATION_EPILOG( name)  SAC_MT_ReleaseHive( SAC_MT_DetachHive());
#else

#define SAC_MT_BEGIN_SPMD_INVOCATION_PROLOG( name)
#define SAC_MT_END_SPMD_INVOCATION_EPILOG( name)
#endif


#define SAC_ND_PRF_RUNMT_GENARRAY__DATA( var_NT, mem_NT, min_parallel_size)  SAC_ND_WRITE( var_NT, 0) = (SAC_ND_A_DESC_SIZE(mem_NT) >= (min_parallel_size));
#define SAC_ND_PRF_RUNMT_MODARRAY__DATA( var_NT, mem_NT, min_parallel_size)  SAC_ND_WRITE( var_NT, 0) = (SAC_ND_A_DESC_SIZE(mem_NT) >= (min_parallel_size));
#define SAC_ND_PRF_RUNMT_FOLD__DATA( var_NT, args)  SAC_ND_WRITE( var_NT, 0) = 0;


#define SAC_ND_PROP_OBJ_IN( )  SAC_MT_ACQUIRE_LOCK( SAC_MT_propagate_lock);
#define SAC_ND_PROP_OBJ_OUT( )  SAC_MT_RELEASE_LOCK( SAC_MT_propagate_lock);
#define SAC_ND_PROP_OBJ_UNBOX( unboxed, boxed)  SAC_ND_A_FIELD( unboxed) = *SAC_NAMEP( SAC_ND_A_FIELD( boxed));
#define SAC_ND_PROP_OBJ_BOX( boxed, unboxed)  *SAC_NAMEP( SAC_ND_A_FIELD( boxed)) = SAC_ND_A_FIELD( unboxed);



SAC_C_EXTERN volatile unsigned int SAC_MT_cnt_hives;
SAC_C_EXTERN volatile unsigned int SAC_MT_cnt_worker_bees;
SAC_C_EXTERN volatile unsigned int SAC_MT_cnt_queen_bees;

SAC_C_EXTERN void *SAC_MT_singleton_queen;

SAC_MT_DECLARE_LOCK( SAC_MT_propagate_lock)

SAC_MT_DECLARE_LOCK( SAC_MT_output_lock)


SAC_C_EXTERN void SAC_MT_SetupInitial( int argc, char *argv[],
unsigned int num_threads,
unsigned int max_threads);
SAC_C_EXTERN void SAC_MT_SetupAsLibraryInitial(void);
SAC_C_EXTERN struct sac_hive_common_t* SAC_MT_AllocHive( unsigned int num_bees, 
int num_schedulers, const int *places,
void *thdata);
SAC_C_EXTERN void SAC_MT_ReleaseHive(struct sac_hive_common_t* h);
SAC_C_EXTERN void SAC_MT_AttachHive(struct sac_hive_common_t* h);
SAC_C_EXTERN struct sac_hive_common_t* SAC_MT_DetachHive(void);
SAC_C_EXTERN void SAC_MT_ReleaseQueen(void);

SAC_C_EXTERN void SAC_MT_BEEHIVE_SetupInitial( int argc, char *argv[],
unsigned int num_threads,
unsigned int max_threads);
SAC_C_EXTERN struct sac_hive_common_t *SAC_MT_Helper_AllocHiveCommons(
unsigned num_bees, unsigned num_schedulers, unsigned sizeof_hive, unsigned sizeof_bee);
SAC_C_EXTERN void SAC_MT_Helper_FreeHiveCommons(struct sac_hive_common_t *hive);
SAC_C_EXTERN void SAC_MT_Generic_AttachHive(struct sac_hive_common_t* hive, struct sac_bee_common_t *queen);
SAC_C_EXTERN struct sac_hive_common_t* SAC_MT_Generic_DetachHive(struct sac_bee_common_t *queen);
SAC_C_EXTERN struct sac_bee_common_t* SAC_MT_CurrentBee(void);


#else 
#define SAC_MT_SELF_THREAD_ID() 0

#define SAC_MT_DEFINE_ST_SELF() 
#endif 
#endif 


#ifndef DEF_FILE_mt_gen
#define DEF_FILE_mt_gen
#ifndef _SAC_MT_GEN_H_
#define _SAC_MT_GEN_H_
#if SAC_DO_MULTITHREAD

#define SAC_MT_FRAME_ELEMENT_inout( arg1, arg2, arg3, nt ) CAT_M4_mt_gen_1(SAC_MT_FRAME_ELEMENT_inout_, NT_SHP(nt))( arg1, arg2, arg3, nt )
#define SAC_MT_FRAME_ELEMENT_inout_SCL(...) SAC_MT_FRAME_ELEMENT_inout__NODESC(__VA_ARGS__)
#define SAC_MT_FRAME_ELEMENT_inout_AKS(...) SAC_MT_FRAME_ELEMENT_inout__DESC(__VA_ARGS__)
#define SAC_MT_FRAME_ELEMENT_inout_AKD(...) SAC_MT_FRAME_ELEMENT_inout__DESC(__VA_ARGS__)
#define SAC_MT_FRAME_ELEMENT_inout_AUD(...) SAC_MT_FRAME_ELEMENT_inout__DESC(__VA_ARGS__)
#define SAC_MT_FRAME_ELEMENT_in( arg1, arg2, arg3, nt ) CAT_M4_mt_gen_2(SAC_MT_FRAME_ELEMENT_in_, NT_SHP(nt))( arg1, arg2, arg3, nt )
#define SAC_MT_FRAME_ELEMENT_in_SCL(...) SAC_MT_FRAME_ELEMENT_in__NODESC(__VA_ARGS__)
#define SAC_MT_FRAME_ELEMENT_in_AKS(...) SAC_MT_FRAME_ELEMENT_in__DESC(__VA_ARGS__)
#define SAC_MT_FRAME_ELEMENT_in_AKD(...) SAC_MT_FRAME_ELEMENT_in__DESC(__VA_ARGS__)
#define SAC_MT_FRAME_ELEMENT_in_AUD(...) SAC_MT_FRAME_ELEMENT_in__DESC(__VA_ARGS__)
#define SAC_MT_FRAME_ELEMENT_out(...) SAC_MT_FRAME_ELEMENT_out_(__VA_ARGS__)
#define SAC_MT_FRAME_ELEMENT_out_(...) SAC_MT_FRAME_ELEMENT__NOOP(__VA_ARGS__)

#define SAC_MT_SEND_PARAM_in( arg1, arg2, nt ) CAT_M4_mt_gen_3(SAC_MT_SEND_PARAM_in_, NT_SHP(nt))( arg1, arg2, nt )
#define SAC_MT_SEND_PARAM_in_SCL(...) SAC_MT_SEND_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_MT_SEND_PARAM_in_AKS(...) SAC_MT_SEND_PARAM_in__DESC_AKD(__VA_ARGS__)
#define SAC_MT_SEND_PARAM_in_AKD(...) SAC_MT_SEND_PARAM_in__DESC_AKD(__VA_ARGS__)
#define SAC_MT_SEND_PARAM_in_AUD(...) SAC_MT_SEND_PARAM_in__DESC_AUD(__VA_ARGS__)
#define SAC_MT_SEND_PARAM_inout( arg1, arg2, nt ) CAT_M4_mt_gen_4(SAC_MT_SEND_PARAM_inout_, NT_SHP(nt))( arg1, arg2, nt )
#define SAC_MT_SEND_PARAM_inout_SCL(...) SAC_MT_SEND_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_MT_SEND_PARAM_inout_AKS(...) SAC_MT_SEND_PARAM_inout__DESC_AKD(__VA_ARGS__)
#define SAC_MT_SEND_PARAM_inout_AKD(...) SAC_MT_SEND_PARAM_inout__DESC_AKD(__VA_ARGS__)
#define SAC_MT_SEND_PARAM_inout_AUD(...) SAC_MT_SEND_PARAM_inout__DESC_AUD(__VA_ARGS__)
#define SAC_MT_SEND_PARAM_out(...) SAC_MT_SEND_PARAM_out_(__VA_ARGS__)
#define SAC_MT_SEND_PARAM_out_(...) SAC_MT_SEND_PARAM__NOOP(__VA_ARGS__)

#define SAC_MT_RECEIVE_PARAM_in( arg1, arg2, arg3, nt ) CAT_M4_mt_gen_5(SAC_MT_RECEIVE_PARAM_in_, CAT_M4_mt_gen_6(NT_SHP(nt), NT_HID(nt)))( arg1, arg2, arg3, nt )
#define SAC_MT_RECEIVE_PARAM_in_SCLNHD(...) SAC_MT_RECEIVE_PARAM_in__NODESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_SCLHID(...) SAC_MT_RECEIVE_PARAM_in__NEWDESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AKSNHD(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AKSHID(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AKSHNS(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AKS___(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AKDNHD(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AKDHID(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AKDHNS(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AKD___(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AUDNHD(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AUDHID(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AUDHNS(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_in_AUD___(...) SAC_MT_RECEIVE_PARAM_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout( arg1, arg2, arg3, nt ) CAT_M4_mt_gen_7(SAC_MT_RECEIVE_PARAM_inout_, CAT_M4_mt_gen_8(NT_SHP(nt), NT_HID(nt)))( arg1, arg2, arg3, nt )
#define SAC_MT_RECEIVE_PARAM_inout_SCLNHD(...) SAC_MT_RECEIVE_PARAM_inout__NODESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_SCLHID(...) SAC_MT_RECEIVE_PARAM_inout__NODESC__FAKERC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AKSNHD(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AKSHID(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AKSHNS(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AKS___(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AKDNHD(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AKDHID(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AKDHNS(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AKD___(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AUDNHD(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AUDHID(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AUDHNS(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_inout_AUD___(...) SAC_MT_RECEIVE_PARAM_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_out(...) SAC_MT_RECEIVE_PARAM_out_(__VA_ARGS__)
#define SAC_MT_RECEIVE_PARAM_out_(...) SAC_MT_RECEIVE_PARAM__NOOP(__VA_ARGS__)

#define SAC_MT_DECL__MIRROR_PARAM( nt , gra1) CAT_M4_mt_gen_9(SAC_MT_DECL__MIRROR_PARAM_, CAT_M4_mt_gen_10(NT_SHP(nt), NT_HID(nt)))( nt , gra1)
#define SAC_MT_DECL__MIRROR_PARAM_SCLNHD(...) SAC_MT_DECL__MIRROR_PARAM__NODESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_SCLHID(...) SAC_MT_DECL__MIRROR_PARAM__DESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AKSNHD(...) SAC_MT_DECL__MIRROR_PARAM__DESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AKSHID(...) SAC_MT_DECL__MIRROR_PARAM__DESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AKSHNS(...) SAC_MT_DECL__MIRROR_PARAM__DESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AKS___(...) SAC_MT_DECL__MIRROR_PARAM__DESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AKDNHD(...) SAC_MT_DECL__MIRROR_PARAM__NODESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AKDHID(...) SAC_MT_DECL__MIRROR_PARAM__NODESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AKDHNS(...) SAC_MT_DECL__MIRROR_PARAM__NODESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AKD___(...) SAC_MT_DECL__MIRROR_PARAM__NODESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AUDNHD(...) SAC_MT_DECL__MIRROR_PARAM__NODESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AUDHID(...) SAC_MT_DECL__MIRROR_PARAM__NODESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AUDHNS(...) SAC_MT_DECL__MIRROR_PARAM__NODESC(__VA_ARGS__)
#define SAC_MT_DECL__MIRROR_PARAM_AUD___(...) SAC_MT_DECL__MIRROR_PARAM__NODESC(__VA_ARGS__)

#define SAC_MT_BARRIER_ELEMENT_in(...) SAC_MT_BARRIER_ELEMENT_in_(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_in_(...) SAC_MT_BARRIER_ELEMENT__NOOP(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_inout(...) SAC_MT_BARRIER_ELEMENT_inout_(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_inout_(...) SAC_MT_BARRIER_ELEMENT__NOOP(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out( arg1, arg2, arg3, nt ) CAT_M4_mt_gen_11(SAC_MT_BARRIER_ELEMENT_out_, CAT_M4_mt_gen_12(NT_SHP(nt), NT_HID(nt)))( arg1, arg2, arg3, nt )
#define SAC_MT_BARRIER_ELEMENT_out_SCLNHD(...) SAC_MT_BARRIER_ELEMENT_out__NODESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_SCLHID(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AKSNHD(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AKSHID(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AKSHNS(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AKS___(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AKDNHD(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AKDHID(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AKDHNS(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AKD___(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AUDNHD(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AUDHID(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AUDHNS(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)
#define SAC_MT_BARRIER_ELEMENT_out_AUD___(...) SAC_MT_BARRIER_ELEMENT_out__DESC(__VA_ARGS__)

#define SAC_MT_SEND_RESULT_in(...) SAC_MT_SEND_RESULT_in_(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_in_(...) SAC_MT_SEND_RESULT__NOOP(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_inout(...) SAC_MT_SEND_RESULT_inout_(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_inout_(...) SAC_MT_SEND_RESULT__NOOP(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out( arg1, arg2, arg3, nt ) CAT_M4_mt_gen_13(SAC_MT_SEND_RESULT_out_, CAT_M4_mt_gen_14(NT_SHP(nt), NT_HID(nt)))( arg1, arg2, arg3, nt )
#define SAC_MT_SEND_RESULT_out_SCLNHD(...) SAC_MT_SEND_RESULT_out__NODESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_SCLHID(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AKSNHD(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AKSHID(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AKSHNS(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AKS___(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AKDNHD(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AKDHID(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AKDHNS(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AKD___(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AUDNHD(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AUDHID(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AUDHNS(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_SEND_RESULT_out_AUD___(...) SAC_MT_SEND_RESULT_out__DESC(__VA_ARGS__)

#define SAC_MT_RECEIVE_RESULT_in( arg1, arg2, arg3, nt ) CAT_M4_mt_gen_15(SAC_MT_RECEIVE_RESULT_in_, NT_SHP(nt))( arg1, arg2, arg3, nt )
#define SAC_MT_RECEIVE_RESULT_in_SCL(...) SAC_MT_RECEIVE_RESULT__NOOP(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_in_AKS(...) SAC_MT_RECEIVE_RESULT_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_in_AKD(...) SAC_MT_RECEIVE_RESULT_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_in_AUD(...) SAC_MT_RECEIVE_RESULT_in__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_inout( arg1, arg2, arg3, nt ) CAT_M4_mt_gen_16(SAC_MT_RECEIVE_RESULT_inout_, NT_SHP(nt))( arg1, arg2, arg3, nt )
#define SAC_MT_RECEIVE_RESULT_inout_SCL(...) SAC_MT_RECEIVE_RESULT__NOOP(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_inout_AKS(...) SAC_MT_RECEIVE_RESULT_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_inout_AKD(...) SAC_MT_RECEIVE_RESULT_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_inout_AUD(...) SAC_MT_RECEIVE_RESULT_inout__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out( arg1, arg2, arg3, nt ) CAT_M4_mt_gen_17(SAC_MT_RECEIVE_RESULT_out_, CAT_M4_mt_gen_18(NT_SHP(nt), NT_HID(nt)))( arg1, arg2, arg3, nt )
#define SAC_MT_RECEIVE_RESULT_out_SCLNHD(...) SAC_MT_RECEIVE_RESULT_out__NODESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_SCLHID(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AKSNHD(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AKSHID(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AKSHNS(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AKS___(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AKDNHD(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AKDHID(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AKDHNS(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AKD___(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AUDNHD(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AUDHID(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AUDHNS(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)
#define SAC_MT_RECEIVE_RESULT_out_AUD___(...) SAC_MT_RECEIVE_RESULT_out__DESC(__VA_ARGS__)

#define SAC_MT_SYNC_FOLD_in(...) SAC_MT_SYNC_FOLD_in_(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_in_(...) SAC_MT_SYNC_FOLD__NOOP(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_inout(...) SAC_MT_SYNC_FOLD_inout_(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_inout_(...) SAC_MT_SYNC_FOLD__NOOP(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out( arg1, arg2, nt , gra1, gra2, gra3, gra4) CAT_M4_mt_gen_19(SAC_MT_SYNC_FOLD_out_, CAT_M4_mt_gen_20(NT_SHP(nt), NT_HID(nt)))( arg1, arg2, nt , gra1, gra2, gra3, gra4)
#define SAC_MT_SYNC_FOLD_out_SCLNHD(...) SAC_MT_SYNC_FOLD_out__NODESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_SCLHID(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AKSNHD(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AKSHID(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AKSHNS(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AKS___(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AKDNHD(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AKDHID(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AKDHNS(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AKD___(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AUDNHD(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AUDHID(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AUDHNS(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#define SAC_MT_SYNC_FOLD_out_AUD___(...) SAC_MT_SYNC_FOLD_out__DESC(__VA_ARGS__)
#endif 
#endif 
#define CAT_M4_mt_gen_20(x, y) xCAT_M4_mt_gen_20(x, y)
#define xCAT_M4_mt_gen_20(x, y) x##y
#define CAT_M4_mt_gen_19(x, y) xCAT_M4_mt_gen_19(x, y)
#define xCAT_M4_mt_gen_19(x, y) x##y
#define CAT_M4_mt_gen_18(x, y) xCAT_M4_mt_gen_18(x, y)
#define xCAT_M4_mt_gen_18(x, y) x##y
#define CAT_M4_mt_gen_17(x, y) xCAT_M4_mt_gen_17(x, y)
#define xCAT_M4_mt_gen_17(x, y) x##y
#define CAT_M4_mt_gen_16(x, y) xCAT_M4_mt_gen_16(x, y)
#define xCAT_M4_mt_gen_16(x, y) x##y
#define CAT_M4_mt_gen_15(x, y) xCAT_M4_mt_gen_15(x, y)
#define xCAT_M4_mt_gen_15(x, y) x##y
#define CAT_M4_mt_gen_14(x, y) xCAT_M4_mt_gen_14(x, y)
#define xCAT_M4_mt_gen_14(x, y) x##y
#define CAT_M4_mt_gen_13(x, y) xCAT_M4_mt_gen_13(x, y)
#define xCAT_M4_mt_gen_13(x, y) x##y
#define CAT_M4_mt_gen_12(x, y) xCAT_M4_mt_gen_12(x, y)
#define xCAT_M4_mt_gen_12(x, y) x##y
#define CAT_M4_mt_gen_11(x, y) xCAT_M4_mt_gen_11(x, y)
#define xCAT_M4_mt_gen_11(x, y) x##y
#define CAT_M4_mt_gen_10(x, y) xCAT_M4_mt_gen_10(x, y)
#define xCAT_M4_mt_gen_10(x, y) x##y
#define CAT_M4_mt_gen_9(x, y) xCAT_M4_mt_gen_9(x, y)
#define xCAT_M4_mt_gen_9(x, y) x##y
#define CAT_M4_mt_gen_8(x, y) xCAT_M4_mt_gen_8(x, y)
#define xCAT_M4_mt_gen_8(x, y) x##y
#define CAT_M4_mt_gen_7(x, y) xCAT_M4_mt_gen_7(x, y)
#define xCAT_M4_mt_gen_7(x, y) x##y
#define CAT_M4_mt_gen_6(x, y) xCAT_M4_mt_gen_6(x, y)
#define xCAT_M4_mt_gen_6(x, y) x##y
#define CAT_M4_mt_gen_5(x, y) xCAT_M4_mt_gen_5(x, y)
#define xCAT_M4_mt_gen_5(x, y) x##y
#define CAT_M4_mt_gen_4(x, y) xCAT_M4_mt_gen_4(x, y)
#define xCAT_M4_mt_gen_4(x, y) x##y
#define CAT_M4_mt_gen_3(x, y) xCAT_M4_mt_gen_3(x, y)
#define xCAT_M4_mt_gen_3(x, y) x##y
#define CAT_M4_mt_gen_2(x, y) xCAT_M4_mt_gen_2(x, y)
#define xCAT_M4_mt_gen_2(x, y) x##y
#define CAT_M4_mt_gen_1(x, y) xCAT_M4_mt_gen_1(x, y)
#define xCAT_M4_mt_gen_1(x, y) x##y
#endif

#ifndef _MT_BARRIERS
#define _MT_BARRIERS
#include <pthread.h>



#ifdef __linux__
#include <limits.h>
#include <sys/syscall.h>
#include <linux/futex.h>
long syscall(long number, ...);
#endif

#define SAC_MT_PTH_INIT_BARRIER(nrthreads)
#define SAC_MT_PTH_SIGNAL_BARRIER(glflag) SAC_MT_PTH_signal_barrier(NULL, glflag)
#define SAC_MT_PTH_DESTROY_BARRIER()


#ifdef SAC_SET_BARRIER_TYPE
#ifndef __APPLE__
#define ACCEPT_PTHREAD 1
#else
#define ACCEPT_PTHREAD 0
#endif

#ifdef __linux__
#define ACCEPT_FUTEX 1
#else
#define ACCEPT_FUTEX 0
#endif

#undef SAC_MT_PTH_INIT_BARRIER
#undef SAC_MT_PTH_SIGNAL_BARRIER
#undef SAC_MT_PTH_DESTROY_BARRIER

#if SAC_SET_BARRIER_TYPE == 1
#define SAC_MT_PTH_INIT_BARRIER(nrthreads) init_mutex_barrier(nrthreads)
#define SAC_MT_PTH_SIGNAL_BARRIER(glflag) take_mutex_barrier()
#define SAC_MT_PTH_DESTROY_BARRIER() destroy_mutex_barrier()
#elif SAC_SET_BARRIER_TYPE == 2
#define SAC_MT_PTH_INIT_BARRIER(nrthreads) init_cond_barrier()
#define SAC_MT_PTH_SIGNAL_BARRIER(glflag) lift_cond_barrier(glflag)
#define SAC_MT_PTH_DESTROY_BARRIER() destroy_cond_barrier()
#elif SAC_SET_BARRIER_TYPE == 3 && ACCEPT_PTHREAD == 1
#define SAC_MT_PTH_INIT_BARRIER(nrthreads) init_pthread_barrier(nrthreads)
#define SAC_MT_PTH_SIGNAL_BARRIER(glflag) take_pthread_barrier()
#define SAC_MT_PTH_DESTROY_BARRIER() destroy_pthread_barrier()
#elif SAC_SET_BARRIER_TYPE == 4 && ACCEPT_FUTEX == 1
#define SAC_MT_PTH_INIT_BARRIER(nrthreads)
#define SAC_MT_PTH_SIGNAL_BARRIER(glflag) lift_futex_barrier(glflag)
#define SAC_MT_PTH_DESTROY_BARRIER()
#else
#define SAC_MT_PTH_INIT_BARRIER(nrthreads)
#define SAC_MT_PTH_SIGNAL_BARRIER(glflag) SAC_MT_PTH_signal_barrier(NULL, glflag)
#define SAC_MT_PTH_DESTROY_BARRIER()
#endif
#undef ACCEPT_FUTEX
#undef ACCEPT_PTHREAD
#endif




#ifdef SAC_SET_BARRIER_TYPE
#define SAC_MT_PTH_EXTERN
#else
#define SAC_MT_PTH_EXTERN SAC_C_EXTERN
#endif
SAC_MT_PTH_EXTERN int mutex_nr_threads;
SAC_MT_PTH_EXTERN int mutex_thread_count;
SAC_MT_PTH_EXTERN pthread_mutex_t mutex_sacred;
SAC_MT_PTH_EXTERN pthread_mutex_t mutex_lock_sacred;
SAC_MT_PTH_EXTERN pthread_mutex_t mutex_barrier;
SAC_MT_PTH_EXTERN pthread_cond_t cond_barrier;
SAC_MT_PTH_EXTERN pthread_mutex_t cond_mutex;
#ifndef __APPLE__
SAC_MT_PTH_EXTERN pthread_barrier_t pthread_barrier;
#endif
#undef SAC_MT_PTH_EXTERN

static inline void init_mutex_barrier(int nr_threads) {
mutex_nr_threads = nr_threads;
pthread_mutex_init(&mutex_sacred, NULL);
pthread_mutex_init(&mutex_lock_sacred, NULL);
pthread_mutex_init(&mutex_barrier, NULL);
}

static inline void take_mutex_barrier(void) {
int lock = 0;
pthread_mutex_lock(&mutex_lock_sacred);
pthread_mutex_unlock(&mutex_lock_sacred);
pthread_mutex_lock(&mutex_sacred);
 mutex_thread_count++;
 if (mutex_thread_count == mutex_nr_threads) {
 pthread_mutex_lock(&mutex_lock_sacred);
 pthread_mutex_unlock(&mutex_barrier);
 }
 else {
 lock = 1;
 }
 if (mutex_thread_count == 1) {
 pthread_mutex_trylock(&mutex_barrier);
 }
pthread_mutex_unlock(&mutex_sacred);
if (lock) {
 pthread_mutex_lock(&mutex_barrier);
 mutex_thread_count--;
 if (mutex_thread_count == 1) {
 mutex_thread_count = 0;
 pthread_mutex_unlock(&mutex_lock_sacred);
 }
 else {
 pthread_mutex_unlock(&mutex_barrier);
 }
}
}

static inline void destroy_mutex_barrier(void) {
pthread_mutex_destroy(&mutex_sacred);
pthread_mutex_destroy(&mutex_lock_sacred);
pthread_mutex_destroy(&mutex_barrier);
}

static inline void init_cond_barrier(void) {
pthread_cond_init(&cond_barrier, NULL);
pthread_mutex_init(&cond_mutex, NULL);
}

static inline void wait_on_cond_barrier(volatile unsigned int *glflag, unsigned int *lcflag) {
pthread_mutex_lock(&cond_mutex);
if (*glflag == *lcflag) {
 pthread_cond_wait(&cond_barrier, &cond_mutex);
}
pthread_mutex_unlock(&cond_mutex);
(*lcflag)++;
}

static inline void lift_cond_barrier(volatile unsigned int *glflag) {
pthread_mutex_lock(&cond_mutex);
(*glflag)++;
pthread_cond_broadcast(&cond_barrier);
pthread_mutex_unlock(&cond_mutex);
}

static inline void destroy_cond_barrier(void) {
pthread_cond_destroy(&cond_barrier);
pthread_mutex_destroy(&cond_mutex);
}
#ifndef __APPLE__

static inline void init_pthread_barrier(int nr_threads) {
pthread_barrier_init(&pthread_barrier, NULL, nr_threads);
}

static inline void take_pthread_barrier(void) {
pthread_barrier_wait(&pthread_barrier);
}

static inline void destroy_pthread_barrier(void) {
pthread_barrier_destroy(&pthread_barrier);
}
#endif
#ifdef __linux__

static inline void wait_on_futex_barrier(volatile unsigned int *glflag, unsigned int *lcflag) {
syscall(SYS_futex, glflag, FUTEX_WAIT, *lcflag, NULL, NULL, 0);
(*lcflag)++;
}

static inline void lift_futex_barrier(volatile unsigned int *glflag) {
(*glflag)++;
syscall(SYS_futex, glflag, FUTEX_WAKE, INT_MAX, NULL, NULL, 0);
}
#endif
#endif
#ifndef _SAC_MT_PTH_H_
#define _SAC_MT_PTH_H_
#if SAC_DO_MULTITHREAD && SAC_DO_MT_PTHREAD


SAC_C_EXTERN pthread_key_t SAC_MT_self_bee_key;

struct sac_bee_pth_t;
struct sac_hive_pth_t;
SAC_C_EXTERN int barrier_type;

struct sac_pth_llmutex_t {

volatile unsigned flag;
};

static inline
void SAC_MT_PTH_release_lck(struct sac_pth_llmutex_t * const lck)
{
lck->flag = 0;
}

static inline
void SAC_MT_PTH_acquire_lck(struct sac_pth_llmutex_t * const lck)
{

while (lck->flag != 0)
;
lck->flag = 1;
}

static inline
int SAC_MT_PTH_may_acquire_lck(struct sac_pth_llmutex_t * const lck)
{
return (lck->flag == 0);
}

static inline
void SAC_MT_PTH_init_lck(struct sac_pth_llmutex_t * const lck, int locked)
{
lck->flag = locked;
}

static inline
void SAC_MT_PTH_destroy_lck(struct sac_pth_llmutex_t * const lck)
{

}

static inline
void SAC_MT_PTH_wait_on_barrier(unsigned *locfl, volatile unsigned *sharedfl)
{
const unsigned old_fl = *locfl;
unsigned new_fl;

do {
new_fl = *sharedfl;
} while (new_fl == old_fl);

*locfl = new_fl;
}
static inline
void SAC_MT_PTH_signal_barrier(unsigned *locfl, volatile unsigned *sharedfl)
{

unsigned new_fl = ~(*sharedfl);
*sharedfl = new_fl;
if (locfl != NULL) {
*locfl = new_fl;
}
}


#define SAC_MT_SPMDFUN_REAL_PARAM_LIST()  struct sac_bee_pth_t *SAC_MT_self

#define SAC_MT_MYTHREAD_PARAM()  struct sac_bee_pth_t *SAC_MT_self

typedef SAC_MT_SPMDFUN_REAL_RETTYPE() (* volatile sac_hive_spmd_fun_pth_t)
( struct sac_bee_pth_t *SAC_MT_self );

struct sac_bee_pth_t {

struct sac_bee_common_t c;


pthread_t pth;

unsigned start_barr_locfl;

struct sac_pth_llmutex_t stop_lck;
};

struct sac_hive_pth_t {

struct sac_hive_common_t c;

sac_hive_spmd_fun_pth_t spmd_fun;

volatile unsigned start_barr_sharedfl;
};

static inline
struct sac_bee_pth_t* CAST_BEE_COMMON_TO_PTH(struct sac_bee_common_t *cp)
{
return (struct sac_bee_pth_t *)cp;
}

static inline
struct sac_hive_pth_t* CAST_HIVE_COMMON_TO_PTH(struct sac_hive_common_t *cp)
{
return (struct sac_hive_pth_t *)cp;
}

#define SAC_MT_DEFINE_ST_SELF()  struct sac_bee_pth_t * const SAC_MT_self = (struct sac_bee_pth_t *)SAC_MT_singleton_queen;



#define SAC_MT_CLEAR_BARRIER( spmdfun, loc_id)  SAC_MT_PTH_acquire_lck(&CAST_BEE_COMMON_TO_PTH(SAC_MT_self->c.hive->bees[loc_id])->stop_lck);

#define SAC_MT_SET_BARRIER( spmdfun, loc_id)  SAC_MT_PTH_release_lck(&CAST_BEE_COMMON_TO_PTH(SAC_MT_self->c.hive->bees[loc_id])->stop_lck);

#define SAC_MT_CHECK_BARRIER( spmdfun, loc_id)  SAC_MT_PTH_may_acquire_lck(&CAST_BEE_COMMON_TO_PTH(SAC_MT_self->c.hive->bees[loc_id])->stop_lck)

#define SAC_MT_INIT_BARRIER(bee)  SAC_MT_PTH_init_lck(&bee->stop_lck, 1)


#define SAC_MT_SPMD_EXECUTE( name) {  SAC_TR_MT_PRINT( ("Parallel PTH execution of spmd-block %s started.", #name));  CAST_HIVE_COMMON_TO_PTH(SAC_MT_self->c.hive)->spmd_fun = &name;  SAC_MT_self->c.hive->framedata = frame;  SAC_MT_self->c.hive->retdata = rdata;  SAC_MT_PTH_do_spmd_execute(SAC_MT_self);  SAC_TR_MT_PRINT( ("Parallel execution of spmd-block %s finished.", #name)); }

static inline
void SAC_MT_PTH_do_spmd_execute(struct sac_bee_pth_t * const SAC_MT_self)
{
volatile unsigned * sharedfl = &CAST_HIVE_COMMON_TO_PTH(SAC_MT_self->c.hive)->start_barr_sharedfl;

unsigned old_globally_single = SAC_MT_globally_single;
if (SAC_MT_globally_single) {
SAC_MT_globally_single = 0;
}

SAC_MT_PTH_SIGNAL_BARRIER(sharedfl);

CAST_HIVE_COMMON_TO_PTH(SAC_MT_self->c.hive)->spmd_fun (SAC_MT_self);

CAST_HIVE_COMMON_TO_PTH(SAC_MT_self->c.hive)->spmd_fun = NULL;
SAC_MT_self->c.hive->framedata = NULL;
SAC_MT_self->c.hive->retdata = NULL;

if (old_globally_single) {
SAC_MT_globally_single = 1;
}
}

#define SAC_MT_SYNC_RELAX() 


#define SAC_MT_SETUP_INITIAL()  SAC_MT_barrier_type = SAC_SET_BARRIER_TYPE;  SAC_MT_cpu_bind_strategy = SAC_SET_CPU_BIND_STRATEGY;  SAC_MT_do_trace = SAC_DO_TRACE_MT;  SAC_MT_SetupInitial( __argc, __argv,  SAC_SET_THREADS, SAC_SET_THREADS_MAX);  SAC_MT_PTH_INIT_BARRIER(SAC_MT_GLOBAL_THREADS());  SAC_MT_SMART_INIT(SAC_MT_global_threads);
#define SAC_MT_SETUP()  SAC_MT_PTH_SetupStandalone( SAC_SET_NUM_SCHEDULERS);
#define SAC_MT_FINALIZE()  SAC_MT_ReleaseHive(SAC_MT_DetachHive()); SAC_MT_ReleaseQueen(); SAC_MT_singleton_queen = NULL;  SAC_MT_PTH_DESTROY_BARRIER();  SAC_MT_SMART_FINALIZE();
#define SAC_INVOKE_MAIN_FUN( fname, arg)  fname ( arg )



SAC_C_EXTERN pthread_attr_t SAC_MT_thread_attribs;

SAC_C_EXTERN void SAC_MT_SetupInitial( int argc, char *argv[],
unsigned int num_threads,
unsigned int max_threads);
SAC_C_EXTERN void SAC_MT_PTH_SetupStandalone( int num_schedulers);
SAC_C_EXTERN void SAC_MT_SetupAsLibraryInitial(void);
SAC_C_EXTERN unsigned int SAC_Get_CurrentBee_GlobalID(void);

SAC_C_EXTERN unsigned int SAC_MT_Internal_CurrentThreadId(void);
#endif 
#endif 

#ifndef _SAC_FP_H_
#define _SAC_FP_H_
#if SAC_DO_FP

#define SAC_FP_FRAME_START() typedef struct _SAC_fp_frame {  int entry;  int done;  int dqstate;  void (*slow_clone)(struct _SAC_fp_frame *f);  union {
#define SAC_FP_FRAME_END() } calls;  } SAC_fp_frame;
#define SAC_FP_FRAME_FUNC_START() struct {
#define SAC_FP_FRAME_FUNC_END( name) } name;

#define SAC_FP_FRAME_LIVEVAR( type, name) type name;
#define SAC_FP_FRAME_SYNC( name) int name ## _ready;  int name ## _waiting;
#define SAC_FP_FRAME_RESULT( type, n) type res_ ## n;

#define SAC_FP_SETUP_FAST( clone) int _fp_dqstate;  SAC_fp_frame *_fp_frame =  malloc( sizeof( SAC_fp_frame));  _fp_frame->slow_clone = &clone;  _fp_frame->done = 0;  _fp_frame->dqstate = 0;
#define SAC_FP_SETUP_SLOW_START() int _fp_dqstate;  switch( _fp_frame->dqstate) {
#define SAC_FP_CASE( n) case n: goto label ## n;
#define SAC_FP_SETUP_SLOW_END() } label0:;
#define SAC_FP_SET_LIVEVAR( func, name) _fp_frame->calls.func.name = name;
#define SAC_FP_GET_LIVEVAR( func, name) name = _fp_frame->calls.func.name;

#define SAC_FP_SPAWN_START( point) _fp_frame->entry = point;  _fp_dqstate = _fp_frame->dqstate;  _fp_pushframe( _fp_frame);
#define SAC_FP_SPAWN_END_FAST( function, sync, point)  _fp_frame->calls.function.sync ## _ready = 1;  if( _fp_dqstate != _fp_frame->dqstate) {  if(_fp_frame->calls.function.sync ## _waiting) {  _fp_frame->entry = point;  _fp_pushframe( _fp_frame);  }  _fp_saveframe( _fp_frame);  return;  }  _fp_popframe(); 
#define SAC_FP_SPAWN_END_SLOW( function, sync, point, jump)  _fp_frame->calls.function.sync ## _ready = 1;  if( _fp_dqstate != _fp_frame->dqstate) {  if(_fp_frame->calls.function.sync ## _waiting) {  _fp_frame->entry = point;   _fp_pushframe( _fp_frame);  }  _fp_saveframe( _fp_frame);  return;  }  _fp_popframe();  label ## entry:;
#define SAC_FP_SYNC_START( function, sync, entry)  if(!_fp_frame->calls.function.sync ## _ready) {  _fp_frame->calls.function.sync ## _waiting = 1;  _fp_saveframe( _fp_frame);  return;  }  if(0) { label ## entry:;
#define SAC_FP_SYNC_END() }

#define SAC_FP_SAVE_RESULT__NOOP( function, n, var_NT) SAC_NOOP()
#define SAC_FP_SAVE_RESULT__NODESC( function, n, var_NT)  _fp_frame->calls.function.res_ ## n = SAC_ND_A_FIELD( var_NT);
#define SAC_FP_RETURN() _fp_frame->done = 1;  _fp_saveframe( _fp_frame);
#define SAC_FP_AP_CHECK_START( name)  SAC_fp_frame *f_ ## name = _fp_getframe();  while(!f_ ## name->done) {  _fp_doonething(-1);  }

#define SAC_FP_AP_CHECK_END( name) free(f_ ## name);
#define SAC_FP_GET_RESULT__NOOP( frame, function, n, var_NT) SAC_NOOP()
#define SAC_FP_GET_RESULT__NODESC( frame, function, n, var_NT)  SAC_ND_A_FIELD( var_NT) = f_ ## frame->calls.function.res_ ## n;

#endif 
#endif 


#ifndef DEF_FILE_fp_gen
#define DEF_FILE_fp_gen
#ifndef _SAC_FP_GEN_H_
#define _SAC_FP_GEN_H_
#if SAC_DO_FP
#define SAC_FP_SAVE_RESULT( arg1, arg2, nt ) CAT_M4_fp_gen_1(SAC_FP_SAVE_RESULT_, NT_SHP(nt))( arg1, arg2, nt )
#define SAC_FP_SAVE_RESULT_SCL(...) SAC_FP_SAVE_RESULT__NODESC(__VA_ARGS__)
#define SAC_FP_SAVE_RESULT_AKS(...) SAC_FP_SAVE_RESULT__NOOP(__VA_ARGS__)
#define SAC_FP_SAVE_RESULT_AKD(...) SAC_FP_SAVE_RESULT__NOOP(__VA_ARGS__)
#define SAC_FP_SAVE_RESULT_AUD(...) SAC_FP_SAVE_RESULT__NOOP(__VA_ARGS__)
#define SAC_FP_SAVE_RESULT____(...) SAC_FP_SAVE_RESULT__NOOP(__VA_ARGS__)
#define SAC_FP_GET_RESULT( arg1, arg2, arg3, nt ) CAT_M4_fp_gen_2(SAC_FP_GET_RESULT_, NT_SHP(nt))( arg1, arg2, arg3, nt )
#define SAC_FP_GET_RESULT_SCL(...) SAC_FP_GET_RESULT__NODESC(__VA_ARGS__)
#define SAC_FP_GET_RESULT_AKS(...) SAC_FP_GET_RESULT__NOOP(__VA_ARGS__)
#define SAC_FP_GET_RESULT_AKD(...) SAC_FP_GET_RESULT__NOOP(__VA_ARGS__)
#define SAC_FP_GET_RESULT_AUD(...) SAC_FP_GET_RESULT__NOOP(__VA_ARGS__)
#define SAC_FP_GET_RESULT____(...) SAC_FP_GET_RESULT__NOOP(__VA_ARGS__)
#endif 
#endif 
#define CAT_M4_fp_gen_2(x, y) xCAT_M4_fp_gen_2(x, y)
#define xCAT_M4_fp_gen_2(x, y) x##y
#define CAT_M4_fp_gen_1(x, y) xCAT_M4_fp_gen_1(x, y)
#define xCAT_M4_fp_gen_1(x, y) x##y
#endif

#ifndef _MT_SMART
#define _MT_SMART
SAC_C_EXTERN unsigned current_nr_threads;
SAC_C_EXTERN unsigned smart_sample_size;
SAC_C_EXTERN unsigned problem_size;
SAC_C_EXTERN struct timespec begin, end;
#ifdef SAC_SET_SMART_DECISIONS
SAC_C_EXTERN void SAC_MT_smart_init(int type, char * file_id, char * arch_id, unsigned nr_threads);
SAC_C_EXTERN int SAC_MT_smart_train(int spmd_id, int64_t measurement_period);
SAC_C_EXTERN void SAC_MT_smart_decide(int size, const int (* recommendations)[2]);
SAC_C_EXTERN void SAC_MT_smart_finalize(void);
#if SAC_SET_SMART_DECISIONS == 1
#define SAC_MT_SMART_INIT(nr_threads) SAC_MT_smart_init(SAC_SET_SMART_DECISIONS, SAC_SET_SMART_FILENAME, SAC_SET_SMART_ARCH, nr_threads)
#define SAC_MT_SMART_BEGIN(spmd_id) while(SAC_MT_smart_train(spmd_id, SAC_SET_SMART_PERIOD)) { clock_gettime(CLOCK_REALTIME, &begin); for(unsigned i = 0; i < smart_sample_size; i++) {
#define SAC_MT_SMART_END() } clock_gettime(CLOCK_REALTIME, &end); }
#define SAC_MT_SMART_FINALIZE() SAC_MT_smart_finalize()
#elif SAC_SET_SMART_DECISIONS == 2
#define SAC_MT_SMART_DATA_BEGIN(data_size) { int size = data_size; const int recommendations[data_size][2] = {
#define SAC_MT_SMART_DATA_ADD(problem_size, nr_threads) {problem_size, nr_threads},
#define SAC_MT_SMART_DATA_END() };
#define SAC_MT_SMART_INIT(nr_threads) SAC_MT_smart_init(SAC_SET_SMART_DECISIONS, SAC_SET_SMART_FILENAME, SAC_SET_SMART_ARCH, nr_threads)
#define SAC_MT_SMART_BEGIN(spmd_id) SAC_MT_smart_decide( size, recommendations );
#define SAC_MT_SMART_END() }
#define SAC_MT_SMART_FINALIZE() 
#else
#define SAC_MT_SMART_INIT(nr_threads)
#define SAC_MT_SMART_BEGIN(spmd_id)
#define SAC_MT_SMART_END()
#define SAC_MT_SMART_FINALIZE()
#endif
#endif
#endif 
#ifndef _SAC_LPEL_H_
#define _SAC_LPEL_H_

#if SAC_DO_MULTITHREAD && SAC_DO_MT_LPEL

#include <lpel.h>
struct sac_bee_lpel_t;
struct sac_hive_lpel_t;

#define SAC_MT_SPMDFUN_REAL_PARAM_LIST()  struct sac_bee_lpel_t *SAC_MT_self

#define SAC_MT_MYTHREAD_PARAM()  struct sac_bee_lpel_t *SAC_MT_self

typedef SAC_MT_SPMDFUN_REAL_RETTYPE() (*sac_hive_spmd_fun_lpel_t)
( struct sac_bee_lpel_t *SAC_MT_self );

struct sac_bee_lpel_t {

struct sac_bee_common_t c;


unsigned int worker_id;

lpel_task_t *tsk;

lpel_bisema_t start_lck;

lpel_bisema_t stop_lck;

unsigned int magic1;
};
#define SAC_MT_LPEL_MAGIC_1 0xBeefCace 
#define SAC_MT_LPEL_BAD_MAGIC_1 0xDeadBeef 

struct sac_hive_lpel_t {

struct sac_hive_common_t c;

sac_hive_spmd_fun_lpel_t spmd_fun;
};

static inline
struct sac_bee_lpel_t* CAST_BEE_COMMON_TO_LPEL(struct sac_bee_common_t *cp)
{
return (struct sac_bee_lpel_t *)cp;
}

static inline
struct sac_hive_lpel_t* CAST_HIVE_COMMON_TO_LPEL(struct sac_hive_common_t *cp)
{
return (struct sac_hive_lpel_t *)cp;
}

#define SAC_MT_INIT_START_LCK(bee)  LpelBiSemaInit(&(bee)->start_lck); LpelBiSemaWait(&(bee)->start_lck);
#define SAC_MT_RELEASE_START_LCK(bee)  LpelBiSemaSignal(&(bee)->start_lck)
#define SAC_MT_ACQUIRE_START_LCK(bee)  LpelBiSemaWait(&(bee)->start_lck)

#define SAC_MT_DEFINE_ST_SELF()  struct sac_bee_lpel_t * const SAC_MT_self = SAC_MT_singleton_queen;

#define SAC_MT_LPEL_STACK_SIZE (8*1024*1024) 



#define SAC_MT_INIT_BARRIER(bee)  LpelBiSemaInit(&bee->stop_lck); LpelBiSemaWait(&bee->stop_lck);

#define SAC_MT_SET_BARRIER( spmdfun, loc_id)  LpelBiSemaSignal(&CAST_BEE_COMMON_TO_LPEL(SAC_MT_self->c.hive->bees[loc_id])->stop_lck);


#ifdef LPEL_HAS_BISEMA_COUNT_WAITING


#define SAC_MT_CHECK_BARRIER( spmdfun, loc_id)  !LpelBiSemaCountWaiting(&CAST_BEE_COMMON_TO_LPEL(SAC_MT_self->c.hive->bees[loc_id])->stop_lck)

#define SAC_MT_CLEAR_BARRIER( spmdfun, loc_id)  LpelBiSemaWait(&CAST_BEE_COMMON_TO_LPEL(SAC_MT_self->c.hive->bees[loc_id])->stop_lck);

#define SAC_MT_SYNC_RELAX() LpelTaskYield();
#else 


#define SAC_MT_CHECK_BARRIER( spmdfun, loc_id)  (LpelBiSemaWait(&CAST_BEE_COMMON_TO_LPEL(SAC_MT_self->c.hive->bees[loc_id])->stop_lck), 1)

#define SAC_MT_CLEAR_BARRIER( spmdfun, loc_id) 
#define SAC_MT_SYNC_RELAX() 
#endif


#define SAC_MT_SPMD_EXECUTE( name) {  SAC_TR_MT_PRINT( ("Parallel LPEL execution of spmd-block %s started.", #name));  CAST_HIVE_COMMON_TO_LPEL(SAC_MT_self->c.hive)->spmd_fun = &name;  SAC_MT_self->c.hive->framedata = frame;  SAC_MT_self->c.hive->retdata = rdata;  SAC_MT_LPEL_do_spmd_execute(SAC_MT_self);  SAC_TR_MT_PRINT( ("Parallel execution of spmd-block %s finished.", #name)); }

static inline
void SAC_MT_LPEL_do_spmd_execute(struct sac_bee_lpel_t * const SAC_MT_self)
{

unsigned old_globally_single = SAC_MT_globally_single;
if (SAC_MT_globally_single) {
SAC_MT_globally_single = 0;
}

for (unsigned i = 1; i < SAC_MT_self->c.hive->num_bees; ++i) {
struct sac_bee_lpel_t *b = CAST_BEE_COMMON_TO_LPEL(SAC_MT_self->c.hive->bees[i]);
SAC_MT_RELEASE_START_LCK(b);
}

CAST_HIVE_COMMON_TO_LPEL(SAC_MT_self->c.hive)->spmd_fun (SAC_MT_self);

CAST_HIVE_COMMON_TO_LPEL(SAC_MT_self->c.hive)->spmd_fun = NULL;
SAC_MT_self->c.hive->framedata = NULL;
SAC_MT_self->c.hive->retdata = NULL;

if (old_globally_single) {
SAC_MT_globally_single = 1;
}
}


#define SAC_MT_SETUP()
#define SAC_MT_SETUP_INITIAL()  SAC_MT_SetupInitial( __argc, __argv,  SAC_SET_THREADS, SAC_SET_THREADS_MAX);
#define SAC_INVOKE_MAIN_FUN(fname, arg)  SAC_MT_LPEL_SetupAndRunStandalone( fname, arg, SAC_SET_NUM_SCHEDULERS);

#define SAC_MT_FINALIZE() 


typedef void (*SAC_main_fun_t) (int *);

SAC_C_EXTERN void SAC_MT_SetupInitial( int argc, char *argv[],
unsigned int num_threads,
unsigned int max_threads);
SAC_C_EXTERN void SAC_MT_SetupAsLibraryInitial(void);
SAC_C_EXTERN void SAC_MT_LPEL_SetupAndRunStandalone(
SAC_main_fun_t main_fn, int *main_arg, int num_schedulers);
SAC_C_EXTERN void SAC_MT_LPEL_TR_SetupAndRunStandalone(
SAC_main_fun_t main_fn, int *main_arg, int num_schedulers);
SAC_C_EXTERN unsigned int SAC_Get_CurrentBee_GlobalID(void);
#endif 
#endif 

#ifndef _SAC_HEAPMGR_H
#define _SAC_HEAPMGR_H
#include <assert.h>
#if SAC_MUTC_MACROS
#define SAC_DO_PHM 0
#endif

typedef unsigned long int SAC_HM_size_byte_t;
typedef long int SAC_HM_size_unit_t;
#ifndef SAC_COMPILE_SACLIB
#if ! SAC_MUTC_MACROS
#define MUTC 1
#ifndef SAC_BACKEND_MUTC
#include <sys/types.h> 
#else
#include "stddef.h"
#endif
#undef MUTC
#endif
#endif 
#ifndef SAC_C_EXTERN
#define SAC_C_EXTERN extern
#endif 

#if ! SAC_MUTC_MACROS && ! SAC_CUDA_MACROS
SAC_C_EXTERN void *malloc( size_t size);
SAC_C_EXTERN void free( void *addr);
#endif

#ifndef SAC_MALLOC
#define SAC_MALLOC( x) malloc(x)
#endif
#ifndef SAC_FREE
#define SAC_FREE( x) free(x)
#endif

#ifndef SAC_CALLOC
#define SAC_CALLOC( nmemb, size) calloc(nmemb, size)
#endif
#if SAC_DO_PHM

#define SAC_HM_NUM_ARENAS 9
#define SAC_HM_NUM_SMALLCHUNK_ARENAS 5
#define SAC_HM_ARENA_OF_ARENAS 0
#define SAC_HM_TOP_ARENA (SAC_HM_NUM_ARENAS - 1)
#define SAC_HM_ALIGNMENT sizeof( double)

typedef union header_t {
struct header_data1_t {
SAC_HM_size_unit_t size;
struct arena_t *arena;
} data1;
struct header_data2_t {
union header_t *prevfree;
union header_t *nextfree;
} data2;
struct header_data3_t {
SAC_HM_size_unit_t prevsize;
SAC_HM_size_unit_t diag;
} data3;
char align[(((SAC_MAX( SAC_MAX( sizeof( struct header_data1_t),
sizeof( struct header_data2_t)),
sizeof( struct header_data3_t))
-1) / SAC_HM_ALIGNMENT) + 1) * SAC_HM_ALIGNMENT];
} SAC_HM_header_t;

#define SAC_HM_LARGECHUNK_SIZE( header) (((header)+1)->data1.size)
#define SAC_HM_LARGECHUNK_PREVSIZE( header) (((header)+0)->data3.prevsize)
#define SAC_HM_LARGECHUNK_ARENA( header) (((header)+1)->data1.arena)
#define SAC_HM_LARGECHUNK_NEXTFREE( header) (((header)+2)->data2.nextfree)

#define SAC_HM_SMALLCHUNK_SIZE( header) (((header)+0)->data1.size)
#define SAC_HM_SMALLCHUNK_ARENA( header) (((header)+0)->data1.arena)
#define SAC_HM_SMALLCHUNK_NEXTFREE( header) (((header)+1)->data2.nextfree)
#define SAC_HM_LARGECHUNK_DIAG( header) (((header)+0)->data3.diag)
#define SAC_HM_SMALLCHUNK_DIAG( header) (((header)+0)->data1.size)

#define SAC_HM_UNIT_SIZE (sizeof( SAC_HM_header_t))
#define SAC_HM_BYTES_2_UNITS( size) ((((size) - 1) / SAC_HM_UNIT_SIZE) + 1)

typedef struct arena_t {
int num;
SAC_HM_header_t freelist[3];
SAC_HM_header_t *wilderness;
SAC_HM_size_unit_t binsize; 
SAC_HM_size_unit_t min_chunk_size; 

volatile SAC_HM_header_t *unused_list;

unsigned long int size; 
unsigned long int cnt_bins;
unsigned long int cnt_alloc;
unsigned long int cnt_alloc_var_size;
unsigned long int cnt_after_freelist;
unsigned long int cnt_after_splitting;
unsigned long int cnt_after_wilderness;
unsigned long int cnt_after_coalascing;
unsigned long int cnt_after_coalascing_wilderness;
unsigned long int cnt_after_extension;
unsigned long int cnt_free;
unsigned long int cnt_free_var_size;
unsigned long int cnt_coalascing;
unsigned long int cnt_coalascing_wilderness;
} SAC_HM_arena_t;

#define SAC_HM_SMALL_ARENA_FREELIST_BASE( n) {  {{ 0, &(SAC_HM_arenas[0][n]) }},  {{ 0, NULL }},  {{ 0, NULL }} }
#define SAC_HM_LARGE_ARENA_FREELIST_BASE( n) {  {{ -1, NULL}},  {{ 0, &(SAC_HM_arenas[0][n]) }},  {{ 0, NULL }} }
#define SAC_HM_ARENA_OF_SMALL_CHUNKS( n, binsize, mincs) {  n,  SAC_HM_SMALL_ARENA_FREELIST_BASE( n),  SAC_HM_arenas[0][n].freelist,  binsize,  mincs,  NULL,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
#define SAC_HM_ARENA_OF_LARGE_CHUNKS( n, binsize, mincs) {  n,  SAC_HM_LARGE_ARENA_FREELIST_BASE( n),  SAC_HM_arenas[0][n].freelist,  binsize,  mincs,  NULL,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
#define SAC_HM_SETUP_ARENAS() {  {  SAC_HM_ARENA_OF_SMALL_CHUNKS( 0, SAC_HM_ARENA_0_BINSIZE, SAC_HM_ARENA_0_MINCS),  SAC_HM_ARENA_OF_SMALL_CHUNKS( 1, SAC_HM_ARENA_1_BINSIZE, SAC_HM_ARENA_2_MINCS - 1),  SAC_HM_ARENA_OF_SMALL_CHUNKS( 2, SAC_HM_ARENA_2_BINSIZE, SAC_HM_ARENA_3_MINCS - 1),  SAC_HM_ARENA_OF_SMALL_CHUNKS( 3, SAC_HM_ARENA_3_BINSIZE, SAC_HM_ARENA_4_MINCS - 1),  SAC_HM_ARENA_OF_SMALL_CHUNKS( 4, SAC_HM_ARENA_4_BINSIZE, SAC_HM_ARENA_5_MINCS - 1),  SAC_HM_ARENA_OF_LARGE_CHUNKS( 5, SAC_HM_ARENA_5_BINSIZE, SAC_HM_ARENA_5_MINCS),  SAC_HM_ARENA_OF_LARGE_CHUNKS( 6, SAC_HM_ARENA_6_BINSIZE, SAC_HM_ARENA_6_MINCS),  SAC_HM_ARENA_OF_LARGE_CHUNKS( 7, SAC_HM_ARENA_7_BINSIZE, SAC_HM_ARENA_7_MINCS),  SAC_HM_ARENA_OF_LARGE_CHUNKS( 8, SAC_HM_ARENA_8_BINSIZE, SAC_HM_ARENA_8_MINCS)  } }

#define SAC_HM_ADDR_ARENA( addr) ((((SAC_HM_header_t *) addr) -1)->data1.arena)
#define SAC_HM_ADDR_SIZE( addr) ((((SAC_HM_header_t *) addr) -1)->data1.size) 
#define SAC_HM_ADDR_NEXTFREE( addr) (((SAC_HM_header_t *) addr)->data2.nextfree)

#define SAC_HM_ARENA_0_MINCS 1
#define SAC_HM_ARENA_1_MINCS 2
#define SAC_HM_ARENA_2_MINCS 3
#define SAC_HM_ARENA_3_MINCS 5
#define SAC_HM_ARENA_4_MINCS 9
#define SAC_HM_ARENA_5_MINCS 17
#define SAC_HM_ARENA_6_MINCS 129
#define SAC_HM_ARENA_7_MINCS 1025
#define SAC_HM_ARENA_8_MINCS 8193

#define SAC_HM_ARENA_1_MAXCS_BYTES ((SAC_HM_ARENA_2_MINCS -2) * SAC_HM_UNIT_SIZE)
#define SAC_HM_ARENA_2_MAXCS_BYTES ((SAC_HM_ARENA_3_MINCS -2) * SAC_HM_UNIT_SIZE)
#define SAC_HM_ARENA_3_MAXCS_BYTES ((SAC_HM_ARENA_4_MINCS -2) * SAC_HM_UNIT_SIZE)
#define SAC_HM_ARENA_4_MAXCS_BYTES ((SAC_HM_ARENA_5_MINCS -2) * SAC_HM_UNIT_SIZE)
#define SAC_HM_ARENA_5_MAXCS_BYTES ((SAC_HM_ARENA_6_MINCS -3) * SAC_HM_UNIT_SIZE)
#define SAC_HM_ARENA_6_MAXCS_BYTES ((SAC_HM_ARENA_7_MINCS -3) * SAC_HM_UNIT_SIZE)
#define SAC_HM_ARENA_7_MAXCS_BYTES ((SAC_HM_ARENA_8_MINCS -3) * SAC_HM_UNIT_SIZE)

#define SAC_HM_ARENA_0_BINSIZE 131072
#define SAC_HM_ARENA_1_BINSIZE 512
#define SAC_HM_ARENA_2_BINSIZE 512
#define SAC_HM_ARENA_3_BINSIZE 256
#define SAC_HM_ARENA_4_BINSIZE 512
#define SAC_HM_ARENA_5_BINSIZE 2048
#define SAC_HM_ARENA_6_BINSIZE 8196
#define SAC_HM_ARENA_7_BINSIZE 32768
#define SAC_HM_ARENA_8_BINSIZE 0

typedef enum {
SAC_HM_single_threaded, 
SAC_HM_multi_threaded, 
SAC_HM_any_threaded
} SAC_HM_thread_status_t;
#define SAC_HM_DEFINE_THREAD_STATUS( status)  static const SAC_HM_thread_status_t SAC_HM_thread_status = status;

SAC_MT_DECLARE_LOCK( SAC_HM_top_arena_lock)
SAC_MT_DECLARE_LOCK( SAC_HM_diag_counter_lock)

SAC_C_EXTERN int SAC_HM_not_yet_initialized;
SAC_C_EXTERN unsigned long int SAC_HM_acquire_top_arena_lock;

SAC_C_EXTERN void SAC_HM_Setup( unsigned int threads);
SAC_C_EXTERN void *SAC_HM_MallocSmallChunk( SAC_HM_size_unit_t units,
SAC_HM_arena_t *arena);
SAC_C_EXTERN void *SAC_HM_MallocLargeChunk( SAC_HM_size_unit_t units,
SAC_HM_arena_t *arena);
SAC_C_EXTERN void SAC_HM_FreeSmallChunk( SAC_HM_header_t *addr,
SAC_HM_arena_t *arena);
SAC_C_EXTERN void SAC_HM_FreeLargeChunk( SAC_HM_header_t *addr,
SAC_HM_arena_t *arena);
SAC_C_EXTERN void *SAC_HM_MallocAnyChunk_at( SAC_HM_size_byte_t size,
unsigned int thread_id);
SAC_C_EXTERN void *SAC_HM_MallocAnyChunk_st( SAC_HM_size_byte_t size);
SAC_C_EXTERN void *SAC_HM_MallocAnyChunk_mt( SAC_HM_size_byte_t size,
unsigned int thread_id);
SAC_C_EXTERN void *SAC_HM_MallocSmallChunk_at( SAC_HM_size_unit_t units,
int arena_num);
SAC_C_EXTERN void *SAC_HM_MallocLargeChunk_at( SAC_HM_size_unit_t units,
int arena_num);
SAC_C_EXTERN void *SAC_HM_MallocTopArena_at( SAC_HM_size_unit_t units);
SAC_C_EXTERN void *SAC_HM_MallocTopArena_mt( SAC_HM_size_unit_t units);
SAC_C_EXTERN void *SAC_HM_MallocDesc( SAC_HM_header_t *addr,
SAC_HM_size_byte_t size,
SAC_HM_size_byte_t desc_size);
SAC_C_EXTERN void SAC_HM_FreeTopArena_mt( SAC_HM_header_t *addr);
SAC_C_EXTERN void SAC_HM_FreeTopArena_at( SAC_HM_header_t *addr);
SAC_C_EXTERN void SAC_HM_FreeDesc( SAC_HM_header_t *addr);
SAC_C_EXTERN void SAC_HM_ShowDiagnostics(void);
SAC_C_EXTERN void SAC_HM_CheckAllocPatternAnyChunk( SAC_HM_header_t *addr);
SAC_C_EXTERN void *SAC_HM_PlaceArray( void *alloc, void *base,
long int offset, long int cache_size);


#define SAC_HM_THREADID_INVALID (0xDeadBeef)
SAC_C_EXTERN unsigned int SAC_HM_CurrentThreadId(void);
SAC_C_EXTERN int SAC_HM_DiscoversThreads(void);

#define SAC_HM_SETUP() {  SAC_HM_Setup( SAC_MT_GLOBAL_THREADS() + SAC_HM_RTSPEC_THREADS()); }

#ifdef __cplusplus
#define SAC_EXTERN_IF_CPP extern
#else
#define SAC_EXTERN_IF_CPP
#endif
#define SAC_HM_DEFINE__IMPL()  SAC_HM_arena_t SAC_HM_arenas[SAC_SET_THREADS_MAX][SAC_HM_NUM_ARENAS+2]  = SAC_HM_SETUP_ARENAS();  SAC_EXTERN_IF_CPP const SAC_HM_size_byte_t SAC_HM_initial_master_arena_of_arenas_size  = SAC_SET_INITIAL_MASTER_HEAPSIZE;  SAC_EXTERN_IF_CPP const SAC_HM_size_byte_t SAC_HM_initial_worker_arena_of_arenas_size  = SAC_SET_INITIAL_WORKER_HEAPSIZE;  SAC_EXTERN_IF_CPP const SAC_HM_size_byte_t SAC_HM_initial_top_arena_size  = SAC_SET_INITIAL_UNIFIED_HEAPSIZE;  SAC_EXTERN_IF_CPP const unsigned int SAC_HM_max_worker_threads  = SAC_SET_THREADS_MAX - 1;
#if SAC_DO_COMPILE_MODULE
#define SAC_HM_DEFINE()  SAC_C_EXTERN SAC_HM_arena_t SAC_HM_arenas[][SAC_HM_NUM_ARENAS+2];
#else 
#define SAC_HM_DEFINE()  SAC_HM_DEFINE__IMPL()
#endif 
#if SAC_DO_CHECK_HEAP
#define SAC_HM_PRINT() SAC_HM_ShowDiagnostics();
#define SAC_HM_INC_DIAG_COUNTER( counter) (counter)++;
#else
#define SAC_HM_PRINT()
#define SAC_HM_INC_DIAG_COUNTER( counter)
#endif

#define SAC_HM_ASSERT(x) assert(x)

#define SAC_HM_MALLOC( var, size, basetype) {  switch (SAC_HM_thread_status) {  case SAC_HM_single_threaded:  SAC_HM_ASSERT(SAC_MT_globally_single && "An ST/SEQ call in the MT/XT context!! (1)");  var = (basetype*)SAC_HM_MallocAnyChunk_st( size);  break;  case SAC_HM_multi_threaded:  var = (basetype*)SAC_HM_MallocAnyChunk_mt( size, SAC_MT_SELF_THREAD_ID());  break;  case SAC_HM_any_threaded:  var = (basetype*)SAC_HM_MallocAnyChunk_at( size, SAC_MT_SELF_THREAD_ID());  break;  } }
#define SAC_HM_MALLOC_AS_SCALAR( var, size, basetype) {  switch (SAC_HM_thread_status) {  case SAC_HM_single_threaded:  SAC_HM_ASSERT(SAC_MT_globally_single && "An ST/SEQ call in the MT/XT context!! (2)");  var = (basetype)SAC_HM_MallocAnyChunk_st( size);  break;  case SAC_HM_multi_threaded:  var = (basetype)SAC_HM_MallocAnyChunk_mt( size,  SAC_MT_SELF_THREAD_ID());  break;  case SAC_HM_any_threaded:  var = (basetype)SAC_HM_MallocAnyChunk_at( size,  SAC_MT_SELF_THREAD_ID());  break;  } }
#if SAC_DO_MULTITHREAD
#define SAC_HM_MALLOC_SMALL_CHUNK( var, units, arena_num, basetype) {  SAC_HM_ASSERT((arena_num >= 0 && arena_num < 5) && "That is not a small arena!");  switch (SAC_HM_thread_status) {  case SAC_HM_single_threaded:  SAC_HM_ASSERT(SAC_MT_globally_single && "An ST/SEQ small-arena call in the MT/XT context!!");  var = (basetype*)SAC_HM_MallocSmallChunk( units, &(SAC_HM_arenas[0][arena_num]));  break;  case SAC_HM_multi_threaded:  var = (basetype*)SAC_HM_MallocSmallChunk( units, &(SAC_HM_arenas[SAC_MT_SELF_THREAD_ID()][arena_num]));  break;  case SAC_HM_any_threaded:    var = (basetype*)SAC_HM_MallocSmallChunk( units, &(SAC_HM_arenas[SAC_MT_SELF_THREAD_ID()][arena_num]));  break;  } }
#define SAC_HM_MALLOC_LARGE_CHUNK( var, units, arena_num, basetype) {  SAC_HM_ASSERT((arena_num >= 5 && arena_num < SAC_HM_TOP_ARENA) && "That is not a large arena");  switch (SAC_HM_thread_status) {  case SAC_HM_single_threaded:  SAC_HM_ASSERT(SAC_MT_globally_single && "An ST/SEQ large-arena call in the MT/XT context!!");  var = (basetype*)SAC_HM_MallocLargeChunk( units, &(SAC_HM_arenas[0][arena_num]));  break;  case SAC_HM_multi_threaded:  var = (basetype*)SAC_HM_MallocLargeChunk( units, &(SAC_HM_arenas[SAC_MT_SELF_THREAD_ID()][arena_num]));  break;  case SAC_HM_any_threaded:    var = (basetype*)SAC_HM_MallocLargeChunk( units, &(SAC_HM_arenas[SAC_MT_SELF_THREAD_ID()][arena_num]));  break;  } }
#define SAC_HM_MALLOC_TOP_ARENA( var, units, basetype) {  switch (SAC_HM_thread_status) {  case SAC_HM_single_threaded:  SAC_HM_ASSERT(SAC_MT_globally_single && "An ST/SEQ top-arena call in the MT/XT context!!");  var = (basetype*)SAC_HM_MallocLargeChunk( units, &(SAC_HM_arenas[0][SAC_HM_TOP_ARENA]));  break;  case SAC_HM_multi_threaded:  SAC_MT_ACQUIRE_LOCK( SAC_HM_top_arena_lock);  SAC_HM_INC_DIAG_COUNTER( SAC_HM_acquire_top_arena_lock);  var = (basetype*)SAC_HM_MallocLargeChunk( units, &(SAC_HM_arenas[0][SAC_HM_TOP_ARENA]));  SAC_MT_RELEASE_LOCK( SAC_HM_top_arena_lock);  break;  case SAC_HM_any_threaded:  var = (basetype*)SAC_HM_MallocTopArena_at( units);  break;  } }
#else 
#define SAC_HM_MALLOC_SMALL_CHUNK( var, units, arena_num, basetype)  var = (basetype*)SAC_HM_MallocSmallChunk( units, &(SAC_HM_arenas[0][arena_num]));
#define SAC_HM_MALLOC_LARGE_CHUNK( var, units, arena_num, basetype)  var = (basetype*)SAC_HM_MallocLargeChunk( units, &(SAC_HM_arenas[0][arena_num]));
#define SAC_HM_MALLOC_TOP_ARENA( var, units, basetype)  var = (basetype*)SAC_HM_MallocLargeChunk( units, &(SAC_HM_arenas[0][SAC_HM_TOP_ARENA]));
#endif 
#if 0

#define SAC_HM_MALLOC_FIXED_SIZE( size) (((size) <= ARENA_4_MAXCS_BYTES)  ? (((size) <= ARENA_2_MAXCS_BYTES)  ? (((size) <= ARENA_1_MAXCS_BYTES)  ? (SAC_HM_MallocSmallChunkPresplit( 2, &(SAC_HM_arenas[1]), 16))  : (SAC_HM_MallocSmallChunkPresplit( 4, &(SAC_HM_arenas[2]), 16)))  : (((size) <= ARENA_3_MAXCS_BYTES)  ? (SAC_HM_MallocSmallChunk( 8, &(SAC_HM_arenas[3])))  : (SAC_HM_MallocSmallChunk( 16, &(SAC_HM_arenas[4])))))  : ((SAC_HM_UNITS(size) < ARENA_7_MINCS)  ? ((SAC_HM_UNITS(size) < ARENA_6_MINCS)  ? (SAC_HM_MallocLargeChunk( SAC_HM_UNITS( size), &(SAC_HM_arenas[5])))  : (SAC_HM_MallocLargeChunk( SAC_HM_UNITS( size), &(SAC_HM_arenas[6]))))  : ((SAC_HM_UNITS(size) < ARENA_8_MINCS)  ? (SAC_HM_MallocLargeChunk( SAC_HM_UNITS( size), &(SAC_HM_arenas[7])))  : (SAC_HM_MallocLargeChunk( SAC_HM_UNITS( size), &(SAC_HM_arenas[8]))))))
#endif 

#if SAC_DO_APS
#if SAC_DO_MSCA
#define SAC_HM_MALLOC_FIXED_SIZE( var, size, basetype) {  if ((size) <= SAC_HM_ARENA_4_MAXCS_BYTES) {  if ((size) <= SAC_HM_ARENA_2_MAXCS_BYTES) {  if ((size) <= SAC_HM_ARENA_1_MAXCS_BYTES) {  SAC_HM_MALLOC_SMALL_CHUNK( var, 2, 1, basetype)  }  else {  SAC_HM_MALLOC_SMALL_CHUNK( var, 4, 2, basetype)  }  }  else {  if ((size) <= SAC_HM_ARENA_3_MAXCS_BYTES) {  SAC_HM_MALLOC_SMALL_CHUNK( var, 8, 3, basetype)  }  else {  SAC_HM_MALLOC_SMALL_CHUNK( var, 16, 4, basetype)  }  }  }  else {  const SAC_HM_size_byte_t _real_size_1 = size  + SAC_HM_CACHE_ADJUST( size,  SAC_SET_CACHE_3_SIZE,  SAC_SET_CACHE_3_MSCA_FACTOR);  const SAC_HM_size_byte_t _real_size_2 = _real_size_1  + SAC_HM_CACHE_ADJUST( _real_size_1,  SAC_SET_CACHE_2_SIZE,  SAC_SET_CACHE_2_MSCA_FACTOR);  const SAC_HM_size_byte_t _real_size_3 = _real_size_2  + SAC_HM_CACHE_ADJUST( _real_size_2,  SAC_SET_CACHE_1_SIZE,  SAC_SET_CACHE_1_MSCA_FACTOR);  const SAC_HM_size_unit_t _units = SAC_HM_BYTES_2_UNITS( _real_size_3) + 2;   if (_units < SAC_HM_ARENA_7_MINCS) {  if (_units < SAC_HM_ARENA_6_MINCS) {  SAC_HM_MALLOC_LARGE_CHUNK( var, _units, 5, basetype)  }  else {  SAC_HM_MALLOC_LARGE_CHUNK( var, _units, 6, basetype)  }  }  else {  if (_units < SAC_HM_ARENA_8_MINCS){  SAC_HM_MALLOC_LARGE_CHUNK( var, _units, 7, basetype)  }  else {  SAC_HM_MALLOC_TOP_ARENA( var, _units, basetype)  }  }  } }
#else 
#define SAC_HM_MALLOC_FIXED_SIZE( var, size, basetype) {  if ((size) <= SAC_HM_ARENA_4_MAXCS_BYTES) {  if ((size) <= SAC_HM_ARENA_2_MAXCS_BYTES) {  if ((size) <= SAC_HM_ARENA_1_MAXCS_BYTES) {  SAC_HM_MALLOC_SMALL_CHUNK( var, 2, 1, basetype)  }  else {  SAC_HM_MALLOC_SMALL_CHUNK( var, 4, 2, basetype)  }  }  else {  if ((size) <= SAC_HM_ARENA_3_MAXCS_BYTES) {  SAC_HM_MALLOC_SMALL_CHUNK( var, 8, 3, basetype)  }  else {  SAC_HM_MALLOC_SMALL_CHUNK( var, 16, 4, basetype)  }  }  }  else {  const SAC_HM_size_unit_t units = SAC_HM_BYTES_2_UNITS( size) + 2;  if (units < SAC_HM_ARENA_7_MINCS) {  if (units < SAC_HM_ARENA_6_MINCS) {  SAC_HM_MALLOC_LARGE_CHUNK( var, units, 5, basetype)  }  else {  SAC_HM_MALLOC_LARGE_CHUNK( var, units, 6, basetype)  }  }  else {  if (units < SAC_HM_ARENA_8_MINCS){  SAC_HM_MALLOC_LARGE_CHUNK( var, units, 7, basetype)  }  else {  SAC_HM_MALLOC_TOP_ARENA( var, units, basetype)  }  }  } }
#endif 
#else 
#define SAC_HM_MALLOC_FIXED_SIZE( var, size, basetype)  SAC_HM_MALLOC( var, size, basetype)
#endif 
#if SAC_DO_DAO
#if 0

#define SAC_HM_MALLOC_FIXED_SIZE_WITH_DESC( var, var_desc, size, dim) {  SAC_HM_MALLOC_FIXED_SIZE( var, ((size)  + BYTE_SIZE_OF_DESC( dim)  + 2 * SAC_HM_UNIT_SIZE))   var_desc = (SAC_array_descriptor_t) (((SAC_HM_header_t *) var)  + (SAC_HM_BYTES_2_UNITS( size) + 1));  SAC_HM_ADDR_ARENA( var_desc) = NULL; }
#else
#define SAC_HM_MALLOC_FIXED_SIZE_WITH_DESC( var, var_desc, size, dim, basetype, descbasetype) {  SAC_HM_MALLOC_FIXED_SIZE( var, ((size)  + BYTE_SIZE_OF_DESC( dim)  + 2 * SAC_HM_UNIT_SIZE), basetype)   var_desc = (descbasetype*)SAC_HM_MallocDesc( (SAC_HM_header_t *) var,  size,  BYTE_SIZE_OF_DESC( dim)); }
#endif
#else 
#define SAC_HM_MALLOC_FIXED_SIZE_WITH_DESC( var, var_desc, size, dim, basetype, descbasetype) {  SAC_HM_MALLOC_FIXED_SIZE( var, (size), basetype)  SAC_HM_MALLOC_FIXED_SIZE( var_desc, BYTE_SIZE_OF_DESC( dim), descbasetype) }
#endif 

#define SAC_HM_FREE( addr)  free( addr);
#if SAC_DO_APS

#define SAC_HM_FREE_DESC( addr) {  SAC_HM_FreeDesc( (SAC_HM_header_t *) addr); }
#define SAC_HM_FREE_FIXED_SIZE( addr, size) {  if (((size) + 2 * SAC_HM_UNIT_SIZE) <= SAC_HM_ARENA_4_MAXCS_BYTES) {  SAC_HM_FreeSmallChunk( (SAC_HM_header_t *) addr, SAC_HM_ADDR_ARENA( addr));  }  else {  if (size <= SAC_HM_ARENA_4_MAXCS_BYTES) {  if (SAC_HM_ADDR_ARENA( addr)->num == 4) {  SAC_HM_FreeSmallChunk( (SAC_HM_header_t *) addr, SAC_HM_ADDR_ARENA( addr));  }  else {  SAC_HM_FreeLargeChunk( (SAC_HM_header_t *) addr, SAC_HM_ADDR_ARENA( addr));  }  }  else {  if (SAC_HM_BYTES_2_UNITS( size) + (2+2) < SAC_HM_ARENA_8_MINCS) {  SAC_HM_FreeLargeChunk( (SAC_HM_header_t *) addr, SAC_HM_ADDR_ARENA( addr));  }  else {  if (SAC_HM_BYTES_2_UNITS( size) + 2 < SAC_HM_ARENA_8_MINCS) {  if (SAC_HM_ADDR_ARENA( addr)->num == 7) {  SAC_HM_FreeLargeChunk( (SAC_HM_header_t *) addr, SAC_HM_ADDR_ARENA( addr));  }  else {  switch (SAC_HM_thread_status) {  case SAC_HM_single_threaded:  SAC_HM_FreeLargeChunk( (SAC_HM_header_t *) addr,  &(SAC_HM_arenas[0][SAC_HM_TOP_ARENA]));  break;  case SAC_HM_multi_threaded:  SAC_HM_FreeTopArena_mt( (SAC_HM_header_t *) addr);  break;  case SAC_HM_any_threaded:  SAC_HM_FreeTopArena_at( (SAC_HM_header_t *) addr);  break;  }  }  }  else {  switch (SAC_HM_thread_status) {  case SAC_HM_single_threaded:  SAC_HM_FreeLargeChunk( (SAC_HM_header_t *) addr,  &(SAC_HM_arenas[0][SAC_HM_TOP_ARENA]));  break;  case SAC_HM_multi_threaded:  SAC_HM_FreeTopArena_mt( (SAC_HM_header_t *) addr);  break;  case SAC_HM_any_threaded:  SAC_HM_FreeTopArena_at( (SAC_HM_header_t *) addr);  break;  }  }  }  }  } }
#else 
#define SAC_HM_FREE_DESC( addr) {  if (SAC_HM_ADDR_ARENA( addr) != NULL) {  SAC_HM_FREE( addr)  } }
#define SAC_HM_FREE_FIXED_SIZE( addr, size)  SAC_HM_FREE( addr)
#endif 
#define SAC_DO_INLINE_FREE 0
#if SAC_DO_INLINE_FREE
#if SAC_DO_HM_XTHR_FREE
#error SAC_DO_INLINE_FREE is incompatible with SAC_DO_HM_XTHR_FREE !

#endif
#define SAC_HM_FreeLargeChunk( addr, arena) {  SAC_HM_header_t *freep;   freep = (addr) - 2;   SAC_HM_LARGECHUNK_PREVSIZE( freep + SAC_HM_LARGECHUNK_SIZE( freep))  = SAC_HM_LARGECHUNK_SIZE( freep);   SAC_HM_LARGECHUNK_NEXTFREE( freep) = SAC_HM_LARGECHUNK_NEXTFREE( (arena)->freelist);  SAC_HM_LARGECHUNK_NEXTFREE( (arena)->freelist) = freep; }
#define SAC_HM_FreeSmallChunk( addr, arena) {  SAC_HM_header_t *freep;   freep = (addr) - 1;   SAC_HM_SMALLCHUNK_NEXTFREE( freep) = SAC_HM_SMALLCHUNK_NEXTFREE( (arena)->freelist);  SAC_HM_SMALLCHUNK_NEXTFREE( (arena)->freelist) = freep; }
#endif 
#if SAC_DO_MSCA
#define SAC_HM_CACHE_ADJUST( size, cache_size, factor) ( (cache_size) <= 0  ? 0  : ((size) % (cache_size) < (cache_size) * (factor)  ? (SAC_HM_size_byte_t) ((cache_size) * (factor)) - (size) % (cache_size)  : ((cache_size) - (size) % (cache_size) < (cache_size) * (factor)  ? (SAC_HM_size_byte_t) ((cache_size) * (factor))  + (cache_size) - (size) % (cache_size)  : 0)))
#else 
#define SAC_HM_CACHE_ADJUST( size, cache_size, factor)  0
#endif 
#else 
#define SAC_HM_SETUP()
#define SAC_HM_PRINT()
#define SAC_HM_DEFINE()
#if SAC_DO_CHECK_MALLOC
SAC_C_EXTERN void *SAC_HM_MallocCheck( unsigned int);
#define SAC_HM_MALLOC( var, size, basetype)  var = (basetype*)SAC_HM_MallocCheck( size);
#define SAC_HM_MALLOC_AS_SCALAR( var, size, basetype)  var = (basetype)SAC_HM_MallocCheck( size);
#else 
#define SAC_HM_MALLOC( var, size, basetype)  var = (basetype*)malloc( size);
#define SAC_HM_MALLOC_AS_SCALAR( var, size, basetype)  var = (basetype)malloc( size);
#endif 
#define SAC_HM_MALLOC_FIXED_SIZE( var, size, basetype)  SAC_HM_MALLOC( var, size, basetype)
#define SAC_HM_MALLOC_FIXED_SIZE_WITH_DESC( var, var_desc, size, dim, basetype, descbasetype) {  SAC_HM_MALLOC_FIXED_SIZE( var, (size), basetype)  SAC_HM_MALLOC_FIXED_SIZE( var_desc, BYTE_SIZE_OF_DESC( dim), descbasetype) }
#define SAC_HM_FREE( addr)  free( addr);
#define SAC_HM_FREE_DESC( addr)  SAC_HM_FREE( addr)
#define SAC_HM_FREE_FIXED_SIZE( addr, size)  SAC_HM_FREE( addr)
#define SAC_HM_DEFINE_THREAD_STATUS( status)
#if ! SAC_MUTC_MACROS
SAC_C_EXTERN void SAC_HM_ShowDiagnostics(void);
#endif
#endif 
#endif 

#ifndef _SAC_MUTC_H_
#define _SAC_MUTC_H_
#ifdef SAC_BACKEND_MUTC

#include <svp/perf.h>
#define SAC_MUTC_TIME_BEGIN {  uint64_t TIME_begin;  uint64_t TIME_end;  TIME_begin = get_cycles(); 
#define SAC_MUTC_TIME_END  {  TIME_end = get_cycles();  long long n = TIME_end - TIME_begin;   sl_proccall(svp_io_puts, sl_glarg(const char*, sl_anon, "\nCYCLES: "));  sl_proccall(svp_io_putn,  sl_glarg(long long, sl_anon, n),  sl_glarg(int, sl_anon, 10));  sl_proccall(svp_io_puts, sl_glarg(const char*, sl_anon, "\n"));  } } 
#define SAC_MUTC_DECL_FAMILY(name) 
#define SAC_MUTC_DECL_INDEX(name) sl_index(name);
#if SAC_MUTC_SEQ_DATA_PARALLEL
#define SAC_MUTC_CREATE(name, place, lb, ub, st, bl, ap)  sl_create( , place, lb, ub, st, bl, sl__forceseq, ap);
#else
#define SAC_MUTC_CREATE(name, place, lb, ub, st, bl, ap)  sl_create( , place, lb, ub, st, bl, , ap);
#endif
#define SAC_MUTC_DECL_THREADFUN2(name, anon, ...)  sl_decl(name, void, __VA_ARGS__)
#define SAC_MUTC_SYNC(name) sl_sync();
#define SAC_MUTC_THREAD_AP2(name, ...) name, __VA_ARGS__
#define SAC_MUTC_SAVE_NODESC( nt)  NT_NAME( nt) = sl_geta( CAT0( SAC_ND_A_FIELD( nt), _sh));
#define SAC_MUTC_SAVE_DESC( nt)  SAC_ND_A_FIELD( nt) = sl_geta( CAT0( SAC_ND_A_FIELD( nt), _sh));  SAC_ND_A_DESC( nt) = sl_geta( CAT0( SAC_ND_A_DESC( nt), _sh));
#define SAC_MUTC_CREATE_BLOCK_START() {
#define SAC_MUTC_CREATE_BLOCK_END() }
#define SAC_MUTC_DEF_THREADFUN_BEGIN2(name, anon, ...)  sl_def(name, void, __VA_ARGS__) {  SAC_MUTC_THREAD_INIT
#define SAC_MUTC_THREADFUN_DEF_END(...)  SAC_MUTC_THREAD_CLEANUP  } sl_enddef
#define SAC_MUTC_UNLOCK_SHARED(nt) sl_setp(NT_NAME(nt), 1);
#define SAC_MUTC_LOCK_SHARED(nt) sl_getp(NT_NAME(nt));
#define SAC_ND_PRF_SYNCIN_NODESC( nt, sh)  NT_NAME( nt) = sl_getp( NT_NAME( sh));
#define SAC_ND_PRF_SYNCIN_DESC( nt, sh)  SAC_ND_PRF_SYNCIN_NODESC( nt, sh)  SAC_ND_A_DESC_NAME( nt) = sl_getp( SAC_ND_A_DESC_NAME( sh));
#define SAC_ND_PRF_SYNCOUT_NODESC( nt, sh)  sl_setp( NT_NAME( sh), NT_NAME( nt));
#if SVP_HAS_SEP
#define SAC_MUTC_MEMORY_WRITE_BARRIER  {__asm__ __volatile__("wmb # memory barrier" ::: "memory");}
#else
#define SAC_MUTC_MEMORY_WRITE_BARRIER
#endif
#define SAC_ND_PRF_SYNCOUT_DESC( nt, sh)  SAC_MUTC_MEMORY_WRITE_BARRIER  SAC_ND_PRF_SYNCOUT_NODESC( nt, sh)  sl_setp( SAC_ND_A_DESC_NAME( sh), SAC_ND_A_DESC_NAME( nt));
#define SAC_MUTC_ND_PARAM_INT_GLO(t, name, nt) sl_glparm_mutable( t, name)
#define SAC_MUTC_ND_PARAM_FLO_GLO(t, name, nt) sl_glfparm_mutable( t, name)
#define SAC_MUTC_ND_PARAM_INT_SHA(t, name, nt) sl_shparm( t, name)
#define SAC_MUTC_ND_PARAM_FLO_SHA(t, name, nt) sl_shfparm( t, name)
#if SAC_MUTC_FUNAP_AS_CREATE
#define SAC_MUTC_PARAM_FUN(t, name, nt) SAC_MUTC_PARAM_THREAD(t, name,nt)
#else
#define SAC_MUTC_PARAM_FUN(t, name, nt) t name
#endif
#define SAC_MUTC_ND_ARG_INT_GLO(name, nt, t)  sl_glarg( t, sl_anon, name)
#define SAC_MUTC_ND_ARG_FLO_GLO(name, nt, t)  sl_glfarg( t, sl_anon, name)
#define SAC_MUTC_ND_ARG_INT_SHA(name, nt, t)  sl_sharg( t, sh1, name)
#define SAC_MUTC_ND_ARG_FLO_SHA(name, nt, t)  sl_shfarg( t, sh1, name)
#define SAC_MUTC_ARG_SHA( tag, type, name1, name2)  CAT0( CAT1( sl_sh, tag), arg)( type, name1, name2)
#define SAC_MUTC_ARG_SHA_DESC( nt)  SAC_MUTC_ARG_SHA( , SAC_ND_DESC_TYPE( nt),  CAT0( SAC_ND_A_DESC_NAME( nt), _sh),  SAC_ND_A_DESC_NAME(nt)) 
#define SAC_MUTC_ARG_SHA_NAME( tag, nt, t)  SAC_MUTC_ARG_SHA( tag, SAC_ND_TYPE( nt, t),  CAT0( SAC_ND_A_FIELD( nt), _sh),  SAC_ND_A_FIELD(nt)) 
#define SAC_MUTC_ARG_SHARED_DESC_INT( nt, t)  SAC_MUTC_ARG_SHA_NAME( , nt, t), SAC_MUTC_ARG_SHA_DESC( nt)
#define SAC_MUTC_ARG_SHARED_DESC_FLO( nt, t)  SAC_MUTC_ARG_SHA_NAME( f, nt, t), SAC_MUTC_ARG_SHA_DESC( nt)
#define SAC_MUTC_ARG_SHARED_NODESC_INT( nt, t)  SAC_MUTC_ARG_SHA_NAME( , nt, t)
#define SAC_MUTC_ARG_SHARED_NODESC_FLO( nt, t)  SAC_MUTC_ARG_SHA_NAME( f, nt, t)
#define SAC_ND_ARG_shared( nt, t)  SAC_MUTC_ARG_SHARED( nt, t)
#if SAC_MUTC_FUNAP_AS_CREATE
#define SAC_MUTC_ARG_FUN(name, nt, t) SAC_MUTC_ARG_THREAD(name, nt, t)
#else
#define SAC_MUTC_ARG_FUN(name, nt, t) name
#endif
#undef SAC_ND_REAL_PARAM
#define SAC_ND_REAL_PARAM( type, name, nt) SAC_MUTC_PARAM( type, name, nt)
#undef SAC_ND_REAL_ARG
#define SAC_ND_REAL_ARG( name, nt, type) SAC_MUTC_ARG( name, nt, type)
#undef SAC_ND_REAL_ARG_out
#define SAC_ND_REAL_ARG_out( name, nt, type) SAC_MUTC_ARG_out( name, nt, type)
#if SAC_MUTC_FUNAP_AS_CREATE
#undef SAC_ND_FUNAP2
#define SAC_ND_FUNAP2(name, ...) SAC_MUTC_THREAD_FUNAP( name, __VA_ARGS__);
#endif 
#define SAC_MUTC_THREAD_FUNAP( name, ...) sl_proccall(name, __VA_ARGS__);
#define SAC_MUTC_GETVAR( var_NT, name) name
#define SAC_MUTC_GETTHREADPAR( var_NT, name) sl_getp( name)
#if SAC_MUTC_FUNAP_AS_CREATE
#define SAC_MUTC_GETFUNPAR( var_NT, name) SAC_MUTC_GETTHREADPAR( var_NT, name)
#else
#define SAC_MUTC_GETFUNPAR( var_NT, name) name
#endif
#undef SAC_INIT_LOCAL_MEM
#undef SAC_CLEANUP_LOCAL_MEM
#define SAC_INIT_LOCAL_MEM() SAC_MUTC_THREAD_INIT_MALLOC
#define SAC_CLEANUP_LOCAL_MEM() SAC_MUTC_THREAD_CLEANUP_MALLOC
#if SAC_MUTC_FUNAP_AS_CREATE
#undef SAC_ND_FUN_DEF_END2
#define SAC_ND_FUN_DEF_END2() SAC_MUTC_THREADFUN_DEF_END()
#else 
#endif 
#if SAC_MUTC_FUNAP_AS_CREATE
#undef SAC_ND_DECL_FUN2
#define SAC_ND_DECL_FUN2(name, type, ...)  SAC_MUTC_DECL_FUN2_##type(name, type, __VA_ARGS__)
#define SAC_MUTC_DECL_FUN2_void(name, type, ...)  SAC_MUTC_DECL_THREADFUN2(name, type, __VA_ARGS__)
#endif 
#if SAC_MUTC_FUNAP_AS_CREATE
#undef SAC_ND_DEF_FUN_BEGIN2
#define SAC_ND_DEF_FUN_BEGIN2(name, type, ...)  SAC_MUTC_DEF_FUN_BEGIN2_##type(name, type, __VA_ARGS__)
#define SAC_MUTC_DEF_FUN_BEGIN2_void(name, type, ...)  SAC_MUTC_DEF_THREADFUN_BEGIN2(name, type, __VA_ARGS__)
#endif 
#define SAC_MUTC_LOCAL_ALLOC__DESC__NOOP( var_NT, dim) SAC_NOOP()
#define SAC_MUTC_LOCAL_ALLOC__DESC__FIXED( var_NT, dim) {  SAC_ASSURE_TYPE( (dim == SAC_ND_A_MIRROR_DIM( var_NT)),  ("Inconsistant dimension for array %s found!",  NT_STR( var_NT)));  SAC_MUTC_LOCAL_MALLOC( SAC_ND_A_DESC( var_NT),  BYTE_SIZE_OF_DESC( dim),  SAC_ND_DESC_TYPE( var_NT))  SAC_TR_MEM_PRINT( ("ND_ALLOC__DESC( %s, %s) at addr: %p",  NT_STR( var_NT), #dim, SAC_ND_A_DESC( var_NT))) }
#define SAC_MUTC_LOCAL_ALLOC__DESC__AUD( var_NT, dim) {  SAC_ASSURE_TYPE( (dim >= 0),  ("Illegal dimension for array %s found!",  NT_STR( var_NT)));  SAC_MUTC_LOCAL_MALLOC(  SAC_ND_A_DESC( var_NT), BYTE_SIZE_OF_DESC( dim), int)  SAC_TR_MEM_PRINT( ("ND_ALLOC__DESC( %s, %s) at addr: %p",  NT_STR( var_NT), #dim, SAC_ND_A_DESC( var_NT)))  SAC_ND_A_DESC_DIM( var_NT) = SAC_ND_A_MIRROR_DIM( var_NT) = dim; }
#if SAC_MUTC_DISABLE_THREAD_MEM
#define SAC_MUTC_THREAD_INIT_MALLOC 
#define SAC_MUTC_THREAD_CLEANUP_MALLOC 
#define SAC_MUTC_LOCAL_MALLOC( var, size, basetype) var = (basetype)malloc( size);
#else
#define SAC_MUTC_THREAD_INIT_MALLOC
#define SAC_MUTC_THREAD_CLEANUP_MALLOC 
#define SAC_MUTC_LOCAL_MALLOC( var, size, basetype) var = (basetype)tls_malloc( size);
#endif
#if SAC_MUTC_THREAD_MALLOC
#ifdef SAC_HM_MALLOC
#undef SAC_HM_MALLOC
#endif
#define SAC_HM_MALLOC( var, size, basetype)SAC_MUTC_LOCAL_MALLOC( var, size, basetype)
#ifdef SAC_HM_FREE
#undef SAC_HM_FREE
#endif
#define SAC_HM_FREE( var) free( var)
#endif 
#if 0
#define SAC_MUTC_THREAD_INIT SAC_MUTC_THREAD_INIT_MALLOC
#define SAC_MUTC_THREAD_CLEANUP SAC_MUTC_THREAD_CLEANUP_MALLOC
#else
#define SAC_MUTC_THREAD_INIT 
#define SAC_MUTC_THREAD_CLEANUP 
#endif
#define SAC_MUTC_INIT_SUBALLOC_DESC_DO( var_NT)  SAC_ND_A_DESC_NAME( var_NT) = sl_getp( SAC_ND_A_DESC_NAME( var_NT));
#define SAC_MUTC_SPAWN_AP( syncid, place, name, ...) sl_spawn(NT_NAME(syncid),place,,,,, SAC_MUTC_FORCE_SPAWN_FLAGS, name, __VA_ARGS__);
#define SAC_MUTC_DECL_SYNCVAR( syncid) sl_spawndecl( syncid);
#define SAC_MUTC_SPAWNFUN_DECL2(...) sl_decl( __VA_ARGS__)
#define SAC_MUTC_DEF_SPAWNFUN_BEGIN2(name, anon, ...)  sl_def(name, void, __VA_ARGS__) {  SAC_MUTC_THREAD_INIT
#define SAC_MUTC_SPAWNFUN_DEF_END(...)  SAC_MUTC_THREAD_CLEANUP  } sl_enddef
#define SAC_MUTC_SPAWNSYNC(syncid) sl_spawnsync(NT_NAME( syncid));
#endif 
#undef MUTC
#endif 
#define SAC_MUTC_WORLD_OBJECT int SAC__MUTC_IO__dummy_value_which_is_completely_useless = 0; SAC_ND_DECL__DATA( (SACo_MutcIO__mutcWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, ) SAC_ND_DECL__DESC( (SACo_MutcIO__mutcWorld, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), ) SAC_NOTHING() SAC_MUTC_DEF_THREADFUN_BEGIN2(SACf_MutcIO__to_MUTC_IO__i,,  SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (TPA, ))))))), int),  SAC_ND_PARAM_in( (SACl_from, (SCL, (NHD, (NUQ, (INT, (GLO, (TPA, ))))))), int)) {  SAC_NOTHING()  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ, (INT, (GLO, (TPA, ))))))), (SACl_from, (SCL, (NHD, (NUQ, (INT, (GLO, (TPA, ))))))))  return; } SAC_MUTC_THREADFUN_DEF_END(SACf_MutcIO__to_MUTC_IO__i) SAC_MUTC_DEF_THREADFUN_BEGIN2(SACf_MutcIO_CL_INIT__init_mutcWorld__SACt_MutcIO__MutcIO,,  SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (TPO, ))))))), int)) {  SAC_ND_DECL__DATA( (SACp_emal_2726__isaa_1643__OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )  SAC_ND_DECL__DESC( (SACp_emal_2726__isaa_1643__OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )  SAC_NOTHING()  SAC_ND_DECL__DATA( (SACp_OI_object__SSA0_1, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), int, )  SAC_ND_DECL__DESC( (SACp_OI_object__SSA0_1, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )  SAC_NOTHING()  SAC_ND_DECL_PARAM_inout((SACp_OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (TPO, ))))))), int)  SAC_NOTHING()  SAC_ND_ALLOC_BEGIN((SACp_emal_2726__isaa_1643__OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, int)  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_2726__isaa_1643__OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, )))))))) == 0), 9,  "Assignment with incompatible types found!");  SAC_NOOP()  SAC_ND_ALLOC_END((SACp_emal_2726__isaa_1643__OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 1, 0, int)  SAC_ND_CREATE__SCALAR__DATA((SACp_emal_2726__isaa_1643__OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), 0)  SAC_MUTC_THREAD_FUNAP(SACf_MutcIO__to_MUTC_IO__i,  SAC_ND_ARG_out( (SACp_OI_object__SSA0_1, (SCL, (NHD, (NUQ, (INT, (GLO, (TAG, ))))))), int),  SAC_ND_ARG_in( (SACp_emal_2726__isaa_1643__OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (TAG, ))))))), int))  SAC_NOOP()  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (TPO, )))))))) == 0), 9,  "Assignment with incompatible types found!");  SAC_NOOP()  SAC_NOOP()  SAC_NOOP()  SAC_ND_ASSIGN__DATA( (SACp_OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (TPO, ))))))),  (SACp_OI_object__SSA0_1, (SCL, (NHD, (NUQ, (INT, (GLO, (NON, ))))))), )  SAC_ND_RET_inout( (SACp_OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (TPO, ))))))),  (SACp_OI_object, (SCL, (NHD, (NUQ, (INT, (GLO, (TPO, ))))))))  return; } SAC_MUTC_THREADFUN_DEF_END(SACf_MutcIO_CL_INIT__init_mutcWorld__SACt_MutcIO__MutcIO) 


#ifndef DEF_FILE_mutc_gen
#define DEF_FILE_mutc_gen

#define SAC_MUTC_INIT_SUBALLOC_DESC( nt ) CAT_M4_mutc_gen_1(SAC_MUTC_INIT_SUBALLOC_DESC_, NT_SHP(nt))( nt )
#define SAC_MUTC_INIT_SUBALLOC_DESC_SCL(...) SAC_NOP(__VA_ARGS__)
#define SAC_MUTC_INIT_SUBALLOC_DESC_AKS(...) SAC_NOP(__VA_ARGS__)
#define SAC_MUTC_INIT_SUBALLOC_DESC_AKD(...) SAC_MUTC_INIT_SUBALLOC_DESC_DO(__VA_ARGS__)
#define SAC_MUTC_INIT_SUBALLOC_DESC_AUD(...) SAC_MUTC_INIT_SUBALLOC_DESC_DO(__VA_ARGS__)
#define SAC_MUTC_INIT_SUBALLOC_DESC____(...) SAC_MUTC_INIT_SUBALLOC_DESC_DO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD( arg1, nt , gra1) CAT_M4_mutc_gen_2(SAC_MUTC_ARG_THREAD_, CAT_M4_mutc_gen_3(NT_REG(nt), CAT_M4_mutc_gen_4(NT_SCO(nt), NT_SHP(nt))))( arg1, nt , gra1)
#define SAC_MUTC_ARG_THREAD_INTGLOSCL(...) SAC_MUTC_ND_ARG_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_INTGLOAKS(...) SAC_MUTC_ND_ARG_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_INTGLOAKD(...) SAC_MUTC_ND_ARG_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_INTGLOAUD(...) SAC_MUTC_ND_ARG_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_INTGLO___(...) SAC_MUTC_ND_ARG_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_FLOGLOSCL(...) SAC_MUTC_ND_ARG_FLO_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_FLOGLOAKS(...) SAC_MUTC_ND_ARG_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_FLOGLOAKD(...) SAC_MUTC_ND_ARG_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_FLOGLOAUD(...) SAC_MUTC_ND_ARG_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_FLOGLO___(...) SAC_MUTC_ND_ARG_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_INTSHASCL(...) SAC_MUTC_ND_ARG_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_INTSHAAKS(...) SAC_MUTC_ND_ARG_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_INTSHAAKD(...) SAC_MUTC_ND_ARG_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_INTSHAAUD(...) SAC_MUTC_ND_ARG_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_INTSHA___(...) SAC_MUTC_ND_ARG_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_FLOSHASCL(...) SAC_MUTC_ND_ARG_FLO_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_FLOSHAAKS(...) SAC_MUTC_ND_ARG_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_FLOSHAAKD(...) SAC_MUTC_ND_ARG_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_FLOSHAAUD(...) SAC_MUTC_ND_ARG_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_FLOSHA___(...) SAC_MUTC_ND_ARG_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_out( arg1, nt , gra1) CAT_M4_mutc_gen_5(SAC_MUTC_ARG_THREAD_out_, NT_SCO(nt))( arg1, nt , gra1)
#define SAC_MUTC_ARG_THREAD_out_GLO(...) SAC_MUTC_ND_ARG_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_ARG_THREAD_out_SHA(...) SAC_MUTC_ND_ARG_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_ARG( arg1, nt , gra1) CAT_M4_mutc_gen_6(SAC_MUTC_ARG_, NT_USG(nt))( arg1, nt , gra1)
#define SAC_MUTC_ARG_FAG(...) SAC_MUTC_ARG_FUN(__VA_ARGS__)
#define SAC_MUTC_ARG_FPA(...) SAC_MUTC_ARG_FUN(__VA_ARGS__)
#define SAC_MUTC_ARG_FTA(...) SAC_MUTC_ARG_FUN(__VA_ARGS__)
#define SAC_MUTC_ARG_TPM(...) SAC_MUTC_ARG_THREAD(__VA_ARGS__)
#define SAC_MUTC_ARG_TPA(...) SAC_MUTC_ARG_THREAD(__VA_ARGS__)
#define SAC_MUTC_ARG_TAG(...) SAC_MUTC_ARG_THREAD(__VA_ARGS__)
#define SAC_MUTC_ARG_TPO(...) SAC_MUTC_ARG_THREAD(__VA_ARGS__)
#define SAC_MUTC_ARG_FPM(...) SAC_MUTC_ARG_THREAD(__VA_ARGS__)
#define SAC_MUTC_ARG_FPO(...) SAC_MUTC_ARG_THREAD(__VA_ARGS__)
#define SAC_MUTC_ARG_NON(...) SAC_MUTC_ARG_THREAD(__VA_ARGS__)
#define SAC_MUTC_ARG____(...) SAC_MUTC_ARG_THREAD(__VA_ARGS__)
#define SAC_MUTC_ARG_out( arg1, nt , gra1) CAT_M4_mutc_gen_7(SAC_MUTC_ARG_out_, NT_USG(nt))( arg1, nt , gra1)
#define SAC_MUTC_ARG_out_FAG(...) SAC_MUTC_ARG_FUN(__VA_ARGS__)
#define SAC_MUTC_ARG_out_FPA(...) SAC_MUTC_ARG_FUN(__VA_ARGS__)
#define SAC_MUTC_ARG_out_FTA(...) SAC_MUTC_ARG_FUN(__VA_ARGS__)
#define SAC_MUTC_ARG_out_TPM(...) SAC_MUTC_ARG_THREAD_out(__VA_ARGS__)
#define SAC_MUTC_ARG_out_TPA(...) SAC_MUTC_ARG_THREAD_out(__VA_ARGS__)
#define SAC_MUTC_ARG_out_TAG(...) SAC_MUTC_ARG_THREAD_out(__VA_ARGS__)
#define SAC_MUTC_ARG_out_TPO(...) SAC_MUTC_ARG_THREAD_out(__VA_ARGS__)
#define SAC_MUTC_ARG_out_FPM(...) SAC_MUTC_ARG_THREAD_out(__VA_ARGS__)
#define SAC_MUTC_ARG_out_FPO(...) SAC_MUTC_ARG_THREAD_out(__VA_ARGS__)
#define SAC_MUTC_ARG_out_NON(...) SAC_MUTC_ARG_THREAD_out(__VA_ARGS__)
#define SAC_MUTC_ARG_out____(...) SAC_MUTC_ARG_THREAD_out(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED( nt , gra1) CAT_M4_mutc_gen_8(SAC_MUTC_ARG_SHARED_, CAT_M4_mutc_gen_9(NT_SHP(nt), CAT_M4_mutc_gen_10(NT_HID(nt), CAT_M4_mutc_gen_11(NT_UNQ(nt), NT_REG(nt)))))( nt , gra1)
#define SAC_MUTC_ARG_SHARED_SCLNHDNUQINT(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLNHDUNQINT(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLNHD___INT(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHIDNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHIDUNQINT(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHNSUNQINT(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCL___UNQINT(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSNHDUNQINT(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHIDUNQINT(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHNSUNQINT(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKS___UNQINT(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHID___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHNSNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHNS___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCL___NUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCL______INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSNHDNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSNHD___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHIDNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHID___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHNSNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHNS___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKS___NUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKS______INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDNHDNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDNHDUNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDNHD___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHIDNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHIDUNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHID___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHNSNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHNSUNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHNS___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKD___NUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKD___UNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKD______INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDNHDNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDNHDUNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDNHD___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHIDNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHIDUNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHID___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHNSNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHNSUNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHNS___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUD___NUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUD___UNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUD______INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____NHDNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____NHDUNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____NHD___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HIDNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HIDUNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HID___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HNSNUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HNSUNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HNS___INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_______NUQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_______UNQINT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED__________INT(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLNHDNUQFLO(...) SAC_MUTC_ARG_SHARED_NODESC_FLO(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLNHDUNQFLO(...) SAC_MUTC_ARG_SHARED_NODESC_FLO(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLNHD___FLO(...) SAC_MUTC_ARG_SHARED_NODESC_FLO(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHIDNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHIDUNQFLO(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHNSUNQFLO(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCL___UNQFLO(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSNHDUNQFLO(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHIDUNQFLO(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHNSUNQFLO(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKS___UNQFLO(...) SAC_MUTC_ARG_SHARED_NODESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHID___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHNSNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCLHNS___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCL___NUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_SCL______FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSNHDNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSNHD___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHIDNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHID___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHNSNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKSHNS___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKS___NUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKS______FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDNHDNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDNHDUNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDNHD___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHIDNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHIDUNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHID___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHNSNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHNSUNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKDHNS___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKD___NUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKD___UNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AKD______FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDNHDNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDNHDUNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDNHD___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHIDNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHIDUNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHID___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHNSNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHNSUNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUDHNS___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUD___NUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUD___UNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_AUD______FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____NHDNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____NHDUNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____NHD___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HIDNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HIDUNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HID___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HNSNUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HNSUNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED____HNS___FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_______NUQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED_______UNQFLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_ARG_SHARED__________FLO(...) SAC_MUTC_ARG_SHARED_DESC_INT(__VA_ARGS__)
#define SAC_MUTC_PARAM( arg1, arg2, nt ) CAT_M4_mutc_gen_12(SAC_MUTC_PARAM_, NT_USG(nt))( arg1, arg2, nt )
#define SAC_MUTC_PARAM_TPA(...) SAC_MUTC_PARAM_THREAD(__VA_ARGS__)
#define SAC_MUTC_PARAM_TPM(...) SAC_MUTC_PARAM_THREAD(__VA_ARGS__)
#define SAC_MUTC_PARAM_TPO(...) SAC_MUTC_PARAM_THREAD(__VA_ARGS__)
#define SAC_MUTC_PARAM_TAG(...) SAC_MUTC_PARAM_FUN(__VA_ARGS__)
#define SAC_MUTC_PARAM_FTA(...) SAC_MUTC_PARAM_FUN(__VA_ARGS__)
#define SAC_MUTC_PARAM_FPM(...) SAC_MUTC_PARAM_FUN(__VA_ARGS__)
#define SAC_MUTC_PARAM_FPA(...) SAC_MUTC_PARAM_FUN(__VA_ARGS__)
#define SAC_MUTC_PARAM_FPO(...) SAC_MUTC_PARAM_FUN(__VA_ARGS__)
#define SAC_MUTC_PARAM_FAG(...) SAC_MUTC_PARAM_FUN(__VA_ARGS__)
#define SAC_MUTC_PARAM_NON(...) SAC_MUTC_PARAM_FUN(__VA_ARGS__)
#define SAC_MUTC_PARAM____(...) SAC_MUTC_PARAM_FUN(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD( arg1, arg2, nt ) CAT_M4_mutc_gen_13(SAC_MUTC_PARAM_THREAD_, CAT_M4_mutc_gen_14(NT_REG(nt), CAT_M4_mutc_gen_15(NT_SCO(nt), NT_SHP(nt))))( arg1, arg2, nt )
#define SAC_MUTC_PARAM_THREAD_INTGLOSCL(...) SAC_MUTC_ND_PARAM_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_INTGLOAKS(...) SAC_MUTC_ND_PARAM_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_INTGLOAKD(...) SAC_MUTC_ND_PARAM_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_INTGLOAUD(...) SAC_MUTC_ND_PARAM_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_INTGLO___(...) SAC_MUTC_ND_PARAM_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_FLOGLOSCL(...) SAC_MUTC_ND_PARAM_FLO_GLO(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_FLOGLOAKS(...) SAC_MUTC_ND_PARAM_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_FLOGLOAKD(...) SAC_MUTC_ND_PARAM_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_FLOGLOAUD(...) SAC_MUTC_ND_PARAM_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_FLOGLO___(...) SAC_MUTC_ND_PARAM_INT_GLO(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_INTSHASCL(...) SAC_MUTC_ND_PARAM_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_INTSHAAKS(...) SAC_MUTC_ND_PARAM_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_INTSHAAKD(...) SAC_MUTC_ND_PARAM_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_INTSHAAUD(...) SAC_MUTC_ND_PARAM_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_INTSHA___(...) SAC_MUTC_ND_PARAM_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_FLOSHASCL(...) SAC_MUTC_ND_PARAM_FLO_SHA(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_FLOSHAAKS(...) SAC_MUTC_ND_PARAM_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_FLOSHAAKD(...) SAC_MUTC_ND_PARAM_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_FLOSHAAUD(...) SAC_MUTC_ND_PARAM_INT_SHA(__VA_ARGS__)
#define SAC_MUTC_PARAM_THREAD_FLOSHA___(...) SAC_MUTC_ND_PARAM_INT_SHA(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN( arg1, nt ) CAT_M4_mutc_gen_16(SAC_ND_PRF_SYNCIN_, CAT_M4_mutc_gen_17(NT_SHP(nt), CAT_M4_mutc_gen_18(NT_HID(nt), NT_UNQ(nt))))( arg1, nt )
#define SAC_ND_PRF_SYNCIN_SCLNHDNUQ(...) SAC_ND_PRF_SYNCIN_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCLNHDUNQ(...) SAC_ND_PRF_SYNCIN_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCLNHD___(...) SAC_ND_PRF_SYNCIN_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCLHIDUNQ(...) SAC_ND_PRF_SYNCIN_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCLHNSUNQ(...) SAC_ND_PRF_SYNCIN_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCL___UNQ(...) SAC_ND_PRF_SYNCIN_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKSNHDUNQ(...) SAC_ND_PRF_SYNCIN_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKSHIDUNQ(...) SAC_ND_PRF_SYNCIN_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKSHNSUNQ(...) SAC_ND_PRF_SYNCIN_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKS___UNQ(...) SAC_ND_PRF_SYNCIN_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCLHIDNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCLHID___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCLHNSNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCLHNS___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCL___NUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_SCL______(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKSNHDNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKSNHD___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKSHIDNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKSHID___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKSHNSNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKSHNS___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKS___NUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKS______(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKDNHDNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKDNHDUNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKDNHD___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKDHIDNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKDHIDUNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKDHID___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKDHNSNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKDHNSUNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKDHNS___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKD___NUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKD___UNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AKD______(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUDNHDNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUDNHDUNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUDNHD___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUDHIDNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUDHIDUNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUDHID___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUDHNSNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUDHNSUNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUDHNS___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUD___NUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUD___UNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_AUD______(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN____NHDNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN____NHDUNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN____NHD___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN____HIDNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN____HIDUNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN____HID___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN____HNSNUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN____HNSUNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN____HNS___(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_______NUQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN_______UNQ(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCIN__________(...) SAC_ND_PRF_SYNCIN_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT( arg1, nt ) CAT_M4_mutc_gen_19(SAC_ND_PRF_SYNCOUT_, CAT_M4_mutc_gen_20(NT_SHP(nt), CAT_M4_mutc_gen_21(NT_HID(nt), NT_UNQ(nt))))( arg1, nt )
#define SAC_ND_PRF_SYNCOUT_SCLNHDNUQ(...) SAC_ND_PRF_SYNCOUT_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCLNHDUNQ(...) SAC_ND_PRF_SYNCOUT_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCLNHD___(...) SAC_ND_PRF_SYNCOUT_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCLHIDUNQ(...) SAC_ND_PRF_SYNCOUT_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCLHNSUNQ(...) SAC_ND_PRF_SYNCOUT_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCL___UNQ(...) SAC_ND_PRF_SYNCOUT_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKSNHDUNQ(...) SAC_ND_PRF_SYNCOUT_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKSHIDUNQ(...) SAC_ND_PRF_SYNCOUT_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKSHNSUNQ(...) SAC_ND_PRF_SYNCOUT_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKS___UNQ(...) SAC_ND_PRF_SYNCOUT_NODESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCLHIDNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCLHID___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCLHNSNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCLHNS___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCL___NUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_SCL______(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKSNHDNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKSNHD___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKSHIDNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKSHID___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKSHNSNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKSHNS___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKS___NUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKS______(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKDNHDNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKDNHDUNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKDNHD___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKDHIDNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKDHIDUNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKDHID___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKDHNSNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKDHNSUNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKDHNS___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKD___NUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKD___UNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AKD______(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUDNHDNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUDNHDUNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUDNHD___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUDHIDNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUDHIDUNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUDHID___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUDHNSNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUDHNSUNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUDHNS___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUD___NUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUD___UNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_AUD______(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT____NHDNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT____NHDUNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT____NHD___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT____HIDNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT____HIDUNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT____HID___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT____HNSNUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT____HNSUNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT____HNS___(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_______NUQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT_______UNQ(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_ND_PRF_SYNCOUT__________(...) SAC_ND_PRF_SYNCOUT_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE( nt ) CAT_M4_mutc_gen_22(SAC_MUTC_SAVE_, CAT_M4_mutc_gen_23(NT_SHP(nt), CAT_M4_mutc_gen_24(NT_HID(nt), NT_UNQ(nt))))( nt )
#define SAC_MUTC_SAVE_SCLNHDNUQ(...) SAC_MUTC_SAVE_NODESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCLNHDUNQ(...) SAC_MUTC_SAVE_NODESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCLNHD___(...) SAC_MUTC_SAVE_NODESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCLHIDUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCLHNSUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCL___UNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKSNHDUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKSHIDUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKSHNSUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKS___UNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCLHIDNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCLHID___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCLHNSNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCLHNS___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCL___NUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_SCL______(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKSNHDNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKSNHD___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKSHIDNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKSHID___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKSHNSNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKSHNS___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKS___NUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKS______(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKDNHDNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKDNHDUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKDNHD___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKDHIDNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKDHIDUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKDHID___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKDHNSNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKDHNSUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKDHNS___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKD___NUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKD___UNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AKD______(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUDNHDNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUDNHDUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUDNHD___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUDHIDNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUDHIDUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUDHID___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUDHNSNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUDHNSUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUDHNS___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUD___NUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUD___UNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_AUD______(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE____NHDNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE____NHDUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE____NHD___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE____HIDNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE____HIDUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE____HID___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE____HNSNUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE____HNSUNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE____HNS___(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_______NUQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE_______UNQ(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_SAVE__________(...) SAC_MUTC_SAVE_DESC(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC( nt , gra1) CAT_M4_mutc_gen_25(SAC_MUTC_LOCAL_ALLOC__DESC_, CAT_M4_mutc_gen_26(NT_SHP(nt), CAT_M4_mutc_gen_27(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCLNHDNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCLNHDUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCLNHD___(...) SAC_MUTC_LOCAL_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCLHIDUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCLHNSUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCL___UNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKSNHDUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKSHIDUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKSHNSUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKS___UNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__NOOP(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUDNHDNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUDNHDUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUDNHD___(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUDHIDNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUDHIDUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUDHID___(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUDHNSNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUDHNSUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUDHNS___(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUD___NUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUD___UNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AUD______(...) SAC_MUTC_LOCAL_ALLOC__DESC__AUD(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCLHIDNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCLHID___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCLHNSNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCLHNS___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCL___NUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_SCL______(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKSNHDNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKSNHD___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKSHIDNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKSHID___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKSHNSNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKSHNS___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKS___NUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKS______(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKDNHDNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKDNHDUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKDNHD___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKDHIDNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKDHIDUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKDHID___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKDHNSNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKDHNSUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKDHNS___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKD___NUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKD___UNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_AKD______(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC____NHDNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC____NHDUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC____NHD___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC____HIDNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC____HIDUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC____HID___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC____HNSNUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC____HNSUNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC____HNS___(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_______NUQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC_______UNQ(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define SAC_MUTC_LOCAL_ALLOC__DESC__________(...) SAC_MUTC_LOCAL_ALLOC__DESC__FIXED(__VA_ARGS__)
#define MUTC 1
#ifdef SAC_BACKEND_MUTC
#define SAC_MUTC_C_GETVAR( ...) SAC_ND_GETVAR( __VA_ARGS__)
#undef SAC_ND_GETVAR
#define SAC_ND_GETVAR( nt , gra1) CAT_M4_mutc_gen_28(SAC_ND_GETVAR_, NT_USG(nt))( nt , gra1)
#define SAC_ND_GETVAR_FPA(...) SAC_MUTC_GETFUNPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_FPM(...) SAC_MUTC_GETFUNPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_FTA(...) SAC_MUTC_GETTHREADPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_TPA(...) SAC_MUTC_GETTHREADPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_TPM(...) SAC_MUTC_GETTHREADPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_TAG(...) SAC_MUTC_GETVAR(__VA_ARGS__)
#define SAC_ND_GETVAR_TPO(...) SAC_MUTC_GETVAR(__VA_ARGS__)
#define SAC_ND_GETVAR_FPO(...) SAC_MUTC_GETVAR(__VA_ARGS__)
#define SAC_ND_GETVAR_FAG(...) SAC_MUTC_GETVAR(__VA_ARGS__)
#define SAC_ND_GETVAR_NON(...) SAC_MUTC_GETVAR(__VA_ARGS__)
#define SAC_ND_GETVAR____(...) SAC_MUTC_GETVAR(__VA_ARGS__)
#undef SAC_ND_GETVAR_INOUT
#define SAC_ND_GETVAR_INOUT( nt , gra1) CAT_M4_mutc_gen_29(SAC_ND_GETVAR_INOUT_, NT_USG(nt))( nt , gra1)
#define SAC_ND_GETVAR_INOUT_FPA(...) SAC_MUTC_GETFUNPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_INOUT_FPM(...) SAC_MUTC_GETFUNPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_INOUT_FPO(...) SAC_MUTC_GETFUNPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_INOUT_FTA(...) SAC_MUTC_GETFUNPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_INOUT_TPA(...) SAC_MUTC_GETTHREADPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_INOUT_TPM(...) SAC_MUTC_GETTHREADPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_INOUT_TPO(...) SAC_MUTC_GETTHREADPAR(__VA_ARGS__)
#define SAC_ND_GETVAR_INOUT_TAG(...) SAC_MUTC_GETVAR(__VA_ARGS__)
#define SAC_ND_GETVAR_INOUT_FAG(...) SAC_MUTC_GETVAR(__VA_ARGS__)
#define SAC_ND_GETVAR_INOUT_NON(...) SAC_MUTC_GETVAR(__VA_ARGS__)
#define SAC_ND_GETVAR_INOUT____(...) SAC_MUTC_GETVAR(__VA_ARGS__)
#endif 
#undef MUTC
#define CAT_M4_mutc_gen_29(x, y) xCAT_M4_mutc_gen_29(x, y)
#define xCAT_M4_mutc_gen_29(x, y) x##y
#define CAT_M4_mutc_gen_28(x, y) xCAT_M4_mutc_gen_28(x, y)
#define xCAT_M4_mutc_gen_28(x, y) x##y
#define CAT_M4_mutc_gen_27(x, y) xCAT_M4_mutc_gen_27(x, y)
#define xCAT_M4_mutc_gen_27(x, y) x##y
#define CAT_M4_mutc_gen_26(x, y) xCAT_M4_mutc_gen_26(x, y)
#define xCAT_M4_mutc_gen_26(x, y) x##y
#define CAT_M4_mutc_gen_25(x, y) xCAT_M4_mutc_gen_25(x, y)
#define xCAT_M4_mutc_gen_25(x, y) x##y
#define CAT_M4_mutc_gen_24(x, y) xCAT_M4_mutc_gen_24(x, y)
#define xCAT_M4_mutc_gen_24(x, y) x##y
#define CAT_M4_mutc_gen_23(x, y) xCAT_M4_mutc_gen_23(x, y)
#define xCAT_M4_mutc_gen_23(x, y) x##y
#define CAT_M4_mutc_gen_22(x, y) xCAT_M4_mutc_gen_22(x, y)
#define xCAT_M4_mutc_gen_22(x, y) x##y
#define CAT_M4_mutc_gen_21(x, y) xCAT_M4_mutc_gen_21(x, y)
#define xCAT_M4_mutc_gen_21(x, y) x##y
#define CAT_M4_mutc_gen_20(x, y) xCAT_M4_mutc_gen_20(x, y)
#define xCAT_M4_mutc_gen_20(x, y) x##y
#define CAT_M4_mutc_gen_19(x, y) xCAT_M4_mutc_gen_19(x, y)
#define xCAT_M4_mutc_gen_19(x, y) x##y
#define CAT_M4_mutc_gen_18(x, y) xCAT_M4_mutc_gen_18(x, y)
#define xCAT_M4_mutc_gen_18(x, y) x##y
#define CAT_M4_mutc_gen_17(x, y) xCAT_M4_mutc_gen_17(x, y)
#define xCAT_M4_mutc_gen_17(x, y) x##y
#define CAT_M4_mutc_gen_16(x, y) xCAT_M4_mutc_gen_16(x, y)
#define xCAT_M4_mutc_gen_16(x, y) x##y
#define CAT_M4_mutc_gen_15(x, y) xCAT_M4_mutc_gen_15(x, y)
#define xCAT_M4_mutc_gen_15(x, y) x##y
#define CAT_M4_mutc_gen_14(x, y) xCAT_M4_mutc_gen_14(x, y)
#define xCAT_M4_mutc_gen_14(x, y) x##y
#define CAT_M4_mutc_gen_13(x, y) xCAT_M4_mutc_gen_13(x, y)
#define xCAT_M4_mutc_gen_13(x, y) x##y
#define CAT_M4_mutc_gen_12(x, y) xCAT_M4_mutc_gen_12(x, y)
#define xCAT_M4_mutc_gen_12(x, y) x##y
#define CAT_M4_mutc_gen_11(x, y) xCAT_M4_mutc_gen_11(x, y)
#define xCAT_M4_mutc_gen_11(x, y) x##y
#define CAT_M4_mutc_gen_10(x, y) xCAT_M4_mutc_gen_10(x, y)
#define xCAT_M4_mutc_gen_10(x, y) x##y
#define CAT_M4_mutc_gen_9(x, y) xCAT_M4_mutc_gen_9(x, y)
#define xCAT_M4_mutc_gen_9(x, y) x##y
#define CAT_M4_mutc_gen_8(x, y) xCAT_M4_mutc_gen_8(x, y)
#define xCAT_M4_mutc_gen_8(x, y) x##y
#define CAT_M4_mutc_gen_7(x, y) xCAT_M4_mutc_gen_7(x, y)
#define xCAT_M4_mutc_gen_7(x, y) x##y
#define CAT_M4_mutc_gen_6(x, y) xCAT_M4_mutc_gen_6(x, y)
#define xCAT_M4_mutc_gen_6(x, y) x##y
#define CAT_M4_mutc_gen_5(x, y) xCAT_M4_mutc_gen_5(x, y)
#define xCAT_M4_mutc_gen_5(x, y) x##y
#define CAT_M4_mutc_gen_4(x, y) xCAT_M4_mutc_gen_4(x, y)
#define xCAT_M4_mutc_gen_4(x, y) x##y
#define CAT_M4_mutc_gen_3(x, y) xCAT_M4_mutc_gen_3(x, y)
#define xCAT_M4_mutc_gen_3(x, y) x##y
#define CAT_M4_mutc_gen_2(x, y) xCAT_M4_mutc_gen_2(x, y)
#define xCAT_M4_mutc_gen_2(x, y) x##y
#define CAT_M4_mutc_gen_1(x, y) xCAT_M4_mutc_gen_1(x, y)
#define xCAT_M4_mutc_gen_1(x, y) x##y
#endif
#define SAC_MUTC_TOSTRING
#if 0
#define SAC_MUTC_TOSTRING SAC_ND_DEF_FUN_BEGIN2( to_string,  void,  SAC_ND_PARAM_out( (out, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))), void *),  SAC_ND_PARAM_in( (ar, T_SHP(AUD, T_HID(NHD, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))), unsigned char),  SAC_ND_PARAM_in( (length, T_SHP(SCL, T_HID(NHD, T_UNQ(UNQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))), int)) {  SAC_ND_DECL__DESC( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY))))))), )  SAC_ND_DECL__DATA( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY))))))), void *, )  if ((SAC_ND_A_RC( (ar, T_SHP(AUD, T_HID(NHD, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY)))))))) == 1)  &&  (SAC_ND_READ( (ar, T_SHP(AUD, T_HID(NHD, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))),  SAC_ND_GETVAR( (length, T_SHP(SCL, T_HID(NHD, T_UNQ(UNQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))),  SAC_ND_A_FIELD( (length, T_SHP(SCL, T_HID(NHD, T_UNQ(UNQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY)))))))))) == '\0')){  SAC_ND_A_DESC( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY))))))))  = SAC_ND_A_DESC( (ar, T_SHP(AUD, T_HID(NHD, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))));  SAC_ND_GETVAR( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY))))))),  SAC_ND_A_FIELD( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY)))))))))  = SAC_ND_GETVAR( (ar, T_SHP(AUD, T_HID(NHD, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))),  SAC_ND_A_FIELD( (ar, T_SHP(AUD, T_HID(NHD, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY)))))))));  }  else {  SAC_ND_ALLOC__DESC( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY))))))), 0)  SAC_ND_SET__RC( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY))))))), 1)  SAC_HM_MALLOC(SAC_ND_A_FIELD( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY)))))))),  SAC_ND_GETVAR( (length, T_SHP(SCL, T_HID(NHD, T_UNQ(UNQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))),  SAC_ND_A_FIELD( (length, T_SHP(SCL, T_HID(NHD, T_UNQ(UNQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))))) + 1, void *);  strncpy( SAC_ND_GETVAR( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY))))))),  SAC_ND_A_FIELD( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY))))))))),  (char *)SAC_ND_GETVAR( (ar, T_SHP(AUD, T_HID(NHD, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))),  SAC_ND_A_FIELD( (ar, T_SHP(AUD, T_HID(NHD, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))))),  SAC_ND_GETVAR( (length, T_SHP(SCL, T_HID(NHD, T_UNQ(UNQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))),  SAC_ND_A_FIELD( (length, T_SHP(SCL, T_HID(NHD, T_UNQ(UNQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))))));  ((char *)SAC_ND_GETVAR( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY))))))),  SAC_ND_A_FIELD( (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY))))))))  ))[SAC_ND_GETVAR( (length, T_SHP(SCL, T_HID(NHD, T_UNQ(UNQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))),  SAC_ND_A_FIELD( (length, T_SHP(SCL, T_HID(NHD, T_UNQ(UNQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY)))))))))] = '\0';  SAC_ND_DEC_RC_FREE( (ar, T_SHP(AUD, T_HID(NHD, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))), 1, )  }  SAC_ND_RET_out( (out, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(FPA, T_EMPTY))))))),  (str, T_SHP(SCL, T_HID(HID, T_UNQ(NUQ, T_REG(INT, T_SCO(GLO, T_USG(NON, T_EMPTY)))))))) }SAC_ND_FUN_DEF_END2()
#endif
#define SAC_STRING2ARRAY( array, string_arg) {  int i=0, j=0;  char *string = string_arg;  while (string[j]!='\0') {  if (string[j]=='\\') {  switch (string[j+1])  {  case 'n':  array[i++]='\n';  j+=2;  break;  case 't':  array[i++]='\t';  j+=2;  break;  case 'v':  array[i++]='\v';  j+=2;  break;  case 'b':  array[i++]='\b';  j+=2;  break;  case 'r':  array[i++]='\r';  j+=2;  break;  case 'f':  array[i++]='\f';  j+=2;  break;  case 'a':  array[i++]='\a';  j+=2;  break;  case '"': array[i++]='"';  j+=2;  break;  default:  array[i++]='\\';  j+=1;  }  }  else {  array[i++]=string[j++];  }  }  array[i] = '\0'; }
#ifndef _SAC_MUTC_STARTUP_H_
#define _SAC_MUTC_STARTUP_H_
#if SAC_MUTC_RC_INDIRECT == 1
#define SAC_IF_MUTC_RC_INDIRECT(A) A
#define SAC_IF_NOT_MUTC_RC_INDIRECT(A) 
#else
#define SAC_IF_MUTC_RC_INDIRECT(A)
#define SAC_IF_NOT_MUTC_RC_INDIRECT(A) A
#endif
#ifdef SAC_BACKEND_MUTC
#define shutup_cstdlib_h
#include <stdlib.h>
#define shutup_cstring_h
#include <string.h>
#include <svp/sep.h>
#include <svp/slr.h>
#include <svp/testoutput.h>
#include <svp/abort.h>
#include <svp/perf.h>
#include <svp/testoutput.h>
#ifndef SL_PLACES
#define SL_PLACES
#define CORE_PLACE(P)  ({  sl_place_t cpid = get_current_place();  sl_place_t cpid_nosize = cpid & (cpid - 1);  sl_place_t newsize = 1;  ((cpid_nosize + ((P) << 1)) | newsize);  })
#define SIBLING  ({  sl_place_t cpid = get_current_place();  sl_place_t cpid_nosize = cpid & (cpid - 1);  sl_place_t size = cpid & -cpid;  sl_place_t cid = get_core_id();  sl_place_t mybit = (cid << 1) & size;  sl_place_t otherbit = mybit ^ size;  (cpid_nosize | otherbit | ( size >> 1));  })
#define UPPER_HALF  ({  sl_place_t cpid = get_current_place();  sl_place_t size = cpid & - cpid;  (cpid + size / 2);  })
#define LOWER_HALF  ({  sl_place_t cpid = get_current_place();  sl_place_t size = cpid & - cpid;  (cpid - size / 2);  })
#define NEXT_CORE NEXT_N_CORE(1)
#define PREV_CORE PREV_N_CORE(1)
#define NEXT_N_CORE(N)  ({  sl_place_t cpid = get_current_place();  sl_place_t size = cpid & - cpid;  sl_place_t cpid_nosize = cpid - size;  sl_place_t newsize = 1;  sl_place_t gcid = get_core_id();  sl_place_t lcid = gcid & (size - 1);  sl_place_t ncid = (lcid + (N)) & (size - 1);  (cpid_nosize | (ncid << 1) | newsize);  })
#define PREV_N_CORE(N)  ({  sl_place_t cpid = get_current_place();  sl_place_t size = cpid & - cpid;  sl_place_t cpid_nosize = cpid - size;  sl_place_t newsize = 1;  sl_place_t gcid = get_core_id();  sl_place_t lcid = gcid & (size - 1);  sl_place_t ncid = (lcid + (size - (N))) & (size - 1);  (cpid_nosize | (ncid << 1) | newsize);  })
#define NEXT_N_GCORE(N)  ({  sl_place_t cpid = SAC_MUTC_main_place;  sl_place_t size = cpid & - cpid;  sl_place_t cpid_nosize = cpid - size;  sl_place_t newsize = 1;  sl_place_t gcid = get_core_id();  sl_place_t lcid = gcid & (size - 1);  sl_place_t ncid = (lcid + (N)) & (size - 1);  (cpid_nosize | (ncid << 1) | newsize);  })
#define NEXT_HALF_GCORE  ({  sl_place_t cpid = SAC_MUTC_main_place;  sl_place_t size = cpid & - cpid;  sl_place_t cpid_nosize = cpid - size;  sl_place_t newsize = 1;  sl_place_t gcid = get_core_id();  sl_place_t lcid = gcid & (size - 1);  sl_place_t ncid = (lcid + (size>>1)) & (size - 1);  (cpid_nosize | (ncid << 1) | newsize);  })
#define PREV_N_GCORE(N)  ({  sl_place_t cpid = SAC_MUTC_main_place;  sl_place_t size = cpid & - cpid;  sl_place_t cpid_nosize = cpid - size;  sl_place_t newsize = 1;  sl_place_t gcid = get_core_id();  sl_place_t lcid = gcid & (size - 1);  sl_place_t ncid = (lcid + (size - (N))) & (size - 1);  (cpid_nosize | (ncid << 1) | newsize);  })
#endif
#define SAC_MUTC_RC_PLACES_VAR SAC_mutc_rc_places
#if (!defined(SAC_DO_COMPILE_MODULE)) || (SAC_DO_COMPILE_MODULE == 1)
extern const int SAC_MUTC_RC_PLACES_VAR;
extern sl_place_t SAC_mutc_rc_place_many[];
extern const sl_place_t SAC_MUTC_main_place;
#else
#ifndef SAC_MUTC_RC_PLACES
#define SAC_MUTC_RC_PLACES 1
#endif
const int SAC_MUTC_RC_PLACES_VAR = SAC_MUTC_RC_PLACES;
sl_place_t SAC_mutc_rc_place_many[SAC_MUTC_RC_PLACES];
sl_place_t SAC_MUTC_main_place;
#endif
SAC_IF_MUTC_RC_INDIRECT(sl_place_t SAC_mutc_rc_place_w;)
void *tls_malloc(size_t arg1);
void *tlstack_malloc(size_t arg1);
#endif 
#if SAC_DO_COMPILE_MODULE
#define SAC_MUTC_STARTUP SAC_MUTC_STARTUP_ANON() 
#else
#define SAC_MUTC_STARTUP SAC_MUTC_STARTUP_ANON() SAC_MUTC_TOSTRING SAC_MUTC_SAC_SVP_IO_PUTN

#endif
#define SAC_MUTC_SAC_SVP_IO_PUTN sl_decl(svp_io_putn, void, sl_glparm(long long, a), sl_glparm(int, t));  sl_def(sac_svp_io_putn, void, sl_glparm(int, a), sl_glparm(int, t)){ long long b = (long long) sl_getp(a); sl_proccall(svp_io_putn, sl_glarg(long long, sl_anon, b), sl_glarg(int, sl_anon, sl_getp(t))); } sl_enddef
#define SAC_MUTC_THE_WORLD_TAGS()  T_SHP( SCL, T_HID( NHD, T_UNQ( UNQ, T_REG( INT, T_SCO( GLO, T_USG( FPA,  T_EMPTY))))))
#define SAC_MUTC_STARTUP_ANON() m4_define([[_sl_anon_counter]], 0) m4_define([[sl_anon]], [[m4_step([[_sl_anon_counter]])_sl_anonarg[[]]_sl_anon_counter]]) 
#define SAC_MUTC_MAIN_RES_NT (SAC_res, T_SHP(SCL, T_HID(NHD, T_UNQ(UNQ, T_REG(INT, T_SCO(GLO, T_EMPTY))))))
#if SVP_HAS_SEP
#if 0
#define SAC_MUTC_SEPALLOC(P,N)do {  sl_create(,root_sep->sep_place|1,,,,,, root_sep->sep_alloc,  sl_glarg(struct SEP*,, root_sep),  sl_glarg(unsigned long, , SAL_EXACT|N),  sl_sharg(struct placeinfo*, p, 0));  sl_sync();  if (!sl_geta(p)) {  output_string("Place allocation failed!\n", 2);  svp_abort();  }  (P) = sl_geta(p)->pid;  } while(0)
#else
#define SAC_MUTC_SEPALLOC( P, N) do {  int res = sep_alloc( root_sep, &(P), SAL_EXACT, 1);  if ( res == -1){  output_string( "Can not allocate place @ " #P "\n");  svp_abort();  }  } while (0);
#endif
#if 0
#define SAC_MUTC_RC_ALLOC(P) do {  sl_create(,root_sep->sep_place,,,,, sl__exclusive,  root_sep->sep_alloc,  sl_glarg(struct SEP*, , root_sep),  sl_glarg(unsigned long, , SAL_EXCLUSIVE),  sl_sharg(struct placeinfo*, p, 0));  sl_sync();  if (sl_geta(p)==0) {  output_string( "Place allocation for exclusive place "  "for reference counting failed!\n",  2);  svp_abort();  }  P = sl_geta(p)->pid; } while (0)
#else
#define SAC_MUTC_RC_ALLOC( P) do {  int res = sep_alloc( root_sep, &(P), SAL_EXACT, 1);  if ( res == -1){  output_string( "Place allocation of exclusive place "  "for reference counting failed @ "  #P "\n",  2);  svp_abort();  } } while( 0)
#endif
#define SAC_MUTC_RC_ALLOC_MANY(P,N)  do {  int i;  for ( i=0; i < N; i++){  SAC_MUTC_RC_ALLOC( P[i]);  } } while (0)
#define SAC_MUTC_RC_ALLOC_W(P) SAC_MUTC_SEPALLOC( P, 1)
#else
#define SAC_MUTC_SEPALLOC(P, N) do { (P) = PLACE_DEFAULT; } while(0)
#define SAC_MUTC_RC_ALLOC(P) do { (P) = PLACE_DEFAULT; } while(0)
#define SAC_MUTC_RC_ALLOC_W(P) do { (P) = PLACE_DEFAULT; } while(0)
#define SAC_MUTC_RC_ALLOC_MANY(P, N) do {  int i;  for ( i = 0; i < N; i++){  (P[i]) = PLACE_DEFAULT;  }  } while(0)
#endif
#if defined(__slc_arch_mtalpha__)
#define SAC_MUTC_OUTPUT( a) __asm__ __volatile__("print %0, 0x10" : : "r"(0xa##ULL));
#else 
#define SAC_MUTC_OUTPUT( a)
#endif
#define SAC_MUTC_DISPLAY_ENV  output_hex( SAC_MUTC_main_place, 0);  SAC_MUTC_OUTPUT( 0x5052433020)  output_hex( SAC_mutc_rc_place_many[0], 0);  if ( SAC_MUTC_RC_PLACES_VAR > 1){  SAC_MUTC_OUTPUT( 0x5052433120)  output_hex( SAC_mutc_rc_place_many[1], 0);  }  if ( SAC_MUTC_RC_PLACES_VAR > 2){  SAC_MUTC_OUTPUT( 0x5052433220)  output_hex( SAC_mutc_rc_place_many[2], 0);  }  if ( SAC_MUTC_RC_PLACES_VAR > 3){  SAC_MUTC_OUTPUT( 0x5052433320)  output_hex( SAC_mutc_rc_place_many[3], 0);  }  if ( SAC_MUTC_RC_PLACES_VAR > 4){  SAC_MUTC_OUTPUT( 0x5052433420)  output_hex( SAC_mutc_rc_place_many[4], 0);  }  if ( SAC_MUTC_RC_PLACES_VAR > 5){  SAC_MUTC_OUTPUT( 0x5052433520)  output_hex( SAC_mutc_rc_place_many[5], 0);  }  if ( SAC_MUTC_RC_PLACES_VAR > 6){  SAC_MUTC_OUTPUT( 0x5052433620)  output_hex( SAC_mutc_rc_place_many[6], 0);  }  if ( SAC_MUTC_RC_PLACES_VAR > 7){  SAC_MUTC_OUTPUT( 0x5052433720)  output_hex( SAC_mutc_rc_place_many[7], 0);  }  if ( SAC_MUTC_RC_PLACES_VAR > 8){  SAC_MUTC_OUTPUT( 0x5052433820)  output_hex( SAC_mutc_rc_place_many[8], 0);  }  if ( SAC_MUTC_RC_PLACES_VAR > 9){  SAC_MUTC_OUTPUT( 0x5052433920)  output_hex( SAC_mutc_rc_place_many[9], 0);  }  SAC_IF_MUTC_RC_INDIRECT( SAC_MUTC_OUTPUT( 0x5052435720))  SAC_IF_MUTC_RC_INDIRECT( output_hex( SAC_mutc_rc_place_w, 0);) 
#if 0
#if SAC_MUTC_MACROS
struct s_interval *sac_benchmark_intervals;
static int sac_benchmark_count;
#endif
#define SAC_MUTC_SAC_MAIN  slr_decl(slr_var(unsigned, ncores));  sl_def(sac_main, void)  {  sac_benchmark_intervals = mtperf_alloc_intervals( 1024);  sac_benchmark_count = 0;  unsigned P = 1;  if (slr_len(ncores)) P = slr_get(ncores)[0];  sl_place_t svp_pid;  SAC_MUTC_SEPALLOC(svp_pid, P);  SAC_ND_DECL__DATA( SAC_MUTC_MAIN_RES_NT, int, )  SAC_ND_DECL__DESC( SAC_MUTC_MAIN_RES_NT, )  SAC_NOTHING()  sl_create(, svp_pid,,,,,, SACwf__MAIN__main,  SAC_ND_ARG_out( SAC_MUTC_MAIN_RES_NT, int)); sl_sync();  mtperf_free_intervals( sac_benchmark_intervals);  }  sl_enddef
#else
#define SAC_MUTC_SAC_MAIN  sl_def(sac_main, void)  {  SAC_MUTC_RC_ALLOC_MANY(SAC_mutc_rc_place_many,SAC_MUTC_RC_PLACES);  SAC_IF_MUTC_RC_INDIRECT(SAC_MUTC_RC_ALLOC_W(SAC_mutc_rc_place_w);)  SAC_MUTC_SAVE_PLACE  SAC_MUTC_DISPLAY_ENV  SAC_ND_DECL__DATA( SAC_MUTC_MAIN_RES_NT, int, )  SAC_ND_DECL__DESC( SAC_MUTC_MAIN_RES_NT, )  SAC_NOTHING()  sl_create(, ,,,,,, SACwtf__MAIN__main,  SAC_ND_ARG_out( SAC_MUTC_MAIN_RES_NT, int));  sl_sync();  }  sl_enddef
#endif
#define SAC_MUTC_SAVE_PLACE  SAC_MUTC_main_place = get_current_place();
#define SAC_MUTC_T_MAIN sl_def( t_main, void) { sl_proccall(sac_main); } sl_enddef 
#define SAC_MUTC_MAIN SAC_MUTC_SAC_MAIN SAC_MUTC_T_MAIN
#if SAC_MUTC_MACROS
SAC_MUTC_STARTUP
#endif 
#endif 
#ifdef SAC_BACKEND_MUTC

#include <limits.h>
#define SAC_SL_DETACH() sl_detach()
#ifndef SAC_RC_METHOD 
#define SAC_RC_METHOD -1
#endif
#if SAC_DEBUG_RC
#include <stdio.h>
#define SAC_MUTC_RC_PRINT( var_NT)  fprintf( stddebug, " ");  printf( "%s:%d " TO_STR( var_NT) " @ %p = {%d} [ %d, %p, %d]\n",  __FILE__,  __LINE__,  SAC_REAL_DESC( SAC_ND_A_DESC( var_NT)),  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)),  (int) SAC_ND_A_DESC( var_NT)[0],  (void*) SAC_ND_A_DESC( var_NT)[1],  (int) SAC_ND_A_DESC( var_NT)[2]);
#define SAC_MUTC_DEBUG_RC( a) a
#else
#define SAC_MUTC_RC_PRINT( var_NT)
#define SAC_MUTC_DEBUG_RC( a) 
#endif
#if (SAC_RC_METHOD == SAC_RCM_async) ||  (SAC_RC_METHOD == SAC_RCM_async_norc_ptr) ||  (SAC_RC_METHOD == SAC_RCM_local_pasync_norc_desc) ||  (SAC_RC_METHOD == SAC_RCM_async_norc_copy_desc) ||  (SAC_RC_METHOD == SAC_RCM_local_async_norc_ptr)
SAC_IF_MUTC_RC_INDIRECT(
sl_decl(SAC_set_rc_w, void, sl_glparm(int*,desc), sl_glparm(int ,rc));
sl_decl(SAC_inc_rc_w, void, sl_glparm(int*,desc), sl_glparm(int ,rc));
sl_decl(SAC_dec_rc_w, void, sl_glparm(int*,desc), sl_glparm(int ,rc));
sl_decl(SAC_dec_and_maybeFree_rc_w, void, sl_glparm(int *,desc), sl_glparm(int, val), sl_glparm(void*, data));
sl_decl(SAC_get_rc_w, void, sl_glparm(int *,desc), sl_shparm(int, val));
sl_decl(SAC_rc_barrier_w, void, sl_glparm( int *, desc));
sl_decl(SAC_dec_and_maybeFree_parent_w, void, sl_glparm( SAC_ND_DESC_PARENT_TYPE, parent));
sl_decl(SAC_get_parent_count_w, void, sl_glparm( SAC_ND_DESC_PARENT_TYPE, parent), sl_shparm( SAC_ND_DESC_PARENT_BASETYPE, val));
sl_decl(SAC_inc_parent_count_w, void, sl_glparm( SAC_ND_DESC_PARENT_TYPE, parent));
)
SAC_IF_NOT_MUTC_RC_INDIRECT(
sl_decl(SAC_set_rc, void, sl_glparm(int*,desc), sl_glparm(int ,rc));
sl_decl(SAC_inc_rc, void, sl_glparm(int*,desc), sl_glparm(int ,rc));
sl_decl(SAC_dec_rc, void, sl_glparm(int*,desc), sl_glparm(int ,rc));
sl_decl(SAC_get_rc, void, sl_glparm(int *,desc), sl_shparm(int, val));
sl_decl(SAC_dec_and_get_rc, void, sl_glparm(int *,desc), sl_shparm(int, val));
sl_decl(SAC_rc_barrier, void, sl_glparm( int *, desc));
sl_decl(SAC_dec_and_maybeFree_rc, void, sl_glparm(int *,desc), sl_glparm(int, val), sl_glparm(void*, data));
sl_decl(SAC_dec_and_maybeFree_parent, void, sl_glparm( SAC_ND_DESC_PARENT_TYPE, parent));
sl_decl(SAC_get_parent_count, void, sl_glparm( SAC_ND_DESC_PARENT_TYPE, parent), sl_shparm( SAC_ND_DESC_PARENT_BASETYPE, val));
sl_decl(SAC_inc_parent_count, void, sl_glparm( SAC_ND_DESC_PARENT_TYPE, parent));
)
#endif
#define SAC_MUTC_GET_RC_PLACE( DESC) ({  long int address = (long int)DESC;  address = address >> 6;  address = (SAC_MUTC_RC_PLACES_VAR - 1) & address;  SAC_mutc_rc_place_many[address]; })
#define SAC_ND_INIT__RC__ASYNC( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  SAC_ND_INIT__RC__C99( var_NT, rc) }
#define SAC_ND_DEC_RC__ASYNC( var_NT, rc) {  SAC_MUTC_DEBUG_RC( printf( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_TR_REF_PRINT( ("ND_DEC_RC( %s, %d)", NT_STR( var_NT), rc))  SAC_MUTC_RC_PRINT( var_NT);  SAC_IF_MUTC_RC_INDIRECT( sl_create( ,SAC_mutc_rc_place_w,,,,,,  SAC_dec_rc_w,  sl_glarg(int*, ,SAC_ND_A_DESC(var_NT)),  sl_glarg(int,,rc));)  SAC_IF_NOT_MUTC_RC_INDIRECT( sl_create( ,SAC_MUTC_GET_RC_PLACE( SAC_ND_A_DESC( var_NT)),  0,  1,  1,,  sl__exclusive,  SAC_dec_rc,  sl_glarg(int*, ,SAC_ND_A_DESC(var_NT)),  sl_glarg(int,,rc));)  SAC_SL_DETACH();  SAC_TR_REF_PRINT_RC( var_NT) }
#define SAC_ND_SET__RC__ASYNC( var_NT, rc) {  SAC_MUTC_DEBUG_RC( printf( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_TR_REF_PRINT( ("ND_SET__RC( %s, %d)", NT_STR( var_NT), rc))  SAC_MUTC_RC_PRINT( var_NT);  SAC_IF_MUTC_RC_INDIRECT( sl_create( ,SAC_mutc_rc_place_w,,,,,,  SAC_set_rc_w,  sl_glarg(int*, ,SAC_ND_A_DESC(var_NT)),  sl_glarg(int,,rc));)  SAC_IF_NOT_MUTC_RC_INDIRECT( sl_create( ,SAC_MUTC_GET_RC_PLACE( SAC_ND_A_DESC( var_NT)),  0,  1,  1,,  sl__exclusive,  SAC_set_rc,  sl_glarg(int*, ,SAC_ND_A_DESC(var_NT)),  sl_glarg(int,,rc));)  SAC_SL_DETACH();  SAC_TR_REF_PRINT_RC( var_NT) }
#define SAC_ND_INC_RC__ASYNC( var_NT, rc) {  SAC_TR_REF_PRINT( ("ND_INC_RC_ASYNC_RC( %s, %d)", NT_STR( var_NT), rc))  SAC_MUTC_RC_PRINT( var_NT);  SAC_IF_MUTC_RC_INDIRECT( sl_create( ,  SAC_mutc_rc_place_w,,,,,,  SAC_inc_rc_w,  sl_glarg( int*, ,  SAC_ND_A_DESC(var_NT)),  sl_glarg( int,, rc));)  SAC_IF_NOT_MUTC_RC_INDIRECT( sl_create( ,  SAC_MUTC_GET_RC_PLACE( SAC_ND_A_DESC( var_NT)),  0,  1,  1,,  sl__exclusive,  SAC_inc_rc,  sl_glarg( int*, ,  SAC_ND_A_DESC(var_NT)),  sl_glarg(int,,rc));)  SAC_SL_DETACH();  SAC_TR_REF_PRINT_RC( var_NT) }
#define SAC_ND_A_RC__ASYNC( var_NT) ({  SAC_TR_REF_PRINT( ("ND_A_RC( %s)", NT_STR( var_NT)))  SAC_MUTC_DEBUG_RC( printf( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_MUTC_RC_PRINT( var_NT);   SAC_IF_MUTC_RC_INDIRECT( sl_create( ,SAC_mutc_rc_place_w,,,,,,  SAC_get_rc_w,  sl_glarg(int*, ,SAC_ND_A_DESC( var_NT)),  sl_sharg(int,val,0));)  SAC_IF_NOT_MUTC_RC_INDIRECT( sl_create( ,SAC_MUTC_GET_RC_PLACE( SAC_ND_A_DESC( var_NT)),  0,  1,  1,,  sl__exclusive,  SAC_get_rc,  sl_glarg(int*, ,SAC_ND_A_DESC( var_NT)),  sl_sharg(int,val,0));)  sl_sync();  (int) sl_geta(val); })
#define SAC_ND_DEC_RC_FREE__ASYNC( var_NT, rc, freefun) {  SAC_TR_REF_PRINT( ("ND_DEC_RC_FREE( %s, %d, %s)",  NT_STR( var_NT), rc, #freefun))  SAC_MUTC_DEBUG_RC( printf( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_MUTC_RC_PRINT( var_NT);  SAC_IF_MUTC_RC_INDIRECT( sl_create( ,SAC_mutc_rc_place_w,,,,,,  SAC_dec_and_maybeFree_rc_w,  sl_glarg( int*, , SAC_ND_A_DESC( var_NT)),  sl_glarg( int,val,rc),  sl_glarg( void*, ,  SAC_ND_GETVAR( var_NT,  SAC_ND_A_FIELD(var_NT))));)  SAC_IF_NOT_MUTC_RC_INDIRECT( sl_create( ,SAC_MUTC_GET_RC_PLACE( SAC_ND_A_DESC( var_NT)),  0,  1,  1,,  sl__exclusive,SAC_dec_and_maybeFree_rc,  sl_glarg(int*, , SAC_ND_A_DESC(var_NT)),  sl_glarg(int,val,rc),  sl_glarg( void*, ,  SAC_ND_GETVAR( var_NT,  SAC_ND_A_FIELD(var_NT))));)  SAC_SL_DETACH(); }
#if SAC_RC_METHOD == SAC_RCM_async
#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc) SAC_ND_INIT__RC__ASYNC( var_NT, rc)
#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) SAC_ND_DEC_RC_FREE__ASYNC( var_NT, rc, freefun)
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) SAC_ND_SET__RC__ASYNC( var_NT, rc)
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) SAC_ND_DEC_RC__ASYNC( var_NT, rc)
#define SAC_ND_INC_RC__DEFAULT( var_NT, rc) SAC_ND_INC_RC__ASYNC( var_NT, rc)
#define SAC_ND_A_RC__DEFAULT( var_NT) SAC_ND_A_RC__ASYNC( var_NT)
#endif
#if SAC_RC_METHOD == SAC_RCM_local_pasync_norc_desc
#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc) {  SAC_ND_INIT__RC__C99( var_NT, rc)  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  DESC_PARENT( SAC_ND_A_DESC( var_NT)) = 0; }
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_SET__RC__C99( var_NT, rc);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC){  SAC_ND_SET__RC__NORC( var_NT, rc);  } else {  SAC_ND_SET__RC__C99( var_NT, rc);  } }
#define SAC_ND_SET__RC__ASYNC_RC( var_NT, rc) {  SAC_IF_MUTC_RC_INDIRECT( sl_create( ,  SAC_mutc_rc_place_w,,,,,,  SAC_set_rc_w,  sl_glarg( int*, ,  SAC_ND_A_DESC(var_NT)),  sl_glarg(int,,rc));)  SAC_IF_NOT_MUTC_RC_INDIRECT( sl_create( ,  SAC_MUTC_GET_RC_PLACE( SAC_ND_A_DESC( var_NT)),  0,  1,  1,,  sl__exclusive,  SAC_set_rc,  sl_glarg( int*, ,  SAC_ND_A_DESC( var_NT)),  sl_glarg(int,,rc));)  SAC_SL_DETACH();  SAC_TR_REF_PRINT_RC( var_NT) }

#define SAC_ND_INC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_INC_RC__C99( var_NT, rc);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC){  SAC_ND_INC_RC__NORC( var_NT, rc);  } else {  SAC_ND_INC_RC__C99( var_NT, rc);  } }
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_DEC_RC__C99( var_NT, rc);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC){  SAC_ND_DEC_RC__NORC( var_NT, rc);  } else {  SAC_ND_DEC_RC__C99( var_NT, rc);  } }

#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_DEC_RC_FREE__C99( var_NT, rc, freefun);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) ==  SAC_DESC_RC_MODE_NORC){  SAC_ND_DEC_RC_FREE__NORC( var_NT, rc, freefun);  } else {  SAC_ND_DEC_RC_FREE__ASYNC_RC( var_NT, rc, freefun);  } }
#define SAC_ND_DEC_RC_FREE__ASYNC_RC( var_NT, rc, freefun) {  SAC_MUTC_RC_PRINT( var_NT);  if ((SAC_ND_A_RC__C99( var_NT) -= rc) == 0) {  SAC_MUTC_DEC_FREE_PARENT__ASYNC_RC( var_NT)  SAC_TR_REF_PRINT_RC( var_NT)  SAC_ND_FREE( var_NT, freefun)  } else {  SAC_TR_REF_PRINT_RC( var_NT)  } }
#define SAC_MUTC_DEC_FREE_PARENT__ASYNC_RC( var_NT) {  SAC_IF_MUTC_RC_INDIRECT(  sl_create( ,  SAC_mutc_rc_place_w,,,,,,  SAC_dec_and_maybeFree_parent_w,  sl_glarg( SAC_ND_DESC_PARENT_TYPE( var_NT), ,  (SAC_ND_DESC_PARENT_TYPE) SAC_ND_A_DESC_PARENT( var_NT)));)  SAC_IF_NOT_MUTC_RC_INDIRECT(  sl_create( ,  SAC_MUTC_GET_RC_PLACE( SAC_ND_A_DESC_PARENT( var_NT)),  0,  1,  1,,  sl__exclusive,  SAC_dec_and_maybeFree_parent,  sl_glarg( SAC_ND_DESC_PARENT_TYPE, ,  (SAC_ND_DESC_PARENT_TYPE) SAC_ND_A_DESC_PARENT( var_NT)));)  SAC_SL_DETACH(); }
#define SAC_ND_A_RC__DEFAULT( var_NT) ({  int rc;  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  rc = SAC_ND_A_RC__C99( var_NT);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC){  rc = SAC_ND_A_RC__NORC( var_NT);  } else {  rc = SAC_ND_A_RC__ASYNC_RC( var_NT);  }  (int)rc; })
#define SAC_ND_A_RC__ASYNC_RC( var_NT) ({  SAC_ND_A_RC__C99( var_NT) <= 1 ?  SAC_ND_A_PARENT_ASYNC_RC( var_NT) : SAC_ND_A_RC__C99( var_NT); })

#define SAC_ND_A_PARENT_ASYNC_RC( var_NT) ({  SAC_TR_REF_PRINT( ("ND_A_RC__ASYNC_RC( %s)", NT_STR( var_NT)))  SAC_MUTC_DEBUG_RC( printf( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););   SAC_IF_MUTC_RC_INDIRECT(  sl_create( ,  SAC_mutc_rc_place_w,,,,,,  SAC_get_parent_count_w,  sl_glarg( SAC_ND_DESC_PARENT_TYPE, ,  (SAC_ND_DESC_PARENT_TYPE)SAC_ND_A_DESC_PARENT( var_NT)),  sl_sharg( SAC_ND_DESC_PARENT_BASETYPE, val, 0));)  SAC_IF_NOT_MUTC_RC_INDIRECT(  sl_create( ,  SAC_MUTC_GET_RC_PLACE( SAC_ND_A_DESC_PARENT( var_NT)),  0,  1,  1,,  sl__exclusive,  SAC_get_parent_count,  sl_glarg( SAC_ND_DESC_PARENT_TYPE, ,  (SAC_ND_DESC_PARENT_TYPE)SAC_ND_A_DESC_PARENT( var_NT)),  sl_sharg( SAC_ND_DESC_PARENT_BASETYPE, val, 0));)  sl_sync();  if ( sl_geta( val) == 1){  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  }  (int) sl_geta(val); })
#define SAC_MUTC_RC_PARENT_INC_SYNC( var_NT) {  SAC_MUTC_DEBUG_RC( printf( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_TR_REF_PRINT( ("MUTC_RC_PARENT_INC( %s)",  NT_STR( var_NT)))  SAC_IF_MUTC_RC_INDIRECT(  sl_create( ,  SAC_mutc_rc_place_w,,,,,,  SAC_inc_parent_count_w,  sl_glarg( SAC_ND_DESC_PARENT_TYPE, ,  (SAC_ND_DESC_PARENT_TYPE)SAC_ND_A_DESC_PARENT(var_NT)));)  SAC_IF_NOT_MUTC_RC_INDIRECT(  sl_create( ,  SAC_MUTC_GET_RC_PLACE( SAC_ND_A_DESC_PARENT( var_NT)),  0,  1,  1,,  sl__exclusive,  SAC_inc_parent_count,  sl_glarg( SAC_ND_DESC_PARENT_TYPE, ,  (SAC_ND_DESC_PARENT_TYPE)SAC_ND_A_DESC_PARENT(var_NT)));)  SAC_MUTC_SYNC();  SAC_TR_REF_PRINT_RC( var_NT) }

#define SAC_MUTC_RC_BARRIER__DESC( var_NT ) {  SAC_MUTC_DEBUG_RC( printf( TO_STR( var_NT) " = %p\n",  SAC_ND_A_DESC( var_NT)););  SAC_TR_REF_PRINT( ("MUTC_RC_BARRIER( %s)", NT_STR( var_NT)))  SAC_IF_MUTC_RC_INDIRECT( sl_create( ,SAC_mutc_rc_place_w,,,,,,  SAC_rc_barrier_w,  sl_glarg( SAC_ND_DESC_TYPE( var_NT),,  SAC_ND_A_DESC(var_NT)));)  SAC_IF_NOT_MUTC_RC_INDIRECT( sl_create( ,SAC_MUTC_GET_RC_PLACE( SAC_ND_A_DESC_PARENT( var_NT)),  0,  1,  1,,  sl__exclusive,  SAC_rc_barrier,  sl_glarg( SAC_ND_DESC_TYPE( var_NT),,  SAC_ND_A_DESC(var_NT)));)  SAC_MUTC_SYNC(); }

#define SAC_ND_PRF_RESTORERC__DO( array, rc)  SAC_MUTC_RC_PRINT( array);  SAC_ND_A_DESC_RC_MODE( array) = SAC_ND_A_RC_T_MODE( rc);
#define SAC_ND_PRF_RESTORERC__NOOP( array, rc) 
#define SAC_ND_PRF_2NORC__DO( rc, array)  SAC_MUTC_RC_PRINT( array);  SAC_ND_A_RC_T_MODE( rc) = SAC_ND_A_DESC_RC_MODE( array);  SAC_ND_A_DESC_RC_MODE( array) = SAC_DESC_RC_MODE_NORC;

#define SAC_ND_PRF_2ASYNC__DO( new, array)  if ( DESC_RC_MODE( SAC_ND_A_DESC( array)) != SAC_DESC_RC_MODE_NORC){  if ( DESC_RC( SAC_ND_A_DESC( array)) == 1){  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));  SAC_ND_A_DESC( new) = SAC_ND_A_DESC( array);  } else {  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));  SAC_ND_A_DESC_RC_MODE( array) = SAC_DESC_RC_MODE_ASYNC;  SAC_MUTC_RC_PRINT( array);  if ( SAC_ND_A_DESC_PARENT( array) == NULL){  SAC_ND_ALLOC__DESC__PARENT( array, SAC_ND_A_DIM( array));  SAC_MUTC_DEBUG_RC(  printf( "alloced parent at %p in %p\n",  (void*)SAC_ND_A_DESC_PARENT( array),  SAC_ND_A_DESC( array));)  PARENT_DESC_NCHILD( SAC_ND_A_DESC_PARENT( array)) = 2;  } else {  SAC_MUTC_RC_PARENT_INC_SYNC( array);  }  SAC_ND_A_COPY_DESC( new, array);  DESC_RC( SAC_ND_A_DESC( new)) = 0;  SAC_MUTC_DEBUG_RC(  printf( "copy from %p to %p\n",  SAC_ND_GETVAR( array, SAC_ND_A_DESC( array)),  SAC_ND_A_DESC( new)););  SAC_MUTC_RC_PRINT( array);  SAC_MUTC_RC_PRINT( new);  }  } else {  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));  SAC_ND_A_DESC( new) = SAC_ND_A_DESC( array);  }
#endif
#if SAC_RC_METHOD == SAC_RCM_local_norc_desc
#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc) {  SAC_ND_INIT__RC__C99( var_NT, rc)  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  DESC_PARENT( SAC_ND_A_DESC( var_NT)) = 0; }
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_SET__RC__C99( var_NT, rc);  } else {  SAC_ND_SET__RC__NORC( var_NT, rc);  } }
#define SAC_ND_INC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_INC_RC__C99( var_NT, rc);  } else {  SAC_ND_INC_RC__NORC( var_NT, rc);  } }
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_DEC_RC__C99( var_NT, rc);  } else {  SAC_ND_DEC_RC__NORC( var_NT, rc);  } }
#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_DEC_RC_FREE__C99( var_NT, rc, freefun);  } else {  SAC_ND_DEC_RC_FREE__NORC( var_NT, rc, freefun);  } }
#define SAC_ND_A_RC__DEFAULT( var_NT) ({  int rc;  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  rc = SAC_ND_A_RC__C99( var_NT);  } else {  rc = SAC_ND_A_RC__NORC( var_NT);  }  (int)rc; })

#define SAC_ND_PRF_RESTORERC__DO( array, rc)  SAC_MUTC_RC_PRINT( array);  SAC_ND_A_DESC_RC_MODE( array) = SAC_ND_A_RC_T_MODE( rc);
#define SAC_ND_PRF_RESTORERC__NOOP( array, rc) 
#define SAC_ND_PRF_2NORC__DO( rc, array)  SAC_MUTC_RC_PRINT( array);  SAC_ND_A_RC_T_MODE( rc) = SAC_ND_A_DESC_RC_MODE( array);  SAC_ND_A_DESC_RC_MODE( array) = SAC_DESC_RC_MODE_NORC;
#endif
#if SAC_RC_METHOD == SAC_RCM_local_norc_ptr
#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc) {  SAC_ND_INIT__RC__C99( var_NT, rc)  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( var_NT), SAC_DESC_RC_MODE_LOCAL); }
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_SET__RC__C99( var_NT, rc);  } else {  SAC_ND_SET__RC__NORC( var_NT, rc);  } }
#define SAC_ND_INC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_INC_RC__C99( var_NT, rc);  } else {  SAC_ND_INC_RC__NORC( var_NT, rc);  } }
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_DEC_RC__C99( var_NT, rc);  } else {  SAC_ND_DEC_RC__NORC( var_NT, rc);  } }
#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_DEC_RC_FREE__C99( var_NT, rc, freefun);  } else {  SAC_ND_DEC_RC_FREE__NORC( var_NT, rc, freefun);  } }
#define SAC_ND_A_RC__DEFAULT( var_NT) ({  int rc;  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  rc = SAC_ND_A_RC__C99( var_NT);  } else {  rc = SAC_ND_A_RC__NORC( var_NT);  }  (int)rc; })

#define SAC_ND_PRF_RESTORERC__DO( array, rc)  SAC_MUTC_RC_PRINT( array);  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( array), SAC_ND_A_RC_T_MODE( rc));
#define SAC_ND_PRF_RESTORERC__NOOP( array, rc) 
#define SAC_ND_PRF_2NORC__DO( rc, array)  SAC_MUTC_RC_PRINT( array);  SAC_ND_A_RC_T_MODE( rc) = SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( array));  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( array), SAC_DESC_RC_MODE_NORC);
#endif
#if SAC_RC_METHOD == SAC_RCM_async_norc_ptr
#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc) {  SAC_ND_INIT__RC__C99( var_NT, rc)  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( var_NT), SAC_DESC_RC_MODE_ASYNC); }
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC){  SAC_ND_SET__RC__ASYNC( var_NT, rc);  } else {  SAC_ND_SET__RC__NORC( var_NT, rc);  } }
#define SAC_ND_INC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC){  SAC_ND_INC_RC__ASYNC( var_NT, rc);  } else {  SAC_ND_INC_RC__NORC( var_NT, rc);  } }
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC){  SAC_ND_DEC_RC__ASYNC( var_NT, rc);  } else {  SAC_ND_DEC_RC__NORC( var_NT, rc);  } }
#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC){  SAC_TR_REF_PRINT( ("ND_DEC_RC_FREE( %s, %d, %s)",  NT_STR( var_NT), rc, #freefun));  SAC_MUTC_DEBUG_RC( printf( TO_STR( var_NT) " = %p\n",  SAC_REAL_DESC( SAC_ND_A_DESC( var_NT))););  SAC_MUTC_RC_PRINT( var_NT);  SAC_IF_MUTC_RC_INDIRECT( sl_create( ,SAC_mutc_rc_place_w,,,,,,  SAC_dec_and_maybeFree_rc_w,  sl_glarg( int*, ,  SAC_REAL_DESC( SAC_ND_A_DESC( var_NT))),  sl_glarg( int,  val,  rc),  sl_glarg( void*, ,  SAC_ND_GETVAR( var_NT,  SAC_ND_A_FIELD( var_NT))));)  SAC_IF_NOT_MUTC_RC_INDIRECT( sl_create( ,SAC_MUTC_GET_RC_PLACE( SAC_REAL_DESC( SAC_ND_A_DESC( var_NT))),  0,  1,  1,,  sl__exclusive,  SAC_dec_and_maybeFree_rc,  sl_glarg( int*, ,  SAC_REAL_DESC( SAC_ND_A_DESC(var_NT))),  sl_glarg( int,  val,  rc),  sl_glarg( void*, ,  SAC_ND_GETVAR( var_NT,  SAC_ND_A_FIELD( var_NT))));)  SAC_SL_DETACH();  } else {  SAC_ND_DEC_RC_FREE__NORC( var_NT, rc, freefun);  } }
#define SAC_ND_A_RC__DEFAULT( var_NT) ({  int rc;  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC){  rc = SAC_ND_A_RC__ASYNC( var_NT);  } else {  rc = SAC_ND_A_RC__NORC( var_NT);  }  (int)rc; })

#define SAC_ND_PRF_RESTORERC__DO( array, rc)  SAC_MUTC_RC_PRINT( array);  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( array), SAC_ND_A_RC_T_MODE( rc));
#define SAC_ND_PRF_RESTORERC__NOOP( array, rc) 
#define SAC_ND_PRF_2NORC__DO( rc, array)  SAC_MUTC_RC_PRINT( array);  SAC_ND_A_RC_T_MODE( rc) = SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( array));  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( array), SAC_DESC_RC_MODE_NORC);
#endif
#if SAC_RC_METHOD == SAC_RCM_async_norc_copy_desc
#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc) {  SAC_ND_INIT__RC__C99( var_NT, rc)  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_ASYNC; }
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC){  SAC_ND_SET__RC__ASYNC( var_NT, rc);  } else {  SAC_ND_SET__RC__NORC( var_NT, rc);  } }
#define SAC_ND_INC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC){  SAC_ND_INC_RC__ASYNC( var_NT, rc);  } else {  SAC_ND_INC_RC__NORC( var_NT, rc);  } }
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC){  SAC_ND_DEC_RC__ASYNC( var_NT, rc);  } else {  SAC_ND_DEC_RC__NORC( var_NT, rc);  } }
#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) {  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC){  SAC_ND_DEC_RC_FREE__ASYNC( var_NT, rc, freefun);  } else {  SAC_ND_DEC_RC_FREE__NORC( var_NT, rc, freefun);  } }
#define SAC_ND_A_RC__DEFAULT( var_NT) ({  int rc;  SAC_MUTC_RC_PRINT( var_NT);  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_ASYNC){  rc = SAC_ND_A_RC__ASYNC( var_NT);  } else {  rc = SAC_ND_A_RC__NORC( var_NT);  }  (int)rc; })

#define SAC_ND_PRF_RESTORERC__DO( array, rc)  SAC_MUTC_RC_PRINT( array);  DESC_RC_MODE( SAC_ND_A_DESC( array)) = (SAC_array_descriptor_t)SAC_ND_A_RC_T_MODE( rc);
#define SAC_ND_PRF_RESTORERC__NOOP( array, rc) 
#define SAC_ND_PRF_2NORC__DO( rc, array)  if ( DESC_RC_MODE( SAC_ND_A_DESC( array)) != SAC_DESC_RC_MODE_NORC){  SAC_array_descriptor_parent_t new;  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array,  SAC_ND_A_FIELD( array));  SAC_MUTC_RC_PRINT( array);  SAC_MUTC_LOCAL_ALLOC__DESC( new, SAC_ND_A_SIZE( array));  SAC_ND_A_COPY_OVER_DESC( new, array);  DESC_RC_MODE( SAC_ND_A_DESC( array)) = SAC_DESC_RC_MODE_NORC;  SAC_MUTC_DEBUG_RC( printf( "copy from %p to %p\n",  SAC_ND_GETVAR( array,  SAC_ND_A_DESC( array)),  SAC_ND_A_DESC( new)););  SAC_MUTC_RC_PRINT( array);  SAC_MUTC_RC_PRINT( new);  rc = (SAC_referencecount_t) array;  array = new;  } else {  rc = array;  }
#endif
#if SAC_RC_METHOD == SAC_RCM_local_async_norc_ptr
#define SAC_ND_INIT__RC__DEFAULT( var_NT, rc) {  SAC_ND_INIT__RC__C99( var_NT, rc)  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( var_NT), SAC_DESC_RC_MODE_OTHER); }
#define SAC_ND_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun)  {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC){  SAC_ND_DEC_RC_FREE__NORC( var_NT, rc, freefun);  } else {  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) ==  SAC_DESC_RC_MODE_LOCAL){  SAC_ND_DEC_RC_FREE__C99( var_NT, rc, freefun);  } else {  SAC_ND_DEC_RC_FREE__ASYNC( var_NT, rc, freefun);  }  }  }
#define SAC_ND_SET__RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC){  SAC_ND_SET__RC__NORC( var_NT, rc);  } else {  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_SET__RC__C99( var_NT, rc);  } else if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT))){  SAC_ND_SET__RC__ASYNC( var_NT, rc);  }  } }
#define SAC_ND_DEC_RC__DEFAULT( var_NT, rc) {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC){  SAC_ND_DEC_RC__NORC( var_NT, rc);  } else {  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_DEC_RC__C99( var_NT, rc);  } else {  SAC_ND_DEC_RC__ASYNC( var_NT, rc);  }  } }
#define SAC_ND_INC_RC__DEFAULT( var_NT, rc)  {  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC){  SAC_ND_INC_RC__NORC( var_NT, rc);  } else {  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  SAC_ND_INC_RC__C99( var_NT, rc);  } else {  SAC_ND_INC_RC__ASYNC( var_NT, rc);  }  }  }
#define SAC_ND_A_RC__DEFAULT( var_NT)  ({  int rc;  SAC_MUTC_RC_PRINT( var_NT);  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_NORC){  rc = SAC_ND_A_RC__NORC( var_NT);  } else {  if ( DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) == SAC_DESC_RC_MODE_LOCAL){  rc = SAC_ND_A_RC__C99( var_NT);  } else {  rc = SAC_ND_A_RC__ASYNC( var_NT);  if ( rc == 1) {  DESC_RC_MODE( SAC_ND_A_DESC( var_NT)) = SAC_DESC_RC_MODE_LOCAL;  }  }  }  (int)rc;  })
#define SAC_ND_PRF_RESTORERC__DO( array, rc)  if ( ((intptr_t) SAC_ND_A_FIELD( rc)) == 1) {  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( array), SAC_DESC_RC_MODE_OTHER);  }
#define SAC_ND_PRF_2NORC__DO( rc, array)  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( array)) != SAC_DESC_RC_MODE_NORC){  SAC_DESC_SET_HIDDEN_DATA( SAC_ND_A_DESC( array), SAC_DESC_RC_MODE_NORC);  SAC_ND_A_FIELD( rc) = (SAC_referencecount_t)1;  } else {  SAC_ND_A_FIELD( rc) = (SAC_referencecount_t)0;  }
#define SAC_ND_PRF_2ASYNC__DO( new, array)  if ( SAC_DESC_HIDDEN_DATA( SAC_ND_A_DESC( array)) != SAC_DESC_RC_MODE_NORC){  DESC_RC_MODE( SAC_ND_A_DESC( array)) = SAC_DESC_RC_MODE_ASYNC;  }
#endif
#define SAC_ND_PRF_RESTORERC__NOOP( array, rc) 
#define SAC_ND_PRF_2NORC__NOOP( rc, array) 
#define SAC_ND_PRF_2ASYNC__NOOP( new, array)  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));
#ifndef SAC_ND_PRF_RESTORERC__DO
#define SAC_ND_PRF_RESTORERC__DO( array, rc)  SAC_ND_PRF_RESTORERC__NOOP( array, rc) 
#endif
#ifndef SAC_ND_PRF_2NORC__DO
#define SAC_ND_PRF_2NORC__DO( rc, array)  SAC_ND_PRF_2NORC__NOOP( rc, array) 
#endif
#ifndef SAC_ND_PRF_2ASYNC__DO
#define SAC_ND_PRF_2ASYNC__DO( new, array)  SAC_ND_A_FIELD( new) = SAC_ND_GETVAR( array, SAC_ND_A_FIELD( array));  SAC_ND_A_DESC( new) = SAC_ND_A_DESC( array);
#endif
#ifndef SAC_MUTC_RC_BARRIER__DESC
#define SAC_MUTC_RC_BARRIER__DESC( var_NT) 
#endif
#endif


#ifndef DEF_FILE_mutc_rc_gen
#define DEF_FILE_mutc_rc_gen

#define SAC_MUTC_RC_BARRIER( nt ) CAT_M4_mutc_rc_gen_1(SAC_MUTC_RC_BARRIER_, CAT_M4_mutc_rc_gen_2(NT_SHP(nt), CAT_M4_mutc_rc_gen_3(NT_HID(nt), NT_UNQ(nt))))( nt )
#define SAC_MUTC_RC_BARRIER_SCLNHDNUQ(...) SAC_NOP(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCLNHDUNQ(...) SAC_NOP(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCLNHD___(...) SAC_NOP(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCLHIDNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCLHIDUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCLHID___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCLHNSNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCLHNSUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCLHNS___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCL___NUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCL___UNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_SCL______(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKSNHDNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKSNHDUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKSNHD___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKSHIDNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKSHIDUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKSHID___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKSHNSNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKSHNSUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKSHNS___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKS___NUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKS___UNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKS______(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKDNHDNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKDNHDUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKDNHD___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKDHIDNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKDHIDUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKDHID___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKDHNSNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKDHNSUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKDHNS___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKD___NUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKD___UNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AKD______(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUDNHDNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUDNHDUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUDNHD___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUDHIDNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUDHIDUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUDHID___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUDHNSNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUDHNSUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUDHNS___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUD___NUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUD___UNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_AUD______(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER____NHDNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER____NHDUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER____NHD___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER____HIDNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER____HIDUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER____HID___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER____HNSNUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER____HNSUNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER____HNS___(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_______NUQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER_______UNQ(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#define SAC_MUTC_RC_BARRIER__________(...) SAC_MUTC_RC_BARRIER__DESC(__VA_ARGS__)
#undef SAC_ND_PRF_RESTORERC
#define SAC_ND_PRF_RESTORERC( nt , gra1) CAT_M4_mutc_rc_gen_4(SAC_ND_PRF_RESTORERC_, CAT_M4_mutc_rc_gen_5(NT_SHP(nt), CAT_M4_mutc_rc_gen_6(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_PRF_RESTORERC_SCLNHDNUQ(...) SAC_ND_PRF_RESTORERC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCLNHDUNQ(...) SAC_ND_PRF_RESTORERC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCLNHD___(...) SAC_ND_PRF_RESTORERC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCLHIDNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCLHIDUNQ(...) SAC_ND_PRF_RESTORERC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCLHNSUNQ(...) SAC_ND_PRF_RESTORERC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCL___UNQ(...) SAC_ND_PRF_RESTORERC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKSNHDUNQ(...) SAC_ND_PRF_RESTORERC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKSHIDUNQ(...) SAC_ND_PRF_RESTORERC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKSHNSUNQ(...) SAC_ND_PRF_RESTORERC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKS___UNQ(...) SAC_ND_PRF_RESTORERC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCLHID___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCLHNSNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCLHNS___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCL___NUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_SCL______(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKSNHDNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKSNHD___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKSHIDNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKSHID___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKSHNSNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKSHNS___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKS___NUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKS______(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKDNHDNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKDNHDUNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKDNHD___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKDHIDNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKDHIDUNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKDHID___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKDHNSNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKDHNSUNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKDHNS___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKD___NUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKD___UNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AKD______(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUDNHDNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUDNHDUNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUDNHD___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUDHIDNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUDHIDUNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUDHID___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUDHNSNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUDHNSUNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUDHNS___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUD___NUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUD___UNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_AUD______(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC____NHDNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC____NHDUNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC____NHD___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC____HIDNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC____HIDUNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC____HID___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC____HNSNUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC____HNSUNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC____HNS___(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_______NUQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC_______UNQ(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#define SAC_ND_PRF_RESTORERC__________(...) SAC_ND_PRF_RESTORERC__DO(__VA_ARGS__)
#undef SAC_ND_PRF_2NORC
#define SAC_ND_PRF_2NORC( arg1, nt ) CAT_M4_mutc_rc_gen_7(SAC_ND_PRF_2NORC_, CAT_M4_mutc_rc_gen_8(NT_SHP(nt), CAT_M4_mutc_rc_gen_9(NT_HID(nt), NT_UNQ(nt))))( arg1, nt )
#define SAC_ND_PRF_2NORC_SCLNHDNUQ(...) SAC_ND_PRF_2NORC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCLNHDUNQ(...) SAC_ND_PRF_2NORC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCLNHD___(...) SAC_ND_PRF_2NORC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCLHIDNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCLHIDUNQ(...) SAC_ND_PRF_2NORC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCLHNSUNQ(...) SAC_ND_PRF_2NORC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCL___UNQ(...) SAC_ND_PRF_2NORC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKSNHDUNQ(...) SAC_ND_PRF_2NORC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKSHIDUNQ(...) SAC_ND_PRF_2NORC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKSHNSUNQ(...) SAC_ND_PRF_2NORC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKS___UNQ(...) SAC_ND_PRF_2NORC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCLHID___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCLHNSNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCLHNS___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCL___NUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_SCL______(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKSNHDNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKSNHD___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKSHIDNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKSHID___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKSHNSNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKSHNS___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKS___NUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKS______(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKDNHDNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKDNHDUNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKDNHD___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKDHIDNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKDHIDUNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKDHID___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKDHNSNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKDHNSUNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKDHNS___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKD___NUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKD___UNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AKD______(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUDNHDNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUDNHDUNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUDNHD___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUDHIDNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUDHIDUNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUDHID___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUDHNSNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUDHNSUNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUDHNS___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUD___NUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUD___UNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_AUD______(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC____NHDNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC____NHDUNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC____NHD___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC____HIDNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC____HIDUNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC____HID___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC____HNSNUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC____HNSUNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC____HNS___(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_______NUQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC_______UNQ(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2NORC__________(...) SAC_ND_PRF_2NORC__DO(__VA_ARGS__)
#undef SAC_ND_PRF_2ASYNC
#define SAC_ND_PRF_2ASYNC( arg1, nt ) CAT_M4_mutc_rc_gen_10(SAC_ND_PRF_2ASYNC_, CAT_M4_mutc_rc_gen_11(NT_SHP(nt), CAT_M4_mutc_rc_gen_12(NT_HID(nt), NT_UNQ(nt))))( arg1, nt )
#define SAC_ND_PRF_2ASYNC_SCLNHDNUQ(...) SAC_ND_PRF_2ASYNC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCLNHDUNQ(...) SAC_ND_PRF_2ASYNC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCLNHD___(...) SAC_ND_PRF_2ASYNC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCLHIDNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCLHIDUNQ(...) SAC_ND_PRF_2ASYNC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCLHNSUNQ(...) SAC_ND_PRF_2ASYNC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCL___UNQ(...) SAC_ND_PRF_2ASYNC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKSNHDUNQ(...) SAC_ND_PRF_2ASYNC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKSHIDUNQ(...) SAC_ND_PRF_2ASYNC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKSHNSUNQ(...) SAC_ND_PRF_2ASYNC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKS___UNQ(...) SAC_ND_PRF_2ASYNC__NOOP(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCLHID___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCLHNSNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCLHNS___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCL___NUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_SCL______(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKSNHDNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKSNHD___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKSHIDNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKSHID___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKSHNSNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKSHNS___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKS___NUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKS______(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKDNHDNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKDNHDUNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKDNHD___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKDHIDNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKDHIDUNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKDHID___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKDHNSNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKDHNSUNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKDHNS___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKD___NUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKD___UNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AKD______(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUDNHDNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUDNHDUNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUDNHD___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUDHIDNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUDHIDUNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUDHID___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUDHNSNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUDHNSUNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUDHNS___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUD___NUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUD___UNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_AUD______(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC____NHDNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC____NHDUNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC____NHD___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC____HIDNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC____HIDUNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC____HID___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC____HNSNUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC____HNSUNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC____HNS___(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_______NUQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC_______UNQ(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define SAC_ND_PRF_2ASYNC__________(...) SAC_ND_PRF_2ASYNC__DO(__VA_ARGS__)
#define CAT_M4_mutc_rc_gen_12(x, y) xCAT_M4_mutc_rc_gen_12(x, y)
#define xCAT_M4_mutc_rc_gen_12(x, y) x##y
#define CAT_M4_mutc_rc_gen_11(x, y) xCAT_M4_mutc_rc_gen_11(x, y)
#define xCAT_M4_mutc_rc_gen_11(x, y) x##y
#define CAT_M4_mutc_rc_gen_10(x, y) xCAT_M4_mutc_rc_gen_10(x, y)
#define xCAT_M4_mutc_rc_gen_10(x, y) x##y
#define CAT_M4_mutc_rc_gen_9(x, y) xCAT_M4_mutc_rc_gen_9(x, y)
#define xCAT_M4_mutc_rc_gen_9(x, y) x##y
#define CAT_M4_mutc_rc_gen_8(x, y) xCAT_M4_mutc_rc_gen_8(x, y)
#define xCAT_M4_mutc_rc_gen_8(x, y) x##y
#define CAT_M4_mutc_rc_gen_7(x, y) xCAT_M4_mutc_rc_gen_7(x, y)
#define xCAT_M4_mutc_rc_gen_7(x, y) x##y
#define CAT_M4_mutc_rc_gen_6(x, y) xCAT_M4_mutc_rc_gen_6(x, y)
#define xCAT_M4_mutc_rc_gen_6(x, y) x##y
#define CAT_M4_mutc_rc_gen_5(x, y) xCAT_M4_mutc_rc_gen_5(x, y)
#define xCAT_M4_mutc_rc_gen_5(x, y) x##y
#define CAT_M4_mutc_rc_gen_4(x, y) xCAT_M4_mutc_rc_gen_4(x, y)
#define xCAT_M4_mutc_rc_gen_4(x, y) x##y
#define CAT_M4_mutc_rc_gen_3(x, y) xCAT_M4_mutc_rc_gen_3(x, y)
#define xCAT_M4_mutc_rc_gen_3(x, y) x##y
#define CAT_M4_mutc_rc_gen_2(x, y) xCAT_M4_mutc_rc_gen_2(x, y)
#define xCAT_M4_mutc_rc_gen_2(x, y) x##y
#define CAT_M4_mutc_rc_gen_1(x, y) xCAT_M4_mutc_rc_gen_1(x, y)
#define xCAT_M4_mutc_rc_gen_1(x, y) x##y
#endif


#ifndef _SAC_CUDA_H_
#define _SAC_CUDA_H_

#define SAC_CUDA_ALLOC_BEGIN__DAO( var_NT, rc, dim, basetype) {  SAC_ND_ALLOC__DESC( var_NT, dim)  SAC_CUDA_ALLOC__DATA( var_NT, basetype)  SAC_ND_SET__RC( var_NT, rc)
#define SAC_CUDA_ALLOC_BEGIN__NO_DAO( var_NT, rc, dim, basetype) {  SAC_ND_ALLOC__DESC( var_NT, dim)  SAC_ND_SET__RC( var_NT, rc)
#define SAC_CUDA_ALLOC_END__DAO( var_NT, rc, dim, basetype) }
#define SAC_CUDA_ALLOC_END__NO_DAO( var_NT, rc, dim, basetype)  SAC_CUDA_ALLOC__DATA( var_NT, basetype) }
#define SAC_CUDA_FREE( var_NT, freefun)  cudaFree( SAC_ND_A_FIELD( var_NT));  SAC_GET_CUDA_FREE_ERROR();

#define SAC_CUDA_ALLOC__DATA__NOOP( var_NT, basetype)  SAC_NOOP()
#define SAC_CUDA_ALLOC__DATA__AKS( var_NT, basetype)  cudaMalloc((void**)& SAC_ND_A_FIELD( var_NT), SAC_ND_A_SIZE( var_NT)* sizeof( basetype));  SAC_GET_CUDA_MALLOC_ERROR( );

#define SAC_CUDA_ALLOC__DATA__AKD_AUD( var_NT, basetype)  cudaMalloc((void**)& SAC_ND_A_FIELD( var_NT), SAC_ND_A_SIZE( var_NT)* sizeof( basetype));  SAC_GET_CUDA_MALLOC_ERROR( );

#define SAC_CUDA_DEC_RC_FREE__UNQ( var_NT, rc, freefun)  SAC_CUDA_FREE( var_NT, freefun)
#define SAC_CUDA_DEC_RC_FREE__NOOP( var_NT, rc, freefun)  SAC_NOOP()
#define SAC_CUDA_DEC_RC_FREE__DEFAULT( var_NT, rc, freefun) {  SAC_TR_REF_PRINT( ("CUDA_DEC_RC_FREE( %s, %d, %s)",  NT_STR( var_NT), rc, #freefun))  if ((SAC_ND_A_RC( var_NT) -= rc) == 0) {  SAC_TR_REF_PRINT_RC( var_NT)  SAC_CUDA_FREE( var_NT, freefun)  }  else {  SAC_TR_REF_PRINT_RC( var_NT)  } }


#define SAC_CUDA_MEM_TRANSFER_SxA( to_NT, offset, from_NT, basetype)  cudaMemcpy(SAC_ND_A_FIELD( to_NT)+offset, &from_NT, sizeof(basetype), cudaMemcpyHostToDevice); SAC_GET_CUDA_MEM_TRANSFER_ERROR();


#define SAC_CUDA_MEM_TRANSFER_AxS( to_NT, offset, from_NT, basetype)  cudaMemcpy(&SAC_ND_A_FIELD( to_NT), SAC_ND_A_FIELD( from_NT)+offset, sizeof(basetype), cudaMemcpyDeviceToHost);  SAC_GET_CUDA_MEM_TRANSFER_ERROR();


#define SAC_CUDA_MEM_TRANSFER_D2D( to_NT, offset, from_NT, basetype)  cudaMemcpy( SAC_ND_A_FIELD( to_NT) + offset, SAC_ND_A_FIELD( from_NT), sizeof( basetype) * SAC_ND_A_SIZE( from_NT), cudaMemcpyDeviceToDevice);  SAC_GET_CUDA_MEM_TRANSFER_ERROR();

#define SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD( to_NT, from_NT, basetype, direction)  cudaMemcpy( SAC_ND_A_FIELD( to_NT), SAC_ND_A_FIELD( from_NT), SAC_ND_A_MIRROR_SIZE(from_NT)*sizeof(basetype), direction);  SAC_GET_CUDA_MEM_TRANSFER_ERROR();

#define SAC_CUDA_COPY__ARRAY( to_NT, from_NT, basetype, freefun)  cudaMemcpy( SAC_ND_A_FIELD( to_NT), SAC_ND_A_FIELD( from_NT), SAC_ND_A_MIRROR_SIZE(from_NT) * sizeof( basetype), cudaMemcpyDeviceToDevice);  SAC_GET_CUDA_MEM_TRANSFER_ERROR();

#define SAC_CUDA_FUN_DEF_END(...) 


#define SAC_CUDA_PARAM_in__SCL( var_NT, basetype)  basetype NT_NAME( var_NT)
#define SAC_CUDA_PARAM_in__AKS_AKD( var_NT, basetype)  basetype* NT_NAME( var_NT)
#define SAC_CUDA_ARG_in__SCL( var_NT, basetype)  NT_NAME( var_NT)
#define SAC_CUDA_ARG_in__AKS_AKD( var_NT, basetype)  NT_NAME( var_NT)
#define SAC_CUDA_PARAM_out__SCL( var_NT, basetype)  basetype *SAC_NAMEP( SAC_ND_A_FIELD( var_NT))
#define SAC_CUDA_PARAM_out__AKS_AKD( var_NT, basetype)  basetype* NT_NAME( var_NT)
#define SAC_CUDA_ARG_out__SCL( var_NT, basetype)  &NT_NAME( var_NT)
#define SAC_CUDA_ARG_out__AKS_AKD( var_NT, basetype)  NT_NAME( var_NT)
#define SAC_CUDA_PARAM_inout__SCL( var_NT, basetype)  basetype *SAC_NAMEP( SAC_ND_A_FIELD( var_NT))
#define SAC_CUDA_PARAM_inout__AKS_AKD( var_NT, basetype)  basetype* NT_NAME( var_NT)
#define SAC_CUDA_ARG_inout__SCL( var_NT, basetype)  &NT_NAME( var_NT)
#define SAC_CUDA_ARG_inout__AKS_AKD( var_NT, basetype)  NT_NAME( var_NT)

#define BLOCKIDX_X blockIdx.x
#define BLOCKIDX_Y blockIdx.y
#define BLOCKDIM_X blockDim.x
#define BLOCKDIM_Y blockDim.y
#define BLOCKDIM_Z blockDim.z
#define GRIDDIM_X gridDim.x
#define GRIDDIM_Y gridDim.y
#define THREADIDX_X threadIdx.x
#define THREADIDX_Y threadIdx.y
#define THREADIDX_Z threadIdx.z
#define SAC_CUDA_BLOCKIDX_X( to_nt)  NT_NAME( to_nt) = blockIdx.x;
#define SAC_CUDA_BLOCKIDX_Y( to_nt)  NT_NAME( to_nt) = blockIdx.y;
#define SAC_CUDA_BLOCKDIM_X( to_nt)  NT_NAME( to_nt) = blockDim.x;
#define SAC_CUDA_BLOCKDIM_Y( to_nt)  NT_NAME( to_nt) = blockDim.y;
#define SAC_CUDA_THREADIDX_X( to_nt)  NT_NAME( to_nt) = threadIdx.x;
#define SAC_CUDA_THREADIDX_Y( to_nt)  NT_NAME( to_nt) = threadIdx.y;
#define SAC_CUDA_THREADIDX_Z( to_nt)  NT_NAME( to_nt) = threadIdx.z;
#define SAC_CUDA_GRIDDIM_X( to_nt)  NT_NAME( to_nt) = gridDim.x;
#define SAC_CUDA_GRIDDIM_Y( to_nt)  NT_NAME( to_nt) = gridDim.y;

#define SAC_CUDA_SYNCTHREADS()  syncthreads();
#define SAC_CUDA_KERNEL_TERMINATE()  return;
#define SAC_CUDA_PRF_SYNCIN( to_nt, from_nt)  NT_NAME( to_nt) = NT_NAME( from_nt);
#define SAC_CUDA_PRF_SYNCOUT( to_nt, from_nt)  NT_NAME( to_nt) = NT_NAME( from_nt);


#define SAC_CUDA_WLIDS_1D_0( wlids_NT, wlids_NT_dim, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = BLOCKIDX_X * BLOCKDIM_X + THREADIDX_X + lb_var;  if( SAC_ND_READ( wlids_NT, wlids_NT_dim) >= ub_var) return;

#define SAC_CUDA_WLIDS_1D_SW_0( wlids_NT, wlids_NT_dim, step_var, width_var, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = BLOCKIDX_X * BLOCKDIM_X + THREADIDX_X;  if( step_var > 1 && ( SAC_ND_READ( wlids_NT, wlids_NT_dim) % step_var > ( width_var-1))) return;  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) += lb_var;  if( SAC_ND_READ( wlids_NT, wlids_NT_dim) >= ub_var) return;

#define SAC_CUDA_WLIDS_2D_0( wlids_NT, wlids_NT_dim, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = BLOCKIDX_Y * BLOCKDIM_Y + THREADIDX_Y + lb_var;  if( SAC_ND_READ( wlids_NT, wlids_NT_dim) >= ub_var) return;
#define SAC_CUDA_WLIDS_2D_1( wlids_NT, wlids_NT_dim, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = BLOCKIDX_X * BLOCKDIM_X + THREADIDX_X + lb_var;  if( SAC_ND_READ( wlids_NT, wlids_NT_dim) >= ub_var) return;

#define SAC_CUDA_WLIDS_2D_SW_0( wlids_NT, wlids_NT_dim, step_var, width_var, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = BLOCKIDX_Y * BLOCKDIM_Y + THREADIDX_Y;  if( step_var > 1 && ( SAC_ND_READ( wlids_NT, wlids_NT_dim) % step_var > ( width_var-1))) return;  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) += lb_var;  if( SAC_ND_READ( wlids_NT, wlids_NT_dim) >= ub_var) return;
#define SAC_CUDA_WLIDS_2D_SW_1( wlids_NT, wlids_NT_dim, step_var, width_var, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = BLOCKIDX_X * BLOCKDIM_X + THREADIDX_X;  if( step_var > 1 && ( SAC_ND_READ( wlids_NT, wlids_NT_dim) % step_var > ( width_var-1))) return;  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) += lb_var;  if( SAC_ND_READ( wlids_NT, wlids_NT_dim) >= ub_var) return;

#define SAC_CUDA_WLIDS_ND_0( wlids_NT, wlids_NT_dim, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = BLOCKIDX_Y + lb_var;
#define SAC_CUDA_WLIDS_ND_1( wlids_NT, wlids_NT_dim, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = BLOCKIDX_X + lb_var;
#define SAC_CUDA_WLIDS_ND_2( wlids_NT, wlids_NT_dim, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = THREADIDX_X + lb_var;
#define SAC_CUDA_WLIDS_ND_3( wlids_NT, wlids_NT_dim, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = THREADIDX_Y + lb_var;
#define SAC_CUDA_WLIDS_ND_4( wlids_NT, wlids_NT_dim, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = THREADIDX_Z + lb_var;

#define SAC_CUDA_WLIDS_ND_SW_0( wlids_NT, wlids_NT_dim, step_var, width_var, lb_var, ub_var)  if( step_var > 1 && ( BLOCKIDX_Y % step_var > ( width_var-1))) return;  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = BLOCKIDX_Y + lb_var;
#define SAC_CUDA_WLIDS_ND_SW_1( wlids_NT, wlids_NT_dim, step_var, width_var, lb_var, ub_var)  if( step_var > 1 && ( BLOCKIDX_X % step_var > ( width_var-1))) return;  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = BLOCKIDX_X + lb_var;
#define SAC_CUDA_WLIDS_ND_SW_2( wlids_NT, wlids_NT_dim, step_var, width_var, lb_var, ub_var)  if( step_var > 1 && ( THREADIDX_X % step_var > ( width_var-1))) return;  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = THREADIDX_X + lb_var;
#define SAC_CUDA_WLIDS_ND_SW_3( wlids_NT, wlids_NT_dim, step_var, width_var, lb_var, ub_var)  if( step_var > 1 && ( THREADIDX_Y % step_var > ( width_var-1))) return;  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = THREADIDX_Y + lb_var;
#define SAC_CUDA_WLIDS_ND_SW_4( wlids_NT, wlids_NT_dim, step_var, width_var, lb_var, ub_var)  if( step_var > 1 && ( THREADIDX_Z % step_var > ( width_var-1))) return;  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = THREADIDX_Z + lb_var;

#define SAC_CUDA_WLIDS( wlids_NT, wlids_NT_dim, blockidx, blockdim, threadidx, step_var, width_var, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = blockidx * blockdim + threadidx + lb_var;  if( SAC_ND_READ( wlids_NT, wlids_NT_dim) >= ub_var) return;
#define SAC_CUDA_WLIDS_SW( wlids_NT, wlids_NT_dim, blockidx, blockdim, threadidx, step_var, width_var, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = blockidx * blockdim + threadidx;  if( step_var > 1 && ( SAC_ND_READ( wlids_NT, wlids_NT_dim) % step_var > ( width_var-1))) return;  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) += lb_var;  if( SAC_ND_READ( wlids_NT, wlids_NT_dim) >= ub_var) return;
#define SAC_CUDA_WLIDS_HD( wlids_NT, wlids_NT_dim, index, step_var, width_var, lb_var, ub_var)  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = index + lb_var;
#define SAC_CUDA_WLIDS_HD_SW( wlids_NT, wlids_NT_dim, index, step_var, width_var, lb_var, ub_var)  if( step_var > 1 && ( index % step_var > ( width_var-1))) return;  SAC_ND_WRITE( wlids_NT, wlids_NT_dim) = index + lb_var;


#define SAC_CUDA_FORLOOP_BEGIN( iterator, upper_bound)  for(; iterator < upper_bound;) {
#define SAC_CUDA_FORLOOP_END()  }
#endif

#ifndef DEF_FILE_cuda_gen
#define DEF_FILE_cuda_gen
#define SAC_CUDA_ALLOC_BEGIN( nt , gra1, gra2, gra3) CAT_M4_cuda_gen_1(SAC_CUDA_ALLOC_BEGIN_, NT_SHP(nt))( nt , gra1, gra2, gra3)
#define SAC_CUDA_ALLOC_BEGIN_SCL(...) SAC_CUDA_ALLOC_BEGIN__DAO(__VA_ARGS__)
#define SAC_CUDA_ALLOC_BEGIN_AKS(...) SAC_CUDA_ALLOC_BEGIN__DAO(__VA_ARGS__)
#define SAC_CUDA_ALLOC_BEGIN_AKD(...) SAC_CUDA_ALLOC_BEGIN__NO_DAO(__VA_ARGS__)
#define SAC_CUDA_ALLOC_BEGIN_AUD(...) SAC_CUDA_ALLOC_BEGIN__NO_DAO(__VA_ARGS__)
#define SAC_CUDA_ALLOC_END( nt , gra1, gra2, gra3) CAT_M4_cuda_gen_2(SAC_CUDA_ALLOC_END_, NT_SHP(nt))( nt , gra1, gra2, gra3)
#define SAC_CUDA_ALLOC_END_SCL(...) SAC_CUDA_ALLOC_END__DAO(__VA_ARGS__)
#define SAC_CUDA_ALLOC_END_AKS(...) SAC_CUDA_ALLOC_END__DAO(__VA_ARGS__)
#define SAC_CUDA_ALLOC_END_AKD(...) SAC_CUDA_ALLOC_END__NO_DAO(__VA_ARGS__)
#define SAC_CUDA_ALLOC_END_AUD(...) SAC_CUDA_ALLOC_END__NO_DAO(__VA_ARGS__)

#define SAC_CUDA_ALLOC__DATA( nt , gra1) CAT_M4_cuda_gen_3(SAC_CUDA_ALLOC__DATA_, NT_SHP(nt))( nt , gra1)
#define SAC_CUDA_ALLOC__DATA_SCL(...) SAC_CUDA_ALLOC__DATA__NOOP(__VA_ARGS__)
#define SAC_CUDA_ALLOC__DATA_AKS(...) SAC_CUDA_ALLOC__DATA__AKS(__VA_ARGS__)
#define SAC_CUDA_ALLOC__DATA_AKD(...) SAC_CUDA_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_CUDA_ALLOC__DATA_AUD(...) SAC_CUDA_ALLOC__DATA__AKD_AUD(__VA_ARGS__)
#define SAC_CUDA_ALLOC__DATA____(...) SAC_CUDA_ALLOC__DATA__AKD_AUD(__VA_ARGS__)


#define SAC_CUDA_MEM_TRANSFER( nt , gra1, gra2, gra3) CAT_M4_cuda_gen_8(SAC_CUDA_MEM_TRANSFER_, NT_SHP(nt))( nt , gra1, gra2, gra3)

#define SAC_CUDA_MEM_TRANSFER_AKS(...) GEN_SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD(__VA_ARGS__)
#define SAC_CUDA_MEM_TRANSFER_AKD(...) GEN_SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD(__VA_ARGS__)
#define SAC_CUDA_MEM_TRANSFER_AUD(...) GEN_SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD(__VA_ARGS__)

#define GEN_SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD( arg1, nt , gra1, gra2) CAT_M4_cuda_gen_10(GEN_SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD_, NT_SHP(nt))( arg1, nt , gra1, gra2)
#define GEN_SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD_AKS(...) SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD(__VA_ARGS__)
#define GEN_SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD_AKD(...) SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD(__VA_ARGS__)
#define GEN_SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD_AUD(...) SAC_CUDA_MEM_TRANSFER__AKS_AKD_AUD(__VA_ARGS__)

#define SAC_CUDA_PARAM_in( nt , gra1) CAT_M4_cuda_gen_11(SAC_CUDA_PARAM_in_, NT_SHP(nt))( nt , gra1)
#define SAC_CUDA_PARAM_in_SCL(...) SAC_CUDA_PARAM_in__SCL(__VA_ARGS__)
#define SAC_CUDA_PARAM_in_AKS(...) SAC_CUDA_PARAM_in__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_PARAM_in_AKD(...) SAC_CUDA_PARAM_in__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_ARG_in( nt , gra1) CAT_M4_cuda_gen_12(SAC_CUDA_ARG_in_, NT_SHP(nt))( nt , gra1)
#define SAC_CUDA_ARG_in_SCL(...) SAC_CUDA_ARG_in__SCL(__VA_ARGS__)
#define SAC_CUDA_ARG_in_AKS(...) SAC_CUDA_ARG_in__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_ARG_in_AKD(...) SAC_CUDA_ARG_in__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_PARAM_out( nt , gra1) CAT_M4_cuda_gen_13(SAC_CUDA_PARAM_out_, NT_SHP(nt))( nt , gra1)
#define SAC_CUDA_PARAM_out_SCL(...) SAC_CUDA_PARAM_out__SCL(__VA_ARGS__)
#define SAC_CUDA_PARAM_out_AKS(...) SAC_CUDA_PARAM_out__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_PARAM_out_AKD(...) SAC_CUDA_PARAM_out__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_ARG_out( nt , gra1) CAT_M4_cuda_gen_14(SAC_CUDA_ARG_out_, NT_SHP(nt))( nt , gra1)
#define SAC_CUDA_ARG_out_SCL(...) SAC_CUDA_ARG_out__SCL(__VA_ARGS__)
#define SAC_CUDA_ARG_out_AKS(...) SAC_CUDA_ARG_out__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_ARG_out_AKD(...) SAC_CUDA_ARG_out__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_PARAM_inout( nt , gra1) CAT_M4_cuda_gen_15(SAC_CUDA_PARAM_inout_, NT_SHP(nt))( nt , gra1)
#define SAC_CUDA_PARAM_inout_SCL(...) SAC_CUDA_PARAM_inout__SCL(__VA_ARGS__)
#define SAC_CUDA_PARAM_inout_AKS(...) SAC_CUDA_PARAM_inout__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_PARAM_inout_AKD(...) SAC_CUDA_PARAM_inout__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_ARG_inout( nt , gra1) CAT_M4_cuda_gen_16(SAC_CUDA_ARG_inout_, NT_SHP(nt))( nt , gra1)
#define SAC_CUDA_ARG_inout_SCL(...) SAC_CUDA_ARG_inout__SCL(__VA_ARGS__)
#define SAC_CUDA_ARG_inout_AKS(...) SAC_CUDA_ARG_inout__AKS_AKD(__VA_ARGS__)
#define SAC_CUDA_ARG_inout_AKD(...) SAC_CUDA_ARG_inout__AKS_AKD(__VA_ARGS__)

#define SAC_CUDA_DEC_RC_FREE( nt , gra1, gra2) CAT_M4_cuda_gen_17(SAC_CUDA_DEC_RC_FREE_, CAT_M4_cuda_gen_18(NT_SHP(nt), CAT_M4_cuda_gen_19(NT_HID(nt), NT_UNQ(nt))))( nt , gra1, gra2)
#define SAC_CUDA_DEC_RC_FREE_SCLNHDUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_SCLHIDUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_SCLHNSUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_SCL___UNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKSNHDUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKSHIDUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKSHNSUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKS___UNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKDNHDUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKDHIDUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKDHNSUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKD___UNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AUDNHDUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AUDHIDUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AUDHNSUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AUD___UNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE____NHDUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE____HIDUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE____HNSUNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_______UNQ(...) SAC_CUDA_DEC_RC_FREE__UNQ(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_SCLNHDNUQ(...) SAC_CUDA_DEC_RC_FREE__NOOP(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_SCLHIDNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_SCLHNSNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_SCL___NUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKSNHDNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKSHIDNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKSHNSNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKS___NUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKDNHDNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKDHIDNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKDHNSNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AKD___NUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AUDNHDNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AUDHIDNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AUDHNSNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_AUD___NUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE____NHDNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE____HIDNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE____HNSNUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define SAC_CUDA_DEC_RC_FREE_______NUQ(...) SAC_CUDA_DEC_RC_FREE__DEFAULT(__VA_ARGS__)
#define CAT_M4_cuda_gen_19(x, y) xCAT_M4_cuda_gen_19(x, y)
#define xCAT_M4_cuda_gen_19(x, y) x##y
#define CAT_M4_cuda_gen_18(x, y) xCAT_M4_cuda_gen_18(x, y)
#define xCAT_M4_cuda_gen_18(x, y) x##y
#define CAT_M4_cuda_gen_17(x, y) xCAT_M4_cuda_gen_17(x, y)
#define xCAT_M4_cuda_gen_17(x, y) x##y
#define CAT_M4_cuda_gen_16(x, y) xCAT_M4_cuda_gen_16(x, y)
#define xCAT_M4_cuda_gen_16(x, y) x##y
#define CAT_M4_cuda_gen_15(x, y) xCAT_M4_cuda_gen_15(x, y)
#define xCAT_M4_cuda_gen_15(x, y) x##y
#define CAT_M4_cuda_gen_14(x, y) xCAT_M4_cuda_gen_14(x, y)
#define xCAT_M4_cuda_gen_14(x, y) x##y
#define CAT_M4_cuda_gen_13(x, y) xCAT_M4_cuda_gen_13(x, y)
#define xCAT_M4_cuda_gen_13(x, y) x##y
#define CAT_M4_cuda_gen_12(x, y) xCAT_M4_cuda_gen_12(x, y)
#define xCAT_M4_cuda_gen_12(x, y) x##y
#define CAT_M4_cuda_gen_11(x, y) xCAT_M4_cuda_gen_11(x, y)
#define xCAT_M4_cuda_gen_11(x, y) x##y
#define CAT_M4_cuda_gen_10(x, y) xCAT_M4_cuda_gen_10(x, y)
#define xCAT_M4_cuda_gen_10(x, y) x##y
#define CAT_M4_cuda_gen_9(x, y) xCAT_M4_cuda_gen_9(x, y)
#define xCAT_M4_cuda_gen_9(x, y) x##y
#define CAT_M4_cuda_gen_8(x, y) xCAT_M4_cuda_gen_8(x, y)
#define xCAT_M4_cuda_gen_8(x, y) x##y
#define CAT_M4_cuda_gen_7(x, y) xCAT_M4_cuda_gen_7(x, y)
#define xCAT_M4_cuda_gen_7(x, y) x##y
#define CAT_M4_cuda_gen_6(x, y) xCAT_M4_cuda_gen_6(x, y)
#define xCAT_M4_cuda_gen_6(x, y) x##y
#define CAT_M4_cuda_gen_5(x, y) xCAT_M4_cuda_gen_5(x, y)
#define xCAT_M4_cuda_gen_5(x, y) x##y
#define CAT_M4_cuda_gen_4(x, y) xCAT_M4_cuda_gen_4(x, y)
#define xCAT_M4_cuda_gen_4(x, y) x##y
#define CAT_M4_cuda_gen_3(x, y) xCAT_M4_cuda_gen_3(x, y)
#define xCAT_M4_cuda_gen_3(x, y) x##y
#define CAT_M4_cuda_gen_2(x, y) xCAT_M4_cuda_gen_2(x, y)
#define xCAT_M4_cuda_gen_2(x, y) x##y
#define CAT_M4_cuda_gen_1(x, y) xCAT_M4_cuda_gen_1(x, y)
#define xCAT_M4_cuda_gen_1(x, y) x##y
#endif

#if SAC_DO_RTSPEC
#define SAC_RTSPEC_SETUP_INITIAL(mode, command_line, binary_name)  SAC_RTSPEC_SetupInitial( __argc, __argv,  SAC_SET_RTSPEC_THREADS, SAC_DO_TRACE_RTSPEC, mode, command_line, binary_name);  SAC_registry_init( SAC_DO_TRACE_RTSPEC);  SAC_persistence_init( __argc, __argv, SAC_DO_TRACE_RTSPEC);

#define SAC_RTSPEC_SETUP() {  SAC_setupController( SAC_SET_TMPDIR); }

#define SAC_RTSPEC_FINALIZE() {  SAC_finalizeController(); }
#define SAC_RTSPEC_BLOCK_START() {
#define SAC_RTSPEC_BLOCK_END() }
#define SAC_RTSPEC_CURRENT_THREAD_ID()  SAC_RTSPEC_CurrentThreadId();

#define SAC_WE_DEF_FUN_BEGIN2( num_args, name, type, ...)  SAC_ND_DECL_FUN2(name, type, __VA_ARGS__){ 

#define SAC_WE_FUN_DEF_END2(...) }

#define SAC_WE_DECL_REG_FLAG()  static int SAC_registered = 0;

#define SAC_WE_DECL_REG_OBJ()  static reg_obj_t *SAC_reg_obj;

#define SAC_WE_DECL_MOD( name)  static char *SAC_module = name;

#define SAC_WE_DECL_FUN( name)  static char *SAC_function = name;

#define SAC_RTSPEC_DECL_UUID( uuid)  static char *SAC_unique_id = uuid;

#define SAC_WE_DECL_SHAPE_ARRAY()  int *SAC_shapes = NULL;

#define SAC_WE_DECL_I_J()  int i = 0, j = 0;

#define SAC_WE_CALC_SIZE( dim_sum)  int size = 1 + dim_sum;

#define SAC_WE_REGISTRATION(module, name)  if (!SAC_registered) {  SAC_reg_obj = SAC_registrate(module, (void *) &name);  SAC_registered = 1;  }

#define SAC_WE_ENQ_REQ(types, name)  SAC_Simple_enqueueRequest(SAC_function, #types, SAC_shapes, size, SAC_reg_obj);

#define SAC_WE_GET_DIM( arg)  SAC_ND_A_DIM( arg)

#define SAC_WE_ALLOC_SHAPE_ARRAY()  SAC_shapes = malloc( size * sizeof( int));

#define SAC_WE_SET_NUM_ARGS( num)  SAC_shapes[i] = num;  i++;

#define SAC_WE_GET_SHAPE( arg)  SAC_shapes[i] = SAC_WE_GET_DIM( arg);  i++;  for ( j = 0; j < SAC_WE_GET_DIM( arg); j++) {  SAC_shapes[i++] = SAC_ND_A_SHAPE(arg, j);  } 

#define SAC_RTSPEC_GET_DIM_FOR_SHAPE( arg)  SAC_shapes[i] = SAC_WE_GET_DIM( arg);  i++; 
#define SAC_RTSPEC_GET_SHAPE_KNOWN_DIM( arg, j)  SAC_shapes[i++] = SAC_ND_A_SHAPE(arg, j); 
#define SAC_RTSPEC_GET_SHAPE_UNKNOWN_DIM( arg)  SAC_shapes[i] = SAC_WE_GET_DIM( arg);  i++;  for ( j = 0; j < SAC_WE_GET_DIM( arg); j++) {  SAC_shapes[i++] = SAC_ND_A_SHAPE(arg, j);  } 

#define SAC_WE_FUNAP2( types, name)  SAC_WE_REGISTRATION(SAC_module, name)  SAC_WE_ENQ_REQ(types, name) 
#define SAC_WE_PTR_CAST( rettype, ...)  ((rettype(*)(__VA_ARGS__)) SAC_reg_obj->func_ptr)
#define SAC_RTSPEC_PTR_CAST(name, types, rettype, ...)  ((rettype(*)(__VA_ARGS__)) SAC_lookup_function(SAC_function, SAC_unique_id, #types, SAC_shapes, size, SAC_module, (void *) &name))
#else 
#define SAC_RTSPEC_SETUP()
#define SAC_RTSPEC_SETUP_INITIAL(mode, command_line, binary_name)
#define SAC_RTSPEC_FINALIZE()
#define SAC_RTSPEC_CURRENT_THREAD_ID() 0;
#define SAC_RTSPEC_ENQ_REQ_CHK( types, name)
#endif 

#ifndef _SAC_REGISTRY_H_
#define _SAC_REGISTRY_H_

typedef struct {
char *module;
void *func_ptr;
void *dl_handle;
} reg_obj_t;
reg_obj_t *SAC_registrate(char *, void *);
void SAC_registry_init(int trace);
void SAC_register_specialization(char *key, void *dl_handle, void *func_ptr);
void *SAC_lookup_function(char *func_name, char *uuid, char *types, int *shapes,
int shape_size, char *mod_name, void *func_ptr);
#endif 

#ifndef _SAC_SIMPLE_REQQUEUE_H_
#define _SAC_SIMPLE_REQQUEUE_H_

typedef struct simple_queue_node {

char *func_name;

char *type_info;

int *shape_info;

int shape_info_size;

reg_obj_t *reg_obj;

struct simple_queue_node *next;
} simple_queue_node_t;

typedef struct simple_reqqueue {

int size;

simple_queue_node_t *first;

simple_queue_node_t *last;
} simple_reqqueue_t;
void SAC_Simple_initializeQueue(int trace);
void SAC_Simple_deinitializeQueue(void);
simple_queue_node_t *SAC_Simple_createNode(char *, char *, int *, int, reg_obj_t *);
simple_queue_node_t *SAC_Simple_dequeueRequest(void);
void SAC_Simple_enqueueRequest(char *, char *, int *, int, reg_obj_t *);
void SAC_Simple_freeReqqueue(simple_queue_node_t *);
#endif 

#ifndef _SAC_UUID_REQQUEUE_H_
#define _SAC_UUID_REQQUEUE_H_

typedef struct uuid_queue_node {

char *func_name;

char *uuid;

char *type_info;

int *shape_info;

int shape_info_size;

char *shape;

char *mod_name;

char *key;

struct uuid_queue_node *next;
} uuid_queue_node_t;

typedef struct uuid_reqqueue {

int size;

uuid_queue_node_t *first;

uuid_queue_node_t *last;
} uuid_reqqueue_t;
void SAC_UUID_initializeQueue(int trace);
void SAC_UUID_deinitializeQueue(void);
uuid_queue_node_t *SAC_UUID_createNode( char *func_name, char *uuid, char *types, int *shapes, int shapes_size, char *shape, char *mod_name, char *key);
uuid_queue_node_t *SAC_UUID_dequeueRequest(void);
void SAC_UUID_enqueueRequest( char *func_name, char *uuid, char *types, int *shapes, int shapes_size, char *shape, char *mod_name, char *key);
void SAC_UUID_freeReqqueue(uuid_queue_node_t *);
#endif 

#ifndef _SAC_SUPERVISOR_H_
#define _SAC_SUPERVISOR_H_
extern void SAC_RTSPEC_SetupInitial( int argc, char *argv[],
unsigned int num_threads, int trace, int mode, char *command_line, char *binary_name);
extern unsigned int SAC_RTSPEC_CurrentThreadId(void);
extern void SAC_setupController( char *dir );
extern void SAC_finalizeController(void);
#endif 

#ifndef _SAC_SIMPLE_CONTROLLER_H_
#define _SAC_SIMPLE_CONTROLLER_H_
extern void SAC_Simple_setupController( char *dir, int trace, char *command_line, char *binary_name );
extern void *SAC_Simple_runController(void);
extern void SAC_Simple_handleRequest(simple_queue_node_t *);
extern void SAC_Simple_stopController(void);
extern void SAC_Simple_finalizeController(void);
#endif 

#ifndef _SAC_UUID_CONTROLLER_H_
#define _SAC_UUID_CONTROLLER_H_
extern void SAC_UUID_setupController( char *dir, int trace, char *command_line, char *binary_name);
extern void *SAC_UUID_runController(void);
extern void SAC_UUID_handleRequest(uuid_queue_node_t *);
extern void SAC_UUID_stopController(void);
extern void SAC_UUID_finalizeController(void);
#endif 

#ifndef _SAC_PERSISTENCE_H_
#define _SAC_PERSISTENCE_H_
extern char * encodeShapes( int *shapes);
void SAC_persistence_init( int argc, char *argv[], int trace);
char *SAC_persistence_add( char *filename, char *func_name, char *uuid,
char *type_info, char *shape, char *mod_name);
void *SAC_persistence_load( char *filename, char *symbol_name, char *key);
void *SAC_persistence_get( char *key, char *func_name, char *uuid,
char *type_info, char *shape, char *mod_name);
#endif 

#ifndef _SAC_DISTMEM_H_
#define _SAC_DISTMEM_H_

#include <inttypes.h>

SAC_C_EXTERN_VAR size_t SAC_DISTMEM_rank;

SAC_C_EXTERN_VAR int SAC_DISTMEM_trace_profile_rank;

void SAC_DISTMEM_Abort( int exit_code);

#define SAC_DISTMEM_RANK_UNDEFINED SIZE_MAX
#define SAC_DISTMEM_TRACE_PROFILE_RANK_ANY -1

#define SAC_DISTMEM_RANK_MASTER 0
#if SAC_DO_DISTMEM

#ifndef memset
extern void *memset(void *s, int c, size_t n);
#endif
#ifndef memcpy
extern void *memcpy(void *dest, const void *src, size_t n);
#endif

typedef enum SAC_DISTMEM_exec_mode_enum {
SAC_DISTMEM_exec_mode_sync, 
SAC_DISTMEM_exec_mode_dist, 
SAC_DISTMEM_exec_mode_side_effects_outer, 
SAC_DISTMEM_exec_mode_side_effects 
} SAC_DISTMEM_exec_mode_t;


SAC_C_EXTERN_VAR size_t SAC_DISTMEM_size;

SAC_C_EXTERN_VAR size_t SAC_DISTMEM_pagesz;

SAC_C_EXTERN_VAR uintptr_t SAC_DISTMEM_segsz;

SAC_C_EXTERN_VAR void *SAC_DISTMEM_shared_seg_ptr;

SAC_C_EXTERN_VAR void *SAC_DISTMEM_cache_ptr;

SAC_C_EXTERN_VAR void **SAC_DISTMEM_local_seg_ptrs;

SAC_C_EXTERN_VAR bool SAC_DISTMEM_are_dsm_allocs_allowed;

SAC_C_EXTERN_VAR bool SAC_DISTMEM_are_dist_writes_allowed;

SAC_C_EXTERN_VAR bool SAC_DISTMEM_are_cache_writes_allowed;

SAC_C_EXTERN_VAR SAC_DISTMEM_exec_mode_t SAC_DISTMEM_exec_mode;

SAC_C_EXTERN_VAR size_t SAC_DISTMEM_min_elems_per_node;


SAC_C_EXTERN_VAR unsigned long SAC_DISTMEM_TR_num_inval_pages;

SAC_C_EXTERN_VAR unsigned long SAC_DISTMEM_TR_num_segfaults;

SAC_C_EXTERN_VAR unsigned long SAC_DISTMEM_TR_num_ptr_calcs;

SAC_C_EXTERN_VAR unsigned long SAC_DISTMEM_TR_num_avoided_ptr_calcs_local_writes;

SAC_C_EXTERN_VAR unsigned long SAC_DISTMEM_TR_num_avoided_ptr_calcs_local_reads;

SAC_C_EXTERN_VAR unsigned long SAC_DISTMEM_TR_num_avoided_ptr_calcs_known_local_reads;

SAC_C_EXTERN_VAR unsigned long SAC_DISTMEM_TR_num_avoided_ptr_calcs_remote_reads;

SAC_C_EXTERN_VAR unsigned long SAC_DISTMEM_TR_num_ptr_cache_updates;

SAC_C_EXTERN_VAR unsigned long SAC_DISTMEM_TR_num_barriers;


SAC_C_EXTERN_VAR uintptr_t SAC_DISTMEM_CH_max_valid_cache_ptr;

SAC_C_EXTERN_VAR uintptr_t SAC_DISTMEM_CH_max_valid_write_ptr;


void SAC_DISTMEM_Init( int argc, char *argv[]);

void SAC_DISTMEM_Setup( size_t maxmem_mb, size_t min_elems_per_node, int trace_profile_rank, bool alloc_cache_outside_dsm);

void SAC_DISTMEM_InvalEntireCache( void);

void SAC_DISTMEM_InvalCache( uintptr_t arr_offset, size_t b);

void SAC_DISTMEM_InvalCacheOfNode( uintptr_t arr_offset, size_t node, size_t b);

void SAC_DISTMEM_Barrier( void);

void SAC_DISTMEM_Exit( int exit_code);

bool SAC_DISTMEM_DetDoDistrArr( size_t total_elems, size_t dim0_size);

size_t SAC_DISTMEM_DetMaxElemsPerNode( size_t total_elems, size_t dim0_size);

size_t SAC_DISTMEM_DetDim0Start( size_t dim0_size, size_t start_range, size_t stop_range);

size_t SAC_DISTMEM_DetDim0Stop( size_t dim0_size, size_t start_range, size_t stop_range);

void SAC_DISTMEM_IncCounter( unsigned long *counter_ptr);

void SAC_DISTMEM_UpdatePtrCacheBound( int *ptr_cache_from, int *ptr_cache_count,
int ptr_cache_from_val, int ptr_cache_count_val);

void SAC_DISTMEM_UpdatePtrCachePtr( void **ptr_cache, void *ptr_cache_val);

void SAC_DISTMEM_TR_Init( int argc, char *argv[]);
void SAC_DISTMEM_TR_Setup( size_t maxmem_mb, size_t min_elems_per_node, int trace_profile_rank, bool alloc_cache_outside_dsm);
void SAC_DISTMEM_TR_InvalEntireCache( void);
void SAC_DISTMEM_TR_InvalCache( uintptr_t arr_offset, size_t b);
void SAC_DISTMEM_TR_InvalCacheOfNode( uintptr_t arr_offset, size_t node, size_t b);
void SAC_DISTMEM_TR_Barrier( void);
void SAC_DISTMEM_TR_AllowDistWrites( void);
void SAC_DISTMEM_TR_ForbidDistWrites( void);
void SAC_DISTMEM_TR_Abort( int exit_code);
void SAC_DISTMEM_TR_Exit( int exit_code);
bool SAC_DISTMEM_TR_DetDoDistrArr( size_t total_elems, size_t dim0_size);
size_t SAC_DISTMEM_TR_DetMaxElemsPerNode( size_t total_elems, size_t dim0_size);
size_t SAC_DISTMEM_TR_DetDim0Start( size_t dim0_size, size_t start, size_t stop);
size_t SAC_DISTMEM_TR_DetDim0Stop( size_t dim0_size, size_t start, size_t stop);

void SAC_DISTMEM_PR_Init( int argc, char *argv[]);
void SAC_DISTMEM_PR_Setup( size_t maxmem_mb, size_t min_elems_per_node, int trace_profile_rank, bool alloc_cache_outside_dsm);
void SAC_DISTMEM_PR_InvalEntireCache( void);
void SAC_DISTMEM_PR_InvalCache( uintptr_t arr_offset, size_t b);
void SAC_DISTMEM_PR_InvalCacheOfNode( uintptr_t arr_offset, size_t node, size_t b);
void SAC_DISTMEM_PR_Barrier( void);
void SAC_DISTMEM_PR_AllowDistWrites( void);
void SAC_DISTMEM_PR_ForbidDistWrites( void);
void SAC_DISTMEM_PR_Abort( int exit_code);
void SAC_DISTMEM_PR_Exit( int exit_code);
bool SAC_DISTMEM_PR_DetDoDistrArr( size_t total_elems, size_t dim0_size);
size_t SAC_DISTMEM_PR_DetMaxElemsPerNode( size_t total_elems, size_t dim0_size);
size_t SAC_DISTMEM_PR_DetDim0Start( size_t dim0_size, size_t start, size_t stop);
size_t SAC_DISTMEM_PR_DetDim0Stop( size_t dim0_size, size_t start, size_t stop);


#define _SAC_DISTMEM_DET_OWNER( var_NT, elem_index)  ((elem_index) / SAC_ND_A_FIRST_ELEMS( var_NT))
#if SAC_DO_CHECK_DISTMEM
#define SAC_DISTMEM_DET_OWNER( var_NT, elem_index) (  (SAC_ND_A_FIRST_ELEMS( var_NT) == 0) ? (  SAC_RuntimeError( "elems_first_nodes is 0 when determining owner of element %d of array %s",  elem_index, NT_STR( var_NT)),  0  ) : _SAC_DISTMEM_DET_OWNER( var_NT, elem_index) )
#else 
#define SAC_DISTMEM_DET_OWNER( var_NT, elem_index)  _SAC_DISTMEM_DET_OWNER( var_NT, elem_index)
#endif 
#if SAC_DO_DISTMEM_PTR_DESC

#define SAC_DISTMEM_INIT_PTR_DESC( var_NT) for (int i = 0; i < SAC_DISTMEM_size; i++) {  SAC_ND_A_DESC_PTR( var_NT, i) = (uintptr_t) (((SAC_NT_CBASETYPE( var_NT) *) (((uintptr_t)SAC_DISTMEM_local_seg_ptrs[i])  + (unsigned)SAC_ND_A_OFFS( var_NT))) - (unsigned)SAC_DISTMEM_DET_FROM( var_NT, i));  SAC_TR_DISTMEM_PRINT( "Writing start of array %s at node %d = %p to %p", NT_STR( var_NT),  i, SAC_ND_A_DESC_PTR( var_NT, i), &(SAC_ND_A_DESC_PTR( var_NT, i))); }

#define _SAC_DISTMEM_ELEM_DESC_POINTER( var_NT, elem_index)  (((SAC_NT_CBASETYPE( var_NT) *) SAC_ND_A_DESC_PTR( var_NT, ((unsigned)elem_index / (unsigned)SAC_ND_A_FIRST_ELEMS( var_NT)))) + elem_index)
#define _SAC_DISTMEM_TR_ELEM_DESC_POINTER( var_NT, elem_index) (  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_ptr_calcs),  _SAC_DISTMEM_ELEM_DESC_POINTER( var_NT, elem_index) )
#define _SAC_DISTMEM_PR_ELEM_DESC_POINTER( var_NT, elem_index) (  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_ptr_calcs),  _SAC_DISTMEM_ELEM_DESC_POINTER( var_NT, elem_index) )
#else 
#define SAC_DISTMEM_INIT_PTR_DESC( var_NT)
#endif 

#define SAC_DISTMEM_UPDATE_PTR_CACHE_EXPR( var_NT, elem_index)  SAC_TR_DISTMEM_PRINT_EXPR( "Updating pointer cache of array %s for index %d. "  "Array offset: %"PRIuPTR", first elems: %zd.",  NT_STR(var_NT), elem_index,  SAC_ND_A_OFFS( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT))  SAC_DISTMEM_UpdatePtrCacheBound( &SAC_ND_A_MIRROR_PTR_CACHE_FROM( var_NT),  &SAC_ND_A_MIRROR_PTR_CACHE_COUNT( var_NT),  SAC_DISTMEM_DET_FROM( var_NT,  SAC_DISTMEM_DET_OWNER( var_NT, elem_index)),  SAC_ND_A_FIRST_ELEMS( var_NT)),  _SAC_DISTMEM_UPDATE_PTR_CACHE_EXPR_PTR( var_NT, elem_index)  SAC_DISTMEM_UPDATED_PTR_CACHE_EXPR()  0
#if SAC_DO_DISTMEM_PTR_DESC
#define _SAC_DISTMEM_UPDATE_PTR_CACHE_EXPR_PTR( var_NT, elem_index)  SAC_DISTMEM_UpdatePtrCachePtr( (void**)&SAC_ND_A_MIRROR_PTR_CACHE( var_NT),  ((void*)SAC_ND_A_DESC_PTR( var_NT,  SAC_DISTMEM_DET_OWNER( var_NT, elem_index)))),  SAC_TR_DISTMEM_PRINT_EXPR( "Updated pointer cache of array %s for index %d to %p "  "(%d elements from index %d are owned by %d), calculated ptr: %p",  NT_STR(var_NT), elem_index, SAC_ND_A_MIRROR_PTR_CACHE( var_NT),  SAC_ND_A_MIRROR_PTR_CACHE_COUNT( var_NT),  SAC_ND_A_MIRROR_PTR_CACHE_FROM( var_NT),  SAC_DISTMEM_DET_OWNER( var_NT, elem_index),  SAC_ND_A_DESC_PTR( var_NT,  SAC_DISTMEM_DET_OWNER( var_NT, elem_index)))
#else 
#define _SAC_DISTMEM_UPDATE_PTR_CACHE_EXPR_PTR( var_NT, elem_index)  SAC_DISTMEM_UpdatePtrCachePtr( (void**)&SAC_ND_A_MIRROR_PTR_CACHE( var_NT),  (SAC_DISTMEM_ELEM_POINTER( SAC_ND_A_OFFS( var_NT),  SAC_NT_CBASETYPE( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT),  SAC_ND_A_MIRROR_PTR_CACHE_FROM( var_NT)) - (unsigned)SAC_ND_A_MIRROR_PTR_CACHE_FROM( var_NT))),  SAC_TR_DISTMEM_PRINT_EXPR( "Updated pointer cache of array %s for index %d to %p "  "(%d elements from index %d), calculated ptr: %p ",  NT_STR(var_NT), elem_index, SAC_ND_A_MIRROR_PTR_CACHE( var_NT),  SAC_ND_A_MIRROR_PTR_CACHE_COUNT( var_NT),  SAC_ND_A_MIRROR_PTR_CACHE_FROM( var_NT),  SAC_DISTMEM_ELEM_POINTER( SAC_ND_A_OFFS( var_NT),  SAC_NT_CBASETYPE( var_NT),  SAC_ND_A_FIRST_ELEMS( var_NT),  SAC_ND_A_MIRROR_PTR_CACHE_FROM( var_NT))) 
#endif  

#define SAC_DISTMEM_DET_FROM( var_NT, rank) (  SAC_ND_A_IS_DIST( var_NT)  ? (  SAC_ND_A_FIRST_ELEMS( var_NT) * rank  )  : 0 )

#define SAC_DISTMEM_DET_LOCAL_FROM( var_NT)  SAC_DISTMEM_DET_FROM( var_NT, SAC_DISTMEM_rank) 

#define SAC_DISTMEM_DET_LOCAL_TO( var_NT) (  SAC_ND_A_IS_DIST( var_NT)  ? (  SAC_TR_DISTMEM_PRINT_EXPR( "The last element of array %s local to node %d is %d.",  NT_STR( var_NT),  SAC_DISTMEM_rank,  SAC_ND_A_FIRST_ELEMS( var_NT) * (SAC_DISTMEM_rank + 1) - 1)  SAC_MIN( SAC_ND_A_FIRST_ELEMS( var_NT) * (SAC_DISTMEM_rank + 1) - 1,  SAC_ND_A_SIZE( var_NT) - 1)  )  : (SAC_ND_A_SIZE( var_NT) - 1) )

#define SAC_DISTMEM_DET_LOCAL_COUNT( var_NT) (  SAC_ND_A_IS_DIST( var_NT)  ? SAC_ND_A_FIRST_ELEMS( var_NT)  : SAC_ND_A_SIZE( var_NT) )

#define SAC_DISTMEM_RECHECK_IS_DIST( var_NT)  if ( SAC_ND_A_IS_DIST( var_NT)) {  SAC_TR_DISTMEM_PRINT( "Rechecking if array %s should still be distributed? %d",  NT_STR( var_NT),  SAC_ND_A_IS_DIST( var_NT)  && SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_sync);  SAC_ND_A_MIRROR_IS_DIST( var_NT) = SAC_ND_A_IS_DIST( var_NT)  && SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_sync;  }

#define SAC_DISTMEM_DET_OFFS( addr) (  SAC_TR_DISTMEM_PRINT_EXPR( "Offset of address %p in shared segment is %"PRIuPTR".",  addr, (uintptr_t) addr - (uintptr_t) SAC_DISTMEM_shared_seg_ptr)  (uintptr_t) addr - (uintptr_t) SAC_DISTMEM_shared_seg_ptr )

#define SAC_DISTMEM_MOVE_PTR_FOR_WRITES( addr, first_elems)  SAC_TR_DISTMEM_PRINT( "Moving pointer from %p to %p (first elems: %zd).",  addr, addr - (unsigned)first_elems * SAC_DISTMEM_rank, first_elems);  addr -= (unsigned)first_elems * SAC_DISTMEM_rank; 

#define SAC_DISTMEM_GET_PTR_FOR_FREE( addr, first_elems) (  SAC_TR_DISTMEM_PRINT_EXPR( "Getting pointer for free from %p: %p (first elems: %zd).",  addr, addr + first_elems * SAC_DISTMEM_rank, first_elems)  addr + (unsigned)first_elems * SAC_DISTMEM_rank )

#define SAC_DISTMEM_SWITCH_TO_DIST_EXEC()  SAC_TR_DISTMEM_PRINT( "Switching to distributed execution mode.");  SAC_DISTMEM_CHECK_IS_SWITCH_TO_DIST_EXEC_ALLOWED()  SAC_PF_BEGIN_EXEC_DIST()  SAC_DISTMEM_exec_mode = SAC_DISTMEM_exec_mode_dist;  SAC_DISTMEM_FORBID_DSM_ALLOCS();

#define SAC_DISTMEM_SWITCH_TO_SYNC_EXEC()  if (SAC_DISTMEM_exec_mode == SAC_DISTMEM_exec_mode_dist) {  SAC_DISTMEM_ALLOW_DSM_ALLOCS();  }  SAC_TR_DISTMEM_PRINT( "Switching to replicated execution mode.");  SAC_DISTMEM_CHECK_IS_SWITCH_TO_SYNC_EXEC_ALLOWED()  SAC_PF_END_EXEC_MODE()  SAC_DISTMEM_exec_mode = SAC_DISTMEM_exec_mode_sync;

#define SAC_DISTMEM_SWITCH_TO_SIDE_EFFECTS_EXEC()  SAC_TR_DISTMEM_PRINT( "Switching to side effects execution mode.");  SAC_DISTMEM_CHECK_IS_SWITCH_TO_SIDE_EFFECTS_EXEC_ALLOWED()  SAC_DISTMEM_exec_mode = SAC_DISTMEM_exec_mode_side_effects;

#define SAC_DISTMEM_SWITCH_TO_SIDE_EFFECTS_OUTER_EXEC()  SAC_TR_DISTMEM_PRINT( "Switching to side effects outer execution mode.");  SAC_DISTMEM_CHECK_IS_SWITCH_TO_SIDE_EFFECTS_OUTER_EXEC_ALLOWED()  SAC_PF_BEGIN_EXEC_SIDE_EFFECTS()  SAC_DISTMEM_exec_mode = SAC_DISTMEM_exec_mode_side_effects_outer; 

#define SAC_DISTMEM_DET_ALLOC_DSM_IN_DSM()  FALSE 

#define SAC_DISTMEM_DSM_ELEM_POINTER( arr_offset, elem_type, node, elem_index) ((elem_type *)((uintptr_t)SAC_DISTMEM_local_seg_ptrs[node] + arr_offset) + elem_index)

#define _SAC_DISTMEM_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes, elem_index) ((elem_type *)((uintptr_t)SAC_DISTMEM_local_seg_ptrs[elem_index / elems_first_nodes] + arr_offset)  + elem_index % elems_first_nodes) 
#define _SAC_DISTMEM_PR_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes, elem_index) (  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_ptr_calcs),  _SAC_DISTMEM_ELEM_POINTER(arr_offset, elem_type, elems_first_nodes, elem_index) )

#define _SAC_DISTMEM_TR_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes, elem_index) (  (elems_first_nodes == 0) ? (  SAC_RuntimeError( "Invalid arguments for retrieving DSM pointer: element %zd, array offset: "  "%p, elems_first_nodes: %zd", elem_index, arr_offset, elems_first_nodes),  (elem_type *)NULL  ) : (  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_ptr_calcs),  SAC_TR_DISTMEM_AA_PRINT( "Retrieving pointer for element %zd owned by node %zd, segment "  "starting at: %p, offset within segment: %"PRIuPTR", array starting "  "at: %p, elems first nodes: %zd, offset within array: %zd, "  "element address: %p",  elem_index,  elem_index / elems_first_nodes,  (elem_type *)((uintptr_t)SAC_DISTMEM_local_seg_ptrs[elem_index / elems_first_nodes]),  arr_offset,  (elem_type *)((uintptr_t)SAC_DISTMEM_local_seg_ptrs[elem_index / elems_first_nodes] + arr_offset),  elems_first_nodes,  elem_index % elems_first_nodes,  _SAC_DISTMEM_ELEM_POINTER(arr_offset, elem_type, elems_first_nodes, elem_index))  _SAC_DISTMEM_ELEM_POINTER(arr_offset, elem_type, elems_first_nodes, elem_index)  ) )

#define SAC_DISTMEM_RECALC_INDEX( elems_first_nodes, elem_index) elem_index + (elems_first_nodes - elem_index % elems_first_nodes);

#define SAC_DISTMEM_ASSURE_IN_CACHE( arr_offset, elem_type, elems_first_nodes, elem_index, num_elems) {  SAC_TR_DISTMEM_PRINT( "Assuring that %d elements from index %d are in the local cache.",  num_elems, elem_index);  size_t rank;  for (rank = 0; rank < SAC_DISTMEM_size; rank++) {  if (rank == SAC_DISTMEM_rank) {  continue;  }  size_t first_elem_at_rank = SAC_MAX( elems_first_nodes * rank, elem_index);  size_t last_elem_at_rank = SAC_MIN( elems_first_nodes * (rank + 1) - 1, elem_index + num_elems - 1); if (last_elem_at_rank < first_elem_at_rank) {  SAC_TR_DISTMEM_PRINT( " No need to touch cache of node %zd.", rank);  continue;  }  SAC_TR_DISTMEM_PRINT( " Assuring that elements %zd to %zd are in the cache of node %zd.",  first_elem_at_rank, last_elem_at_rank, rank);  void *start_ptr = SAC_DISTMEM_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes,  first_elem_at_rank);  void *end_ptr = SAC_DISTMEM_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes,  last_elem_at_rank);  SAC_DISTMEM_CHECK_POINTER_VALID_FOR_READ( start_ptr);  SAC_DISTMEM_CHECK_POINTER_VALID_FOR_READ( end_ptr);  while ( (uintptr_t) start_ptr < (uintptr_t) end_ptr) {  SAC_TR_DISTMEM_PRINT( " Touching %p in cache of node %zd.", start_ptr, rank);  *((volatile elem_type*)start_ptr);  start_ptr = (elem_type*)((uintptr_t) start_ptr + SAC_DISTMEM_pagesz);  }  SAC_TR_DISTMEM_PRINT( " Touching %p in cache of node %zd.", end_ptr, rank);  *((volatile elem_type*)end_ptr);  } }

#define _BC_DIMSIZE_VAR( value_NT)  CAT12(NT_NAME( value_NT), __bc_dimsize_var)
#define _BC_DIMSIZE_OFFS( value_NT)  CAT12(NT_NAME( value_NT), __bc_dimsize_offs)
#define _BC_VAR( value_NT)  CAT12(NT_NAME( value_NT), __bc_var)
#define _BC_OFFS( value_NT)  CAT12(NT_NAME( value_NT), __bc_offs)
#define _BC_DESC_VAR( value_NT)  CAT12(NT_NAME( value_NT), __bc_desc_var)
#define _BC_DESC_OFFS( value_NT)  CAT12(NT_NAME( value_NT), __bc_desc_offs)
#define _BC_RC_VAR( value_NT)  CAT12(NT_NAME( value_NT), __bc_rc_var)
#define _BC_RC_OFFS( value_NT)  CAT12(NT_NAME( value_NT), __bc_rc_offs)

#define _SAC_DISTMEM_BROADCAST_WITH_DESC_INIT_COMMON( value_type, value_NT)  int *_BC_DIMSIZE_VAR( value_NT);  value_type *_BC_VAR( value_NT);  SAC_ND_DESC_TYPE( value_NT) _BC_DESC_VAR( value_NT);  uintptr_t _BC_DIMSIZE_OFFS( value_NT);  uintptr_t _BC_OFFS( value_NT);  uintptr_t _BC_DESC_OFFS( value_NT);  SAC_TR_DISTMEM_PRINT(  "Initializing broadcast with descriptor of variable %s (type: %s).",  NT_STR(value_NT),  #value_type);  SAC_DISTMEM_HM_MALLOC( _BC_DIMSIZE_VAR( value_NT),  2 * sizeof( int),  int)  SAC_TR_DISTMEM_PRINT( "BC dimsize starting at: %p (offset: %"  PRIuPTR")",  _BC_DIMSIZE_VAR( value_NT),  _BC_DIMSIZE_OFFS( value_NT));  _BC_DIMSIZE_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_DIMSIZE_VAR( value_NT));

#define SAC_DISTMEM_BROADCAST_WITH_DESC_INIT_MASTER( value_type, value_NT)  _SAC_DISTMEM_BROADCAST_WITH_DESC_INIT_COMMON( value_type, value_NT)  _BC_DIMSIZE_VAR( value_NT)[0] =  SAC_A_DIM_BEFORE_UPDATE_MIRROR( value_NT);  _BC_DIMSIZE_VAR( value_NT)[1] = SAC_ND_A_DESC_SIZE( value_NT);  SAC_TR_DISTMEM_PRINT( "BC dim: %d, size: %d",  _BC_DIMSIZE_VAR( value_NT)[0],  _BC_DIMSIZE_VAR( value_NT)[1]);  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE_WITH_DESC(  _BC_VAR( value_NT),  _BC_DESC_VAR( value_NT),  SAC_ND_A_DESC_SIZE( value_NT) * sizeof( value_type),  SAC_A_DIM_BEFORE_UPDATE_MIRROR( value_NT),  value_type,  SAC_ND_DESC_BASETYPE( value_NT));  _BC_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_VAR( value_NT));  SAC_TR_DISTMEM_PRINT( "BC data starting at: %p (offset: %"  PRIuPTR")",  _BC_VAR( value_NT),  _BC_OFFS( value_NT));  _BC_DESC_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_DESC_VAR( value_NT));  SAC_TR_DISTMEM_PRINT( "BC descriptor starting at: %p (offset: %"  PRIuPTR")",  _BC_DESC_VAR( value_NT),  _BC_DESC_OFFS( value_NT));  SAC_TR_DISTMEM_PRINT( "BC copying %d B of descriptor from %p.",  BYTE_SIZE_OF_DESC( SAC_A_DIM_BEFORE_UPDATE_MIRROR( value_NT)), _BC_DESC_VAR( value_NT));  memcpy(_BC_DESC_VAR( value_NT),  SAC_ND_A_DESC( value_NT),  BYTE_SIZE_OF_DESC( SAC_A_DIM_BEFORE_UPDATE_MIRROR( value_NT)));  SAC_TR_DISTMEM_PRINT( "BC copying %d B of data from %p.",  SAC_ND_A_SIZE( value_NT)  * sizeof( value_type),  SAC_ND_A_FIELD( value_NT));  memcpy(_BC_VAR( value_NT),  SAC_ND_A_FIELD( value_NT),  SAC_ND_A_DESC_SIZE( value_NT) * sizeof( value_type));

#define SAC_DISTMEM_BROADCAST_WITH_DESC_INIT_WORKER( value_type, value_NT) _SAC_DISTMEM_BROADCAST_WITH_DESC_INIT_COMMON( value_type, value_NT)  SAC_DISTMEM_INVAL_CACHE_OF_NODE(  _BC_DIMSIZE_OFFS( value_NT),  SAC_DISTMEM_RANK_MASTER,  2 * sizeof(int));  _BC_VAR( value_NT) = NULL; 

#define _SAC_DISTMEM_BROADCAST_INIT_COMMON( value_type, value_NT)  value_type *_BC_VAR( value_NT);  uintptr_t _BC_OFFS( value_NT);  SAC_TR_DISTMEM_PRINT(  "Initializing broadcast of variable %s (type: %s).",  NT_STR(value_NT),  #value_type); 

#define SAC_DISTMEM_BROADCAST_INIT_MASTER( value_type, value_NT)  _SAC_DISTMEM_BROADCAST_INIT_COMMON( value_type, value_NT)  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE(  _BC_VAR( value_NT),  SAC_ND_A_SIZE( value_NT) * sizeof( value_type),  value_type);  _BC_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_VAR( value_NT));  SAC_TR_DISTMEM_PRINT( "BC data starting at: %p (offset: %"  PRIuPTR")",  _BC_VAR( value_NT),  _BC_OFFS( value_NT));  SAC_TR_DISTMEM_PRINT( "BC copying %d B of data from %p.",  SAC_ND_A_SIZE( value_NT)  * sizeof( value_type),  SAC_ND_A_FIELD( value_NT));  memcpy(_BC_VAR( value_NT),  SAC_ND_A_FIELD( value_NT),  SAC_ND_A_SIZE( value_NT) * sizeof( value_type));

#define SAC_DISTMEM_BROADCAST_INIT_WORKER( value_type, value_NT)  _SAC_DISTMEM_BROADCAST_INIT_COMMON( value_type, value_NT)

#define _SAC_DISTMEM_BROADCAST_SCL_INIT_COMMON( value_type, value_NT)  value_type *_BC_VAR( value_NT);  uintptr_t _BC_OFFS( value_NT);  SAC_TR_DISTMEM_PRINT(  "Initializing scalar broadcast of variable %s (type: %s).",  NT_STR(value_NT),  #value_type);

#define SAC_DISTMEM_BROADCAST_SCL_INIT_MASTER( value_type, value_NT)  _SAC_DISTMEM_BROADCAST_INIT_COMMON( value_type, value_NT)  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE(  _BC_VAR( value_NT),  sizeof( value_type),  value_type);  _BC_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_VAR( value_NT));  SAC_TR_DISTMEM_PRINT( "BC data starting at: %p (offset: %"  PRIuPTR")",  _BC_VAR( value_NT),  _BC_OFFS( value_NT));  SAC_TR_DISTMEM_PRINT( "BC copying %d B of data from %p.",  sizeof( value_type),  &SAC_ND_A_FIELD( value_NT));  memcpy(_BC_VAR( value_NT),  &SAC_ND_A_FIELD( value_NT),  sizeof( value_type));

#define SAC_DISTMEM_BROADCAST_SCL_INIT_WORKER( value_type, value_NT)  _SAC_DISTMEM_BROADCAST_INIT_COMMON( value_type, value_NT)

#define _SAC_DISTMEM_BROADCAST_RC_INIT_COMMON( value_NT)  intptr_t *_BC_RC_VAR( value_NT) = NULL;  uintptr_t _BC_RC_OFFS( value_NT) = 0;  if (SAC_ND_A_IS_DIST( value_NT)) {  SAC_TR_DISTMEM_PRINT(  "Initializing RC broadcast of variable %s.",  NT_STR(value_NT));  }

#define SAC_DISTMEM_BROADCAST_RC_INIT_MASTER( value_NT)  _SAC_DISTMEM_BROADCAST_RC_INIT_COMMON( value_NT)  if (SAC_ND_A_IS_DIST( value_NT)) {  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE(  _BC_RC_VAR( value_NT),  sizeof( intptr_t),  intptr_t);  _BC_RC_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_RC_VAR( value_NT));  SAC_TR_DISTMEM_PRINT( "BC RC starting at: %p (offset: %" PRIuPTR")",  _BC_RC_VAR( value_NT),  _BC_RC_OFFS( value_NT));  SAC_TR_DISTMEM_PRINT( "BC copying %d B of RC "  "(value: %"PRIdPTR") from %p to %p.", sizeof( intptr_t),  SAC_ND_A_RC( value_NT),  &SAC_ND_A_RC( value_NT),  _BC_RC_VAR( value_NT));  *_BC_RC_VAR( value_NT) = SAC_ND_A_RC( value_NT);  }

#define SAC_DISTMEM_BROADCAST_RC_INIT_WORKER( value_NT)  _SAC_DISTMEM_BROADCAST_RC_INIT_COMMON( value_NT)

#define SAC_DISTMEM_BROADCAST_WITH_DESC_STEP1_WORKER( value_type, value_NT)  SAC_TR_DISTMEM_PRINT( "Finalizing broadcast with descriptor "  "of variable %s (type: %s), step 1.",  NT_STR(value_NT), #value_type);  SAC_UPDATE_A_MIRROR_DIM( value_NT, *SAC_DISTMEM_DSM_ELEM_POINTER(  _BC_DIMSIZE_OFFS( value_NT),  int, SAC_DISTMEM_RANK_MASTER, 0));  SAC_ND_A_MIRROR_SIZE( value_NT) = *SAC_DISTMEM_DSM_ELEM_POINTER(  _BC_DIMSIZE_OFFS( value_NT),  int, SAC_DISTMEM_RANK_MASTER, 1);  SAC_TR_DISTMEM_PRINT( "BC dim: %d, size: %d",  _BC_DIMSIZE_VAR( value_NT)[0],  _BC_DIMSIZE_VAR( value_NT)[1]);  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE_WITH_DESC(  _BC_VAR( value_NT),  _BC_DESC_VAR( value_NT),  SAC_ND_A_SIZE( value_NT) * sizeof( value_type),  SAC_ND_A_DIM( value_NT),  value_type,  SAC_ND_DESC_BASETYPE( value_NT));  _BC_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_VAR( value_NT));  SAC_TR_DISTMEM_PRINT( "BC data starting at: %p (offset: %"  PRIuPTR")",  _BC_VAR( value_NT),  _BC_OFFS( value_NT));  _BC_DESC_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_DESC_VAR( value_NT));  SAC_TR_DISTMEM_PRINT( "BC descriptor starting at: %p (offset: %"  PRIuPTR")",  _BC_DESC_VAR( value_NT),  _BC_DESC_OFFS( value_NT));  SAC_DISTMEM_INVAL_CACHE_OF_NODE(  _BC_OFFS( value_NT),  SAC_DISTMEM_RANK_MASTER,  SAC_ND_A_SIZE( value_NT) * sizeof( value_type));  SAC_DISTMEM_INVAL_CACHE_OF_NODE(  _BC_DESC_OFFS( value_NT),  SAC_DISTMEM_RANK_MASTER,  BYTE_SIZE_OF_DESC( SAC_ND_A_DIM( value_NT))); 

#define SAC_DISTMEM_BROADCAST_WITH_DESC_STEP2_WORKER( value_type, value_NT)  SAC_TR_DISTMEM_PRINT( "Finalizing broadcast with descriptor "  "of variable %s (type: %s), step 2.",  NT_STR(value_NT), #value_type);  SAC_ND_ALLOC_BEGIN( value_NT, 1, SAC_ND_A_DIM( value_NT),  value_type)  SAC_TR_DISTMEM_PRINT( "BC copying %d B of descriptor to %p.",  BYTE_SIZE_OF_DESC( SAC_ND_A_DIM( value_NT)),  SAC_ND_A_DESC( value_NT));  memcpy(SAC_ND_A_DESC( value_NT),  _BC_DESC_VAR( value_NT),  BYTE_SIZE_OF_DESC( SAC_ND_A_DIM( value_NT)));  SAC_ND_ALLOC_END( value_NT, 1, SAC_ND_A_DIM( value_NT),  value_type)  SAC_TR_DISTMEM_PRINT( "BC copying %d B of data to %p.",  SAC_ND_A_SIZE( value_NT) * sizeof( value_type),  SAC_ND_A_FIELD( value_NT));  memcpy(SAC_ND_A_FIELD( value_NT),  SAC_DISTMEM_DSM_ELEM_POINTER(  _BC_OFFS( value_NT), value_type,  SAC_DISTMEM_RANK_MASTER, 0),  SAC_ND_A_SIZE( value_NT) * sizeof( value_type));

#define SAC_DISTMEM_BROADCAST_STEP1_WORKER( value_type, value_NT)  SAC_TR_DISTMEM_PRINT( "Finalizing broadcast "  "of variable %s (type: %s), step 1",  NT_STR(value_NT), #value_type);  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE(  _BC_VAR( value_NT),  SAC_ND_A_SIZE( value_NT) * sizeof( value_type),  value_type);  _BC_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_VAR( value_NT));  SAC_TR_DISTMEM_PRINT( "BC data starting at: %p (offset: %"  PRIuPTR")",  _BC_VAR( value_NT),  _BC_OFFS( value_NT));  SAC_DISTMEM_INVAL_CACHE_OF_NODE(  _BC_OFFS( value_NT),  SAC_DISTMEM_RANK_MASTER,  SAC_ND_A_SIZE( value_NT) * sizeof( value_type));

#define SAC_DISTMEM_BROADCAST_STEP2_WORKER( value_type, value_NT)  SAC_TR_DISTMEM_PRINT( "Finalizing broadcast "  "of variable %s (type: %s), step 2",  NT_STR(value_NT), #value_type);  SAC_ND_ALLOC_BEGIN( value_NT, 1, SAC_ND_A_DIM( value_NT),  value_type)  SAC_ND_ALLOC_END( value_NT, 1, SAC_ND_A_DIM( value_NT),  value_type)  SAC_TR_DISTMEM_PRINT( "BC copying %d B of data to %p.",  SAC_ND_A_SIZE( value_NT) * sizeof( value_type),  SAC_ND_A_FIELD( value_NT));  memcpy(SAC_ND_A_FIELD( value_NT),  SAC_DISTMEM_DSM_ELEM_POINTER(  _BC_OFFS( value_NT), value_type,  SAC_DISTMEM_RANK_MASTER, 0),  SAC_ND_A_SIZE( value_NT) * sizeof( value_type));

#define SAC_DISTMEM_BROADCAST_SCL_STEP1_WORKER( value_type, value_NT)  SAC_TR_DISTMEM_PRINT( "Finalizing scalar broadcast "  "of variable %s (type: %s), step 1",  NT_STR(value_NT), #value_type);  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE(  _BC_VAR( value_NT),  sizeof( value_type),  value_type);  _BC_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_VAR( value_NT));  SAC_TR_DISTMEM_PRINT( "BC data starting at: %p (offset: %"  PRIuPTR")",  _BC_VAR( value_NT),  _BC_OFFS( value_NT));  SAC_DISTMEM_INVAL_CACHE_OF_NODE(  _BC_OFFS( value_NT),  SAC_DISTMEM_RANK_MASTER,  sizeof( value_type));

#define SAC_DISTMEM_BROADCAST_SCL_STEP2_WORKER( value_type, value_NT)  SAC_TR_DISTMEM_PRINT( "Finalizing scalar broadcast "  "of variable %s (type: %s), step 2",  NT_STR(value_NT), #value_type);  SAC_TR_DISTMEM_PRINT( "BC copying %d B of data to %p.",  sizeof( value_type),  &SAC_ND_A_FIELD( value_NT));  memcpy(&SAC_ND_A_FIELD( value_NT),  SAC_DISTMEM_DSM_ELEM_POINTER(  _BC_OFFS( value_NT), value_type,  SAC_DISTMEM_RANK_MASTER, 0),  sizeof( value_type));

#define SAC_DISTMEM_BROADCAST_RC_STEP1_WORKER( value_NT)  if (SAC_ND_A_IS_DIST( value_NT)) {  SAC_TR_DISTMEM_PRINT( "Finalizing RC broadcast "  "of variable %s, step 1",  NT_STR(value_NT));  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE(  _BC_RC_VAR( value_NT),  sizeof( intptr_t),  intptr_t);  _BC_RC_OFFS( value_NT) =  SAC_DISTMEM_DET_OFFS( _BC_RC_VAR( value_NT));  SAC_TR_DISTMEM_PRINT( "BC RC starting at: %p (offset: %"  PRIuPTR")",  _BC_RC_VAR( value_NT),  _BC_RC_OFFS( value_NT));  SAC_DISTMEM_INVAL_CACHE_OF_NODE(  _BC_RC_OFFS( value_NT),  SAC_DISTMEM_RANK_MASTER,  sizeof( intptr_t));  }

#define SAC_DISTMEM_BROADCAST_RC_STEP2_WORKER( value_NT)  if (SAC_ND_A_IS_DIST( value_NT)) {  SAC_TR_DISTMEM_PRINT( "Finalizing RC broadcast "  "of variable %s, step 2",  NT_STR(value_NT));  SAC_TR_DISTMEM_PRINT( "BC copying %d B of RC (value: %"  PRIdPTR") from %p to %p.",  sizeof( intptr_t),  *SAC_DISTMEM_DSM_ELEM_POINTER(  _BC_RC_OFFS( value_NT), intptr_t,  SAC_DISTMEM_RANK_MASTER, 0),  _BC_RC_VAR( value_NT),  &SAC_ND_A_RC( value_NT));  SAC_ND_SET__RC( value_NT, *SAC_DISTMEM_DSM_ELEM_POINTER(  _BC_RC_OFFS( value_NT), intptr_t,  SAC_DISTMEM_RANK_MASTER, 0));  }

#define SAC_DISTMEM_BROADCAST_WITH_DESC_FREE_MEM_COMMON( value_type, value_NT)  SAC_TR_DISTMEM_PRINT( "Freeing memory after broadcast with "  "descriptor of variable %s of type %s.",  NT_STR(value_NT), #value_type);  SAC_DISTMEM_HM_FREE(_BC_VAR( value_NT))  SAC_DISTMEM_HM_FREE(_BC_DIMSIZE_VAR( value_NT))  SAC_TR_DISTMEM_PRINT( "Done with broadcast with "  "descriptor of variable %s of type %s.",  NT_STR(value_NT), #value_type);

#define SAC_DISTMEM_BROADCAST_FREE_MEM_COMMON( value_type, value_NT)  SAC_TR_DISTMEM_PRINT( "Freeing memory after broadcast of variable %s of type %s.",  NT_STR(value_NT), #value_type);  SAC_DISTMEM_HM_FREE(_BC_VAR( value_NT))  SAC_TR_DISTMEM_PRINT( "Done with broadcast of variable %s of type %s.",  NT_STR(value_NT), #value_type); 

#define SAC_DISTMEM_BROADCAST_SCL_FREE_MEM_COMMON( value_type, value_NT)  SAC_TR_DISTMEM_PRINT( "Freeing memory after scalar broadcast of variable %s of type %s.",  NT_STR(value_NT), #value_type);  SAC_DISTMEM_HM_FREE(_BC_VAR( value_NT))  SAC_TR_DISTMEM_PRINT( "Done with broadcast of variable %s of type %s.",  NT_STR(value_NT), #value_type); 

#define SAC_DISTMEM_BROADCAST_RC_FREE_MEM_COMMON( value_NT)  if (SAC_ND_A_IS_DIST( value_NT)) {  SAC_TR_DISTMEM_PRINT( "Freeing memory after RC broadcast of variable %s.",  NT_STR(value_NT));  SAC_DISTMEM_HM_FREE(_BC_RC_VAR( value_NT))  SAC_TR_DISTMEM_PRINT( "Decrementing RC of variable %s (old value: %"  PRIdPTR").",  NT_STR(value_NT),  SAC_ND_A_RC( value_NT));  SAC_ND_DEC_RC_FREE( value_NT, 1, );  SAC_TR_DISTMEM_PRINT( "Done with RC broadcast of variable %s.",  NT_STR(value_NT));  }

#if SAC_DO_CHECK_DISTMEM

#define SAC_DISTMEM_ALLOW_DSM_ALLOCS() {  SAC_TR_DISTMEM_PRINT( "Allowing allocations in the DSM segment.");  SAC_DISTMEM_are_dsm_allocs_allowed = TRUE; }

#define SAC_DISTMEM_FORBID_DSM_ALLOCS() {  SAC_TR_DISTMEM_PRINT( "Forbidding allocations in the DSM segment.");  SAC_DISTMEM_are_dsm_allocs_allowed = FALSE; }

#define SAC_DISTMEM_ALLOW_DIST_WRITES() {  SAC_TR_DISTMEM_PRINT( "Allowing write accesses to distributed arrays.");  SAC_DISTMEM_are_dist_writes_allowed = TRUE; }

#define SAC_DISTMEM_FORBID_DIST_WRITES() {  SAC_TR_DISTMEM_PRINT( "Forbidding write accesses to distributed arrays.");  SAC_DISTMEM_are_dist_writes_allowed = FALSE; }

#define SAC_DISTMEM_ALLOW_CACHE_WRITES() {  SAC_TR_DISTMEM_PRINT( "Allowing write accesses to distributed "  "arrays (also directly into the local cache).");  SAC_DISTMEM_are_dist_writes_allowed = TRUE;  SAC_DISTMEM_are_cache_writes_allowed = TRUE; }

#define SAC_DISTMEM_FORBID_CACHE_WRITES() {  SAC_TR_DISTMEM_PRINT( "Forbidding write accesses to distributed "  "arrays (also directly into the local cache).");  SAC_DISTMEM_are_dist_writes_allowed = FALSE;  SAC_DISTMEM_are_cache_writes_allowed = FALSE; }

#define SAC_DISTMEM_IS_VALID_WRITE_PTR( ptr) (  ((uintptr_t) ptr < (uintptr_t) SAC_DISTMEM_shared_seg_ptr  || (uintptr_t) ptr > SAC_DISTMEM_CH_max_valid_write_ptr)  ? FALSE  : TRUE )

#define SAC_DISTMEM_IS_VALID_LOCAL_READ_PTR( ptr)  SAC_DISTMEM_IS_VALID_WRITE_PTR( ptr)

#define SAC_DISTMEM_IS_VALID_LOCAL_READ_IDX( var_NT, elem_idx) (  (elem_idx < SAC_DISTMEM_DET_LOCAL_FROM( var_NT)  || elem_idx > SAC_DISTMEM_DET_LOCAL_TO( var_NT))  ? FALSE  : TRUE )

#define SAC_DISTMEM_IS_VALID_CACHE_PTR( ptr) (  ((uintptr_t) ptr < (uintptr_t) SAC_DISTMEM_cache_ptr  || (uintptr_t) ptr > SAC_DISTMEM_CH_max_valid_cache_ptr)  ? FALSE  : TRUE )

#define SAC_DISTMEM_IS_VALID_READ_PTR( ptr) (  (SAC_DISTMEM_IS_VALID_WRITE_PTR( ptr)  || SAC_DISTMEM_IS_VALID_CACHE_PTR( ptr))  ? TRUE  : FALSE )

#define SAC_DISTMEM_IS_NON_DIST_PTR( ptr) (  (!SAC_DISTMEM_IS_VALID_WRITE_PTR( ptr)  && !SAC_DISTMEM_IS_VALID_CACHE_PTR( ptr))  ? TRUE  : FALSE )
#else 
#define SAC_DISTMEM_ALLOW_DSM_ALLOCS()
#define SAC_DISTMEM_FORBID_DSM_ALLOCS()
#define SAC_DISTMEM_ALLOW_DIST_WRITES()
#define SAC_DISTMEM_FORBID_DIST_WRITES()
#define SAC_DISTMEM_ALLOW_CACHE_WRITES()
#define SAC_DISTMEM_FORBID_CACHE_WRITES()
#endif 

#if SAC_DO_TRACE_DISTMEM
#define SAC_DISTMEM_INIT()  SAC_DISTMEM_TR_Init( __argc, __argv);
#define SAC_DISTMEM_SETUP()  SAC_DISTMEM_TR_Setup( SAC_SET_DISTMEM_MAX_MEMORY_MB, SAC_SET_DISTMEM_MIN_ELEMS_PER_NODE,  SAC_SET_DISTMEM_TRACE_PROFILE_NODE, SAC_DO_DISTMEM_ALLOC_CACHE_OUTSIDE_DSM);
#define SAC_DISTMEM_INVAL_ENTIRE_CACHE()  SAC_DISTMEM_TR_InvalEntireCache();
#define SAC_DISTMEM_INVAL_CACHE( arr_offset, b)  SAC_DISTMEM_TR_InvalCache( arr_offset, b);
#define SAC_DISTMEM_INVAL_CACHE_OF_NODE( arr_offset, node, b)  SAC_DISTMEM_TR_InvalCacheOfNode( arr_offset, node, b);
#define SAC_DISTMEM_BARRIER()  SAC_PF_BEGIN_BARRIER()  SAC_DISTMEM_TR_Barrier();  SAC_PF_END_BARRIER() 
#define SAC_DISTMEM_EXIT( exit_code)  SAC_DISTMEM_TR_Exit( exit_code);
#define SAC_DISTMEM_ABORT( exit_code)  SAC_DISTMEM_TR_Abort( exit_code);
#define SAC_DISTMEM_DET_DO_DISTR_ARR( total_elems, dim0_size)  SAC_DISTMEM_TR_DetDoDistrArr( total_elems, dim0_size);
#define SAC_DISTMEM_DET_MAX_ELEMS_PER_NODE( total_elems, dim0_size)  SAC_DISTMEM_TR_DetMaxElemsPerNode( total_elems, dim0_size); 
#define SAC_DISTEM_DET_DIM0_START( dim0_size, start_range, stop_range)  SAC_DISTMEM_TR_DetDim0Start( dim0_size, start_range, stop_range);
#define SAC_DISTEM_DET_DIM0_STOP( dim0_size, start, stop)  SAC_DISTMEM_TR_DetDim0Stop( dim0_size, start, stop);
#define SAC_DISTMEM_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes, elem_index)  _SAC_DISTMEM_TR_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes, elem_index)
#define SAC_DISTMEM_ELEM_DESC_POINTER( var_NT, elem_index)  _SAC_DISTMEM_TR_ELEM_DESC_POINTER( var_NT, elem_index)
#define SAC_DISTMEM_AVOIDED_PTR_CALC_LOCAL_WRITE_EXPR()  SAC_TR_DISTMEM_AA_PRINT("Avoided pointer calculation for local write.")  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_avoided_ptr_calcs_local_writes),
#define SAC_DISTMEM_AVOIDED_PTR_CALC_LOCAL_READ_EXPR( var_NT) (  SAC_ND_A_IS_DIST( var_NT)  ? (SAC_TR_DISTMEM_AA_PRINT("Avoided pointer calculation for local read.")  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_avoided_ptr_calcs_local_reads), 0)  : 0 ),
#define SAC_DISTMEM_AVOIDED_PTR_CALC_KNOWN_LOCAL_READ_EXPR( var_NT) (  SAC_ND_A_IS_DIST( var_NT)  ? (SAC_TR_DISTMEM_AA_PRINT("Avoided pointer calculation for known to be local read.")  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_avoided_ptr_calcs_known_local_reads), 0) : 0 ),
#define SAC_DISTMEM_AVOIDED_PTR_CALC_REMOTE_READ_EXPR()  SAC_TR_DISTMEM_AA_PRINT("Avoided pointer calculation for remote read.")  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_avoided_ptr_calcs_remote_reads),
#define SAC_DISTMEM_UPDATED_PTR_CACHE_EXPR()  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_ptr_cache_updates),
#elif SAC_DO_PROFILE_DISTMEM
#define SAC_DISTMEM_INIT()  SAC_DISTMEM_PR_Init( __argc, __argv);
#define SAC_DISTMEM_SETUP()  SAC_DISTMEM_PR_Setup( SAC_SET_DISTMEM_MAX_MEMORY_MB, SAC_SET_DISTMEM_MIN_ELEMS_PER_NODE,  SAC_SET_DISTMEM_TRACE_PROFILE_NODE, SAC_DO_DISTMEM_ALLOC_CACHE_OUTSIDE_DSM);
#define SAC_DISTMEM_INVAL_ENTIRE_CACHE()  SAC_DISTMEM_PR_InvalEntireCache();
#define SAC_DISTMEM_INVAL_CACHE( arr_offset, b)  SAC_DISTMEM_PR_InvalCache( arr_offset, b);
#define SAC_DISTMEM_INVAL_CACHE_OF_NODE( arr_offset, node, b)  SAC_DISTMEM_PR_InvalCacheOfNode( arr_offset, node, b);
#define SAC_DISTMEM_BARRIER()  SAC_PF_BEGIN_BARRIER()  SAC_DISTMEM_PR_Barrier();  SAC_PF_END_BARRIER() 
#define SAC_DISTMEM_EXIT( exit_code)  SAC_DISTMEM_PR_Exit( exit_code);
#define SAC_DISTMEM_ABORT( exit_code)  SAC_DISTMEM_PR_Abort( exit_code);
#define SAC_DISTMEM_DET_DO_DISTR_ARR( total_elems, dim0_size)  SAC_DISTMEM_PR_DetDoDistrArr( total_elems, dim0_size);
#define SAC_DISTMEM_DET_MAX_ELEMS_PER_NODE( total_elems, dim0_size)  SAC_DISTMEM_PR_DetMaxElemsPerNode( total_elems, dim0_size); 
#define SAC_DISTEM_DET_DIM0_START( dim0_size, start_range, stop_range)  SAC_DISTMEM_PR_DetDim0Start( dim0_size, start_range, stop_range);
#define SAC_DISTEM_DET_DIM0_STOP( dim0_size, start, stop)  SAC_DISTMEM_PR_DetDim0Stop( dim0_size, start, stop);
#define SAC_DISTMEM_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes, elem_index)  _SAC_DISTMEM_PR_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes, elem_index)
#define SAC_DISTMEM_ELEM_DESC_POINTER( var_NT, elem_index)  _SAC_DISTMEM_PR_ELEM_DESC_POINTER( var_NT, elem_index)
#define SAC_DISTMEM_AVOIDED_PTR_CALC_LOCAL_WRITE_EXPR()  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_avoided_ptr_calcs_local_writes),
#define SAC_DISTMEM_AVOIDED_PTR_CALC_LOCAL_READ_EXPR( var_NT)  (SAC_ND_A_IS_DIST( var_NT) ? (SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_avoided_ptr_calcs_local_reads), 0) : 0),
#define SAC_DISTMEM_AVOIDED_PTR_CALC_KNOWN_LOCAL_READ_EXPR( var_NT)  (SAC_ND_A_IS_DIST( var_NT) ? (SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_avoided_ptr_calcs_known_local_reads), 0) : 0),
#define SAC_DISTMEM_AVOIDED_PTR_CALC_REMOTE_READ_EXPR()  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_avoided_ptr_calcs_remote_reads),
#define SAC_DISTMEM_UPDATED_PTR_CACHE_EXPR()  SAC_DISTMEM_IncCounter( &SAC_DISTMEM_TR_num_ptr_cache_updates),
#else
#define SAC_DISTMEM_INIT()  SAC_DISTMEM_Init( __argc, __argv);
#define SAC_DISTMEM_SETUP()  SAC_DISTMEM_Setup( SAC_SET_DISTMEM_MAX_MEMORY_MB, SAC_SET_DISTMEM_MIN_ELEMS_PER_NODE,  SAC_SET_DISTMEM_TRACE_PROFILE_NODE, SAC_DO_DISTMEM_ALLOC_CACHE_OUTSIDE_DSM);
#define SAC_DISTMEM_INVAL_ENTIRE_CACHE()  SAC_DISTMEM_InvalEntireCache();
#define SAC_DISTMEM_INVAL_CACHE( arr_offset, b)  SAC_DISTMEM_InvalCache( arr_offset, b);
#define SAC_DISTMEM_INVAL_CACHE_OF_NODE( arr_offset, node, b)  SAC_DISTMEM_InvalCacheOfNode( arr_offset, node, b);
#define SAC_DISTMEM_BARRIER()  SAC_DISTMEM_Barrier();
#define SAC_DISTMEM_EXIT( exit_code)  SAC_DISTMEM_Exit( exit_code);
#define SAC_DISTMEM_ABORT( exit_code)  SAC_DISTMEM_Abort( exit_code);
#define SAC_DISTMEM_DET_DO_DISTR_ARR( total_elems, dim0_size)  SAC_DISTMEM_DetDoDistrArr( total_elems, dim0_size);
#define SAC_DISTMEM_DET_MAX_ELEMS_PER_NODE( total_elems, dim0_size)  SAC_DISTMEM_DetMaxElemsPerNode( total_elems, dim0_size);
#define SAC_DISTEM_DET_DIM0_START( dim0_size, start_range, stop_range)  SAC_DISTMEM_DetDim0Start( dim0_size, start_range, stop_range);
#define SAC_DISTEM_DET_DIM0_STOP( dim0_size, start_range, stop_range)  SAC_DISTMEM_DetDim0Stop( dim0_size, start_range, stop_range);
#define SAC_DISTMEM_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes, elem_index)  _SAC_DISTMEM_ELEM_POINTER( arr_offset, elem_type, elems_first_nodes, elem_index)
#define SAC_DISTMEM_ELEM_DESC_POINTER( var_NT, elem_index)  _SAC_DISTMEM_ELEM_DESC_POINTER( var_NT, elem_index)
#define SAC_DISTMEM_AVOIDED_PTR_CALC_LOCAL_WRITE_EXPR()
#define SAC_DISTMEM_AVOIDED_PTR_CALC_LOCAL_READ_EXPR( var_NT)
#define SAC_DISTMEM_AVOIDED_PTR_CALC_KNOWN_LOCAL_READ_EXPR( var_NT)
#define SAC_DISTMEM_AVOIDED_PTR_CALC_REMOTE_READ_EXPR()
#define SAC_DISTMEM_UPDATED_PTR_CACHE_EXPR()
#endif
#else 

#define SAC_DISTMEM_ABORT( exit_code)  SAC_DISTMEM_Abort( exit_code);
#define SAC_DISTMEM_BARRIER()

#endif 
#endif 


#ifndef _SAC_CUDAHYBRID_H_
#define _SAC_CUDAHYBRID_H_

#define SAC_DIST_ALLOC( var_NT, rc, dim, basetype)  SAC_ND_ALLOC__DESC( var_NT, dim)  SAC_ND_A_FIELD( var_NT) = dist_var_alloc(SAC_ND_A_SHAPE( var_NT, 0) , SAC_ND_A_SIZE( var_NT), sizeof( basetype));  SAC_ND_SET__RC( var_NT, rc)
#define SAC_DIST_FREE( var_NT, freefun)  dist_var_free( SAC_ND_A_FIELD( var_NT));
#define SAC_DIST_DEC_RC_FREE( var_NT, rc, freefun) {  SAC_TR_REF_PRINT( ("DIST_DEC_RC_FREE( %s, %d, %s)",  NT_STR( var_NT), rc, #freefun))  if ((SAC_ND_A_RC( var_NT) -= rc) == 0) {  SAC_TR_REF_PRINT_RC( var_NT)  SAC_DIST_FREE( var_NT, freefun)  }  else {  SAC_TR_REF_PRINT_RC( var_NT)  } }

#define SAC_DIST_DEV2DIST( to_NT, orig_NT, devnumber_NT, start_NT, stop_NT)  SAC_ND_A_FIELD( to_NT) = conc2dist(SAC_ND_A_FIELD( orig_NT), SAC_ND_A_FIELD( start_NT), SAC_ND_A_FIELD( stop_NT), SAC_ND_A_FIELD( devnumber_NT));
#define SAC_DIST_HOST2DIST_SPMD( to_NT, orig_NT)  SAC_ND_A_FIELD( to_NT) = conc2dist(SAC_ND_A_FIELD( orig_NT), SAC_WL_MT_SCHEDULE_START( 0), SAC_WL_MT_SCHEDULE_STOP( 0), 0);
#define SAC_DIST_HOST2DIST_ST( to_NT, orig_NT, start, stop)  SAC_ND_A_FIELD( to_NT) = conc2dist(SAC_ND_A_FIELD( orig_NT), start, stop, 0);
#define SAC_DIST_DIST2HOST_ABS( to_NT, from_NT, start, stop, setOwner, basetype)  SAC_ND_A_FIELD( to_NT) = (basetype *)dist2conc(SAC_ND_A_FIELD( from_NT), start, stop, 0, setOwner, (cudaStream_t *)0); SAC_ND_A_DESC( to_NT) = SAC_ND_A_DESC( from_NT);
#define SAC_DIST_DIST2DEV_ABS( to_NT, from_NT, start, stop, device_NT, basetype)  SAC_ND_A_FIELD( to_NT) = (basetype *)dist2conc(SAC_ND_A_FIELD( from_NT), start, stop, SAC_ND_A_FIELD( device_NT), FALSE, stream); SAC_ND_A_DESC( to_NT) = SAC_ND_A_DESC( from_NT);
#define SAC_DIST_DIST2HOST_REL( to_NT, from_NT, start, stop, setOwner, basetype)  SAC_ND_A_FIELD( to_NT) = (basetype *)dist2conc(SAC_ND_A_FIELD( from_NT), start+SAC_WL_MT_SCHEDULE_START( 0), stop+SAC_WL_MT_SCHEDULE_STOP( 0), 0, setOwner, (cudaStream_t *)0); SAC_ND_A_DESC( to_NT) = SAC_ND_A_DESC( from_NT);
#define SAC_DIST_DIST2DEV_REL( to_NT, from_NT, start, stop, device_NT, basetype)  SAC_ND_A_FIELD( to_NT) = (basetype *)dist2conc(SAC_ND_A_FIELD( from_NT), start+SAC_WL_MT_SCHEDULE_START( 0), stop+SAC_WL_MT_SCHEDULE_STOP( 0), SAC_ND_A_FIELD( device_NT), TRUE, stream); SAC_ND_A_DESC( to_NT) = SAC_ND_A_DESC( from_NT);
#define SAC_DIST_DIST2DEV_AVAIL( to_NT, from_NT, start, stop, device_NT, start_NT, stop_NT, basetype)  SAC_ND_A_FIELD( to_NT) = (basetype *)dist2conc(SAC_ND_A_FIELD( from_NT), start +SAC_ND_A_FIELD( start_NT), stop +SAC_ND_A_FIELD( stop_NT), SAC_ND_A_FIELD( device_NT), FALSE, stream); SAC_ND_A_DESC( to_NT) = SAC_ND_A_DESC( from_NT);
#define SAC_DIST_DISTCONTBLOCK( to_NT, from_NT, start, stop, device_NT, availstart_NT, availstop_NT)  SAC_ND_A_FIELD( to_NT) = dist_end_contiguous_block(SAC_ND_A_FIELD( from_NT), start+SAC_ND_A_FIELD( availstart_NT), stop+SAC_ND_A_FIELD( availstop_NT), SAC_ND_A_FIELD( device_NT));  SAC_ND_A_FIELD( to_NT) = (SAC_ND_A_FIELD( to_NT) == SAC_ND_A_SHAPE( from_NT, 0) ? SAC_ND_A_FIELD( to_NT) : SAC_ND_A_FIELD( to_NT) - stop);  SAC_ND_A_FIELD( availstop_NT) = min(SAC_ND_A_FIELD( availstop_NT), max(SAC_ND_A_FIELD( availstart_NT)+1, SAC_ND_A_FIELD( to_NT)));

#define SAC_DIST_GETCUDATHREAD( var_NT)  SAC_ND_A_FIELD( var_NT) = getDeviceNumber(SAC_MT_SELF_LOCAL_ID());
#define SAC_CUDA_SET_DEVICE( var_NT)  cudaSetDevice( SAC_ND_A_FIELD( var_NT) - 1);  SAC_CUDA_GET_STREAM( var_NT)
#define SAC_CUDA_DEVICE_SYNC( devnumber_NT)  cudaError_t error = cudaDeviceSynchronize();  if (error != cudaSuccess) SAC_RuntimeError("CUDA error synchronizing devices: %s\n", cudaGetErrorString(error));  cache_stream_destroy(SAC_ND_A_FIELD( devnumber_NT) - 1);
#define SAC_CUDA_GET_STREAM( var_NT)  cudaStream_t *stream = cache_stream_create(SAC_ND_A_FIELD( var_NT) - 1);

#define SAC_SCHED_START( var_NT, dim)  SAC_ND_A_FIELD( var_NT) = SAC_WL_MT_SCHEDULE_START( dim);
#define SAC_SCHED_STOP( var_NT, dim)  SAC_ND_A_FIELD( var_NT) = SAC_WL_MT_SCHEDULE_STOP( dim);
#endif
#ifndef _SAC_ALLOCCACHE_H_
#define _SAC_ALLOCCACHE_H_
#ifdef __CUDACC__
void cache_init();
void* cache_malloc(size_t size, int device);
void cache_free(void* pointer, int device);
cudaStream_t* cache_stream_create(int device);
void cache_stream_destroy(int device);
void cache_end();
#ifdef DEBUG_CACHE
#define debug(s,...) printf(s,##__VA_ARGS__)
#else
#define debug(s,...)
#endif
typedef struct cache_alloc {
void* pointer;
size_t size;
struct cache_alloc* next;
bool inUse;
} *cache_alloc_t;
typedef struct cache_stream {
cudaStream_t stream;
struct cache_stream* next;
bool inUse;
} *cache_stream_t;
static cache_alloc_t* cacheAlloc;
static cache_stream_t* cacheStream;
extern unsigned int SAC_CUDA_DEVICES;

void cache_init() {
cacheAlloc = (cache_alloc_t*)calloc(SAC_CUDA_DEVICES, sizeof(cache_alloc_t));
cacheStream = (cache_stream_t*)calloc(SAC_CUDA_DEVICES, sizeof(cache_stream_t));
}

void cache_end() {
for (unsigned int i = 0; i < SAC_CUDA_DEVICES; i++) {
cudaSetDevice(i);
for (cache_alloc_t elem = cacheAlloc[i]; elem != NULL;) {
cache_alloc_t temp;
cudaFree(elem->pointer);
temp = elem;
elem = elem->next;
free(temp);
}
for (cache_stream_t elem = cacheStream[i]; elem != NULL;) {
cache_stream_t temp;
cudaStreamDestroy(elem->stream);
temp = elem;
elem = elem->next;
free(temp);
}
}
free(cacheAlloc);
free(cacheStream);
}

void* cache_malloc(size_t size, int device) {
int res;
cache_alloc_t newElem;
cache_alloc_t *last;
debug("Looking for array of size %zu in cache for device %d\n", size, device); 

for (cache_alloc_t elem = cacheAlloc[device]; elem != NULL; elem = elem->next) {
if( elem->size == size && !(elem->inUse) ) {
debug("Found array in cache\n"); 
elem->inUse = true;
return elem->pointer;
}
}
debug("Array not found, allocating\n"); 
 
newElem = (cache_alloc_t)malloc(sizeof(struct cache_alloc));
cudaSetDevice(device);
if( (res = cudaMalloc(&(newElem->pointer), size)) != cudaSuccess) {
debug("Allocation failed, freeing cache\n"); 

for (cache_alloc_t *elem = &(cacheAlloc[device]); *elem != NULL;) {
if( !((*elem)->inUse)) {
cache_alloc_t temp;
cudaFree((*elem)->pointer);
temp = *elem;
elem = &((*elem)->next);
free(temp);
} else
elem = &((*elem)->next);
}
cacheAlloc[device] = NULL;
if ( (res = cudaMalloc(&(newElem->pointer), size)) != cudaSuccess) {
SAC_RuntimeError("Error allocating %zu bytes on CUDA device %d: %d\n", size,
device, res);
exit(-1);
}
}
newElem->size = size;
newElem->next = NULL;
newElem->inUse = true;
for (last = &(cacheAlloc[device]); *last != NULL; last = &((*last)->next));
*last = newElem;
debug("Allocated %p on device %d\n", newElem->pointer, device); 
return newElem->pointer;
}

void cache_free(void* pointer, int device) {
debug("Freeing %p on device %d\n", pointer, device); 
for (cache_alloc_t elem = cacheAlloc[device]; elem != NULL; elem = elem->next) {
debug("Found %p on device %d == %p ?: %d\n", elem->pointer, device, pointer, elem->pointer == pointer); 
if( elem->pointer == pointer ) {
elem->inUse = false;
return;
}
}
SAC_RuntimeError("Pointer %p being freed not found on cache for device %d\n",
pointer, device);
exit(-1);
}

cudaStream_t* cache_stream_create(int device) {
cache_stream_t newElem;
cache_stream_t* last;

for (cache_stream_t elem = cacheStream[device]; elem != NULL; elem = elem->next) {
if( !(elem->inUse) ) {
debug("Found stream in cache\n"); 
elem->inUse = true;
return &(elem->stream);
}
}
debug("Stream not found, allocating\n"); 
 
newElem = (cache_stream_t)malloc(sizeof(struct cache_stream));
cudaSetDevice(device);
cudaStreamCreate(&(newElem->stream));
newElem->next = NULL;
newElem->inUse = true;
for (last = &(cacheStream[device]); *last != NULL; last = &((*last)->next));
*last = newElem;
return &(newElem->stream);
}

void cache_stream_destroy(int device) {
for (cache_stream_t elem = cacheStream[device]; elem != NULL; elem = elem->next) {
elem->inUse = false;
}
return;
}
#endif
#endif
#ifndef _SAC_DIST_VAR_NO_MEMSAVE_H_
#define _SAC_DIST_VAR_NO_MEMSAVE_H_
#ifdef __CUDACC__
#ifndef DIST_MEMSAVE

enum block_state {
Invalid = 0,
Shared = 1,
Owned = 2
};
typedef struct dist_var {
int n_blocks;
size_t block_size;
block_state * state;
int * owner;
char **allocations; 
} * dist_var_t;
unsigned int SAC_MT_DEVICES;
unsigned int SAC_CUDA_DEVICES;


dist_var_t dist_var_alloc(unsigned int n_blocks, int total_size, size_t unit_size);

dist_var_t dist_var_free(dist_var_t dist_array);


dist_var_t conc2dist(dist_var_t dist_array, int block_start, int block_stop,
int device);

void* dist2conc(dist_var_t dist_array, int block_start,
int block_stop, int device, bool set_owner,
cudaStream_t* stream);


unsigned int dist_end_contiguous_block(dist_var_t dist_array,
int block_start,
int block_stop,
int device);
#ifdef DEBUG_DIST
#define debug_dist(s,...) SAC_Print(s,##__VA_ARGS__)
#else
#define debug_dist(s,...)
#endif
#define checkBounds() if(block_start >= dist_array->n_blocks) { block_start = dist_array->n_blocks-1;} else if (block_start < 0) {block_start = 0;} if(block_stop > (dist_array->n_blocks) ) {block_stop = dist_array->n_blocks;}

dist_var_t dist_var_alloc(unsigned int n_blocks, int total_size, size_t unit_size)
{
dist_var_t result = (dist_var_t)malloc(sizeof(dist_var));
result->n_blocks = n_blocks;
result->block_size = total_size * unit_size / n_blocks;
int* owner = (int *)malloc(SAC_MT_DEVICES * n_blocks * sizeof(int));
for(unsigned int i = 0; i < n_blocks; i++)
owner[i] = -1;
result->owner = owner;
result->allocations = (char **)calloc(SAC_MT_DEVICES, sizeof(char*));
result->state = (block_state *)calloc(SAC_MT_DEVICES * n_blocks, sizeof(block_state));
debug_dist("Allocating host-side array\n");
#ifdef DEBUG_DIST
result->allocations[0] = (char*)calloc(total_size, unit_size);
#else
result->allocations[0] = (char*)malloc(total_size * unit_size);
#endif
debug_dist("New dist var with %d blocks of size: %zu\n", n_blocks, result->block_size);
return result;
}
dist_var_t dist_var_free(dist_var_t dist_array) {
debug_dist("Freeing dist_array\n");
free(dist_array->owner);
free(dist_array->allocations[0]);
for(unsigned int i = 1; i < SAC_MT_DEVICES; i++) {
if(dist_array->allocations[i] != NULL)
cache_free(dist_array->allocations[i], i-1);
}
free(dist_array->allocations);
free(dist_array->state);
free(dist_array);
return dist_array;
}

dist_var_t conc2dist(dist_var_t dist_array, int block_start, int block_stop,
int device)
{
debug_dist("conc2dist(dist %p, start %d, stop %d, device %d)\n",
dist_array, block_start, block_stop, device);

block_state (*state)[SAC_MT_DEVICES][dist_array->n_blocks] =
(block_state(*)[SAC_MT_DEVICES][dist_array->n_blocks])(dist_array->state);
int i;
checkBounds();
for (i = 0; i < device; i++) {
for (int j = block_start; j < block_stop; j++) {
(*state)[i][j] = Invalid;
}
}
for (int j = block_start; j < block_stop; j++) {
(*state)[device][j] = Owned;
}
for (i = device+1; i < (int)SAC_MT_DEVICES; i++) {
for (int j = block_start; j < block_stop; j++) {
(*state)[i][j] = Invalid;
}
}
debug_dist("conc2dist(dist %p, start %d, stop %d, device %d) = %p\n",
dist_array, block_start, block_stop, device, dist_array);
return dist_array;
}
unsigned int dist_end_contiguous_block( dist_var_t dist_array,
int block_start,
int block_stop,
int device) {
debug_dist("dist_end_contiguous_block(dist %p, start %d, stop %d, device %d)\n",
(void*)dist_array, block_start, block_stop, device);
checkBounds();

block_state (*state)[SAC_MT_DEVICES][dist_array->n_blocks] =
(block_state(*)[SAC_MT_DEVICES][dist_array->n_blocks])(dist_array->state);
int res;

if( (*state)[device][block_start] == Invalid ) {
for( res = block_start + 1; res < block_stop && (*state)[device][res] == Invalid; res++);
debug_dist("Device %d has invalid blocks from %d to %d\n", device, block_start, res);
} else {
for( res = block_start + 1; res < block_stop && (*state)[device][res] != Invalid; res++);
debug_dist("Device %d has valid blocks from %d to %d\n", device, block_start, res);
}
debug_dist("dist_end_contiguous_block(dist %p, start %d, stop %d, device %d) = %d\n",
(void*)dist_array, block_start, block_stop, device, res);
return res;
}
void* dist2conc(dist_var_t dist_array, int block_start,
int block_stop, int device, bool set_owner,
cudaStream_t* stream)
{
debug_dist("dist2conc(dist %p, start %d, stop %d, device %d, owner? %d, stream %p)\n",
(void*)dist_array, block_start, block_stop, device, set_owner, stream);
char* array_p;
size_t block_size = dist_array->block_size;
int* owner = dist_array->owner;

block_state (*state)[SAC_MT_DEVICES][dist_array->n_blocks] =
(block_state(*)[SAC_MT_DEVICES][dist_array->n_blocks])(dist_array->state);
char** allocations = dist_array->allocations;
checkBounds();

if(allocations[device] == NULL) {
debug_dist("Device %d: Array not allocated\n", device);
size_t size_alloc = block_size * dist_array->n_blocks;

if(device == 0) { 
debug_dist("Device %d: allocating host-side array\n", device);
array_p = (char*)malloc(size_alloc);
} else { 
debug_dist("Device %d: allocating cuda array\n", device);
array_p = (char*)cache_malloc(size_alloc, device-1);
}
allocations[device] = array_p;
debug_dist("Device %d: Will store from %p to %p\n", device, array_p, array_p + size_alloc);
} else {
array_p = allocations[device];
debug_dist("Device %d: Will store at %p\n", device, array_p);
}

for (int i = block_start; i < block_stop;) {
int k;
debug_dist("Device %d checking block %d: ", device, i);
debug_dist("local state %d, ", (*state)[device][i]);
debug_dist("owner %d\n", owner[i]);

if((*state)[device][i] == Invalid) {
char* source_p, *destination_p;
int source = owner[i];

for (k = i+1;
k < block_stop && (*state)[device][k] == Invalid && owner[k] == source;
k++);
if( source > -1 ) {
debug_dist("Device %d Missing blocks %d to %d, will copy from %d\n", device, i, k, source);
source_p = allocations[source];
size_t offset = i * block_size;
size_t size = (k - i) * block_size;
source_p += offset;
destination_p = array_p + offset;
debug_dist("Device %d: offset %zu, size %zu\n", device, offset, size);
if(device == 0) { 
debug_dist("Device %d: copying from cuda %p to host %p\n", device, source_p, destination_p);
cudaSetDevice(source-1);
cudaMemcpy(destination_p, source_p, size, cudaMemcpyDeviceToHost);
} else if (source == 0) { 
debug_dist("Device %d: copying from host %p to cuda %p\n", device, source_p, destination_p);
cudaSetDevice(device-1);
if(stream) {
cudaMemcpyAsync(destination_p, source_p, size, cudaMemcpyHostToDevice,
*stream);
} else {
cudaMemcpy(destination_p, source_p, size, cudaMemcpyHostToDevice);
}
} else { 
debug_dist("Device %d: copying from cuda %p to cuda %p\n", device, source_p, destination_p);
if(stream) {
cudaMemcpyPeerAsync(destination_p, device - 1, source_p, source - 1,
size, *stream);
} else {
cudaMemcpyPeer(destination_p, device - 1, source_p, source - 1,
size);
}
}

for( int m = i; m < k; m++) {
(*state)[device][m] = Shared;
}
debug_dist("Device %d copied blocks %d to %d\n", device, i, k);
} else {
debug_dist("Device %d: blocks %d to %d not computed yet, skipping\n", device, i, k);
}
} else {

for (k = i+1; k < block_stop && (*state)[device][k] != Invalid; k++);
debug_dist("Device %d skipped blocks %d to %d\n", device, i, k);
}
i = k;
debug_dist("Device %d check done until block %d\n", device, i);
}

if(set_owner)
for(int i = block_start; i < block_stop; i++)
owner[i] = device;
debug_dist("dist2conc(dist %p, start %d, stop %d, device %d, owner? %d, stream %p) = %p\n",
(void*)dist_array, block_start, block_stop, device, set_owner, stream, array_p);
return array_p;
}
#endif
#endif
#endif

#ifndef _SAC_CUDAHYBRID_BASIC_H_
#define _SAC_CUDAHYBRID_BASIC_H_
#ifdef __CUDACC__
#define getDeviceNumber(SAC_MT_mythread) SAC_MT_mythread - (SAC_MT_LOCAL_THREADS() - SAC_CUDA_DEVICES) + 1
#define SAC_CUDA_ENV_VAR_NAME "SAC_CUDA"
#define SAC_CUDA_SHARE_ENV_VAR_NAME "SAC_CUDA_SHARE"
#define SAC_DIST_SETUP() SAC_DIST_setup(__argc, __argv)
double SAC_CUDA_SHARE;
void SAC_DIST_setup(int argc, char** argv) {

bool option_exists = FALSE;
char *env_res = NULL;
for (int i = 1; i < argc - 1; i++) {
if ((argv[i][0] == '-')
 && (argv[i][1] == 'c')
 && (argv[i][2] == 'u')
 && (argv[i][3] == 'd')
 && (argv[i][4] == 'a')
 && (argv[i][5] == '\0')) {
SAC_CUDA_DEVICES = atoi(argv[i + 1]);
option_exists = TRUE;
break;
}
}
if (!option_exists) {
env_res = getenv(SAC_CUDA_ENV_VAR_NAME);
SAC_CUDA_DEVICES = (env_res != NULL) ? atoi(env_res) : 1;
}
for (int i = 1; i < argc - 1; i++) {
if ((argv[i][0] == '-')
 && (argv[i][1] == 's')
 && (argv[i][2] == 'h')
 && (argv[i][3] == 'a')
 && (argv[i][4] == 'r')
 && (argv[i][5] == 'e')
 && (argv[i][6] == '\0')) {
SAC_CUDA_SHARE = atof(argv[i + 1]);
option_exists = TRUE;
break;
}
}
if (!option_exists) {
env_res = getenv(SAC_CUDA_SHARE_ENV_VAR_NAME);
SAC_CUDA_SHARE = (env_res != NULL) ? atof(env_res) : 1;
}
int deviceCount;
cudaGetDeviceCount(&deviceCount);
if (SAC_CUDA_DEVICES > (unsigned int) deviceCount) {
SAC_RuntimeError("Number of CUDA devices requested exceeds those"
" available (%d).\n"
" Use the '%s' environment variable or the option"
" -cuda <num>' (which overrides the environment variable).",
deviceCount, SAC_CUDA_ENV_VAR_NAME);
}
if (SAC_CUDA_DEVICES > SAC_MT_GLOBAL_THREADS()) {
SAC_RuntimeError("Number of cuda devices requested exceeds threads "
" available (%d).\n"
" Use the '%s' environment variable or the option"
" -cuda <num>' (which overrides the environment variable)"
" to reduce number of cuda devices, or increase"
" number of threads.",
deviceCount, SAC_CUDA_ENV_VAR_NAME);
}
SAC_MT_DEVICES = SAC_CUDA_DEVICES + 1;
cache_init();
}
#define SAC_DIST_SCHEDULER_Block_DIM0( lower, upper, unrolling) {   int devices = SAC_MT_LOCAL_THREADS();  int ub = upper;  int lb = lower;  int device_n = getDeviceNumber(SAC_MT_SELF_LOCAL_ID());   if ( device_n > 0) {  if (SAC_MT_LOCAL_THREADS() != SAC_CUDA_DEVICES) {  ub = SAC_CUDA_SHARE * upper;  devices = SAC_CUDA_DEVICES;  }  device_n--;  } else {  device_n = SAC_MT_SELF_LOCAL_ID();  if (SAC_CUDA_DEVICES > 0) {  lb = upper * SAC_CUDA_SHARE;  devices = SAC_MT_LOCAL_THREADS() - SAC_CUDA_DEVICES;  }  }   const int iterations = (ub - lb) / unrolling;  const int iterations_per_thread = (iterations / devices)  * unrolling;  const int iterations_rest = iterations % SAC_MT_LOCAL_THREADS();   if (iterations_rest &&  (device_n < (unsigned int) iterations_rest)) {  SAC_WL_MT_SCHEDULE_START(0)  = lb + device_n * (iterations_per_thread + unrolling);  SAC_WL_MT_SCHEDULE_STOP(0)  = SAC_WL_MT_SCHEDULE_START(0) + (iterations_per_thread + unrolling);  }  else {  SAC_WL_MT_SCHEDULE_START(0)  = (lb + iterations_rest * unrolling)  + device_n * iterations_per_thread;  SAC_WL_MT_SCHEDULE_STOP(0)  = SAC_WL_MT_SCHEDULE_START(0) + iterations_per_thread;  }   SAC_TR_MT_PRINT( ("Scheduler 'Block': dim 0: %d -> %d",  SAC_WL_MT_SCHEDULE_START( 0),  SAC_WL_MT_SCHEDULE_STOP( 0))); }
#define SAC_DIST_SCHEDULER_BlockVar_DIM0( lower, upper, unrolling) {  SAC_DIST_SCHEDULER_Block_DIM0( lower, upper, unrolling) }
#endif
#endif

#ifndef _SAC_NESTED_H_
#define _SAC_NESTED_H_
#define SAC_ND_DECL_NESTED__DATA__SCL( var_NT, basetype, decoration)  SAC_ND_DECL_NESTED__DATA__SCL_##decoration( var_NT, basetype, decoration)
#define SAC_ND_DECL_NESTED__DATA__SCL_( var_NT, basetype, decoration)  decoration void * SAC_ND_A_FIELD( var_NT)[2] = {NULL, NULL};
#define SAC_ND_DECL_NESTED__DATA__DEFAULT( var_NT, basetype, decoration)  SAC_ND_DECL_NESTED__DATA__DEFAULT_##decoration( var_NT, basetype, decoration)
#define SAC_ND_DECL_NESTED__DATA__DEFAULT_( var_NT, basetype, decoration)  decoration void ** SAC_ND_A_FIELD( var_NT) = NULL;
#define SAC_ND_PARAM_NESTED_out__NODESC( var_NT, basetype)  void * ( *SAC_NAMEP( SAC_ND_A_FIELD( var_NT)))[2]
#define SAC_ND_PARAM_NESTED_in__NODESC( var_NT, basetype)  void * SAC_ND_A_FIELD( var_NT)[2]
#define SAC_ND_RET_NESTED_out__NODESC( retvar_NT, var_NT) {  (* SAC_ND_GETVAR_INOUT( retvar_NT,  SAC_NAMEP( SAC_ND_A_FIELD( retvar_NT))))[0]  = SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT))[0];  (* SAC_ND_GETVAR_INOUT( retvar_NT,  SAC_NAMEP( SAC_ND_A_FIELD( retvar_NT))))[1]  = SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT))[1]; }
#define SAC_ND_RET_NESTED_out__DESC( retvar_NT, var_NT) {  (* SAC_ND_GETVAR_INOUT( retvar_NT,  SAC_NAMEP( SAC_ND_A_FIELD( retvar_NT))))  = SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT));  * SAC_ND_GETVAR_INOUT( retvar_NT,  SAC_NAMEP( SAC_ND_A_DESC_NAME( retvar_NT)))  = SAC_ND_A_DESC( var_NT); }
#define SAC_ND_A_DESC_NESTED__SCL( var_NT) SAC_ND_A_FIELD( var_NT)[0]
#define SAC_ND_A_DATA_NESTED__SCL( var_NT) SAC_ND_A_FIELD( var_NT)[1]
#define SAC_ND_ALLOC__DESC_AND_DATA_NESTED__AKS( var_NT, dim, basetype) {  SAC_ASSURE_TYPE( (dim == SAC_ND_A_MIRROR_DIM( var_NT)),  ("Inconsistant dimension for array %s found!",  NT_STR( var_NT)));  SAC_HM_MALLOC_FIXED_SIZE_WITH_DESC( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_DESC( var_NT),  SAC_ND_A_MIRROR_SIZE( var_NT) * 2  * sizeof( * SAC_ND_A_FIELD( var_NT)),  SAC_ND_A_MIRROR_DIM( var_NT),  void *,  SAC_ND_DESC_BASETYPE( var_NT))  SAC_TR_MEM_PRINT( ("ND_ALLOC__DESC( %s, %s) at addr: %p",  NT_STR( var_NT), #dim, SAC_ND_A_DESC( var_NT)))  SAC_TR_MEM_PRINT( ("ND_ALLOC__DATA( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)))  SAC_TR_INC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_REGISTER_ARRAY( var_NT) }
#define SAC_ND_WRITE_COPY__HNS( to_NT, to_pos, expr, copyfun) {  SAC_ND_A_FIELD( to_NT)[to_pos * 2] = expr[0];  SAC_ND_A_FIELD( to_NT)[to_pos * 2 + 1] = expr[1]; }

#define SAC_ND_FREE__DATA__SCL_HNS( var_NT, freefun) {  SAC_ND_DEC_RC( var_NT, 1) }
#define SAC_ND_PARAM_NESTED_in__DESC( var_NT, basetype)  void **SAC_ND_A_FIELD( var_NT),  void *SAC_ND_A_DESC_NAME( var_NT)
#define SAC_ND_PARAM_NESTED_out__DESC( var_NT, basetype)  void ***SAC_NAMEP(SAC_ND_A_FIELD( var_NT)),  void **SAC_NAMEP(SAC_ND_A_DESC_NAME( var_NT))
#define SAC_ND_ARG_NESTED_out__DESC( var_NT, basetype)  &SAC_ND_A_FIELD( var_NT),  (void **) &SAC_ND_A_DESC_NAME( var_NT)
#define SAC_ND_WRITE_READ_COPY__NESTED( to_NT, to_pos, from_NT, from_pos, copyfun) {  SAC_ND_A_FIELD( to_NT)[to_pos * 2] = SAC_ND_A_FIELD( from_NT)[ from_pos * 2];  SAC_ND_A_FIELD( to_NT)[to_pos * 2 + 1] = SAC_ND_A_FIELD( from_NT)[ from_pos * 2 + 1]; }
#define SAC_ND_FREE__DATA__AKS_HNS( var_NT, freefun) {  SAC_TR_MEM_PRINT( ("ND_FREE__DATA( %s, %s) at addr: %p",  NT_STR( var_NT), #freefun, SAC_ND_A_FIELD( var_NT)))  SAC_HM_FREE_FIXED_SIZE( SAC_ND_GETVAR(var_NT, SAC_ND_A_FIELD( var_NT)),  SAC_ND_A_SIZE( var_NT) * 1  * sizeof( * SAC_ND_A_FIELD( var_NT)))  SAC_TR_DEC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_UNREGISTER_ARRAY( var_NT) }
#define SAC_ND_FREE__DATA__AKD_HNS( var_NT, freefun) {  SAC_TR_MEM_PRINT( ("ND_FREE__DATA( %s, %s) at addr: %p",  NT_STR( var_NT), #freefun, SAC_ND_A_FIELD( var_NT)))  SAC_HM_FREE(SAC_ND_GETVAR( var_NT, SAC_ND_A_FIELD( var_NT)))  SAC_TR_DEC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_UNREGISTER_ARRAY( var_NT) }
#define SAC_ND_ALLOC_END__NO_DAO__NESTED( var_NT, rc, dim, basetype)  SAC_ND_ALLOC__DATA_BASETYPE__NESTED( var_NT, basetype) }
#define SAC_ND_ALLOC__DATA_BASETYPE__NESTED__AKD_AUD( var_NT, basetype) {  SAC_HM_MALLOC( SAC_ND_A_FIELD( var_NT),  SAC_ND_A_SIZE( var_NT) * 2  * sizeof( * SAC_ND_A_FIELD( var_NT)),  void *)  SAC_TR_MEM_PRINT( ("ND_ALLOC__DATA( %s) at addr: %p",  NT_STR( var_NT), SAC_ND_A_FIELD( var_NT)))  SAC_TR_INC_ARRAY_MEMCNT( SAC_ND_A_SIZE( var_NT))  SAC_CS_REGISTER_ARRAY( var_NT) }
#endif 


#ifndef DEF_FILE_nested_gen
#define DEF_FILE_nested_gen
#ifndef _SAC_NESTED_GEN_H_
#define _SAC_NESTED_GEN_H_
#define SAC_ND_DECL_NESTED__DESC( nt , gra1) CAT_M4_nested_gen_1(SAC_ND_DECL_NESTED__DESC_, CAT_M4_nested_gen_2(NT_SHP(nt), CAT_M4_nested_gen_3(NT_HID(nt), NT_UNQ(nt))))( nt , gra1)
#define SAC_ND_DECL_NESTED__DESC_SCLHNSNUQ(...) SAC_ND_DECL__DESC__NONE(__VA_ARGS__)
#define SAC_ND_DECL_NESTED__DESC_AKSHNSNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL_NESTED__DESC_AKDHNSNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL_NESTED__DESC_AUDHNSNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL_NESTED__DESC____HNSNUQ(...) SAC_ND_DECL__DESC__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL_NESTED__DATA( nt , gra1, gra2) CAT_M4_nested_gen_4(SAC_ND_DECL_NESTED__DATA_, CAT_M4_nested_gen_5(NT_SHP(nt), CAT_M4_nested_gen_6(NT_HID(nt), NT_UNQ(nt))))( nt , gra1, gra2)
#define SAC_ND_DECL_NESTED__DATA_SCLHNSNUQ(...) SAC_ND_DECL_NESTED__DATA__SCL(__VA_ARGS__)
#define SAC_ND_DECL_NESTED__DATA_AKSHNSNUQ(...) SAC_ND_DECL_NESTED__DATA__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL_NESTED__DATA_AKDHNSNUQ(...) SAC_ND_DECL_NESTED__DATA__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL_NESTED__DATA_AUDHNSNUQ(...) SAC_ND_DECL_NESTED__DATA__DEFAULT(__VA_ARGS__)
#define SAC_ND_DECL_NESTED__DATA____HNSNUQ(...) SAC_ND_DECL_NESTED__DATA__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_NESTED( nt , gra1) CAT_M4_nested_gen_7(SAC_ND_WRITE_NESTED_, NT_SHP(nt))( nt , gra1)
#define SAC_ND_WRITE_NESTED_SCL(...) SAC_ND_WRITE_NESTED__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_NESTED_AKS(...) SAC_ND_WRITE_NESTED__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_NESTED_AKD(...) SAC_ND_WRITE_NESTED__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_NESTED_AUD(...) SAC_ND_WRITE_NESTED__DEFAULT(__VA_ARGS__)
#define SAC_ND_WRITE_NESTED____(...) SAC_ND_WRITE_NESTED__DEFAULT(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE__NESTED( nt , gra1) CAT_M4_nested_gen_8(SAC_ND_ALLOC__DATA_BASETYPE__NESTED_, NT_SHP(nt))( nt , gra1)
#define SAC_ND_ALLOC__DATA_BASETYPE__NESTED_SCL(...) SAC_ND_ALLOC__DATA_BASETYPE__NESTED__SCL(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE__NESTED_AKS(...) SAC_ND_ALLOC__DATA_BASETYPE__NESTED__AKS(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE__NESTED_AKD(...) SAC_ND_ALLOC__DATA_BASETYPE__NESTED__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE__NESTED_AUD(...) SAC_ND_ALLOC__DATA_BASETYPE__NESTED__AKD_AUD(__VA_ARGS__)
#define SAC_ND_ALLOC__DATA_BASETYPE__NESTED____(...) SAC_ND_ALLOC__DATA_BASETYPE__NESTED__AKD_AUD(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS( arg1, nt , gra1) CAT_M4_nested_gen_9(GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_, CAT_M4_nested_gen_10(NT_SHP(nt), NT_HID(nt)))( arg1, nt , gra1)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_SCLNHD(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_SCLHID(...) SAC_ND_ASSIGN__DATA__UNDEF(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_SCLHNS(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_SCL___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AKSNHD(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AKSHID(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AKSHNS(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AKS___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AKDNHD(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AKDHID(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AKDHNS(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AKD___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AUDNHD(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AUDHID(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AUDHNS(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_AUD___(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS____NHD(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS____HID(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS____HNS(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#define GEN_SAC_ND_ASSIGN__DATA__AUD_HNS_______(...) SAC_ND_ASSIGN__DATA__AUD_AKS(__VA_ARGS__)
#endif 
#define CAT_M4_nested_gen_10(x, y) xCAT_M4_nested_gen_10(x, y)
#define xCAT_M4_nested_gen_10(x, y) x##y
#define CAT_M4_nested_gen_9(x, y) xCAT_M4_nested_gen_9(x, y)
#define xCAT_M4_nested_gen_9(x, y) x##y
#define CAT_M4_nested_gen_8(x, y) xCAT_M4_nested_gen_8(x, y)
#define xCAT_M4_nested_gen_8(x, y) x##y
#define CAT_M4_nested_gen_7(x, y) xCAT_M4_nested_gen_7(x, y)
#define xCAT_M4_nested_gen_7(x, y) x##y
#define CAT_M4_nested_gen_6(x, y) xCAT_M4_nested_gen_6(x, y)
#define xCAT_M4_nested_gen_6(x, y) x##y
#define CAT_M4_nested_gen_5(x, y) xCAT_M4_nested_gen_5(x, y)
#define xCAT_M4_nested_gen_5(x, y) x##y
#define CAT_M4_nested_gen_4(x, y) xCAT_M4_nested_gen_4(x, y)
#define xCAT_M4_nested_gen_4(x, y) x##y
#define CAT_M4_nested_gen_3(x, y) xCAT_M4_nested_gen_3(x, y)
#define xCAT_M4_nested_gen_3(x, y) x##y
#define CAT_M4_nested_gen_2(x, y) xCAT_M4_nested_gen_2(x, y)
#define xCAT_M4_nested_gen_2(x, y) x##y
#define CAT_M4_nested_gen_1(x, y) xCAT_M4_nested_gen_1(x, y)
#define xCAT_M4_nested_gen_1(x, y) x##y
#endif

#ifndef _SAC_DISTMEMPHM_H
#if SAC_DO_DISTMEM
#include <assert.h>

typedef unsigned long int SAC_DISTMEM_HM_size_byte_t;
typedef long int SAC_DISTMEM_HM_size_unit_t;

#define SAC_DISTMEM_HM_NUM_ARENAS 9
#define SAC_DISTMEM_HM_NUM_SMALLCHUNK_ARENAS 5
#define SAC_DISTMEM_HM_ARENA_OF_ARENAS 0
#define SAC_DISTMEM_HM_TOP_ARENA (SAC_DISTMEM_HM_NUM_ARENAS - 1)
#define SAC_DISTMEM_HM_ALIGNMENT sizeof( double)

typedef union distmem_hm_header_t {
struct distmem_hm_header_data1_t {
SAC_DISTMEM_HM_size_unit_t size;
struct distmem_hm_arena_t *arena;
} data1;
struct distmem_hm_header_data2_t {
union distmem_hm_header_t *prevfree;
union distmem_hm_header_t *nextfree;
} data2;
struct distmem_hm_header_data3_t {
SAC_DISTMEM_HM_size_unit_t prevsize;
SAC_DISTMEM_HM_size_unit_t diag;
} data3;
char align[(((SAC_MAX( SAC_MAX( sizeof( struct distmem_hm_header_data1_t),
sizeof( struct distmem_hm_header_data2_t)),
sizeof( struct distmem_hm_header_data3_t))
-1) / SAC_DISTMEM_HM_ALIGNMENT) + 1) * SAC_DISTMEM_HM_ALIGNMENT];
} SAC_DISTMEM_HM_header_t;

#define SAC_DISTMEM_HM_LARGECHUNK_SIZE( header) (((header)+1)->data1.size)
#define SAC_DISTMEM_HM_LARGECHUNK_PREVSIZE( header) (((header)+0)->data3.prevsize)
#define SAC_DISTMEM_HM_LARGECHUNK_ARENA( header) (((header)+1)->data1.arena)
#define SAC_DISTMEM_HM_LARGECHUNK_NEXTFREE( header) (((header)+2)->data2.nextfree)

#define SAC_DISTMEM_HM_SMALLCHUNK_SIZE( header) (((header)+0)->data1.size)
#define SAC_DISTMEM_HM_SMALLCHUNK_ARENA( header) (((header)+0)->data1.arena)
#define SAC_DISTMEM_HM_SMALLCHUNK_NEXTFREE( header) (((header)+1)->data2.nextfree)
#define SAC_DISTMEM_HM_LARGECHUNK_DIAG( header) (((header)+0)->data3.diag)
#define SAC_DISTMEM_HM_SMALLCHUNK_DIAG( header) (((header)+0)->data1.size)

#define SAC_DISTMEM_HM_UNIT_SIZE (sizeof( SAC_DISTMEM_HM_header_t))
#define SAC_DISTMEM_HM_BYTES_2_UNITS( size) ((((size) - 1) / SAC_DISTMEM_HM_UNIT_SIZE) + 1)

typedef struct distmem_hm_arena_t {
int num;
SAC_DISTMEM_HM_header_t freelist[3];
SAC_DISTMEM_HM_header_t *wilderness;
SAC_DISTMEM_HM_size_unit_t binsize; 
SAC_DISTMEM_HM_size_unit_t min_chunk_size; 

unsigned long int size; 
unsigned long int cnt_bins;
unsigned long int cnt_alloc;
unsigned long int cnt_alloc_var_size;
unsigned long int cnt_after_freelist;
unsigned long int cnt_after_splitting;
unsigned long int cnt_after_wilderness;
unsigned long int cnt_after_coalascing;
unsigned long int cnt_after_coalascing_wilderness;
unsigned long int cnt_after_extension;
unsigned long int cnt_free;
unsigned long int cnt_free_var_size;
unsigned long int cnt_coalascing;
unsigned long int cnt_coalascing_wilderness;
} SAC_DISTMEM_HM_arena_t;

#define SAC_DISTMEM_HM_SMALL_ARENA_FREELIST_BASE( n) {  {{ 0, &(SAC_DISTMEM_HM_arenas[n]) }},  {{ 0, NULL }},  {{ 0, NULL }} }
#define SAC_DISTMEM_HM_LARGE_ARENA_FREELIST_BASE( n) {  {{ -1, NULL}},  {{ 0, &(SAC_DISTMEM_HM_arenas[n]) }},  {{ 0, NULL }} }
#define SAC_DISTMEM_HM_ARENA_OF_SMALL_CHUNKS( n, binsize, mincs) {  n,  SAC_DISTMEM_HM_SMALL_ARENA_FREELIST_BASE( n),  SAC_DISTMEM_HM_arenas[n].freelist,  binsize,  mincs,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
#define SAC_DISTMEM_HM_ARENA_OF_LARGE_CHUNKS( n, binsize, mincs) {  n,  SAC_DISTMEM_HM_LARGE_ARENA_FREELIST_BASE( n),  SAC_DISTMEM_HM_arenas[n].freelist,  binsize,  mincs,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
#define SAC_DISTMEM_HM_SETUP_ARENAS()  {  SAC_DISTMEM_HM_ARENA_OF_SMALL_CHUNKS( 0, SAC_DISTMEM_HM_ARENA_0_BINSIZE, SAC_DISTMEM_HM_ARENA_0_MINCS),  SAC_DISTMEM_HM_ARENA_OF_SMALL_CHUNKS( 1, SAC_DISTMEM_HM_ARENA_1_BINSIZE, SAC_DISTMEM_HM_ARENA_2_MINCS - 1),  SAC_DISTMEM_HM_ARENA_OF_SMALL_CHUNKS( 2, SAC_DISTMEM_HM_ARENA_2_BINSIZE, SAC_DISTMEM_HM_ARENA_3_MINCS - 1),  SAC_DISTMEM_HM_ARENA_OF_SMALL_CHUNKS( 3, SAC_DISTMEM_HM_ARENA_3_BINSIZE, SAC_DISTMEM_HM_ARENA_4_MINCS - 1),  SAC_DISTMEM_HM_ARENA_OF_SMALL_CHUNKS( 4, SAC_DISTMEM_HM_ARENA_4_BINSIZE, SAC_DISTMEM_HM_ARENA_5_MINCS - 1),  SAC_DISTMEM_HM_ARENA_OF_LARGE_CHUNKS( 5, SAC_DISTMEM_HM_ARENA_5_BINSIZE, SAC_DISTMEM_HM_ARENA_5_MINCS),  SAC_DISTMEM_HM_ARENA_OF_LARGE_CHUNKS( 6, SAC_DISTMEM_HM_ARENA_6_BINSIZE, SAC_DISTMEM_HM_ARENA_6_MINCS),  SAC_DISTMEM_HM_ARENA_OF_LARGE_CHUNKS( 7, SAC_DISTMEM_HM_ARENA_7_BINSIZE, SAC_DISTMEM_HM_ARENA_7_MINCS),  SAC_DISTMEM_HM_ARENA_OF_LARGE_CHUNKS( 8, SAC_DISTMEM_HM_ARENA_8_BINSIZE, SAC_DISTMEM_HM_ARENA_8_MINCS)  } 

#define SAC_DISTMEM_HM_ADDR_ARENA( addr) ((((SAC_DISTMEM_HM_header_t *) addr) -1)->data1.arena)

#define SAC_DISTMEM_HM_ARENA_0_MINCS 1
#define SAC_DISTMEM_HM_ARENA_1_MINCS 2
#define SAC_DISTMEM_HM_ARENA_2_MINCS 3
#define SAC_DISTMEM_HM_ARENA_3_MINCS 5
#define SAC_DISTMEM_HM_ARENA_4_MINCS 9
#define SAC_DISTMEM_HM_ARENA_5_MINCS 17
#define SAC_DISTMEM_HM_ARENA_6_MINCS 129 
#define SAC_DISTMEM_HM_ARENA_7_MINCS 1025
#define SAC_DISTMEM_HM_ARENA_8_MINCS 8193

#define SAC_DISTMEM_HM_ARENA_1_MAXCS_BYTES ((SAC_DISTMEM_HM_ARENA_2_MINCS -2) * SAC_DISTMEM_HM_UNIT_SIZE)
#define SAC_DISTMEM_HM_ARENA_2_MAXCS_BYTES ((SAC_DISTMEM_HM_ARENA_3_MINCS -2) * SAC_DISTMEM_HM_UNIT_SIZE)
#define SAC_DISTMEM_HM_ARENA_3_MAXCS_BYTES ((SAC_DISTMEM_HM_ARENA_4_MINCS -2) * SAC_DISTMEM_HM_UNIT_SIZE)
#define SAC_DISTMEM_HM_ARENA_4_MAXCS_BYTES ((SAC_DISTMEM_HM_ARENA_5_MINCS -2) * SAC_DISTMEM_HM_UNIT_SIZE)
#define SAC_DISTMEM_HM_ARENA_5_MAXCS_BYTES ((SAC_DISTMEM_HM_ARENA_6_MINCS -3) * SAC_DISTMEM_HM_UNIT_SIZE)
#define SAC_DISTMEM_HM_ARENA_6_MAXCS_BYTES ((SAC_DISTMEM_HM_ARENA_7_MINCS -3) * SAC_DISTMEM_HM_UNIT_SIZE)
#define SAC_DISTMEM_HM_ARENA_7_MAXCS_BYTES ((SAC_DISTMEM_HM_ARENA_8_MINCS -3) * SAC_DISTMEM_HM_UNIT_SIZE)

#define SAC_DISTMEM_HM_ARENA_0_BINSIZE 131072
#define SAC_DISTMEM_HM_ARENA_1_BINSIZE 512
#define SAC_DISTMEM_HM_ARENA_2_BINSIZE 512
#define SAC_DISTMEM_HM_ARENA_3_BINSIZE 256
#define SAC_DISTMEM_HM_ARENA_4_BINSIZE 512
#define SAC_DISTMEM_HM_ARENA_5_BINSIZE 2048
#define SAC_DISTMEM_HM_ARENA_6_BINSIZE 8196
#define SAC_DISTMEM_HM_ARENA_7_BINSIZE 32768
#define SAC_DISTMEM_HM_ARENA_8_BINSIZE 0

SAC_C_EXTERN SAC_DISTMEM_HM_arena_t SAC_DISTMEM_HM_arenas[SAC_DISTMEM_HM_NUM_ARENAS + 2]; 

SAC_C_EXTERN void SAC_DISTMEM_HM_Setup( void);
SAC_C_EXTERN void *SAC_DISTMEM_HM_MallocSmallChunk( SAC_DISTMEM_HM_size_unit_t units, 
SAC_DISTMEM_HM_arena_t *arena);
SAC_C_EXTERN void *SAC_DISTMEM_HM_MallocLargeChunk( SAC_DISTMEM_HM_size_unit_t units, 
SAC_DISTMEM_HM_arena_t *arena);
SAC_C_EXTERN void SAC_DISTMEM_HM_FreeSmallChunk( SAC_DISTMEM_HM_header_t *addr, 
SAC_DISTMEM_HM_arena_t *arena);
SAC_C_EXTERN void SAC_DISTMEM_HM_FreeLargeChunk( SAC_DISTMEM_HM_header_t *addr, 
SAC_DISTMEM_HM_arena_t *arena);
SAC_C_EXTERN void *SAC_DISTMEM_HM_MallocAnyChunk( SAC_DISTMEM_HM_size_byte_t size);
SAC_C_EXTERN void SAC_DISTMEM_HM_FreeAnyChunk( void *addr);
SAC_C_EXTERN void *SAC_DISTMEM_HM_MallocDesc( SAC_DISTMEM_HM_header_t *addr, 
SAC_DISTMEM_HM_size_byte_t size, 
SAC_DISTMEM_HM_size_byte_t desc_size);
SAC_C_EXTERN void SAC_DISTMEM_HM_FreeDesc( SAC_DISTMEM_HM_header_t *addr);
SAC_C_EXTERN void SAC_DISTMEM_HM_ShowDiagnostics( void);

#define SAC_DISTMEM_HM_MALLOC( var, size, basetype) {  SAC_TR_DISTMEM_PRINT( "SAC_DISTMEM_HM_MALLOC( %s, %d, %s)",  #var, size, #basetype);  SAC_DISTMEM_CHECK_IS_DSM_ALLOC_ALLOWED();  var = (basetype*)SAC_DISTMEM_HM_MallocAnyChunk( size); }
#define SAC_DISTMEM_HM_MALLOC_SMALL_CHUNK( var, units, arena_num, basetype)  var = (basetype*)SAC_DISTMEM_HM_MallocSmallChunk( units, &(SAC_DISTMEM_HM_arenas[arena_num]));
#define SAC_DISTMEM_HM_MALLOC_LARGE_CHUNK( var, units, arena_num, basetype)  var = (basetype*)SAC_DISTMEM_HM_MallocLargeChunk( units, &(SAC_DISTMEM_HM_arenas[arena_num])); 
#define SAC_DISTMEM_HM_MALLOC_TOP_ARENA( var, units, basetype)  var = (basetype*)SAC_DISTMEM_HM_MallocLargeChunk( units, &(SAC_DISTMEM_HM_arenas[SAC_DISTMEM_HM_TOP_ARENA]));

#if SAC_DO_APS
#if SAC_DO_MSCA
#define SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( var, size, basetype) {  SAC_TR_DISTMEM_PRINT( "SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( %s, %d, %s)",  #var, size, #basetype);  SAC_DISTMEM_CHECK_IS_DSM_ALLOC_ALLOWED();  if ((size) <= SAC_DISTMEM_HM_ARENA_4_MAXCS_BYTES) {  if ((size) <= SAC_DISTMEM_HM_ARENA_2_MAXCS_BYTES) {  if ((size) <= SAC_DISTMEM_HM_ARENA_1_MAXCS_BYTES) {  SAC_DISTMEM_HM_MALLOC_SMALL_CHUNK( var, 2, 1, basetype)  }  else {  SAC_DISTMEM_HM_MALLOC_SMALL_CHUNK( var, 4, 2, basetype)  }  }  else {  if ((size) <= SAC_DISTMEM_HM_ARENA_3_MAXCS_BYTES) {  SAC_DISTMEM_HM_MALLOC_SMALL_CHUNK( var, 8, 3, basetype)  }  else {  SAC_DISTMEM_HM_MALLOC_SMALL_CHUNK( var, 16, 4, basetype)  }  }  }  else {  const SAC_DISTMEM_HM_size_byte_t _real_size_1 = size  + SAC_DISTMEM_HM_CACHE_ADJUST( size,  SAC_SET_CACHE_3_SIZE,  SAC_SET_CACHE_3_MSCA_FACTOR);  const SAC_DISTMEM_HM_size_byte_t _real_size_2 = _real_size_1  + SAC_DISTMEM_HM_CACHE_ADJUST( _real_size_1,  SAC_SET_CACHE_2_SIZE,  SAC_SET_CACHE_2_MSCA_FACTOR);  const SAC_DISTMEM_HM_size_byte_t _real_size_3 = _real_size_2  + SAC_DISTMEM_HM_CACHE_ADJUST( _real_size_2,  SAC_SET_CACHE_1_SIZE,  SAC_SET_CACHE_1_MSCA_FACTOR);  const SAC_DISTMEM_HM_size_unit_t _units = SAC_DISTMEM_HM_BYTES_2_UNITS( _real_size_3) + 2;   if (_units < SAC_DISTMEM_HM_ARENA_7_MINCS) {  if (_units < SAC_DISTMEM_HM_ARENA_6_MINCS) {  SAC_DISTMEM_HM_MALLOC_LARGE_CHUNK( var, _units, 5, basetype)  }  else {  SAC_DISTMEM_HM_MALLOC_LARGE_CHUNK( var, _units, 6, basetype)  }  }  else {  if (_units < SAC_DISTMEM_HM_ARENA_8_MINCS){  SAC_DISTMEM_HM_MALLOC_LARGE_CHUNK( var, _units, 7, basetype)  }  else {  SAC_DISTMEM_HM_MALLOC_TOP_ARENA( var, _units, basetype)  }  }  }  SAC_TR_DISTMEM_PRINT( "Done with SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( %s, %d, %s)",  #var, size, #basetype); }
#else 
#define SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( var, size, basetype) {  SAC_TR_DISTMEM_PRINT( "SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( %s, %d, %s)",  #var, size, #basetype);  SAC_DISTMEM_CHECK_IS_DSM_ALLOC_ALLOWED();  if ((size) <= SAC_DISTMEM_HM_ARENA_4_MAXCS_BYTES) {  if ((size) <= SAC_DISTMEM_HM_ARENA_2_MAXCS_BYTES) {  if ((size) <= SAC_DISTMEM_HM_ARENA_1_MAXCS_BYTES) {  SAC_DISTMEM_HM_MALLOC_SMALL_CHUNK( var, 2, 1, basetype)  }  else {  SAC_DISTMEM_HM_MALLOC_SMALL_CHUNK( var, 4, 2, basetype)  }  }  else {  if ((size) <= SAC_DISTMEM_HM_ARENA_3_MAXCS_BYTES) {  SAC_DISTMEM_HM_MALLOC_SMALL_CHUNK( var, 8, 3, basetype)  }  else {  SAC_DISTMEM_HM_MALLOC_SMALL_CHUNK( var, 16, 4, basetype)  }  }  }  else {  const SAC_DISTMEM_HM_size_unit_t units = SAC_DISTMEM_HM_BYTES_2_UNITS( size) + 2;  if (units < SAC_DISTMEM_HM_ARENA_7_MINCS) {  if (units < SAC_DISTMEM_HM_ARENA_6_MINCS) {  SAC_DISTMEM_HM_MALLOC_LARGE_CHUNK( var, units, 5, basetype)  }  else {  SAC_DISTMEM_HM_MALLOC_LARGE_CHUNK( var, units, 6, basetype)  }  }  else {  if (units < SAC_DISTMEM_HM_ARENA_8_MINCS){  SAC_DISTMEM_HM_MALLOC_LARGE_CHUNK( var, units, 7, basetype)  }  else {  SAC_DISTMEM_HM_MALLOC_TOP_ARENA( var, units, basetype)  }  }  }  SAC_TR_DISTMEM_PRINT( "Done with SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( %s, %d, %s)",  #var, size, #basetype); }
#endif 
#else 
#define SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( var, size, basetype)  SAC_DISTMEM_HM_MALLOC( var, size, basetype)
#endif 
#if SAC_DO_DAO

#define SAC_DISTMEM_HM_MALLOC_FIXED_SIZE_WITH_DESC( var, var_desc, size, dim, basetype, descbasetype) {  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( var, ((size)  + BYTE_SIZE_OF_DESC( dim)  + 2 * SAC_DISTMEM_HM_UNIT_SIZE), basetype)   var_desc = (descbasetype*)SAC_DISTMEM_HM_MallocDesc( (SAC_DISTMEM_HM_header_t *) var,  size,  BYTE_SIZE_OF_DESC( dim)); }
#else 
#define SAC_DISTMEM_HM_MALLOC_FIXED_SIZE_WITH_DESC( var, var_desc, size, dim, basetype, descbasetype) {  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( var, (size), basetype)  SAC_DISTMEM_HM_MALLOC_FIXED_SIZE( var_desc, BYTE_SIZE_OF_DESC( dim), descbasetype) }
#endif 

#define SAC_DISTMEM_HM_FREE( addr)  SAC_TR_DISTMEM_PRINT( "SAC_DISTMEM_HM_FREE( %p)", addr);  SAC_DISTMEM_HM_FreeAnyChunk( addr);
#if SAC_DO_APS

#define SAC_DISTMEM_HM_FREE_DESC( addr) {  SAC_TR_DISTMEM_PRINT( "SAC_DISTMEM_HM_FREE_DESC( %p)", addr);  SAC_DISTMEM_HM_FreeDesc( (SAC_DISTMEM_HM_header_t *) addr); }
#define SAC_DISTMEM_HM_FREE_FIXED_SIZE( addr, size) {  SAC_TR_DISTMEM_PRINT( "SAC_DISTMEM_HM_FREE_FIXED_SIZE( %p, %d)", addr, size);  if (((size) + 2 * SAC_DISTMEM_HM_UNIT_SIZE) <= SAC_DISTMEM_HM_ARENA_4_MAXCS_BYTES) {  SAC_DISTMEM_HM_FreeSmallChunk( (SAC_DISTMEM_HM_header_t *) addr, SAC_DISTMEM_HM_ADDR_ARENA( addr));  }  else {  if (size <= SAC_DISTMEM_HM_ARENA_4_MAXCS_BYTES) {  if (SAC_DISTMEM_HM_ADDR_ARENA( addr)->num == 4) {  SAC_DISTMEM_HM_FreeSmallChunk( (SAC_DISTMEM_HM_header_t *) addr, SAC_DISTMEM_HM_ADDR_ARENA( addr));  }  else {  SAC_DISTMEM_HM_FreeLargeChunk( (SAC_DISTMEM_HM_header_t *) addr, SAC_DISTMEM_HM_ADDR_ARENA( addr));  }  }  else {  if (SAC_DISTMEM_HM_BYTES_2_UNITS( size) + (2+2) < SAC_DISTMEM_HM_ARENA_8_MINCS) {  SAC_DISTMEM_HM_FreeLargeChunk( (SAC_DISTMEM_HM_header_t *) addr, SAC_DISTMEM_HM_ADDR_ARENA( addr));  }  else {  if (SAC_DISTMEM_HM_BYTES_2_UNITS( size) + 2 < SAC_DISTMEM_HM_ARENA_8_MINCS) {  if (SAC_DISTMEM_HM_ADDR_ARENA( addr)->num == 7) {  SAC_DISTMEM_HM_FreeLargeChunk( (SAC_DISTMEM_HM_header_t *) addr, SAC_DISTMEM_HM_ADDR_ARENA( addr));  }  else {  SAC_DISTMEM_HM_FreeLargeChunk( (SAC_DISTMEM_HM_header_t *) addr,  &(SAC_DISTMEM_HM_arenas[SAC_DISTMEM_HM_TOP_ARENA]));  }  }  else {  SAC_DISTMEM_HM_FreeLargeChunk( (SAC_DISTMEM_HM_header_t *) addr,  &(SAC_DISTMEM_HM_arenas[SAC_DISTMEM_HM_TOP_ARENA]));  }  }  }  } }
#else 
#define SAC_DISTMEM_HM_FREE_DESC( addr) {  SAC_TR_DISTMEM_PRINT( "SAC_DISTMEM_HM_FREE_DESC( %p)", addr);  if (SAC_DISTMEM_HM_ADDR_ARENA( addr) != NULL) {  SAC_DISTMEM_HM_FREE( addr)  } }
#define SAC_DISTMEM_HM_FREE_FIXED_SIZE( addr, size)  SAC_TR_DISTMEM_PRINT( "SAC_DISTMEM_HM_FREE_FIXED_SIZE( %p, %d)", addr, size);  SAC_DISTMEM_HM_FREE( addr)
#endif 
#if SAC_DO_MSCA
#define SAC_DISTMEM_HM_CACHE_ADJUST( size, cache_size, factor) ( (cache_size) <= 0  ? 0  : ((size) % (cache_size) < (cache_size) * (factor)  ? (SAC_DISTMEM_HM_size_byte_t) ((cache_size) * (factor)) - (size) % (cache_size)  : ((cache_size) - (size) % (cache_size) < (cache_size) * (factor)  ? (SAC_DISTMEM_HM_size_byte_t) ((cache_size) * (factor))  + (cache_size) - (size) % (cache_size)  : 0)))
#else 
#define SAC_DISTMEM_HM_CACHE_ADJUST( size, cache_size, factor)  0
#endif 
#endif 
#endif 
